
(*
    Maple gets the following for one pole pair:

            2                                2
 3 (1/4 I wp  ln(- I r1 + i1 - wp) - 1/4 I wp  ln(- I r1 + wp + i1)

                2                                     2               2     2
      - 1/4 I wp  ln(I r1 + i1 - wp) - 1/2 i1 r1 ln(i1  - 2 i1 wp + r1  + wp )

                       2     2               2            2
      + 1/2 i1 r1 ln(r1  + wp  + 2 i1 wp + i1 ) + 1/4 I wp  ln(I r1 + wp + i1)

              2        i1 - wp          2        wp + i1
      - 1/2 r1  arctan(-------) + 1/2 r1  arctan(-------)
                          r1                        r1

              2        wp + i1          2        i1 - wp             /   3
      - 1/2 i1  arctan(-------) + 1/2 i1  arctan(-------) - r1 wp)  /  wp
                          r1                        r1             /

     or in input form:

3*(1/4*I*wp^2*ln(-I*r1+i1-wp)-1/4*I*wp^2*ln(-I*r1+wp+i1)-
1/4*I*wp^2*ln(I*r1+i1-wp)-1/2*i1*r1*ln(i1^2-2*i1*wp+r1^2+wp^2)+
1/2*i1*r1*ln(r1^2+wp^2+2*i1*wp+i1^2)+1/4*I*wp^2*ln(I*r1+wp+i1)-
1/2*r1^2*arctan((i1-wp)/r1)+1/2*r1^2*arctan((wp+i1)/r1)-
1/2*i1^2*arctan((wp+i1)/r1)+1/2*i1^2*arctan((i1-wp)/r1)-r1*wp)/wp^3

 *)

deriveLinearPhaseSlope[ r_, i_, n_, wp_] :=
        Block [ {w},
		Integrate[ w phase[r, i, n, w], {w, 0, wp} ] /
		  Integrate[ w^2, {w, 0, wp} ] ]

phase[ r_, i_, n_, w_ ] :=
        Block [ {j},
                Sum[ - ArcTan[ (w - i[j])/r[j] ] - ArcTan[ (w + i[j])/r[j] ],
                     {j, 1, n} ] ]

(*
rule = ( ArcTan[z_] :> ArcTan[ Denominator[z], Numerator[z] ] );
 *)

org = w phase[r, i, n, w]
int = Integrate[ org, w ]
SameQ[ D[int, w], org ]

InputForm[ deriveLinearPhaseSlope[ r, i, 1, wp ] ]
InputForm[ deriveLinearPhaseSlope[ r, i, 2, wp ] ]
