(* Problem given by Karim Haffad haffad@tabk1.gatech.edu *)
s2 = Sqrt[2];
s3 = Sqrt[3];
d1[x_, y_, z_] := (s3/6) Sqrt[(z-2*y*s2)^2 + (z*s3-2(x+1)*s2)^2 + (y*s3-(x+1))^2];
d2[x_, y_, z_] := (s3/6) Sqrt[(z-2*y*s2)^2 + (z*s3+2(x-1)*s2)^2 + (y*s3+(x-1))^2];
d3[x_, y_, z_] := (s3/3) Sqrt[3*x^2 + (z+s2*(y-s3))^2];
d4[x_, y_, z_] := Sqrt[y^2+z^2];
d5[x_, y_, z_] := (1/2) Sqrt[4*z^2 + (y+s3*(x-1))^2];
d6[x_, y_, z_] := (1/2) Sqrt[4*z^2 + (x*s3-(y-s3))^2];
d7[x_, y_, z_] := Sqrt[(x+1)^2 + y^2 + z^2];
d8[x_, y_, z_] := Sqrt[(x-1)^2 + y^2 + z^2];
d9[x_, y_, z_] := Sqrt[x^2 + (y-s3)^2 + z^2];
d10[x_, y_, z_] := (s3/3) Sqrt[3*x^2 + (y*s3-1)^2 + (z*s3-2*s2)^2];
f[x_,y_,z_] := (d1[x,y,z]+d2[x,y,z]+d3[x,y,z]+d4[x,y,z]+d5[x,y,z]+d6[x,y,z])/(d7[x,y,z]+
d8[x,y,z]+d9[x,y,z]+d10[x,y,z]);
fx[x_,y_,z_] := D[f[x,y,z],x];
fy[x_,y_,z_] := D[f[x,y,z],y];
fz[x_,y_,z_] := D[f[x,y,z],z];
eq1 = D[f[x,y,z],x] == 0;
eq2 = D[f[x,y,z],y] == 0;
eq3 = D[f[x,y,z],z] == 0;

(* Load in the code generation package *)
<<../CodeGen.m

(* generate the cost function *)
file = OpenWrite[ "physics.m" ];
WriteString[ file, "function f = physics(v);\n" ];
WriteString[ file, x, " = v(1);\n", y, " = v(2);\n", z, " = v(3);\n" ];
bodyvar = MatlabCodeGen[f[x, y, z], file];
WriteString[ file, "f = ", bodyvar, ";\n" ];
WriteString[ file, "end\n" ];
Close[ file ];

(* generate the derivatives *)
file = OpenWrite[ "phys_der.m" ];
WriteString[ file, "function g = phys_der(v);\n" ];
WriteString[ file, x, " = v(1);\n", y, " = v(2);\n", z, " = v(3);\n" ];
bodyvar = MatlabCodeGen[ D[ f[x, y, z], x], file ];
WriteString[ file, "g(1) = ", bodyvar, ";\n" ];
bodyvar = MatlabCodeGen[ D[ f[x, y, z], y], file ];
WriteString[ file, "g(2) = ", bodyvar, ";\n" ];
bodyvar = MatlabCodeGen[ D[ f[x, y, z], z], file ];
WriteString[ file, "g(3) = ", bodyvar, ";\n" ];
WriteString[ file, "end\n" ];
Close[ file ];
