function f = stepresp(x, a, b, c,d,M1)
%STEPRESP computes the step response of an analog filter with any number of pole pairs.
%
%	This function takes four arguments:
%	  x is time
%	  a are the real values of the poles
%	  b are imaginary values of the poles
%	  c are the real values of the zeros
%	  c are imaginary values of the zeros
%	  M1 scales the step response
expr1 = b(1).^(-1);
expr2 = a(2).^2 + b(2).^2;
expr3 = ((a(1) - a(2)).^2 + (b(1) - b(2)).^2).*((a(1) - a(2)).^2 + (b(1) + b(2)).^2);
expr4 = -1./2;
expr5 = (c(1).^2 + d(1).^2).^(-1);
expr6 = (c(2).^2 + d(2).^2).^(-1);
expr7 = (a(1) - c(1)).^2 + (b(1) - d(1)).^2;
expr8 = (a(1) - c(1)).^2 + (b(1) + d(1)).^2;
expr9 = (a(1) - c(2)).^2 + (b(1) - d(2)).^2;
expr10 = (a(1) - c(2)).^2 + (b(1) + d(2)).^2;
expr11 = 1./2;
expr12 = b(1);
expr13 = angle(1 + (i.*(b(1) - b(2)))./(a(1) - a(2)));
expr14 = angle(1 + (i.*(b(1) + b(2)))./(a(1) - a(2)));
expr15 = -angle(1 + (i.*(b(1) - d(1)))./(a(1) - c(1)));
expr16 = -angle(1 + (i.*(b(1) + d(1)))./(a(1) - c(1)));
expr17 = -angle(1 + (i.*(b(1) - d(2)))./(a(1) - c(2)));
expr18 = -angle(1 + (i.*(b(1) + d(2)))./(a(1) - c(2)));
expr19 = a(1);
expr20 = exp(x.*a(1));
expr21 = cos(x.*b(1));
expr22 = a(1).^2 + b(1).^2;
expr23 = sin(x.*b(1));
expr24 = b(2).^(-1);
expr25 = ((-a(1) + a(2)).^2 + (-b(1) + b(2)).^2).*((-a(1) + a(2)).^2 + (b(1) + b(2)).^2);
expr26 = (a(2) - c(1)).^2 + (b(2) - d(1)).^2;
expr27 = (a(2) - c(1)).^2 + (b(2) + d(1)).^2;
expr28 = (a(2) - c(2)).^2 + (b(2) - d(2)).^2;
expr29 = (a(2) - c(2)).^2 + (b(2) + d(2)).^2;
expr30 = b(2);
expr31 = angle(1 + (i.*(-b(1) + b(2)))./(-a(1) + a(2)));
expr32 = angle(1 + (i.*(b(1) + b(2)))./(-a(1) + a(2)));
expr33 = -angle(1 + (i.*(b(2) - d(1)))./(a(2) - c(1)));
expr34 = -angle(1 + (i.*(b(2) + d(1)))./(a(2) - c(1)));
expr35 = -angle(1 + (i.*(b(2) - d(2)))./(a(2) - c(2)));
expr36 = -angle(1 + (i.*(b(2) + d(2)))./(a(2) - c(2)));
expr37 = a(2);
expr38 = exp(x.*a(2));
expr39 = cos(x.*b(2));
expr40 = sin(x.*b(2));
expr41 = expr3.^expr4;
expr42 = (expr10.*expr7.*expr8.*expr9).^expr11;
expr43 = expr12.*cos(expr13 + expr14 + expr15 + expr16 + expr17 + expr18) + expr19.*sin(expr13 + expr14 + expr15 + expr16 + expr17 + expr18);
expr44 = expr19 - (expr22.*sin(expr13 + expr14 + expr15 + expr16 + expr17 + expr18))./(expr12.*cos(expr13 + expr14 + expr15 + expr16 + expr17 + expr18) + expr19.*sin(expr13 + expr14 + expr15 + expr16 + expr17 + expr18));
expr45 = expr25.^expr4;
expr46 = (expr26.*expr27.*expr28.*expr29).^expr11;
expr47 = expr30.*cos(expr31 + expr32 + expr33 + expr34 + expr35 + expr36) + expr37.*sin(expr31 + expr32 + expr33 + expr34 + expr35 + expr36);
expr48 = expr37 - (expr2.*sin(expr31 + expr32 + expr33 + expr34 + expr35 + expr36))./(expr30.*cos(expr31 + expr32 + expr33 + expr34 + expr35 + expr36) + expr37.*sin(expr31 + expr32 + expr33 + expr34 + expr35 + expr36));
expr49 = expr1.*expr2.*expr41.*expr42.*expr43.*(1 - expr20.*(expr21 - expr1.*expr23.*expr44)).*expr5.*expr6;
expr50 = expr22.*expr24.*expr45.*expr46.*expr47.*(1 - expr38.*(expr39 - expr24.*expr40.*expr48)).*expr5.*expr6;
expr51 = expr49 + expr50;
f = M1.*expr51;
end
