function [gf,GC]=costder3(x)
% COSTDER3 computes the gradient of the cost function
%	for an analog filter having 3 complex pole pairs.
%
%	Code Generated by Mathematica packages written by Brian L. Evans
%	Copyright 1993 by the Regents of the University of California

%% Extract real and imaginary components of the filters's poles a +/- j b

%% Extract real and imaginary components of the filters's zeros c +/- j d
a = x(1:3);
b = x(4:6);
c = x(7:9);
d = x(10:12);

%% Global parameters
global dp ds maxO wmax Wmp Wms Wmt WO wp Wph WQ ws tpeak1;

%% Approximate tpeak by a differentiable function and assign it to tpa
expr319 = 1./3;
expr320 = b(1);
expr321 = a(1).^2 + b(1).^2;
expr322 = angle(1 + (i.*(b(1) - b(2)))./(a(1) - a(2)));
expr323 = angle(1 + (i.*(b(1) + b(2)))./(a(1) - a(2)));
expr324 = angle(1 + (i.*(b(1) - b(3)))./(a(1) - a(3)));
expr325 = angle(1 + (i.*(b(1) + b(3)))./(a(1) - a(3)));
expr326 = -angle(1 + (i.*(b(1) - d(1)))./(a(1) - c(1)));
expr327 = -angle(1 + (i.*(b(1) + d(1)))./(a(1) - c(1)));
expr328 = -angle(1 + (i.*(b(1) - d(2)))./(a(1) - c(2)));
expr329 = -angle(1 + (i.*(b(1) + d(2)))./(a(1) - c(2)));
expr330 = -angle(1 + (i.*(b(1) - d(3)))./(a(1) - c(3)));
expr331 = -angle(1 + (i.*(b(1) + d(3)))./(a(1) - c(3)));
expr332 = a(1);
expr333 = a(1).^2;
expr334 = b(1).^2;
expr335 = b(1).^(-1);
expr336 = b(2);
expr337 = a(2).^2 + b(2).^2;
expr338 = angle(1 + (i.*(-b(1) + b(2)))./(-a(1) + a(2)));
expr339 = angle(1 + (i.*(b(1) + b(2)))./(-a(1) + a(2)));
expr340 = angle(1 + (i.*(b(2) - b(3)))./(a(2) - a(3)));
expr341 = angle(1 + (i.*(b(2) + b(3)))./(a(2) - a(3)));
expr342 = -angle(1 + (i.*(b(2) - d(1)))./(a(2) - c(1)));
expr343 = -angle(1 + (i.*(b(2) + d(1)))./(a(2) - c(1)));
expr344 = -angle(1 + (i.*(b(2) - d(2)))./(a(2) - c(2)));
expr345 = -angle(1 + (i.*(b(2) + d(2)))./(a(2) - c(2)));
expr346 = -angle(1 + (i.*(b(2) - d(3)))./(a(2) - c(3)));
expr347 = -angle(1 + (i.*(b(2) + d(3)))./(a(2) - c(3)));
expr348 = a(2);
expr349 = a(2).^2;
expr350 = b(2).^2;
expr351 = b(2).^(-1);
expr352 = b(3);
expr353 = a(3).^2 + b(3).^2;
expr354 = angle(1 + (i.*(-b(1) + b(3)))./(-a(1) + a(3)));
expr355 = angle(1 + (i.*(b(1) + b(3)))./(-a(1) + a(3)));
expr356 = angle(1 + (i.*(-b(2) + b(3)))./(-a(2) + a(3)));
expr357 = angle(1 + (i.*(b(2) + b(3)))./(-a(2) + a(3)));
expr358 = -angle(1 + (i.*(b(3) - d(1)))./(a(3) - c(1)));
expr359 = -angle(1 + (i.*(b(3) + d(1)))./(a(3) - c(1)));
expr360 = -angle(1 + (i.*(b(3) - d(2)))./(a(3) - c(2)));
expr361 = -angle(1 + (i.*(b(3) + d(2)))./(a(3) - c(2)));
expr362 = -angle(1 + (i.*(b(3) - d(3)))./(a(3) - c(3)));
expr363 = -angle(1 + (i.*(b(3) + d(3)))./(a(3) - c(3)));
expr364 = a(3);
expr365 = a(3).^2;
expr366 = b(3).^2;
expr367 = b(3).^(-1);
expr368 = sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331);
expr369 = (expr320.*cos(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331) + expr332.*sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331)).^(-1);
expr370 = sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347);
expr371 = (expr336.*cos(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347) + expr348.*sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347)).^(-1);
expr372 = sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363);
expr373 = (expr352.*cos(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363) + expr364.*sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363)).^(-1);
expr374 = -(expr335.*(pi - angle(1 + (expr320.*expr321.*expr368.*expr369.*i)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369))));
expr375 = -(expr351.*(pi - angle(1 + (expr336.*expr337.*expr370.*expr371.*i)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371))));
expr376 = -(expr367.*(pi - angle(1 + (expr352.*expr353.*expr372.*expr373.*i)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373))));
expr377 = expr319.*(expr374 + expr375 + expr376);
tpa = expr377;

%% Correction to approximation of tpeak is tpc
tpc = tpeak1./tpa;


%% Derivative for a(1)
w5 = [ws:(99.*ws)./100:100.*ws];
expr378 = -1./99;
expr379 = ws.^(-1);
expr380 = (a(1).^2 + b(1).^2).^2;
expr381 = 4.*w5.^2.*a(1) + 4.*a(1).*(a(1).^2 + b(1).^2);
expr382 = ((a(1).^2 + b(1).^2).^2 + w5.^2.*(w5.^2 + 2.*(a(1).^2 - b(1).^2))).^(-2);
expr383 = (a(2).^2 + b(2).^2).^2;
expr384 = ((a(2).^2 + b(2).^2).^2 + w5.^2.*(w5.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr385 = (a(3).^2 + b(3).^2).^2;
expr386 = ((a(3).^2 + b(3).^2).^2 + w5.^2.*(w5.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr387 = (c(1).^2 + d(1).^2).^(-2);
expr388 = (c(1).^2 + d(1).^2).^2 + w5.^2.*(w5.^2 + 2.*(c(1).^2 - d(1).^2));
expr389 = (c(2).^2 + d(2).^2).^(-2);
expr390 = (c(2).^2 + d(2).^2).^2 + w5.^2.*(w5.^2 + 2.*(c(2).^2 - d(2).^2));
expr391 = (c(3).^2 + d(3).^2).^(-2);
expr392 = (c(3).^2 + d(3).^2).^2 + w5.^2.*(w5.^2 + 2.*(c(3).^2 - d(3).^2));
expr393 = 4./99;
expr394 = ((a(1).^2 + b(1).^2).^2 + w5.^2.*(w5.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr395 = expr378.*expr379.*expr380.*expr381.*expr382.*expr383.*expr384.*expr385.*expr386.*expr387.*expr388.*expr389.*expr390.*expr391.*expr392.*Wms + expr321.*expr332.*expr379.*expr383.*expr384.*expr385.*expr386.*expr387.*expr388.*expr389.*expr390.*expr391.*expr392.*expr393.*expr394.*Wms;
integrate5 = trapz(w5, expr395);
w6 = [0:wp./100:wp];
expr396 = wp.^(-1);
expr397 = -1./2;
expr398 = 4.*w6.^2.*a(1) + 4.*a(1).*(a(1).^2 + b(1).^2);
expr399 = (a(2).^2 + b(2).^2).^2 + w6.^2.*(w6.^2 + 2.*(a(2).^2 - b(2).^2));
expr400 = (a(3).^2 + b(3).^2).^2 + w6.^2.*(w6.^2 + 2.*(a(3).^2 - b(3).^2));
expr401 = (a(1).^2 + b(1).^2).^2 + w6.^2.*(w6.^2 + 2.*(a(1).^2 - b(1).^2));
expr402 = -3./2;
expr403 = (c(1).^2 + d(1).^2).^(-1);
expr404 = (c(2).^2 + d(2).^2).^(-1);
expr405 = (c(3).^2 + d(3).^2).^(-1);
expr406 = (c(1).^2 + d(1).^2).^2 + w6.^2.*(w6.^2 + 2.*(c(1).^2 - d(1).^2));
expr407 = (c(2).^2 + d(2).^2).^2 + w6.^2.*(w6.^2 + 2.*(c(2).^2 - d(2).^2));
expr408 = (c(3).^2 + d(3).^2).^2 + w6.^2.*(w6.^2 + 2.*(c(3).^2 - d(3).^2));
expr409 = 1./2;
expr410 = -1 + expr321.*expr337.*expr353.*(expr399.*expr400.*expr401).^expr397.*expr403.*expr404.*expr405.*(expr406.*expr407.*expr408).^expr409;
expr411 = 2.*expr332.*expr337.*expr353.*(expr399.*expr400.*expr401).^expr397.*expr403.*expr404.*expr405.*(expr406.*expr407.*expr408).^expr409;
expr412 = expr321.*expr337.*expr353.*expr397.*expr398.*expr399.*expr400.*(expr399.*expr400.*expr401).^expr402.*expr403.*expr404.*expr405.*(expr406.*expr407.*expr408).^expr409;
expr413 = 2.*expr396.*expr410.*(expr411 + expr412).*Wmp;
integrate6 = trapz(w6, expr413);
w7 = [wp:(-wp + ws)./100:ws];
expr414 = (-wp + ws).^(-1);
expr415 = 4.*w7.^2.*a(1) + 4.*a(1).*(a(1).^2 + b(1).^2);
expr416 = (a(2).^2 + b(2).^2).^2 + w7.^2.*(w7.^2 + 2.*(a(2).^2 - b(2).^2));
expr417 = (a(3).^2 + b(3).^2).^2 + w7.^2.*(w7.^2 + 2.*(a(3).^2 - b(3).^2));
expr418 = (a(1).^2 + b(1).^2).^2 + w7.^2.*(w7.^2 + 2.*(a(1).^2 - b(1).^2));
expr419 = (c(1).^2 + d(1).^2).^2 + w7.^2.*(w7.^2 + 2.*(c(1).^2 - d(1).^2));
expr420 = (c(2).^2 + d(2).^2).^2 + w7.^2.*(w7.^2 + 2.*(c(2).^2 - d(2).^2));
expr421 = (c(3).^2 + d(3).^2).^2 + w7.^2.*(w7.^2 + 2.*(c(3).^2 - d(3).^2));
expr422 = -(w7./(wp - ws));
expr423 = ws./(wp - ws);
expr424 = 2.*expr332.*expr337.*expr353.*expr403.*expr404.*expr405.*(expr416.*expr417.*expr418).^expr397.*(expr419.*expr420.*expr421).^expr409;
expr425 = expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405.*expr415.*expr416.*expr417.*(expr416.*expr417.*expr418).^expr402.*(expr419.*expr420.*expr421).^expr409;
expr426 = expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*(expr416.*expr417.*expr418).^expr397.*(expr419.*expr420.*expr421).^expr409 + expr422 + expr423;
expr427 = 2.*expr414.*(expr424 + expr425).*expr426.*Wmt;
integrate7 = trapz(w7, expr427);
w8 = [0:wmax./100:wmax];
expr428 = wmax.^(-1);
expr429 = -((w8 - b(1))./(a(1).^2.*(1 + (w8 - b(1)).^2./a(1).^2)));
expr430 = -((w8 + b(1))./(a(1).^2.*(1 + (w8 + b(1)).^2./a(1).^2)));
expr431 = wmax.^(-3);
expr432 = -2.*wmax;
expr433 = 2.*a(1).*(angle(1 + (i.*(wmax - b(1)))./a(1)) + angle(1 + (i.*(wmax + b(1)))./a(1)));
expr434 = (2.*(wmax - b(1)).^2.*b(1))./(a(1).^2.*(1 + (wmax - b(1)).^2./a(1).^2));
expr435 = (-2.*b(1).*(wmax + b(1)).^2)./(a(1).^2.*(1 + (wmax + b(1)).^2./a(1).^2));
expr436 = -wmax.^2 - a(1).^2 + b(1).^2;
expr437 = -((wmax - b(1))./(a(1).^2.*(1 + (wmax - b(1)).^2./a(1).^2)));
expr438 = -((wmax + b(1))./(a(1).^2.*(1 + (wmax + b(1)).^2./a(1).^2)));
expr439 = -(b(1).*log(1 + (wmax - b(1)).^2./a(1).^2));
expr440 = b(1).*log(1 + (wmax + b(1)).^2./a(1).^2);
expr441 = angle(1 + (i.*(w8 - b(1)))./a(1));
expr442 = angle(1 + (i.*(w8 + b(1)))./a(1));
expr443 = angle(1 + (i.*(w8 - b(2)))./a(2));
expr444 = angle(1 + (i.*(w8 + b(2)))./a(2));
expr445 = angle(1 + (i.*(w8 - b(3)))./a(3));
expr446 = angle(1 + (i.*(w8 + b(3)))./a(3));
expr447 = -angle(1 + (i.*(w8 - d(1)))./c(1));
expr448 = -angle(1 + (i.*(w8 + d(1)))./c(1));
expr449 = -angle(1 + (i.*(w8 - d(2)))./c(2));
expr450 = -angle(1 + (i.*(w8 + d(2)))./c(2));
expr451 = -angle(1 + (i.*(w8 - d(3)))./c(3));
expr452 = -angle(1 + (i.*(w8 + d(3)))./c(3));
expr453 = -2.*wmax.*a(1);
expr454 = angle(1 + (i.*(wmax - b(1)))./a(1)) + angle(1 + (i.*(wmax + b(1)))./a(1));
expr455 = -(a(1).*b(1).*log(1 + (wmax - b(1)).^2./a(1).^2));
expr456 = a(1).*b(1).*log(1 + (wmax + b(1)).^2./a(1).^2);
expr457 = -2.*wmax.*a(2);
expr458 = angle(1 + (i.*(wmax - b(2)))./a(2)) + angle(1 + (i.*(wmax + b(2)))./a(2));
expr459 = -wmax.^2 - a(2).^2 + b(2).^2;
expr460 = -(a(2).*b(2).*log(1 + (wmax - b(2)).^2./a(2).^2));
expr461 = a(2).*b(2).*log(1 + (wmax + b(2)).^2./a(2).^2);
expr462 = -2.*wmax.*a(3);
expr463 = angle(1 + (i.*(wmax - b(3)))./a(3)) + angle(1 + (i.*(wmax + b(3)))./a(3));
expr464 = -wmax.^2 - a(3).^2 + b(3).^2;
expr465 = -(a(3).*b(3).*log(1 + (wmax - b(3)).^2./a(3).^2));
expr466 = a(3).*b(3).*log(1 + (wmax + b(3)).^2./a(3).^2);
expr467 = 2.*wmax.*c(1);
expr468 = angle(1 + (i.*(wmax - d(1)))./c(1)) + angle(1 + (i.*(wmax + d(1)))./c(1));
expr469 = -wmax.^2 - c(1).^2 + d(1).^2;
expr470 = c(1).*d(1).*log(1 + (wmax - d(1)).^2./c(1).^2);
expr471 = -(c(1).*d(1).*log(1 + (wmax + d(1)).^2./c(1).^2));
expr472 = 2.*wmax.*c(2);
expr473 = angle(1 + (i.*(wmax - d(2)))./c(2)) + angle(1 + (i.*(wmax + d(2)))./c(2));
expr474 = -wmax.^2 - c(2).^2 + d(2).^2;
expr475 = c(2).*d(2).*log(1 + (wmax - d(2)).^2./c(2).^2);
expr476 = -(c(2).*d(2).*log(1 + (wmax + d(2)).^2./c(2).^2));
expr477 = 2.*wmax.*c(3);
expr478 = angle(1 + (i.*(wmax - d(3)))./c(3)) + angle(1 + (i.*(wmax + d(3)))./c(3));
expr479 = -wmax.^2 - c(3).^2 + d(3).^2;
expr480 = c(3).*d(3).*log(1 + (wmax - d(3)).^2./c(3).^2);
expr481 = -(c(3).*d(3).*log(1 + (wmax + d(3)).^2./c(3).^2));
expr482 = expr429 + expr430 + expr402.*expr431.*(expr432 + expr433 + expr434 + expr435 - expr436.*(expr437 + expr438) + expr439 + expr440).*w8;
expr483 = expr409.*(expr453 - expr436.*expr454 + expr455 + expr456);
expr484 = expr409.*(expr457 - expr458.*expr459 + expr460 + expr461);
expr485 = expr409.*(expr462 - expr463.*expr464 + expr465 + expr466);
expr486 = expr409.*(expr467 + expr468.*expr469 + expr470 + expr471);
expr487 = expr409.*(expr472 + expr473.*expr474 + expr475 + expr476);
expr488 = expr409.*(expr477 + expr478.*expr479 + expr480 + expr481);
expr489 = 2.*expr428.*expr482.*(expr441 + expr442 + expr443 + expr444 + expr445 + expr446 + expr447 + expr448 + expr449 + expr450 + expr451 + expr452 - 3.*expr431.*(expr483 + expr484 + expr485 + expr486 + expr487 + expr488).*w8).*Wph;
integrate8 = trapz(w8, expr489);
expr490 = 1./6;
expr491 = a(1).^(-1);
expr492 = a(2).^(-1);
expr493 = a(3).^(-1);
expr494 = sqrt(a(1).^2 + b(1).^2);
expr495 = sqrt(a(2).^2 + b(2).^2);
expr496 = sqrt(a(3).^2 + b(3).^2);
expr497 = -2./3;
expr498 = sqrt(a(1).^2 + b(1).^2).^(-1);
expr499 = a(1).^(-2);
expr500 = (a(1) - a(2)).^2 + (b(1) - b(2)).^2;
expr501 = (a(1) - a(2)).^2 + (b(1) + b(2)).^2;
expr502 = (a(1) - a(3)).^2 + (b(1) - b(3)).^2;
expr503 = (a(1) - a(3)).^2 + (b(1) + b(3)).^2;
expr504 = (a(1) - c(1)).^2 + (b(1) - d(1)).^2;
expr505 = (a(1) - c(1)).^2 + (b(1) + d(1)).^2;
expr506 = (a(1) - c(2)).^2 + (b(1) - d(2)).^2;
expr507 = (a(1) - c(2)).^2 + (b(1) + d(2)).^2;
expr508 = (a(1) - c(3)).^2 + (b(1) - d(3)).^2;
expr509 = (a(1) - c(3)).^2 + (b(1) + d(3)).^2;
expr510 = (-a(1) + a(2)).^2 + (-b(1) + b(2)).^2;
expr511 = (-a(1) + a(2)).^2 + (b(1) + b(2)).^2;
expr512 = (a(2) - a(3)).^2 + (b(2) - b(3)).^2;
expr513 = (a(2) - a(3)).^2 + (b(2) + b(3)).^2;
expr514 = (a(2) - c(1)).^2 + (b(2) - d(1)).^2;
expr515 = (a(2) - c(1)).^2 + (b(2) + d(1)).^2;
expr516 = (a(2) - c(2)).^2 + (b(2) - d(2)).^2;
expr517 = (a(2) - c(2)).^2 + (b(2) + d(2)).^2;
expr518 = (a(2) - c(3)).^2 + (b(2) - d(3)).^2;
expr519 = (a(2) - c(3)).^2 + (b(2) + d(3)).^2;
expr520 = (-a(1) + a(3)).^2 + (-b(1) + b(3)).^2;
expr521 = (-a(1) + a(3)).^2 + (b(1) + b(3)).^2;
expr522 = (-a(2) + a(3)).^2 + (-b(2) + b(3)).^2;
expr523 = (-a(2) + a(3)).^2 + (b(2) + b(3)).^2;
expr524 = (a(3) - c(1)).^2 + (b(3) - d(1)).^2;
expr525 = (a(3) - c(1)).^2 + (b(3) + d(1)).^2;
expr526 = (a(3) - c(2)).^2 + (b(3) - d(2)).^2;
expr527 = (a(3) - c(2)).^2 + (b(3) + d(2)).^2;
expr528 = (a(3) - c(3)).^2 + (b(3) - d(3)).^2;
expr529 = (a(3) - c(3)).^2 + (b(3) + d(3)).^2;
expr530 = a(1) - a(3);
expr531 = a(1) - a(2);
expr532 = a(1) - c(3);
expr533 = a(1) - c(2);
expr534 = a(1) - c(1);
expr535 = (a(1) - a(2)).^(-2);
expr536 = (1 + (b(1) - b(2)).^2./(a(1) - a(2)).^2).^(-1);
expr537 = b(1) - b(2);
expr538 = -((b(1) + b(2))./((a(1) - a(2)).^2.*(1 + (b(1) + b(2)).^2./(a(1) - a(2)).^2)));
expr539 = (a(1) - a(3)).^(-2);
expr540 = (1 + (b(1) - b(3)).^2./(a(1) - a(3)).^2).^(-1);
expr541 = b(1) - b(3);
expr542 = -((b(1) + b(3))./((a(1) - a(3)).^2.*(1 + (b(1) + b(3)).^2./(a(1) - a(3)).^2)));
expr543 = (a(1) - c(1)).^(-2);
expr544 = (1 + (b(1) - d(1)).^2./(a(1) - c(1)).^2).^(-1);
expr545 = b(1) - d(1);
expr546 = (b(1) + d(1))./((a(1) - c(1)).^2.*(1 + (b(1) + d(1)).^2./(a(1) - c(1)).^2));
expr547 = (a(1) - c(2)).^(-2);
expr548 = (1 + (b(1) - d(2)).^2./(a(1) - c(2)).^2).^(-1);
expr549 = b(1) - d(2);
expr550 = (b(1) + d(2))./((a(1) - c(2)).^2.*(1 + (b(1) + d(2)).^2./(a(1) - c(2)).^2));
expr551 = (a(1) - c(3)).^(-2);
expr552 = (1 + (b(1) - d(3)).^2./(a(1) - c(3)).^2).^(-1);
expr553 = b(1) - d(3);
expr554 = (b(1) + d(3))./((a(1) - c(3)).^2.*(1 + (b(1) + d(3)).^2./(a(1) - c(3)).^2));
expr555 = 2.*a(1);
expr556 = (-a(1) + a(2)).^(-2);
expr557 = -b(1) + b(2);
expr558 = (1 + (-b(1) + b(2)).^2./(-a(1) + a(2)).^2).^(-1);
expr559 = (b(1) + b(2))./((-a(1) + a(2)).^2.*(1 + (b(1) + b(2)).^2./(-a(1) + a(2)).^2));
expr560 = (-a(1) + a(3)).^(-2);
expr561 = -b(1) + b(3);
expr562 = (1 + (-b(1) + b(3)).^2./(-a(1) + a(3)).^2).^(-1);
expr563 = (b(1) + b(3))./((-a(1) + a(3)).^2.*(1 + (b(1) + b(3)).^2./(-a(1) + a(3)).^2));
expr564 = -1./3;
expr565 = -a(1) + a(2);
expr566 = -a(1) + a(3);
expr567 = expr490.*(-(expr491.*expr492.*expr493.*expr494.*expr495.*expr496)).^expr497.*(-(expr492.*expr493.*expr495.*expr496.*expr498) + expr492.*expr493.*expr494.*expr495.*expr496.*expr499).*WQ;
expr568 = (expr500.*expr501.*expr502.*expr503).^expr397;
expr569 = (expr504.*expr505.*expr506.*expr507.*expr508.*expr509).^expr409;
expr570 = expr320.*cos(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331) + expr332.*sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331);
expr571 = (expr510.*expr511.*expr512.*expr513).^expr397;
expr572 = (expr514.*expr515.*expr516.*expr517.*expr518.*expr519).^expr409;
expr573 = expr336.*cos(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347) + expr348.*sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347);
expr574 = (expr520.*expr521.*expr522.*expr523).^expr397;
expr575 = (expr524.*expr525.*expr526.*expr527.*expr528.*expr529).^expr409;
expr576 = expr352.*cos(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363) + expr364.*sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363);
expr577 = (expr500.*expr501.*expr502.*expr503).^expr402;
expr578 = 2.*expr500.*expr501.*expr502.*expr530 + 2.*expr500.*expr501.*expr503.*expr530 + 2.*expr500.*expr502.*expr503.*expr531 + 2.*expr501.*expr502.*expr503.*expr531;
expr579 = (expr504.*expr505.*expr506.*expr507.*expr508.*expr509).^expr397;
expr580 = 2.*expr504.*expr505.*expr506.*expr507.*expr508.*expr532;
expr581 = 2.*expr504.*expr505.*expr506.*expr507.*expr509.*expr532;
expr582 = 2.*expr504.*expr505.*expr506.*expr508.*expr509.*expr533;
expr583 = 2.*expr504.*expr505.*expr507.*expr508.*expr509.*expr533;
expr584 = 2.*expr504.*expr506.*expr507.*expr508.*expr509.*expr534;
expr585 = 2.*expr505.*expr506.*expr507.*expr508.*expr509.*expr534;
expr586 = -(expr535.*expr536.*expr537) + expr538 - expr539.*expr540.*expr541 + expr542 + expr543.*expr544.*expr545 + expr546 + expr547.*expr548.*expr549 + expr550 + expr551.*expr552.*expr553 + expr554;
expr587 = cos(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331);
expr588 = sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331).^2;
expr589 = (expr320.*cos(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331) + expr332.*sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331)).^(-2);
expr590 = sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347).^2;
expr591 = (expr336.*cos(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347) + expr348.*sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347)).^(-2);
expr592 = expr556.*expr557.*expr558 + expr559;
expr593 = cos(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347);
expr594 = expr348.*(expr556.*expr557.*expr558 + expr559).*cos(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347);
expr595 = -(expr336.*(expr556.*expr557.*expr558 + expr559).*sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347));
expr596 = sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363).^2;
expr597 = (expr352.*cos(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363) + expr364.*sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363)).^(-2);
expr598 = expr560.*expr561.*expr562 + expr563;
expr599 = cos(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363);
expr600 = expr364.*(expr560.*expr561.*expr562 + expr563).*cos(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363);
expr601 = -(expr352.*(expr560.*expr561.*expr562 + expr563).*sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363));
expr602 = (expr510.*expr511.*expr512.*expr513).^expr402;
expr603 = -2.*expr510.*expr512.*expr513.*expr565 - 2.*expr511.*expr512.*expr513.*expr565;
expr604 = (expr520.*expr521.*expr522.*expr523).^expr402;
expr605 = -2.*expr520.*expr522.*expr523.*expr566 - 2.*expr521.*expr522.*expr523.*expr566;
expr606 = expr332 - expr321.*expr368.*expr369;
expr607 = expr348 - expr337.*expr370.*expr371;
expr608 = expr364 - expr353.*expr372.*expr373;
expr609 = expr580 + expr581 + expr582 + expr583 + expr584 + expr585;
expr610 = expr368 - expr320.*expr368.*expr586 + expr332.*expr586.*expr587;
expr611 = (1 + (expr334.*expr380.*expr588.*expr589)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369).^2).^(-1);
expr612 = (2.*expr320.*expr332.*expr368.*expr369)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369);
expr613 = (expr320.*expr321.*expr369.*expr586.*expr587)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369);
expr614 = -((expr320.*expr321.*expr368.*(expr368 - expr320.*expr368.*expr586 + expr332.*expr586.*expr587).*expr589)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369));
expr615 = (expr333 + expr334 - expr321.*expr332.*expr368.*expr369).^(-2);
expr616 = -(expr321.*expr368.*expr369) - 2.*expr333.*expr368.*expr369 + expr555 - expr321.*expr332.*expr369.*expr586.*expr587 + expr321.*expr332.*expr368.*(expr368 - expr320.*expr368.*expr586 + expr332.*expr586.*expr587).*expr589;
expr617 = (1 + (expr350.*expr383.*expr590.*expr591)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371).^2).^(-1);
expr618 = (expr336.*expr337.*expr371.*expr592.*expr593)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371);
expr619 = -((expr336.*expr337.*expr370.*expr591.*(expr594 + expr595))./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371));
expr620 = -((expr336.*expr337.*expr370.*expr371.*(-(expr337.*expr348.*expr371.*expr592.*expr593) + expr337.*expr348.*expr370.*expr591.*(expr594 + expr595)))./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371).^2);
expr621 = (1 + (expr366.*expr385.*expr596.*expr597)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373).^2).^(-1);
expr622 = (expr352.*expr353.*expr373.*expr598.*expr599)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373);
expr623 = -((expr352.*expr353.*expr372.*expr597.*(expr600 + expr601))./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373));
expr624 = -((expr352.*expr353.*expr372.*expr373.*(-(expr353.*expr364.*expr373.*expr598.*expr599) + expr353.*expr364.*expr372.*expr597.*(expr600 + expr601)))./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373).^2);
expr625 = 1 - 2.*expr332.*expr368.*expr369 - expr321.*expr369.*expr586.*expr587 + expr321.*expr368.*(expr368 - expr320.*expr368.*expr586 + expr332.*expr586.*expr587).*expr589;
expr626 = expr594 + expr595;
expr627 = -(expr337.*expr371.*expr592.*expr593) + expr337.*expr370.*expr591.*(expr594 + expr595);
expr628 = expr600 + expr601;
expr629 = -(expr353.*expr373.*expr598.*expr599) + expr353.*expr372.*expr597.*(expr600 + expr601);
expr630 = 1 - exp(expr319.*expr332.*(expr374 + expr375 + expr376).*tpc).*(cos(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc) - expr335.*expr606.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc));
expr631 = 1 - exp(expr319.*expr348.*(expr374 + expr375 + expr376).*tpc).*(cos(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc) - expr351.*expr607.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc));
expr632 = 1 - exp(expr319.*expr364.*(expr374 + expr375 + expr376).*tpc).*(cos(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc) - expr367.*expr608.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc));
expr633 = exp(expr319.*expr332.*(expr374 + expr375 + expr376).*tpc);
expr634 = expr319.*(expr374 + expr375 + expr376).*tpc;
expr635 = expr319.*expr332.*(expr335.*expr611.*(expr612 + expr613 + expr614 - expr320.*expr321.*expr368.*expr369.*expr615.*expr616) + expr351.*expr617.*(expr618 + expr619 + expr620) + expr367.*expr621.*(expr622 + expr623 + expr624)).*tpc;
expr636 = cos(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc) - expr335.*expr606.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr637 = expr335.*expr611.*(expr612 + expr613 + expr614 - expr320.*expr321.*expr368.*expr369.*expr615.*expr616) + expr351.*expr617.*(expr618 + expr619 + expr620) + expr367.*expr621.*(expr622 + expr623 + expr624);
expr638 = cos(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr639 = -(expr335.*expr625.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc));
expr640 = sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr641 = exp(expr319.*expr348.*(expr374 + expr375 + expr376).*tpc);
expr642 = cos(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc) - expr351.*expr607.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr643 = cos(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr644 = -(expr351.*expr627.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc));
expr645 = sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr646 = exp(expr319.*expr364.*(expr374 + expr375 + expr376).*tpc);
expr647 = cos(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc) - expr367.*expr608.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr648 = cos(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr649 = -(expr367.*expr629.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc));
expr650 = sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr651 = -1 + expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*expr630 + expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*expr631 + expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*expr632;
expr652 = expr335.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405.*expr569.*expr570.*expr577.*expr578.*expr630;
expr653 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409.*expr568.*expr570.*expr579.*expr609.*expr630;
expr654 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr610.*expr630;
expr655 = 2.*expr332.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*expr631;
expr656 = expr321.*expr351.*expr353.*expr397.*expr403.*expr404.*expr405.*expr572.*expr573.*expr602.*expr603.*expr631;
expr657 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr626.*expr631;
expr658 = 2.*expr332.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*expr632;
expr659 = expr321.*expr337.*expr367.*expr397.*expr403.*expr404.*expr405.*expr575.*expr576.*expr604.*expr605.*expr632;
expr660 = expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr628.*expr632;
expr661 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*(-(expr633.*(expr634 + expr635).*expr636) - expr633.*(expr639 + expr564.*expr606.*expr637.*expr638.*tpc + expr320.*expr564.*expr637.*expr640.*tpc));
expr662 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*(expr348.*expr564.*expr637.*expr641.*expr642.*tpc - expr641.*(expr644 + expr564.*expr607.*expr637.*expr643.*tpc + expr336.*expr564.*expr637.*expr645.*tpc));
expr663 = expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*(expr364.*expr564.*expr637.*expr646.*expr647.*tpc - expr646.*(expr649 + expr564.*expr608.*expr637.*expr648.*tpc + expr352.*expr564.*expr637.*expr650.*tpc));
expr664 = expr567 + integrate5 + integrate6 + integrate7 + integrate8 + 200.*expr651.*(expr652 + expr653 + expr654 + expr655 + expr656 + expr657 + expr658 + expr659 + expr660 + expr661 + expr662 + expr663).*WO;
gf(1) = expr664;

%% Derivative for b(1)
w9 = [ws:(99.*ws)./100:100.*ws];
expr665 = -4.*w9.^2.*b(1) + 4.*b(1).*(a(1).^2 + b(1).^2);
expr666 = ((a(1).^2 + b(1).^2).^2 + w9.^2.*(w9.^2 + 2.*(a(1).^2 - b(1).^2))).^(-2);
expr667 = ((a(2).^2 + b(2).^2).^2 + w9.^2.*(w9.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr668 = ((a(3).^2 + b(3).^2).^2 + w9.^2.*(w9.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr669 = (c(1).^2 + d(1).^2).^2 + w9.^2.*(w9.^2 + 2.*(c(1).^2 - d(1).^2));
expr670 = (c(2).^2 + d(2).^2).^2 + w9.^2.*(w9.^2 + 2.*(c(2).^2 - d(2).^2));
expr671 = (c(3).^2 + d(3).^2).^2 + w9.^2.*(w9.^2 + 2.*(c(3).^2 - d(3).^2));
expr672 = ((a(1).^2 + b(1).^2).^2 + w9.^2.*(w9.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr673 = expr378.*expr379.*expr380.*expr383.*expr385.*expr387.*expr389.*expr391.*expr665.*expr666.*expr667.*expr668.*expr669.*expr670.*expr671.*Wms + expr320.*expr321.*expr379.*expr383.*expr385.*expr387.*expr389.*expr391.*expr393.*expr667.*expr668.*expr669.*expr670.*expr671.*expr672.*Wms;
integrate9 = trapz(w9, expr673);
w10 = [0:wp./100:wp];
expr674 = -4.*w10.^2.*b(1) + 4.*b(1).*(a(1).^2 + b(1).^2);
expr675 = (a(2).^2 + b(2).^2).^2 + w10.^2.*(w10.^2 + 2.*(a(2).^2 - b(2).^2));
expr676 = (a(3).^2 + b(3).^2).^2 + w10.^2.*(w10.^2 + 2.*(a(3).^2 - b(3).^2));
expr677 = (a(1).^2 + b(1).^2).^2 + w10.^2.*(w10.^2 + 2.*(a(1).^2 - b(1).^2));
expr678 = (c(1).^2 + d(1).^2).^2 + w10.^2.*(w10.^2 + 2.*(c(1).^2 - d(1).^2));
expr679 = (c(2).^2 + d(2).^2).^2 + w10.^2.*(w10.^2 + 2.*(c(2).^2 - d(2).^2));
expr680 = (c(3).^2 + d(3).^2).^2 + w10.^2.*(w10.^2 + 2.*(c(3).^2 - d(3).^2));
expr681 = -1 + expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*(expr675.*expr676.*expr677).^expr397.*(expr678.*expr679.*expr680).^expr409;
expr682 = 2.*expr320.*expr337.*expr353.*expr403.*expr404.*expr405.*(expr675.*expr676.*expr677).^expr397.*(expr678.*expr679.*expr680).^expr409;
expr683 = expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405.*expr674.*expr675.*expr676.*(expr675.*expr676.*expr677).^expr402.*(expr678.*expr679.*expr680).^expr409;
expr684 = 2.*expr396.*expr681.*(expr682 + expr683).*Wmp;
integrate10 = trapz(w10, expr684);
w11 = [wp:(-wp + ws)./100:ws];
expr685 = -4.*w11.^2.*b(1) + 4.*b(1).*(a(1).^2 + b(1).^2);
expr686 = (a(2).^2 + b(2).^2).^2 + w11.^2.*(w11.^2 + 2.*(a(2).^2 - b(2).^2));
expr687 = (a(3).^2 + b(3).^2).^2 + w11.^2.*(w11.^2 + 2.*(a(3).^2 - b(3).^2));
expr688 = (a(1).^2 + b(1).^2).^2 + w11.^2.*(w11.^2 + 2.*(a(1).^2 - b(1).^2));
expr689 = (c(1).^2 + d(1).^2).^2 + w11.^2.*(w11.^2 + 2.*(c(1).^2 - d(1).^2));
expr690 = (c(2).^2 + d(2).^2).^2 + w11.^2.*(w11.^2 + 2.*(c(2).^2 - d(2).^2));
expr691 = (c(3).^2 + d(3).^2).^2 + w11.^2.*(w11.^2 + 2.*(c(3).^2 - d(3).^2));
expr692 = -(w11./(wp - ws));
expr693 = 2.*expr320.*expr337.*expr353.*expr403.*expr404.*expr405.*(expr686.*expr687.*expr688).^expr397.*(expr689.*expr690.*expr691).^expr409;
expr694 = expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405.*expr685.*expr686.*expr687.*(expr686.*expr687.*expr688).^expr402.*(expr689.*expr690.*expr691).^expr409;
expr695 = expr423 + expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*(expr686.*expr687.*expr688).^expr397.*(expr689.*expr690.*expr691).^expr409 + expr692;
expr696 = 2.*expr414.*(expr693 + expr694).*expr695.*Wmt;
integrate11 = trapz(w11, expr696);
w12 = [0:wmax./100:wmax];
expr697 = -(1./(a(1).*(1 + (w12 - b(1)).^2./a(1).^2)));
expr698 = 1./(a(1).*(1 + (w12 + b(1)).^2./a(1).^2));
expr699 = -2.*(angle(1 + (i.*(wmax - b(1)))./a(1)) + angle(1 + (i.*(wmax + b(1)))./a(1))).*b(1);
expr700 = (2.*(wmax - b(1)).*b(1))./(a(1).*(1 + (wmax - b(1)).^2./a(1).^2));
expr701 = (2.*b(1).*(wmax + b(1)))./(a(1).*(1 + (wmax + b(1)).^2./a(1).^2));
expr702 = -(1./(a(1).*(1 + (wmax - b(1)).^2./a(1).^2)));
expr703 = 1./(a(1).*(1 + (wmax + b(1)).^2./a(1).^2));
expr704 = -(a(1).*log(1 + (wmax - b(1)).^2./a(1).^2));
expr705 = a(1).*log(1 + (wmax + b(1)).^2./a(1).^2);
expr706 = angle(1 + (i.*(w12 - b(1)))./a(1));
expr707 = angle(1 + (i.*(w12 + b(1)))./a(1));
expr708 = angle(1 + (i.*(w12 - b(2)))./a(2));
expr709 = angle(1 + (i.*(w12 + b(2)))./a(2));
expr710 = angle(1 + (i.*(w12 - b(3)))./a(3));
expr711 = angle(1 + (i.*(w12 + b(3)))./a(3));
expr712 = -angle(1 + (i.*(w12 - d(1)))./c(1));
expr713 = -angle(1 + (i.*(w12 + d(1)))./c(1));
expr714 = -angle(1 + (i.*(w12 - d(2)))./c(2));
expr715 = -angle(1 + (i.*(w12 + d(2)))./c(2));
expr716 = -angle(1 + (i.*(w12 - d(3)))./c(3));
expr717 = -angle(1 + (i.*(w12 + d(3)))./c(3));
expr718 = expr697 + expr698 + expr402.*expr431.*(expr699 + expr700 + expr701 - expr436.*(expr702 + expr703) + expr704 + expr705).*w12;
expr719 = 2.*expr428.*expr718.*(expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712 + expr713 + expr714 + expr715 + expr716 + expr717 - 3.*expr431.*(expr483 + expr484 + expr485 + expr486 + expr487 + expr488).*w12).*Wph;
integrate12 = trapz(w12, expr719);
expr720 = -1./6;
expr721 = b(1).^(-2);
expr722 = b(1) + b(3);
expr723 = b(1) + b(2);
expr724 = b(1) + d(3);
expr725 = b(1) + d(2);
expr726 = b(1) + d(1);
expr727 = 1./((a(1) - a(2)).*(1 + (b(1) - b(2)).^2./(a(1) - a(2)).^2));
expr728 = 1./((a(1) - a(2)).*(1 + (b(1) + b(2)).^2./(a(1) - a(2)).^2));
expr729 = 1./((a(1) - a(3)).*(1 + (b(1) - b(3)).^2./(a(1) - a(3)).^2));
expr730 = 1./((a(1) - a(3)).*(1 + (b(1) + b(3)).^2./(a(1) - a(3)).^2));
expr731 = -(1./((a(1) - c(1)).*(1 + (b(1) - d(1)).^2./(a(1) - c(1)).^2)));
expr732 = -(1./((a(1) - c(1)).*(1 + (b(1) + d(1)).^2./(a(1) - c(1)).^2)));
expr733 = -(1./((a(1) - c(2)).*(1 + (b(1) - d(2)).^2./(a(1) - c(2)).^2)));
expr734 = -(1./((a(1) - c(2)).*(1 + (b(1) + d(2)).^2./(a(1) - c(2)).^2)));
expr735 = -(1./((a(1) - c(3)).*(1 + (b(1) - d(3)).^2./(a(1) - c(3)).^2)));
expr736 = -(1./((a(1) - c(3)).*(1 + (b(1) + d(3)).^2./(a(1) - c(3)).^2)));
expr737 = 2.*b(1);
expr738 = -(1./((-a(1) + a(2)).*(1 + (-b(1) + b(2)).^2./(-a(1) + a(2)).^2)));
expr739 = 1./((-a(1) + a(2)).*(1 + (b(1) + b(2)).^2./(-a(1) + a(2)).^2));
expr740 = -(1./((-a(1) + a(3)).*(1 + (-b(1) + b(3)).^2./(-a(1) + a(3)).^2)));
expr741 = 1./((-a(1) + a(3)).*(1 + (b(1) + b(3)).^2./(-a(1) + a(3)).^2));
expr742 = expr320.*expr491.*expr492.*expr493.*expr495.*expr496.*(-(expr491.*expr492.*expr493.*expr494.*expr495.*expr496)).^expr497.*expr498.*expr720.*WQ;
expr743 = 2.*expr501.*expr502.*expr503.*expr537 + 2.*expr500.*expr501.*expr503.*expr541 + 2.*expr500.*expr501.*expr502.*expr722 + 2.*expr500.*expr502.*expr503.*expr723;
expr744 = 2.*expr505.*expr506.*expr507.*expr508.*expr509.*expr545;
expr745 = 2.*expr504.*expr505.*expr507.*expr508.*expr509.*expr549;
expr746 = 2.*expr504.*expr505.*expr506.*expr507.*expr509.*expr553;
expr747 = 2.*expr504.*expr505.*expr506.*expr507.*expr508.*expr724;
expr748 = 2.*expr504.*expr505.*expr506.*expr508.*expr509.*expr725;
expr749 = 2.*expr504.*expr506.*expr507.*expr508.*expr509.*expr726;
expr750 = expr332.*(expr727 + expr728 + expr729 + expr730 + expr731 + expr732 + expr733 + expr734 + expr735 + expr736).*cos(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331);
expr751 = -(expr320.*(expr727 + expr728 + expr729 + expr730 + expr731 + expr732 + expr733 + expr734 + expr735 + expr736).*sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331));
expr752 = expr727 + expr728 + expr729 + expr730 + expr731 + expr732 + expr733 + expr734 + expr735 + expr736;
expr753 = expr738 + expr739;
expr754 = expr348.*(expr738 + expr739).*cos(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347) - expr336.*(expr738 + expr739).*sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347);
expr755 = expr740 + expr741;
expr756 = expr364.*(expr740 + expr741).*cos(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363) - expr352.*(expr740 + expr741).*sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363);
expr757 = -2.*expr511.*expr512.*expr513.*expr557 + 2.*expr510.*expr512.*expr513.*expr723;
expr758 = -2.*expr521.*expr522.*expr523.*expr561 + 2.*expr520.*expr522.*expr523.*expr722;
expr759 = expr744 + expr745 + expr746 + expr747 + expr748 + expr749;
expr760 = expr587 + expr750 + expr751;
expr761 = (expr321.*expr368.*expr369)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369);
expr762 = (2.*expr334.*expr368.*expr369)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369);
expr763 = -((expr320.*expr321.*expr368.*expr589.*(expr587 + expr750 + expr751))./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369));
expr764 = (expr320.*expr321.*expr369.*expr587.*expr752)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369);
expr765 = -2.*expr320.*expr332.*expr368.*expr369 + expr737 + expr321.*expr332.*expr368.*expr589.*(expr587 + expr750 + expr751) - expr321.*expr332.*expr369.*expr587.*expr752;
expr766 = (expr336.*expr337.*expr371.*expr593.*expr753)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371);
expr767 = -((expr336.*expr337.*expr370.*expr591.*expr754)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371));
expr768 = -((expr336.*expr337.*expr370.*expr371.*(-(expr337.*expr348.*expr371.*expr593.*expr753) + expr337.*expr348.*expr370.*expr591.*expr754))./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371).^2);
expr769 = (expr352.*expr353.*expr373.*expr599.*expr755)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373);
expr770 = -((expr352.*expr353.*expr372.*expr597.*expr756)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373));
expr771 = -((expr352.*expr353.*expr372.*expr373.*(-(expr353.*expr364.*expr373.*expr599.*expr755) + expr353.*expr364.*expr372.*expr597.*expr756))./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373).^2);
expr772 = expr721.*(pi - angle(1 + (expr320.*expr321.*expr368.*expr369.*i)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369)));
expr773 = -2.*expr320.*expr368.*expr369 + expr321.*expr368.*expr589.*(expr587 + expr750 + expr751) - expr321.*expr369.*expr587.*expr752;
expr774 = -(expr337.*expr371.*expr593.*expr753) + expr337.*expr370.*expr591.*expr754;
expr775 = -(expr353.*expr373.*expr599.*expr755) + expr353.*expr372.*expr597.*expr756;
expr776 = expr335.*expr611.*(expr761 + expr762 + expr763 + expr764 - expr320.*expr321.*expr368.*expr369.*expr615.*expr765) + expr351.*expr617.*(expr766 + expr767 + expr768) + expr367.*expr621.*(expr769 + expr770 + expr771) + expr772;
expr777 = expr319.*expr320.*(expr335.*expr611.*(expr761 + expr762 + expr763 + expr764 - expr320.*expr321.*expr368.*expr369.*expr615.*expr765) + expr351.*expr617.*(expr766 + expr767 + expr768) + expr367.*expr621.*(expr769 + expr770 + expr771) + expr772).*tpc;
expr778 = expr606.*expr721.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr779 = -(expr335.*expr773.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc));
expr780 = -(expr351.*expr774.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc));
expr781 = -(expr367.*expr775.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc));
expr782 = 2.*expr320.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*expr631;
expr783 = 2.*expr320.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*expr632;
expr784 = -(expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*expr630.*expr721);
expr785 = expr335.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405.*expr569.*expr570.*expr577.*expr630.*expr743;
expr786 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr631.*expr754;
expr787 = expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr632.*expr756;
expr788 = expr321.*expr351.*expr353.*expr397.*expr403.*expr404.*expr405.*expr572.*expr573.*expr602.*expr631.*expr757;
expr789 = expr321.*expr337.*expr367.*expr397.*expr403.*expr404.*expr405.*expr575.*expr576.*expr604.*expr632.*expr758;
expr790 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409.*expr568.*expr570.*expr579.*expr630.*expr759;
expr791 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr630.*expr760;
expr792 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*(-(expr633.*(-(expr335.*expr606.*expr638.*(expr634 + expr777)) - expr640.*(expr634 + expr777) + expr778 + expr779)) + expr332.*expr564.*expr633.*expr636.*expr776.*tpc);
expr793 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*(expr348.*expr564.*expr641.*expr642.*expr776.*tpc - expr641.*(expr780 + expr564.*expr607.*expr643.*expr776.*tpc + expr336.*expr564.*expr645.*expr776.*tpc));
expr794 = expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*(expr364.*expr564.*expr646.*expr647.*expr776.*tpc - expr646.*(expr781 + expr564.*expr608.*expr648.*expr776.*tpc + expr352.*expr564.*expr650.*expr776.*tpc));
expr795 = expr742 + integrate10 + integrate11 + integrate12 + integrate9 + 200.*expr651.*(expr782 + expr783 + expr784 + expr785 + expr786 + expr787 + expr788 + expr789 + expr790 + expr791 + expr792 + expr793 + expr794).*WO;
gf(4) = expr795;

%% Derivative for a(2)
w13 = [ws:(99.*ws)./100:100.*ws];
expr796 = ((a(1).^2 + b(1).^2).^2 + w13.^2.*(w13.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr797 = 4.*w13.^2.*a(2) + 4.*a(2).*(a(2).^2 + b(2).^2);
expr798 = ((a(2).^2 + b(2).^2).^2 + w13.^2.*(w13.^2 + 2.*(a(2).^2 - b(2).^2))).^(-2);
expr799 = ((a(3).^2 + b(3).^2).^2 + w13.^2.*(w13.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr800 = (c(1).^2 + d(1).^2).^2 + w13.^2.*(w13.^2 + 2.*(c(1).^2 - d(1).^2));
expr801 = (c(2).^2 + d(2).^2).^2 + w13.^2.*(w13.^2 + 2.*(c(2).^2 - d(2).^2));
expr802 = (c(3).^2 + d(3).^2).^2 + w13.^2.*(w13.^2 + 2.*(c(3).^2 - d(3).^2));
expr803 = ((a(2).^2 + b(2).^2).^2 + w13.^2.*(w13.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr804 = expr378.*expr379.*expr380.*expr383.*expr385.*expr387.*expr389.*expr391.*expr796.*expr797.*expr798.*expr799.*expr800.*expr801.*expr802.*Wms + expr337.*expr348.*expr379.*expr380.*expr385.*expr387.*expr389.*expr391.*expr393.*expr796.*expr799.*expr800.*expr801.*expr802.*expr803.*Wms;
integrate13 = trapz(w13, expr804);
w14 = [0:wp./100:wp];
expr805 = (a(1).^2 + b(1).^2).^2 + w14.^2.*(w14.^2 + 2.*(a(1).^2 - b(1).^2));
expr806 = 4.*w14.^2.*a(2) + 4.*a(2).*(a(2).^2 + b(2).^2);
expr807 = (a(3).^2 + b(3).^2).^2 + w14.^2.*(w14.^2 + 2.*(a(3).^2 - b(3).^2));
expr808 = (a(2).^2 + b(2).^2).^2 + w14.^2.*(w14.^2 + 2.*(a(2).^2 - b(2).^2));
expr809 = (c(1).^2 + d(1).^2).^2 + w14.^2.*(w14.^2 + 2.*(c(1).^2 - d(1).^2));
expr810 = (c(2).^2 + d(2).^2).^2 + w14.^2.*(w14.^2 + 2.*(c(2).^2 - d(2).^2));
expr811 = (c(3).^2 + d(3).^2).^2 + w14.^2.*(w14.^2 + 2.*(c(3).^2 - d(3).^2));
expr812 = -1 + expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*(expr805.*expr807.*expr808).^expr397.*(expr809.*expr810.*expr811).^expr409;
expr813 = 2.*expr321.*expr348.*expr353.*expr403.*expr404.*expr405.*(expr805.*expr807.*expr808).^expr397.*(expr809.*expr810.*expr811).^expr409;
expr814 = expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405.*expr805.*expr806.*expr807.*(expr805.*expr807.*expr808).^expr402.*(expr809.*expr810.*expr811).^expr409;
expr815 = 2.*expr396.*expr812.*(expr813 + expr814).*Wmp;
integrate14 = trapz(w14, expr815);
w15 = [wp:(-wp + ws)./100:ws];
expr816 = (a(1).^2 + b(1).^2).^2 + w15.^2.*(w15.^2 + 2.*(a(1).^2 - b(1).^2));
expr817 = 4.*w15.^2.*a(2) + 4.*a(2).*(a(2).^2 + b(2).^2);
expr818 = (a(3).^2 + b(3).^2).^2 + w15.^2.*(w15.^2 + 2.*(a(3).^2 - b(3).^2));
expr819 = (a(2).^2 + b(2).^2).^2 + w15.^2.*(w15.^2 + 2.*(a(2).^2 - b(2).^2));
expr820 = (c(1).^2 + d(1).^2).^2 + w15.^2.*(w15.^2 + 2.*(c(1).^2 - d(1).^2));
expr821 = (c(2).^2 + d(2).^2).^2 + w15.^2.*(w15.^2 + 2.*(c(2).^2 - d(2).^2));
expr822 = (c(3).^2 + d(3).^2).^2 + w15.^2.*(w15.^2 + 2.*(c(3).^2 - d(3).^2));
expr823 = -(w15./(wp - ws));
expr824 = 2.*expr321.*expr348.*expr353.*expr403.*expr404.*expr405.*(expr816.*expr818.*expr819).^expr397.*(expr820.*expr821.*expr822).^expr409;
expr825 = expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405.*expr816.*expr817.*expr818.*(expr816.*expr818.*expr819).^expr402.*(expr820.*expr821.*expr822).^expr409;
expr826 = expr423 + expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*(expr816.*expr818.*expr819).^expr397.*(expr820.*expr821.*expr822).^expr409 + expr823;
expr827 = 2.*expr414.*(expr824 + expr825).*expr826.*Wmt;
integrate15 = trapz(w15, expr827);
w16 = [0:wmax./100:wmax];
expr828 = -((w16 - b(2))./(a(2).^2.*(1 + (w16 - b(2)).^2./a(2).^2)));
expr829 = -((w16 + b(2))./(a(2).^2.*(1 + (w16 + b(2)).^2./a(2).^2)));
expr830 = 2.*a(2).*(angle(1 + (i.*(wmax - b(2)))./a(2)) + angle(1 + (i.*(wmax + b(2)))./a(2)));
expr831 = (2.*(wmax - b(2)).^2.*b(2))./(a(2).^2.*(1 + (wmax - b(2)).^2./a(2).^2));
expr832 = (-2.*b(2).*(wmax + b(2)).^2)./(a(2).^2.*(1 + (wmax + b(2)).^2./a(2).^2));
expr833 = -((wmax - b(2))./(a(2).^2.*(1 + (wmax - b(2)).^2./a(2).^2)));
expr834 = -((wmax + b(2))./(a(2).^2.*(1 + (wmax + b(2)).^2./a(2).^2)));
expr835 = -(b(2).*log(1 + (wmax - b(2)).^2./a(2).^2));
expr836 = b(2).*log(1 + (wmax + b(2)).^2./a(2).^2);
expr837 = angle(1 + (i.*(w16 - b(1)))./a(1));
expr838 = angle(1 + (i.*(w16 + b(1)))./a(1));
expr839 = angle(1 + (i.*(w16 - b(2)))./a(2));
expr840 = angle(1 + (i.*(w16 + b(2)))./a(2));
expr841 = angle(1 + (i.*(w16 - b(3)))./a(3));
expr842 = angle(1 + (i.*(w16 + b(3)))./a(3));
expr843 = -angle(1 + (i.*(w16 - d(1)))./c(1));
expr844 = -angle(1 + (i.*(w16 + d(1)))./c(1));
expr845 = -angle(1 + (i.*(w16 - d(2)))./c(2));
expr846 = -angle(1 + (i.*(w16 + d(2)))./c(2));
expr847 = -angle(1 + (i.*(w16 - d(3)))./c(3));
expr848 = -angle(1 + (i.*(w16 + d(3)))./c(3));
expr849 = expr828 + expr829 + expr402.*expr431.*(expr432 + expr830 + expr831 + expr832 - expr459.*(expr833 + expr834) + expr835 + expr836).*w16;
expr850 = 2.*expr428.*expr849.*(expr837 + expr838 + expr839 + expr840 + expr841 + expr842 + expr843 + expr844 + expr845 + expr846 + expr847 + expr848 - 3.*expr431.*(expr483 + expr484 + expr485 + expr486 + expr487 + expr488).*w16).*Wph;
integrate16 = trapz(w16, expr850);
expr851 = sqrt(a(2).^2 + b(2).^2).^(-1);
expr852 = a(2).^(-2);
expr853 = (b(1) + b(2))./((a(1) - a(2)).^2.*(1 + (b(1) + b(2)).^2./(a(1) - a(2)).^2));
expr854 = -((b(1) + b(2))./((-a(1) + a(2)).^2.*(1 + (b(1) + b(2)).^2./(-a(1) + a(2)).^2)));
expr855 = (a(2) - a(3)).^(-2);
expr856 = (1 + (b(2) - b(3)).^2./(a(2) - a(3)).^2).^(-1);
expr857 = b(2) - b(3);
expr858 = -((b(2) + b(3))./((a(2) - a(3)).^2.*(1 + (b(2) + b(3)).^2./(a(2) - a(3)).^2)));
expr859 = (a(2) - c(1)).^(-2);
expr860 = (1 + (b(2) - d(1)).^2./(a(2) - c(1)).^2).^(-1);
expr861 = b(2) - d(1);
expr862 = (b(2) + d(1))./((a(2) - c(1)).^2.*(1 + (b(2) + d(1)).^2./(a(2) - c(1)).^2));
expr863 = (a(2) - c(2)).^(-2);
expr864 = (1 + (b(2) - d(2)).^2./(a(2) - c(2)).^2).^(-1);
expr865 = b(2) - d(2);
expr866 = (b(2) + d(2))./((a(2) - c(2)).^2.*(1 + (b(2) + d(2)).^2./(a(2) - c(2)).^2));
expr867 = (a(2) - c(3)).^(-2);
expr868 = (1 + (b(2) - d(3)).^2./(a(2) - c(3)).^2).^(-1);
expr869 = b(2) - d(3);
expr870 = (b(2) + d(3))./((a(2) - c(3)).^2.*(1 + (b(2) + d(3)).^2./(a(2) - c(3)).^2));
expr871 = 2.*a(2);
expr872 = (-a(2) + a(3)).^(-2);
expr873 = -b(2) + b(3);
expr874 = (1 + (-b(2) + b(3)).^2./(-a(2) + a(3)).^2).^(-1);
expr875 = (b(2) + b(3))./((-a(2) + a(3)).^2.*(1 + (b(2) + b(3)).^2./(-a(2) + a(3)).^2));
expr876 = a(2) - a(3);
expr877 = a(2) - c(3);
expr878 = a(2) - c(2);
expr879 = a(2) - c(1);
expr880 = -a(2) + a(3);
expr881 = expr490.*(-(expr491.*expr492.*expr493.*expr494.*expr495.*expr496)).^expr497.*(-(expr491.*expr493.*expr494.*expr496.*expr851) + expr491.*expr493.*expr494.*expr495.*expr496.*expr852).*WQ;
expr882 = -2.*expr500.*expr502.*expr503.*expr531 - 2.*expr501.*expr502.*expr503.*expr531;
expr883 = expr332.*(expr535.*expr536.*expr537 + expr853).*cos(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331);
expr884 = -(expr320.*(expr535.*expr536.*expr537 + expr853).*sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331));
expr885 = expr535.*expr536.*expr537 + expr853;
expr886 = -(expr556.*expr557.*expr558) + expr854 - expr855.*expr856.*expr857 + expr858 + expr859.*expr860.*expr861 + expr862 + expr863.*expr864.*expr865 + expr866 + expr867.*expr868.*expr869 + expr870;
expr887 = expr872.*expr873.*expr874 + expr875;
expr888 = expr364.*(expr872.*expr873.*expr874 + expr875).*cos(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363);
expr889 = -(expr352.*(expr872.*expr873.*expr874 + expr875).*sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363));
expr890 = 2.*expr510.*expr512.*expr513.*expr565 + 2.*expr511.*expr512.*expr513.*expr565 + 2.*expr510.*expr511.*expr512.*expr876 + 2.*expr510.*expr511.*expr513.*expr876;
expr891 = (expr514.*expr515.*expr516.*expr517.*expr518.*expr519).^expr397;
expr892 = 2.*expr514.*expr515.*expr516.*expr517.*expr518.*expr877;
expr893 = 2.*expr514.*expr515.*expr516.*expr517.*expr519.*expr877;
expr894 = 2.*expr514.*expr515.*expr516.*expr518.*expr519.*expr878;
expr895 = 2.*expr514.*expr515.*expr517.*expr518.*expr519.*expr878;
expr896 = 2.*expr514.*expr516.*expr517.*expr518.*expr519.*expr879;
expr897 = 2.*expr515.*expr516.*expr517.*expr518.*expr519.*expr879;
expr898 = -2.*expr520.*expr521.*expr522.*expr880 - 2.*expr520.*expr521.*expr523.*expr880;
expr899 = expr883 + expr884;
expr900 = -((expr320.*expr321.*expr368.*expr589.*(expr883 + expr884))./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369));
expr901 = (expr320.*expr321.*expr369.*expr587.*expr885)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369);
expr902 = -((expr320.*expr321.*expr368.*expr369.*(expr321.*expr332.*expr368.*expr589.*(expr883 + expr884) - expr321.*expr332.*expr369.*expr587.*expr885))./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369).^2);
expr903 = (2.*expr336.*expr348.*expr370.*expr371)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371);
expr904 = (expr336.*expr337.*expr371.*expr593.*expr886)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371);
expr905 = -((expr336.*expr337.*expr370.*expr591.*(expr370 - expr336.*expr370.*expr886 + expr348.*expr593.*expr886))./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371));
expr906 = (expr349 + expr350 - expr337.*expr348.*expr370.*expr371).^(-2);
expr907 = -(expr337.*expr370.*expr371) - 2.*expr349.*expr370.*expr371 + expr871 - expr337.*expr348.*expr371.*expr593.*expr886 + expr337.*expr348.*expr370.*expr591.*(expr370 - expr336.*expr370.*expr886 + expr348.*expr593.*expr886);
expr908 = (expr352.*expr353.*expr373.*expr599.*expr887)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373);
expr909 = -((expr352.*expr353.*expr372.*expr597.*(expr888 + expr889))./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373));
expr910 = -((expr352.*expr353.*expr372.*expr373.*(-(expr353.*expr364.*expr373.*expr599.*expr887) + expr353.*expr364.*expr372.*expr597.*(expr888 + expr889)))./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373).^2);
expr911 = expr321.*expr368.*expr589.*(expr883 + expr884) - expr321.*expr369.*expr587.*expr885;
expr912 = expr370 - expr336.*expr370.*expr886 + expr348.*expr593.*expr886;
expr913 = expr892 + expr893 + expr894 + expr895 + expr896 + expr897;
expr914 = 1 - 2.*expr348.*expr370.*expr371 - expr337.*expr371.*expr593.*expr886 + expr337.*expr370.*expr591.*(expr370 - expr336.*expr370.*expr886 + expr348.*expr593.*expr886);
expr915 = expr888 + expr889;
expr916 = -(expr353.*expr373.*expr599.*expr887) + expr353.*expr372.*expr597.*(expr888 + expr889);
expr917 = expr335.*expr611.*(expr900 + expr901 + expr902) + expr351.*expr617.*(expr903 + expr904 + expr905 - expr336.*expr337.*expr370.*expr371.*expr906.*expr907) + expr367.*expr621.*(expr908 + expr909 + expr910);
expr918 = -(expr335.*expr911.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc));
expr919 = expr319.*expr348.*(expr335.*expr611.*(expr900 + expr901 + expr902) + expr351.*expr617.*(expr903 + expr904 + expr905 - expr336.*expr337.*expr370.*expr371.*expr906.*expr907) + expr367.*expr621.*(expr908 + expr909 + expr910)).*tpc;
expr920 = -(expr351.*expr914.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc));
expr921 = -(expr367.*expr916.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc));
expr922 = 2.*expr335.*expr348.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*expr630;
expr923 = 2.*expr321.*expr348.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*expr632;
expr924 = expr335.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405.*expr569.*expr570.*expr577.*expr630.*expr882;
expr925 = expr321.*expr351.*expr353.*expr397.*expr403.*expr404.*expr405.*expr572.*expr573.*expr602.*expr631.*expr890;
expr926 = expr321.*expr337.*expr367.*expr397.*expr403.*expr404.*expr405.*expr575.*expr576.*expr604.*expr632.*expr898;
expr927 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr630.*expr899;
expr928 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr631.*expr912;
expr929 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr409.*expr571.*expr573.*expr631.*expr891.*expr913;
expr930 = expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr632.*expr915;
expr931 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*(expr332.*expr564.*expr633.*expr636.*expr917.*tpc - expr633.*(expr918 + expr564.*expr606.*expr638.*expr917.*tpc + expr320.*expr564.*expr640.*expr917.*tpc));
expr932 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*(-(expr641.*expr642.*(expr634 + expr919)) - expr641.*(expr920 + expr564.*expr607.*expr643.*expr917.*tpc + expr336.*expr564.*expr645.*expr917.*tpc));
expr933 = expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*(expr364.*expr564.*expr646.*expr647.*expr917.*tpc - expr646.*(expr921 + expr564.*expr608.*expr648.*expr917.*tpc + expr352.*expr564.*expr650.*expr917.*tpc));
expr934 = expr881 + integrate13 + integrate14 + integrate15 + integrate16 + 200.*expr651.*(expr922 + expr923 + expr924 + expr925 + expr926 + expr927 + expr928 + expr929 + expr930 + expr931 + expr932 + expr933).*WO;
gf(2) = expr934;

%% Derivative for b(2)
w17 = [ws:(99.*ws)./100:100.*ws];
expr935 = ((a(1).^2 + b(1).^2).^2 + w17.^2.*(w17.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr936 = -4.*w17.^2.*b(2) + 4.*b(2).*(a(2).^2 + b(2).^2);
expr937 = ((a(2).^2 + b(2).^2).^2 + w17.^2.*(w17.^2 + 2.*(a(2).^2 - b(2).^2))).^(-2);
expr938 = ((a(3).^2 + b(3).^2).^2 + w17.^2.*(w17.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr939 = (c(1).^2 + d(1).^2).^2 + w17.^2.*(w17.^2 + 2.*(c(1).^2 - d(1).^2));
expr940 = (c(2).^2 + d(2).^2).^2 + w17.^2.*(w17.^2 + 2.*(c(2).^2 - d(2).^2));
expr941 = (c(3).^2 + d(3).^2).^2 + w17.^2.*(w17.^2 + 2.*(c(3).^2 - d(3).^2));
expr942 = ((a(2).^2 + b(2).^2).^2 + w17.^2.*(w17.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr943 = expr378.*expr379.*expr380.*expr383.*expr385.*expr387.*expr389.*expr391.*expr935.*expr936.*expr937.*expr938.*expr939.*expr940.*expr941.*Wms + expr336.*expr337.*expr379.*expr380.*expr385.*expr387.*expr389.*expr391.*expr393.*expr935.*expr938.*expr939.*expr940.*expr941.*expr942.*Wms;
integrate17 = trapz(w17, expr943);
w18 = [0:wp./100:wp];
expr944 = (a(1).^2 + b(1).^2).^2 + w18.^2.*(w18.^2 + 2.*(a(1).^2 - b(1).^2));
expr945 = -4.*w18.^2.*b(2) + 4.*b(2).*(a(2).^2 + b(2).^2);
expr946 = (a(3).^2 + b(3).^2).^2 + w18.^2.*(w18.^2 + 2.*(a(3).^2 - b(3).^2));
expr947 = (a(2).^2 + b(2).^2).^2 + w18.^2.*(w18.^2 + 2.*(a(2).^2 - b(2).^2));
expr948 = (c(1).^2 + d(1).^2).^2 + w18.^2.*(w18.^2 + 2.*(c(1).^2 - d(1).^2));
expr949 = (c(2).^2 + d(2).^2).^2 + w18.^2.*(w18.^2 + 2.*(c(2).^2 - d(2).^2));
expr950 = (c(3).^2 + d(3).^2).^2 + w18.^2.*(w18.^2 + 2.*(c(3).^2 - d(3).^2));
expr951 = -1 + expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*(expr944.*expr946.*expr947).^expr397.*(expr948.*expr949.*expr950).^expr409;
expr952 = 2.*expr321.*expr336.*expr353.*expr403.*expr404.*expr405.*(expr944.*expr946.*expr947).^expr397.*(expr948.*expr949.*expr950).^expr409;
expr953 = expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405.*expr944.*expr945.*expr946.*(expr944.*expr946.*expr947).^expr402.*(expr948.*expr949.*expr950).^expr409;
expr954 = 2.*expr396.*expr951.*(expr952 + expr953).*Wmp;
integrate18 = trapz(w18, expr954);
w19 = [wp:(-wp + ws)./100:ws];
expr955 = (a(1).^2 + b(1).^2).^2 + w19.^2.*(w19.^2 + 2.*(a(1).^2 - b(1).^2));
expr956 = -4.*w19.^2.*b(2) + 4.*b(2).*(a(2).^2 + b(2).^2);
expr957 = (a(3).^2 + b(3).^2).^2 + w19.^2.*(w19.^2 + 2.*(a(3).^2 - b(3).^2));
expr958 = (a(2).^2 + b(2).^2).^2 + w19.^2.*(w19.^2 + 2.*(a(2).^2 - b(2).^2));
expr959 = (c(1).^2 + d(1).^2).^2 + w19.^2.*(w19.^2 + 2.*(c(1).^2 - d(1).^2));
expr960 = (c(2).^2 + d(2).^2).^2 + w19.^2.*(w19.^2 + 2.*(c(2).^2 - d(2).^2));
expr961 = (c(3).^2 + d(3).^2).^2 + w19.^2.*(w19.^2 + 2.*(c(3).^2 - d(3).^2));
expr962 = -(w19./(wp - ws));
expr963 = 2.*expr321.*expr336.*expr353.*expr403.*expr404.*expr405.*(expr955.*expr957.*expr958).^expr397.*(expr959.*expr960.*expr961).^expr409;
expr964 = expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405.*expr955.*expr956.*expr957.*(expr955.*expr957.*expr958).^expr402.*(expr959.*expr960.*expr961).^expr409;
expr965 = expr423 + expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*(expr955.*expr957.*expr958).^expr397.*(expr959.*expr960.*expr961).^expr409 + expr962;
expr966 = 2.*expr414.*(expr963 + expr964).*expr965.*Wmt;
integrate19 = trapz(w19, expr966);
w20 = [0:wmax./100:wmax];
expr967 = -(1./(a(2).*(1 + (w20 - b(2)).^2./a(2).^2)));
expr968 = 1./(a(2).*(1 + (w20 + b(2)).^2./a(2).^2));
expr969 = -2.*(angle(1 + (i.*(wmax - b(2)))./a(2)) + angle(1 + (i.*(wmax + b(2)))./a(2))).*b(2);
expr970 = (2.*(wmax - b(2)).*b(2))./(a(2).*(1 + (wmax - b(2)).^2./a(2).^2));
expr971 = (2.*b(2).*(wmax + b(2)))./(a(2).*(1 + (wmax + b(2)).^2./a(2).^2));
expr972 = -(1./(a(2).*(1 + (wmax - b(2)).^2./a(2).^2)));
expr973 = 1./(a(2).*(1 + (wmax + b(2)).^2./a(2).^2));
expr974 = -(a(2).*log(1 + (wmax - b(2)).^2./a(2).^2));
expr975 = a(2).*log(1 + (wmax + b(2)).^2./a(2).^2);
expr976 = angle(1 + (i.*(w20 - b(1)))./a(1));
expr977 = angle(1 + (i.*(w20 + b(1)))./a(1));
expr978 = angle(1 + (i.*(w20 - b(2)))./a(2));
expr979 = angle(1 + (i.*(w20 + b(2)))./a(2));
expr980 = angle(1 + (i.*(w20 - b(3)))./a(3));
expr981 = angle(1 + (i.*(w20 + b(3)))./a(3));
expr982 = -angle(1 + (i.*(w20 - d(1)))./c(1));
expr983 = -angle(1 + (i.*(w20 + d(1)))./c(1));
expr984 = -angle(1 + (i.*(w20 - d(2)))./c(2));
expr985 = -angle(1 + (i.*(w20 + d(2)))./c(2));
expr986 = -angle(1 + (i.*(w20 - d(3)))./c(3));
expr987 = -angle(1 + (i.*(w20 + d(3)))./c(3));
expr988 = expr967 + expr968 + expr402.*expr431.*(expr969 + expr970 + expr971 - expr459.*(expr972 + expr973) + expr974 + expr975).*w20;
expr989 = 2.*expr428.*expr988.*(expr976 + expr977 + expr978 + expr979 + expr980 + expr981 + expr982 + expr983 + expr984 + expr985 + expr986 + expr987 - 3.*expr431.*(expr483 + expr484 + expr485 + expr486 + expr487 + expr488).*w20).*Wph;
integrate20 = trapz(w20, expr989);
expr990 = -(1./((a(1) - a(2)).*(1 + (b(1) - b(2)).^2./(a(1) - a(2)).^2)));
expr991 = b(2).^(-2);
expr992 = 1./((-a(1) + a(2)).*(1 + (-b(1) + b(2)).^2./(-a(1) + a(2)).^2));
expr993 = 1./((a(2) - a(3)).*(1 + (b(2) - b(3)).^2./(a(2) - a(3)).^2));
expr994 = 1./((a(2) - a(3)).*(1 + (b(2) + b(3)).^2./(a(2) - a(3)).^2));
expr995 = -(1./((a(2) - c(1)).*(1 + (b(2) - d(1)).^2./(a(2) - c(1)).^2)));
expr996 = -(1./((a(2) - c(1)).*(1 + (b(2) + d(1)).^2./(a(2) - c(1)).^2)));
expr997 = -(1./((a(2) - c(2)).*(1 + (b(2) - d(2)).^2./(a(2) - c(2)).^2)));
expr998 = -(1./((a(2) - c(2)).*(1 + (b(2) + d(2)).^2./(a(2) - c(2)).^2)));
expr999 = -(1./((a(2) - c(3)).*(1 + (b(2) - d(3)).^2./(a(2) - c(3)).^2)));
expr1000 = -(1./((a(2) - c(3)).*(1 + (b(2) + d(3)).^2./(a(2) - c(3)).^2)));
expr1001 = 2.*b(2);
expr1002 = -(1./((-a(2) + a(3)).*(1 + (-b(2) + b(3)).^2./(-a(2) + a(3)).^2)));
expr1003 = 1./((-a(2) + a(3)).*(1 + (b(2) + b(3)).^2./(-a(2) + a(3)).^2));
expr1004 = b(2) + b(3);
expr1005 = b(2) + d(3);
expr1006 = b(2) + d(2);
expr1007 = b(2) + d(1);
expr1008 = expr336.*expr491.*expr492.*expr493.*expr494.*expr496.*(-(expr491.*expr492.*expr493.*expr494.*expr495.*expr496)).^expr497.*expr720.*expr851.*WQ;
expr1009 = -2.*expr501.*expr502.*expr503.*expr537 + 2.*expr500.*expr502.*expr503.*expr723;
expr1010 = expr332.*(expr728 + expr990).*cos(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331) - expr320.*(expr728 + expr990).*sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331);
expr1011 = expr728 + expr990;
expr1012 = expr1000 + expr739 + expr992 + expr993 + expr994 + expr995 + expr996 + expr997 + expr998 + expr999;
expr1013 = expr348.*(expr1000 + expr739 + expr992 + expr993 + expr994 + expr995 + expr996 + expr997 + expr998 + expr999).*cos(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347);
expr1014 = -(expr336.*(expr1000 + expr739 + expr992 + expr993 + expr994 + expr995 + expr996 + expr997 + expr998 + expr999).*sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347));
expr1015 = (expr1002 + expr1003).*expr364.*cos(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363) - (expr1002 + expr1003).*expr352.*sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363);
expr1016 = expr1002 + expr1003;
expr1017 = 2.*expr1004.*expr510.*expr511.*expr512 + 2.*expr511.*expr512.*expr513.*expr557 + 2.*expr510.*expr512.*expr513.*expr723 + 2.*expr510.*expr511.*expr513.*expr857;
expr1018 = 2.*expr1005.*expr514.*expr515.*expr516.*expr517.*expr518;
expr1019 = 2.*expr1006.*expr514.*expr515.*expr516.*expr518.*expr519;
expr1020 = 2.*expr1007.*expr514.*expr516.*expr517.*expr518.*expr519;
expr1021 = 2.*expr515.*expr516.*expr517.*expr518.*expr519.*expr861;
expr1022 = 2.*expr514.*expr515.*expr517.*expr518.*expr519.*expr865;
expr1023 = 2.*expr514.*expr515.*expr516.*expr517.*expr519.*expr869;
expr1024 = 2.*expr1004.*expr520.*expr521.*expr522 - 2.*expr520.*expr521.*expr523.*expr873;
expr1025 = (expr1011.*expr320.*expr321.*expr369.*expr587)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369);
expr1026 = -((expr1010.*expr320.*expr321.*expr368.*expr589)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369));
expr1027 = -((expr320.*expr321.*expr368.*expr369.*(-(expr1011.*expr321.*expr332.*expr369.*expr587) + expr1010.*expr321.*expr332.*expr368.*expr589))./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369).^2);
expr1028 = (expr337.*expr370.*expr371)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371);
expr1029 = (2.*expr350.*expr370.*expr371)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371);
expr1030 = (expr1012.*expr336.*expr337.*expr371.*expr593)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371);
expr1031 = -((expr336.*expr337.*expr370.*expr591.*(expr1013 + expr1014 + expr593))./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371));
expr1032 = expr1001 - 2.*expr336.*expr348.*expr370.*expr371 - expr1012.*expr337.*expr348.*expr371.*expr593 + expr337.*expr348.*expr370.*expr591.*(expr1013 + expr1014 + expr593);
expr1033 = -((expr1015.*expr352.*expr353.*expr372.*expr597)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373));
expr1034 = (expr1016.*expr352.*expr353.*expr373.*expr599)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373);
expr1035 = -((expr352.*expr353.*expr372.*expr373.*(expr1015.*expr353.*expr364.*expr372.*expr597 - expr1016.*expr353.*expr364.*expr373.*expr599))./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373).^2);
expr1036 = expr991.*(pi - angle(1 + (expr336.*expr337.*expr370.*expr371.*i)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371)));
expr1037 = -(expr1011.*expr321.*expr369.*expr587) + expr1010.*expr321.*expr368.*expr589;
expr1038 = expr1013 + expr1014 + expr593;
expr1039 = expr1018 + expr1019 + expr1020 + expr1021 + expr1022 + expr1023;
expr1040 = -2.*expr336.*expr370.*expr371 - expr1012.*expr337.*expr371.*expr593 + expr337.*expr370.*expr591.*(expr1013 + expr1014 + expr593);
expr1041 = expr1015.*expr353.*expr372.*expr597 - expr1016.*expr353.*expr373.*expr599;
expr1042 = expr1036 + (expr1025 + expr1026 + expr1027).*expr335.*expr611 + (expr1033 + expr1034 + expr1035).*expr367.*expr621 + expr351.*expr617.*(expr1028 + expr1029 + expr1030 + expr1031 - expr1032.*expr336.*expr337.*expr370.*expr371.*expr906);
expr1043 = -(expr1037.*expr335.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc));
expr1044 = expr319.*expr336.*(expr1036 + (expr1025 + expr1026 + expr1027).*expr335.*expr611 + (expr1033 + expr1034 + expr1035).*expr367.*expr621 + expr351.*expr617.*(expr1028 + expr1029 + expr1030 + expr1031 - expr1032.*expr336.*expr337.*expr370.*expr371.*expr906)).*tpc;
expr1045 = -(expr1040.*expr351.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc));
expr1046 = expr607.*expr991.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr1047 = -(expr1041.*expr367.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc));
expr1048 = expr1010.*expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr630;
expr1049 = 2.*expr335.*expr336.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*expr630;
expr1050 = expr1009.*expr335.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405.*expr569.*expr570.*expr577.*expr630;
expr1051 = expr1038.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr631;
expr1052 = expr1017.*expr321.*expr351.*expr353.*expr397.*expr403.*expr404.*expr405.*expr572.*expr573.*expr602.*expr631;
expr1053 = expr1015.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr632;
expr1054 = 2.*expr321.*expr336.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*expr632;
expr1055 = expr1024.*expr321.*expr337.*expr367.*expr397.*expr403.*expr404.*expr405.*expr575.*expr576.*expr604.*expr632;
expr1056 = expr1039.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr409.*expr571.*expr573.*expr631.*expr891;
expr1057 = -(expr321.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*expr631.*expr991);
expr1058 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*(-(expr641.*(expr1045 + expr1046 - expr351.*expr607.*(expr1044 + expr634).*expr643 - (expr1044 + expr634).*expr645)) + expr1042.*expr348.*expr564.*expr641.*expr642.*tpc);
expr1059 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*(expr1042.*expr332.*expr564.*expr633.*expr636.*tpc - expr633.*(expr1043 + expr1042.*expr564.*expr606.*expr638.*tpc + expr1042.*expr320.*expr564.*expr640.*tpc));
expr1060 = expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*(expr1042.*expr364.*expr564.*expr646.*expr647.*tpc - expr646.*(expr1047 + expr1042.*expr564.*expr608.*expr648.*tpc + expr1042.*expr352.*expr564.*expr650.*tpc));
expr1061 = expr1008 + integrate17 + integrate18 + integrate19 + integrate20 + 200.*(expr1048 + expr1049 + expr1050 + expr1051 + expr1052 + expr1053 + expr1054 + expr1055 + expr1056 + expr1057 + expr1058 + expr1059 + expr1060).*expr651.*WO;
gf(5) = expr1061;

%% Derivative for a(3)
w21 = [ws:(99.*ws)./100:100.*ws];
expr1062 = ((a(1).^2 + b(1).^2).^2 + w21.^2.*(w21.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr1063 = ((a(2).^2 + b(2).^2).^2 + w21.^2.*(w21.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr1064 = 4.*w21.^2.*a(3) + 4.*a(3).*(a(3).^2 + b(3).^2);
expr1065 = ((a(3).^2 + b(3).^2).^2 + w21.^2.*(w21.^2 + 2.*(a(3).^2 - b(3).^2))).^(-2);
expr1066 = (c(1).^2 + d(1).^2).^2 + w21.^2.*(w21.^2 + 2.*(c(1).^2 - d(1).^2));
expr1067 = (c(2).^2 + d(2).^2).^2 + w21.^2.*(w21.^2 + 2.*(c(2).^2 - d(2).^2));
expr1068 = (c(3).^2 + d(3).^2).^2 + w21.^2.*(w21.^2 + 2.*(c(3).^2 - d(3).^2));
expr1069 = ((a(3).^2 + b(3).^2).^2 + w21.^2.*(w21.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr1070 = expr1062.*expr1063.*expr1064.*expr1065.*expr1066.*expr1067.*expr1068.*expr378.*expr379.*expr380.*expr383.*expr385.*expr387.*expr389.*expr391.*Wms + expr1062.*expr1063.*expr1066.*expr1067.*expr1068.*expr1069.*expr353.*expr364.*expr379.*expr380.*expr383.*expr387.*expr389.*expr391.*expr393.*Wms;
integrate21 = trapz(w21, expr1070);
w22 = [0:wp./100:wp];
expr1071 = (a(1).^2 + b(1).^2).^2 + w22.^2.*(w22.^2 + 2.*(a(1).^2 - b(1).^2));
expr1072 = (a(2).^2 + b(2).^2).^2 + w22.^2.*(w22.^2 + 2.*(a(2).^2 - b(2).^2));
expr1073 = 4.*w22.^2.*a(3) + 4.*a(3).*(a(3).^2 + b(3).^2);
expr1074 = (a(3).^2 + b(3).^2).^2 + w22.^2.*(w22.^2 + 2.*(a(3).^2 - b(3).^2));
expr1075 = (c(1).^2 + d(1).^2).^2 + w22.^2.*(w22.^2 + 2.*(c(1).^2 - d(1).^2));
expr1076 = (c(2).^2 + d(2).^2).^2 + w22.^2.*(w22.^2 + 2.*(c(2).^2 - d(2).^2));
expr1077 = (c(3).^2 + d(3).^2).^2 + w22.^2.*(w22.^2 + 2.*(c(3).^2 - d(3).^2));
expr1078 = -1 + (expr1071.*expr1072.*expr1074).^expr397.*(expr1075.*expr1076.*expr1077).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405;
expr1079 = 2.*(expr1071.*expr1072.*expr1074).^expr397.*(expr1075.*expr1076.*expr1077).^expr409.*expr321.*expr337.*expr364.*expr403.*expr404.*expr405;
expr1080 = expr1071.*expr1072.*expr1073.*(expr1071.*expr1072.*expr1074).^expr402.*(expr1075.*expr1076.*expr1077).^expr409.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr1081 = 2.*expr1078.*(expr1079 + expr1080).*expr396.*Wmp;
integrate22 = trapz(w22, expr1081);
w23 = [wp:(-wp + ws)./100:ws];
expr1082 = (a(1).^2 + b(1).^2).^2 + w23.^2.*(w23.^2 + 2.*(a(1).^2 - b(1).^2));
expr1083 = (a(2).^2 + b(2).^2).^2 + w23.^2.*(w23.^2 + 2.*(a(2).^2 - b(2).^2));
expr1084 = 4.*w23.^2.*a(3) + 4.*a(3).*(a(3).^2 + b(3).^2);
expr1085 = (a(3).^2 + b(3).^2).^2 + w23.^2.*(w23.^2 + 2.*(a(3).^2 - b(3).^2));
expr1086 = (c(1).^2 + d(1).^2).^2 + w23.^2.*(w23.^2 + 2.*(c(1).^2 - d(1).^2));
expr1087 = (c(2).^2 + d(2).^2).^2 + w23.^2.*(w23.^2 + 2.*(c(2).^2 - d(2).^2));
expr1088 = (c(3).^2 + d(3).^2).^2 + w23.^2.*(w23.^2 + 2.*(c(3).^2 - d(3).^2));
expr1089 = -(w23./(wp - ws));
expr1090 = 2.*(expr1082.*expr1083.*expr1085).^expr397.*(expr1086.*expr1087.*expr1088).^expr409.*expr321.*expr337.*expr364.*expr403.*expr404.*expr405;
expr1091 = expr1082.*expr1083.*expr1084.*(expr1082.*expr1083.*expr1085).^expr402.*(expr1086.*expr1087.*expr1088).^expr409.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr1092 = expr1089 + (expr1082.*expr1083.*expr1085).^expr397.*(expr1086.*expr1087.*expr1088).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405 + expr423;
expr1093 = 2.*(expr1090 + expr1091).*expr1092.*expr414.*Wmt;
integrate23 = trapz(w23, expr1093);
w24 = [0:wmax./100:wmax];
expr1094 = -((w24 - b(3))./(a(3).^2.*(1 + (w24 - b(3)).^2./a(3).^2)));
expr1095 = -((w24 + b(3))./(a(3).^2.*(1 + (w24 + b(3)).^2./a(3).^2)));
expr1096 = 2.*a(3).*(angle(1 + (i.*(wmax - b(3)))./a(3)) + angle(1 + (i.*(wmax + b(3)))./a(3)));
expr1097 = (2.*(wmax - b(3)).^2.*b(3))./(a(3).^2.*(1 + (wmax - b(3)).^2./a(3).^2));
expr1098 = (-2.*b(3).*(wmax + b(3)).^2)./(a(3).^2.*(1 + (wmax + b(3)).^2./a(3).^2));
expr1099 = -((wmax - b(3))./(a(3).^2.*(1 + (wmax - b(3)).^2./a(3).^2)));
expr1100 = -((wmax + b(3))./(a(3).^2.*(1 + (wmax + b(3)).^2./a(3).^2)));
expr1101 = -(b(3).*log(1 + (wmax - b(3)).^2./a(3).^2));
expr1102 = b(3).*log(1 + (wmax + b(3)).^2./a(3).^2);
expr1103 = angle(1 + (i.*(w24 - b(1)))./a(1));
expr1104 = angle(1 + (i.*(w24 + b(1)))./a(1));
expr1105 = angle(1 + (i.*(w24 - b(2)))./a(2));
expr1106 = angle(1 + (i.*(w24 + b(2)))./a(2));
expr1107 = angle(1 + (i.*(w24 - b(3)))./a(3));
expr1108 = angle(1 + (i.*(w24 + b(3)))./a(3));
expr1109 = -angle(1 + (i.*(w24 - d(1)))./c(1));
expr1110 = -angle(1 + (i.*(w24 + d(1)))./c(1));
expr1111 = -angle(1 + (i.*(w24 - d(2)))./c(2));
expr1112 = -angle(1 + (i.*(w24 + d(2)))./c(2));
expr1113 = -angle(1 + (i.*(w24 - d(3)))./c(3));
expr1114 = -angle(1 + (i.*(w24 + d(3)))./c(3));
expr1115 = expr1094 + expr1095 + expr402.*expr431.*(expr1096 + expr1097 + expr1098 + expr1101 + expr1102 + expr432 - (expr1099 + expr1100).*expr464).*w24;
expr1116 = 2.*expr1115.*expr428.*(expr1103 + expr1104 + expr1105 + expr1106 + expr1107 + expr1108 + expr1109 + expr1110 + expr1111 + expr1112 + expr1113 + expr1114 - 3.*expr431.*(expr483 + expr484 + expr485 + expr486 + expr487 + expr488).*w24).*Wph;
integrate24 = trapz(w24, expr1116);
expr1117 = sqrt(a(3).^2 + b(3).^2).^(-1);
expr1118 = a(3).^(-2);
expr1119 = (b(1) + b(3))./((a(1) - a(3)).^2.*(1 + (b(1) + b(3)).^2./(a(1) - a(3)).^2));
expr1120 = (b(2) + b(3))./((a(2) - a(3)).^2.*(1 + (b(2) + b(3)).^2./(a(2) - a(3)).^2));
expr1121 = -((b(1) + b(3))./((-a(1) + a(3)).^2.*(1 + (b(1) + b(3)).^2./(-a(1) + a(3)).^2)));
expr1122 = -((b(2) + b(3))./((-a(2) + a(3)).^2.*(1 + (b(2) + b(3)).^2./(-a(2) + a(3)).^2)));
expr1123 = (a(3) - c(1)).^(-2);
expr1124 = (1 + (b(3) - d(1)).^2./(a(3) - c(1)).^2).^(-1);
expr1125 = b(3) - d(1);
expr1126 = (b(3) + d(1))./((a(3) - c(1)).^2.*(1 + (b(3) + d(1)).^2./(a(3) - c(1)).^2));
expr1127 = (a(3) - c(2)).^(-2);
expr1128 = (1 + (b(3) - d(2)).^2./(a(3) - c(2)).^2).^(-1);
expr1129 = b(3) - d(2);
expr1130 = (b(3) + d(2))./((a(3) - c(2)).^2.*(1 + (b(3) + d(2)).^2./(a(3) - c(2)).^2));
expr1131 = (a(3) - c(3)).^(-2);
expr1132 = (1 + (b(3) - d(3)).^2./(a(3) - c(3)).^2).^(-1);
expr1133 = b(3) - d(3);
expr1134 = (b(3) + d(3))./((a(3) - c(3)).^2.*(1 + (b(3) + d(3)).^2./(a(3) - c(3)).^2));
expr1135 = 2.*a(3);
expr1136 = a(3) - c(3);
expr1137 = a(3) - c(2);
expr1138 = a(3) - c(1);
expr1139 = expr490.*(-(expr491.*expr492.*expr493.*expr494.*expr495.*expr496)).^expr497.*(-(expr1117.*expr491.*expr492.*expr494.*expr495) + expr1118.*expr491.*expr492.*expr494.*expr495.*expr496).*WQ;
expr1140 = -2.*expr500.*expr501.*expr502.*expr530 - 2.*expr500.*expr501.*expr503.*expr530;
expr1141 = expr332.*(expr1119 + expr539.*expr540.*expr541).*cos(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331);
expr1142 = -(expr320.*(expr1119 + expr539.*expr540.*expr541).*sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331));
expr1143 = expr1119 + expr539.*expr540.*expr541;
expr1144 = expr1120 + expr855.*expr856.*expr857;
expr1145 = expr348.*(expr1120 + expr855.*expr856.*expr857).*cos(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347);
expr1146 = -(expr336.*(expr1120 + expr855.*expr856.*expr857).*sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347));
expr1147 = expr1121 + expr1122 + expr1123.*expr1124.*expr1125 + expr1126 + expr1127.*expr1128.*expr1129 + expr1130 + expr1131.*expr1132.*expr1133 + expr1134 - expr560.*expr561.*expr562 - expr872.*expr873.*expr874;
expr1148 = -2.*expr510.*expr511.*expr512.*expr876 - 2.*expr510.*expr511.*expr513.*expr876;
expr1149 = (expr524.*expr525.*expr526.*expr527.*expr528.*expr529).^expr397;
expr1150 = 2.*expr1136.*expr524.*expr525.*expr526.*expr527.*expr528;
expr1151 = 2.*expr1136.*expr524.*expr525.*expr526.*expr527.*expr529;
expr1152 = 2.*expr1137.*expr524.*expr525.*expr526.*expr528.*expr529;
expr1153 = 2.*expr1137.*expr524.*expr525.*expr527.*expr528.*expr529;
expr1154 = 2.*expr1138.*expr524.*expr526.*expr527.*expr528.*expr529;
expr1155 = 2.*expr1138.*expr525.*expr526.*expr527.*expr528.*expr529;
expr1156 = 2.*expr520.*expr522.*expr523.*expr566 + 2.*expr521.*expr522.*expr523.*expr566 + 2.*expr520.*expr521.*expr522.*expr880 + 2.*expr520.*expr521.*expr523.*expr880;
expr1157 = expr1141 + expr1142;
expr1158 = (expr1143.*expr320.*expr321.*expr369.*expr587)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369);
expr1159 = -(((expr1141 + expr1142).*expr320.*expr321.*expr368.*expr589)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369));
expr1160 = -((expr320.*expr321.*expr368.*expr369.*(-(expr1143.*expr321.*expr332.*expr369.*expr587) + (expr1141 + expr1142).*expr321.*expr332.*expr368.*expr589))./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369).^2);
expr1161 = -(((expr1145 + expr1146).*expr336.*expr337.*expr370.*expr591)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371));
expr1162 = (expr1144.*expr336.*expr337.*expr371.*expr593)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371);
expr1163 = -((expr336.*expr337.*expr370.*expr371.*((expr1145 + expr1146).*expr337.*expr348.*expr370.*expr591 - expr1144.*expr337.*expr348.*expr371.*expr593))./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371).^2);
expr1164 = (2.*expr352.*expr364.*expr372.*expr373)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373);
expr1165 = (expr1147.*expr352.*expr353.*expr373.*expr599)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373);
expr1166 = -((expr352.*expr353.*expr372.*expr597.*(expr372 - expr1147.*expr352.*expr372 + expr1147.*expr364.*expr599))./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373));
expr1167 = (expr365 + expr366 - expr353.*expr364.*expr372.*expr373).^(-2);
expr1168 = expr1135 - expr353.*expr372.*expr373 - 2.*expr365.*expr372.*expr373 - expr1147.*expr353.*expr364.*expr373.*expr599 + expr353.*expr364.*expr372.*expr597.*(expr372 - expr1147.*expr352.*expr372 + expr1147.*expr364.*expr599);
expr1169 = -(expr1143.*expr321.*expr369.*expr587) + (expr1141 + expr1142).*expr321.*expr368.*expr589;
expr1170 = expr1145 + expr1146;
expr1171 = (expr1145 + expr1146).*expr337.*expr370.*expr591 - expr1144.*expr337.*expr371.*expr593;
expr1172 = expr1150 + expr1151 + expr1152 + expr1153 + expr1154 + expr1155;
expr1173 = expr372 - expr1147.*expr352.*expr372 + expr1147.*expr364.*expr599;
expr1174 = 1 - 2.*expr364.*expr372.*expr373 - expr1147.*expr353.*expr373.*expr599 + expr353.*expr372.*expr597.*(expr372 - expr1147.*expr352.*expr372 + expr1147.*expr364.*expr599);
expr1175 = (expr1158 + expr1159 + expr1160).*expr335.*expr611 + (expr1161 + expr1162 + expr1163).*expr351.*expr617 + expr367.*(expr1164 + expr1165 + expr1166 - expr1167.*expr1168.*expr352.*expr353.*expr372.*expr373).*expr621;
expr1176 = -(expr1169.*expr335.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc));
expr1177 = -(expr1171.*expr351.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc));
expr1178 = expr319.*expr364.*((expr1158 + expr1159 + expr1160).*expr335.*expr611 + (expr1161 + expr1162 + expr1163).*expr351.*expr617 + expr367.*(expr1164 + expr1165 + expr1166 - expr1167.*expr1168.*expr352.*expr353.*expr372.*expr373).*expr621).*tpc;
expr1179 = -(expr1174.*expr367.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc));
expr1180 = expr1157.*expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr630;
expr1181 = 2.*expr335.*expr337.*expr364.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*expr630;
expr1182 = expr1140.*expr335.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405.*expr569.*expr570.*expr577.*expr630;
expr1183 = expr1170.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr631;
expr1184 = 2.*expr321.*expr351.*expr364.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*expr631;
expr1185 = expr1148.*expr321.*expr351.*expr353.*expr397.*expr403.*expr404.*expr405.*expr572.*expr573.*expr602.*expr631;
expr1186 = expr1173.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr632;
expr1187 = expr1149.*expr1172.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr409.*expr574.*expr576.*expr632;
expr1188 = expr1156.*expr321.*expr337.*expr367.*expr397.*expr403.*expr404.*expr405.*expr575.*expr576.*expr604.*expr632;
expr1189 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*(expr1175.*expr332.*expr564.*expr633.*expr636.*tpc - expr633.*(expr1176 + expr1175.*expr564.*expr606.*expr638.*tpc + expr1175.*expr320.*expr564.*expr640.*tpc));
expr1190 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*(expr1175.*expr348.*expr564.*expr641.*expr642.*tpc - expr641.*(expr1177 + expr1175.*expr564.*expr607.*expr643.*tpc + expr1175.*expr336.*expr564.*expr645.*tpc));
expr1191 = expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*(-((expr1178 + expr634).*expr646.*expr647) - expr646.*(expr1179 + expr1175.*expr564.*expr608.*expr648.*tpc + expr1175.*expr352.*expr564.*expr650.*tpc));
expr1192 = expr1139 + integrate21 + integrate22 + integrate23 + integrate24 + 200.*(expr1180 + expr1181 + expr1182 + expr1183 + expr1184 + expr1185 + expr1186 + expr1187 + expr1188 + expr1189 + expr1190 + expr1191).*expr651.*WO;
gf(3) = expr1192;

%% Derivative for b(3)
w25 = [ws:(99.*ws)./100:100.*ws];
expr1193 = ((a(1).^2 + b(1).^2).^2 + w25.^2.*(w25.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr1194 = ((a(2).^2 + b(2).^2).^2 + w25.^2.*(w25.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr1195 = -4.*w25.^2.*b(3) + 4.*b(3).*(a(3).^2 + b(3).^2);
expr1196 = ((a(3).^2 + b(3).^2).^2 + w25.^2.*(w25.^2 + 2.*(a(3).^2 - b(3).^2))).^(-2);
expr1197 = (c(1).^2 + d(1).^2).^2 + w25.^2.*(w25.^2 + 2.*(c(1).^2 - d(1).^2));
expr1198 = (c(2).^2 + d(2).^2).^2 + w25.^2.*(w25.^2 + 2.*(c(2).^2 - d(2).^2));
expr1199 = (c(3).^2 + d(3).^2).^2 + w25.^2.*(w25.^2 + 2.*(c(3).^2 - d(3).^2));
expr1200 = ((a(3).^2 + b(3).^2).^2 + w25.^2.*(w25.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr1201 = expr1193.*expr1194.*expr1195.*expr1196.*expr1197.*expr1198.*expr1199.*expr378.*expr379.*expr380.*expr383.*expr385.*expr387.*expr389.*expr391.*Wms + expr1193.*expr1194.*expr1197.*expr1198.*expr1199.*expr1200.*expr352.*expr353.*expr379.*expr380.*expr383.*expr387.*expr389.*expr391.*expr393.*Wms;
integrate25 = trapz(w25, expr1201);
w26 = [0:wp./100:wp];
expr1202 = (a(1).^2 + b(1).^2).^2 + w26.^2.*(w26.^2 + 2.*(a(1).^2 - b(1).^2));
expr1203 = (a(2).^2 + b(2).^2).^2 + w26.^2.*(w26.^2 + 2.*(a(2).^2 - b(2).^2));
expr1204 = -4.*w26.^2.*b(3) + 4.*b(3).*(a(3).^2 + b(3).^2);
expr1205 = (a(3).^2 + b(3).^2).^2 + w26.^2.*(w26.^2 + 2.*(a(3).^2 - b(3).^2));
expr1206 = (c(1).^2 + d(1).^2).^2 + w26.^2.*(w26.^2 + 2.*(c(1).^2 - d(1).^2));
expr1207 = (c(2).^2 + d(2).^2).^2 + w26.^2.*(w26.^2 + 2.*(c(2).^2 - d(2).^2));
expr1208 = (c(3).^2 + d(3).^2).^2 + w26.^2.*(w26.^2 + 2.*(c(3).^2 - d(3).^2));
expr1209 = -1 + (expr1202.*expr1203.*expr1205).^expr397.*(expr1206.*expr1207.*expr1208).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405;
expr1210 = 2.*(expr1202.*expr1203.*expr1205).^expr397.*(expr1206.*expr1207.*expr1208).^expr409.*expr321.*expr337.*expr352.*expr403.*expr404.*expr405;
expr1211 = expr1202.*expr1203.*expr1204.*(expr1202.*expr1203.*expr1205).^expr402.*(expr1206.*expr1207.*expr1208).^expr409.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr1212 = 2.*expr1209.*(expr1210 + expr1211).*expr396.*Wmp;
integrate26 = trapz(w26, expr1212);
w27 = [wp:(-wp + ws)./100:ws];
expr1213 = (a(1).^2 + b(1).^2).^2 + w27.^2.*(w27.^2 + 2.*(a(1).^2 - b(1).^2));
expr1214 = (a(2).^2 + b(2).^2).^2 + w27.^2.*(w27.^2 + 2.*(a(2).^2 - b(2).^2));
expr1215 = -4.*w27.^2.*b(3) + 4.*b(3).*(a(3).^2 + b(3).^2);
expr1216 = (a(3).^2 + b(3).^2).^2 + w27.^2.*(w27.^2 + 2.*(a(3).^2 - b(3).^2));
expr1217 = (c(1).^2 + d(1).^2).^2 + w27.^2.*(w27.^2 + 2.*(c(1).^2 - d(1).^2));
expr1218 = (c(2).^2 + d(2).^2).^2 + w27.^2.*(w27.^2 + 2.*(c(2).^2 - d(2).^2));
expr1219 = (c(3).^2 + d(3).^2).^2 + w27.^2.*(w27.^2 + 2.*(c(3).^2 - d(3).^2));
expr1220 = -(w27./(wp - ws));
expr1221 = 2.*(expr1213.*expr1214.*expr1216).^expr397.*(expr1217.*expr1218.*expr1219).^expr409.*expr321.*expr337.*expr352.*expr403.*expr404.*expr405;
expr1222 = expr1213.*expr1214.*expr1215.*(expr1213.*expr1214.*expr1216).^expr402.*(expr1217.*expr1218.*expr1219).^expr409.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr1223 = expr1220 + (expr1213.*expr1214.*expr1216).^expr397.*(expr1217.*expr1218.*expr1219).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405 + expr423;
expr1224 = 2.*(expr1221 + expr1222).*expr1223.*expr414.*Wmt;
integrate27 = trapz(w27, expr1224);
w28 = [0:wmax./100:wmax];
expr1225 = -(1./(a(3).*(1 + (w28 - b(3)).^2./a(3).^2)));
expr1226 = 1./(a(3).*(1 + (w28 + b(3)).^2./a(3).^2));
expr1227 = -2.*(angle(1 + (i.*(wmax - b(3)))./a(3)) + angle(1 + (i.*(wmax + b(3)))./a(3))).*b(3);
expr1228 = (2.*(wmax - b(3)).*b(3))./(a(3).*(1 + (wmax - b(3)).^2./a(3).^2));
expr1229 = (2.*b(3).*(wmax + b(3)))./(a(3).*(1 + (wmax + b(3)).^2./a(3).^2));
expr1230 = -(1./(a(3).*(1 + (wmax - b(3)).^2./a(3).^2)));
expr1231 = 1./(a(3).*(1 + (wmax + b(3)).^2./a(3).^2));
expr1232 = -(a(3).*log(1 + (wmax - b(3)).^2./a(3).^2));
expr1233 = a(3).*log(1 + (wmax + b(3)).^2./a(3).^2);
expr1234 = angle(1 + (i.*(w28 - b(1)))./a(1));
expr1235 = angle(1 + (i.*(w28 + b(1)))./a(1));
expr1236 = angle(1 + (i.*(w28 - b(2)))./a(2));
expr1237 = angle(1 + (i.*(w28 + b(2)))./a(2));
expr1238 = angle(1 + (i.*(w28 - b(3)))./a(3));
expr1239 = angle(1 + (i.*(w28 + b(3)))./a(3));
expr1240 = -angle(1 + (i.*(w28 - d(1)))./c(1));
expr1241 = -angle(1 + (i.*(w28 + d(1)))./c(1));
expr1242 = -angle(1 + (i.*(w28 - d(2)))./c(2));
expr1243 = -angle(1 + (i.*(w28 + d(2)))./c(2));
expr1244 = -angle(1 + (i.*(w28 - d(3)))./c(3));
expr1245 = -angle(1 + (i.*(w28 + d(3)))./c(3));
expr1246 = expr1225 + expr1226 + expr402.*expr431.*(expr1227 + expr1228 + expr1229 + expr1232 + expr1233 - (expr1230 + expr1231).*expr464).*w28;
expr1247 = 2.*expr1246.*expr428.*(expr1234 + expr1235 + expr1236 + expr1237 + expr1238 + expr1239 + expr1240 + expr1241 + expr1242 + expr1243 + expr1244 + expr1245 - 3.*expr431.*(expr483 + expr484 + expr485 + expr486 + expr487 + expr488).*w28).*Wph;
integrate28 = trapz(w28, expr1247);
expr1248 = -(1./((a(1) - a(3)).*(1 + (b(1) - b(3)).^2./(a(1) - a(3)).^2)));
expr1249 = b(3).^(-2);
expr1250 = -(1./((a(2) - a(3)).*(1 + (b(2) - b(3)).^2./(a(2) - a(3)).^2)));
expr1251 = 1./((-a(1) + a(3)).*(1 + (-b(1) + b(3)).^2./(-a(1) + a(3)).^2));
expr1252 = 1./((-a(2) + a(3)).*(1 + (-b(2) + b(3)).^2./(-a(2) + a(3)).^2));
expr1253 = -(1./((a(3) - c(1)).*(1 + (b(3) - d(1)).^2./(a(3) - c(1)).^2)));
expr1254 = -(1./((a(3) - c(1)).*(1 + (b(3) + d(1)).^2./(a(3) - c(1)).^2)));
expr1255 = -(1./((a(3) - c(2)).*(1 + (b(3) - d(2)).^2./(a(3) - c(2)).^2)));
expr1256 = -(1./((a(3) - c(2)).*(1 + (b(3) + d(2)).^2./(a(3) - c(2)).^2)));
expr1257 = -(1./((a(3) - c(3)).*(1 + (b(3) - d(3)).^2./(a(3) - c(3)).^2)));
expr1258 = -(1./((a(3) - c(3)).*(1 + (b(3) + d(3)).^2./(a(3) - c(3)).^2)));
expr1259 = 2.*b(3);
expr1260 = b(3) + d(3);
expr1261 = b(3) + d(2);
expr1262 = b(3) + d(1);
expr1263 = expr1117.*expr352.*expr491.*expr492.*expr493.*expr494.*expr495.*(-(expr491.*expr492.*expr493.*expr494.*expr495.*expr496)).^expr497.*expr720.*WQ;
expr1264 = -2.*expr500.*expr501.*expr503.*expr541 + 2.*expr500.*expr501.*expr502.*expr722;
expr1265 = expr332.*(expr1248 + expr730).*cos(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331) - expr320.*(expr1248 + expr730).*sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331);
expr1266 = expr1248 + expr730;
expr1267 = expr1250 + expr994;
expr1268 = expr348.*(expr1250 + expr994).*cos(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347) - expr336.*(expr1250 + expr994).*sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347);
expr1269 = expr1003 + expr1251 + expr1252 + expr1253 + expr1254 + expr1255 + expr1256 + expr1257 + expr1258 + expr741;
expr1270 = expr364.*(expr1003 + expr1251 + expr1252 + expr1253 + expr1254 + expr1255 + expr1256 + expr1257 + expr1258 + expr741).*cos(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363);
expr1271 = -(expr352.*(expr1003 + expr1251 + expr1252 + expr1253 + expr1254 + expr1255 + expr1256 + expr1257 + expr1258 + expr741).*sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363));
expr1272 = 2.*expr1004.*expr510.*expr511.*expr512 - 2.*expr510.*expr511.*expr513.*expr857;
expr1273 = 2.*expr1260.*expr524.*expr525.*expr526.*expr527.*expr528;
expr1274 = 2.*expr1133.*expr524.*expr525.*expr526.*expr527.*expr529;
expr1275 = 2.*expr1261.*expr524.*expr525.*expr526.*expr528.*expr529;
expr1276 = 2.*expr1129.*expr524.*expr525.*expr527.*expr528.*expr529;
expr1277 = 2.*expr1262.*expr524.*expr526.*expr527.*expr528.*expr529;
expr1278 = 2.*expr1125.*expr525.*expr526.*expr527.*expr528.*expr529;
expr1279 = 2.*expr1004.*expr520.*expr521.*expr522 + 2.*expr521.*expr522.*expr523.*expr561 + 2.*expr520.*expr522.*expr523.*expr722 + 2.*expr520.*expr521.*expr523.*expr873;
expr1280 = (expr1266.*expr320.*expr321.*expr369.*expr587)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369);
expr1281 = -((expr1265.*expr320.*expr321.*expr368.*expr589)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369));
expr1282 = -((expr320.*expr321.*expr368.*expr369.*(-(expr1266.*expr321.*expr332.*expr369.*expr587) + expr1265.*expr321.*expr332.*expr368.*expr589))./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369).^2);
expr1283 = -((expr1268.*expr336.*expr337.*expr370.*expr591)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371));
expr1284 = (expr1267.*expr336.*expr337.*expr371.*expr593)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371);
expr1285 = -((expr336.*expr337.*expr370.*expr371.*(expr1268.*expr337.*expr348.*expr370.*expr591 - expr1267.*expr337.*expr348.*expr371.*expr593))./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371).^2);
expr1286 = (expr353.*expr372.*expr373)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373);
expr1287 = (2.*expr366.*expr372.*expr373)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373);
expr1288 = (expr1269.*expr352.*expr353.*expr373.*expr599)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373);
expr1289 = -((expr352.*expr353.*expr372.*expr597.*(expr1270 + expr1271 + expr599))./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373));
expr1290 = expr1259 - 2.*expr352.*expr364.*expr372.*expr373 - expr1269.*expr353.*expr364.*expr373.*expr599 + expr353.*expr364.*expr372.*expr597.*(expr1270 + expr1271 + expr599);
expr1291 = expr1249.*(pi - angle(1 + (expr352.*expr353.*expr372.*expr373.*i)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373)));
expr1292 = -(expr1266.*expr321.*expr369.*expr587) + expr1265.*expr321.*expr368.*expr589;
expr1293 = expr1268.*expr337.*expr370.*expr591 - expr1267.*expr337.*expr371.*expr593;
expr1294 = expr1273 + expr1274 + expr1275 + expr1276 + expr1277 + expr1278;
expr1295 = expr1270 + expr1271 + expr599;
expr1296 = -2.*expr352.*expr372.*expr373 - expr1269.*expr353.*expr373.*expr599 + expr353.*expr372.*expr597.*(expr1270 + expr1271 + expr599);
expr1297 = expr1291 + (expr1280 + expr1281 + expr1282).*expr335.*expr611 + (expr1283 + expr1284 + expr1285).*expr351.*expr617 + expr367.*(expr1286 + expr1287 + expr1288 + expr1289 - expr1167.*expr1290.*expr352.*expr353.*expr372.*expr373).*expr621;
expr1298 = -(expr1292.*expr335.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc));
expr1299 = -(expr1293.*expr351.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc));
expr1300 = expr319.*expr352.*(expr1291 + (expr1280 + expr1281 + expr1282).*expr335.*expr611 + (expr1283 + expr1284 + expr1285).*expr351.*expr617 + expr367.*(expr1286 + expr1287 + expr1288 + expr1289 - expr1167.*expr1290.*expr352.*expr353.*expr372.*expr373).*expr621).*tpc;
expr1301 = -(expr1296.*expr367.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc));
expr1302 = expr1249.*expr608.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr1303 = expr1265.*expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr630;
expr1304 = 2.*expr335.*expr337.*expr352.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*expr630;
expr1305 = expr1264.*expr335.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405.*expr569.*expr570.*expr577.*expr630;
expr1306 = expr1268.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr631;
expr1307 = 2.*expr321.*expr351.*expr352.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*expr631;
expr1308 = expr1272.*expr321.*expr351.*expr353.*expr397.*expr403.*expr404.*expr405.*expr572.*expr573.*expr602.*expr631;
expr1309 = expr1295.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr632;
expr1310 = expr1149.*expr1294.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr409.*expr574.*expr576.*expr632;
expr1311 = -(expr1249.*expr321.*expr337.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*expr632);
expr1312 = expr1279.*expr321.*expr337.*expr367.*expr397.*expr403.*expr404.*expr405.*expr575.*expr576.*expr604.*expr632;
expr1313 = expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*(-(expr646.*(expr1301 + expr1302 - expr367.*expr608.*(expr1300 + expr634).*expr648 - (expr1300 + expr634).*expr650)) + expr1297.*expr364.*expr564.*expr646.*expr647.*tpc);
expr1314 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*(expr1297.*expr332.*expr564.*expr633.*expr636.*tpc - expr633.*(expr1298 + expr1297.*expr564.*expr606.*expr638.*tpc + expr1297.*expr320.*expr564.*expr640.*tpc));
expr1315 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*(expr1297.*expr348.*expr564.*expr641.*expr642.*tpc - expr641.*(expr1299 + expr1297.*expr564.*expr607.*expr643.*tpc + expr1297.*expr336.*expr564.*expr645.*tpc));
expr1316 = expr1263 + integrate25 + integrate26 + integrate27 + integrate28 + 200.*(expr1303 + expr1304 + expr1305 + expr1306 + expr1307 + expr1308 + expr1309 + expr1310 + expr1311 + expr1312 + expr1313 + expr1314 + expr1315).*expr651.*WO;
gf(6) = expr1316;

%% Derivative for c(1)
w29 = [ws:(99.*ws)./100:100.*ws];
expr1317 = 1./99;
expr1318 = ((a(1).^2 + b(1).^2).^2 + w29.^2.*(w29.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr1319 = ((a(2).^2 + b(2).^2).^2 + w29.^2.*(w29.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr1320 = ((a(3).^2 + b(3).^2).^2 + w29.^2.*(w29.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr1321 = 4.*w29.^2.*c(1) + 4.*c(1).*(c(1).^2 + d(1).^2);
expr1322 = (c(2).^2 + d(2).^2).^2 + w29.^2.*(w29.^2 + 2.*(c(2).^2 - d(2).^2));
expr1323 = (c(3).^2 + d(3).^2).^2 + w29.^2.*(w29.^2 + 2.*(c(3).^2 - d(3).^2));
expr1324 = -4./99;
expr1325 = c(1);
expr1326 = (c(1).^2 + d(1).^2).^(-3);
expr1327 = (c(1).^2 + d(1).^2).^2 + w29.^2.*(w29.^2 + 2.*(c(1).^2 - d(1).^2));
expr1328 = expr1318.*expr1319.*expr1320.*expr1322.*expr1323.*expr1324.*expr1325.*expr1326.*expr1327.*expr379.*expr380.*expr383.*expr385.*expr389.*expr391.*Wms + expr1317.*expr1318.*expr1319.*expr1320.*expr1321.*expr1322.*expr1323.*expr379.*expr380.*expr383.*expr385.*expr387.*expr389.*expr391.*Wms;
integrate29 = trapz(w29, expr1328);
w30 = [0:wp./100:wp];
expr1329 = (a(1).^2 + b(1).^2).^2 + w30.^2.*(w30.^2 + 2.*(a(1).^2 - b(1).^2));
expr1330 = (a(2).^2 + b(2).^2).^2 + w30.^2.*(w30.^2 + 2.*(a(2).^2 - b(2).^2));
expr1331 = (a(3).^2 + b(3).^2).^2 + w30.^2.*(w30.^2 + 2.*(a(3).^2 - b(3).^2));
expr1332 = 4.*w30.^2.*c(1) + 4.*c(1).*(c(1).^2 + d(1).^2);
expr1333 = (c(2).^2 + d(2).^2).^2 + w30.^2.*(w30.^2 + 2.*(c(2).^2 - d(2).^2));
expr1334 = (c(3).^2 + d(3).^2).^2 + w30.^2.*(w30.^2 + 2.*(c(3).^2 - d(3).^2));
expr1335 = (c(1).^2 + d(1).^2).^2 + w30.^2.*(w30.^2 + 2.*(c(1).^2 - d(1).^2));
expr1336 = -1 + (expr1329.*expr1330.*expr1331).^expr397.*(expr1333.*expr1334.*expr1335).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405;
expr1337 = -2.*expr1325.*(expr1329.*expr1330.*expr1331).^expr397.*(expr1333.*expr1334.*expr1335).^expr409.*expr321.*expr337.*expr353.*expr387.*expr404.*expr405;
expr1338 = (expr1329.*expr1330.*expr1331).^expr397.*expr1332.*expr1333.*expr1334.*(expr1333.*expr1334.*expr1335).^expr397.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr1339 = 2.*expr1336.*(expr1337 + expr1338).*expr396.*Wmp;
integrate30 = trapz(w30, expr1339);
w31 = [wp:(-wp + ws)./100:ws];
expr1340 = (a(1).^2 + b(1).^2).^2 + w31.^2.*(w31.^2 + 2.*(a(1).^2 - b(1).^2));
expr1341 = (a(2).^2 + b(2).^2).^2 + w31.^2.*(w31.^2 + 2.*(a(2).^2 - b(2).^2));
expr1342 = (a(3).^2 + b(3).^2).^2 + w31.^2.*(w31.^2 + 2.*(a(3).^2 - b(3).^2));
expr1343 = 4.*w31.^2.*c(1) + 4.*c(1).*(c(1).^2 + d(1).^2);
expr1344 = (c(2).^2 + d(2).^2).^2 + w31.^2.*(w31.^2 + 2.*(c(2).^2 - d(2).^2));
expr1345 = (c(3).^2 + d(3).^2).^2 + w31.^2.*(w31.^2 + 2.*(c(3).^2 - d(3).^2));
expr1346 = (c(1).^2 + d(1).^2).^2 + w31.^2.*(w31.^2 + 2.*(c(1).^2 - d(1).^2));
expr1347 = -(w31./(wp - ws));
expr1348 = -2.*expr1325.*(expr1340.*expr1341.*expr1342).^expr397.*(expr1344.*expr1345.*expr1346).^expr409.*expr321.*expr337.*expr353.*expr387.*expr404.*expr405;
expr1349 = (expr1340.*expr1341.*expr1342).^expr397.*expr1343.*expr1344.*expr1345.*(expr1344.*expr1345.*expr1346).^expr397.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr1350 = expr1347 + (expr1340.*expr1341.*expr1342).^expr397.*(expr1344.*expr1345.*expr1346).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405 + expr423;
expr1351 = 2.*(expr1348 + expr1349).*expr1350.*expr414.*Wmt;
integrate31 = trapz(w31, expr1351);
w32 = [0:wmax./100:wmax];
expr1352 = (w32 - d(1))./(c(1).^2.*(1 + (w32 - d(1)).^2./c(1).^2));
expr1353 = (w32 + d(1))./(c(1).^2.*(1 + (w32 + d(1)).^2./c(1).^2));
expr1354 = 2.*wmax;
expr1355 = -2.*(angle(1 + (i.*(wmax - d(1)))./c(1)) + angle(1 + (i.*(wmax + d(1)))./c(1))).*c(1);
expr1356 = (-2.*(wmax - d(1)).^2.*d(1))./(c(1).^2.*(1 + (wmax - d(1)).^2./c(1).^2));
expr1357 = (2.*d(1).*(wmax + d(1)).^2)./(c(1).^2.*(1 + (wmax + d(1)).^2./c(1).^2));
expr1358 = -((wmax - d(1))./(c(1).^2.*(1 + (wmax - d(1)).^2./c(1).^2)));
expr1359 = -((wmax + d(1))./(c(1).^2.*(1 + (wmax + d(1)).^2./c(1).^2)));
expr1360 = d(1).*log(1 + (wmax - d(1)).^2./c(1).^2);
expr1361 = -(d(1).*log(1 + (wmax + d(1)).^2./c(1).^2));
expr1362 = angle(1 + (i.*(w32 - b(1)))./a(1));
expr1363 = angle(1 + (i.*(w32 + b(1)))./a(1));
expr1364 = angle(1 + (i.*(w32 - b(2)))./a(2));
expr1365 = angle(1 + (i.*(w32 + b(2)))./a(2));
expr1366 = angle(1 + (i.*(w32 - b(3)))./a(3));
expr1367 = angle(1 + (i.*(w32 + b(3)))./a(3));
expr1368 = -angle(1 + (i.*(w32 - d(1)))./c(1));
expr1369 = -angle(1 + (i.*(w32 + d(1)))./c(1));
expr1370 = -angle(1 + (i.*(w32 - d(2)))./c(2));
expr1371 = -angle(1 + (i.*(w32 + d(2)))./c(2));
expr1372 = -angle(1 + (i.*(w32 - d(3)))./c(3));
expr1373 = -angle(1 + (i.*(w32 + d(3)))./c(3));
expr1374 = expr1352 + expr1353 + expr402.*expr431.*(expr1354 + expr1355 + expr1356 + expr1357 + expr1360 + expr1361 + (expr1358 + expr1359).*expr469).*w32;
expr1375 = 2.*expr1374.*expr428.*(expr1362 + expr1363 + expr1364 + expr1365 + expr1366 + expr1367 + expr1368 + expr1369 + expr1370 + expr1371 + expr1372 + expr1373 - 3.*expr431.*(expr483 + expr484 + expr485 + expr486 + expr487 + expr488).*w32).*Wph;
integrate32 = trapz(w32, expr1375);
expr1376 = -((b(1) + d(1))./((a(1) - c(1)).^2.*(1 + (b(1) + d(1)).^2./(a(1) - c(1)).^2)));
expr1377 = -((b(2) + d(1))./((a(2) - c(1)).^2.*(1 + (b(2) + d(1)).^2./(a(2) - c(1)).^2)));
expr1378 = -((b(3) + d(1))./((a(3) - c(1)).^2.*(1 + (b(3) + d(1)).^2./(a(3) - c(1)).^2)));
expr1379 = -2.*expr504.*expr506.*expr507.*expr508.*expr509.*expr534 - 2.*expr505.*expr506.*expr507.*expr508.*expr509.*expr534;
expr1380 = expr332.*(expr1376 - expr543.*expr544.*expr545).*cos(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331);
expr1381 = -(expr320.*(expr1376 - expr543.*expr544.*expr545).*sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331));
expr1382 = expr1376 - expr543.*expr544.*expr545;
expr1383 = expr1377 - expr859.*expr860.*expr861;
expr1384 = expr348.*(expr1377 - expr859.*expr860.*expr861).*cos(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347);
expr1385 = -(expr336.*(expr1377 - expr859.*expr860.*expr861).*sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347));
expr1386 = (-(expr1123.*expr1124.*expr1125) + expr1378).*expr364.*cos(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363);
expr1387 = -((-(expr1123.*expr1124.*expr1125) + expr1378).*expr352.*sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363));
expr1388 = -(expr1123.*expr1124.*expr1125) + expr1378;
expr1389 = -2.*expr514.*expr516.*expr517.*expr518.*expr519.*expr879 - 2.*expr515.*expr516.*expr517.*expr518.*expr519.*expr879;
expr1390 = -2.*expr1138.*expr524.*expr526.*expr527.*expr528.*expr529 - 2.*expr1138.*expr525.*expr526.*expr527.*expr528.*expr529;
expr1391 = expr1380 + expr1381;
expr1392 = (expr1382.*expr320.*expr321.*expr369.*expr587)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369);
expr1393 = -(((expr1380 + expr1381).*expr320.*expr321.*expr368.*expr589)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369));
expr1394 = -((expr320.*expr321.*expr368.*expr369.*(-(expr1382.*expr321.*expr332.*expr369.*expr587) + (expr1380 + expr1381).*expr321.*expr332.*expr368.*expr589))./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369).^2);
expr1395 = -(((expr1384 + expr1385).*expr336.*expr337.*expr370.*expr591)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371));
expr1396 = (expr1383.*expr336.*expr337.*expr371.*expr593)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371);
expr1397 = -((expr336.*expr337.*expr370.*expr371.*((expr1384 + expr1385).*expr337.*expr348.*expr370.*expr591 - expr1383.*expr337.*expr348.*expr371.*expr593))./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371).^2);
expr1398 = -(((expr1386 + expr1387).*expr352.*expr353.*expr372.*expr597)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373));
expr1399 = (expr1388.*expr352.*expr353.*expr373.*expr599)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373);
expr1400 = -((expr352.*expr353.*expr372.*expr373.*((expr1386 + expr1387).*expr353.*expr364.*expr372.*expr597 - expr1388.*expr353.*expr364.*expr373.*expr599))./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373).^2);
expr1401 = -(expr1382.*expr321.*expr369.*expr587) + (expr1380 + expr1381).*expr321.*expr368.*expr589;
expr1402 = expr1384 + expr1385;
expr1403 = (expr1384 + expr1385).*expr337.*expr370.*expr591 - expr1383.*expr337.*expr371.*expr593;
expr1404 = expr1386 + expr1387;
expr1405 = (expr1386 + expr1387).*expr353.*expr372.*expr597 - expr1388.*expr353.*expr373.*expr599;
expr1406 = (expr1392 + expr1393 + expr1394).*expr335.*expr611 + (expr1395 + expr1396 + expr1397).*expr351.*expr617 + (expr1398 + expr1399 + expr1400).*expr367.*expr621;
expr1407 = expr564.*expr606.*((expr1392 + expr1393 + expr1394).*expr335.*expr611 + (expr1395 + expr1396 + expr1397).*expr351.*expr617 + (expr1398 + expr1399 + expr1400).*expr367.*expr621).*tpc.*cos(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr1408 = -(expr1401.*expr335.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc));
expr1409 = expr320.*expr564.*((expr1392 + expr1393 + expr1394).*expr335.*expr611 + (expr1395 + expr1396 + expr1397).*expr351.*expr617 + (expr1398 + expr1399 + expr1400).*expr367.*expr621).*tpc.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr1410 = expr564.*expr607.*((expr1392 + expr1393 + expr1394).*expr335.*expr611 + (expr1395 + expr1396 + expr1397).*expr351.*expr617 + (expr1398 + expr1399 + expr1400).*expr367.*expr621).*tpc.*cos(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr1411 = -(expr1403.*expr351.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc));
expr1412 = expr336.*expr564.*((expr1392 + expr1393 + expr1394).*expr335.*expr611 + (expr1395 + expr1396 + expr1397).*expr351.*expr617 + (expr1398 + expr1399 + expr1400).*expr367.*expr621).*tpc.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr1413 = expr564.*expr608.*((expr1392 + expr1393 + expr1394).*expr335.*expr611 + (expr1395 + expr1396 + expr1397).*expr351.*expr617 + (expr1398 + expr1399 + expr1400).*expr367.*expr621).*tpc.*cos(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr1414 = -(expr1405.*expr367.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc));
expr1415 = expr352.*expr564.*((expr1392 + expr1393 + expr1394).*expr335.*expr611 + (expr1395 + expr1396 + expr1397).*expr351.*expr617 + (expr1398 + expr1399 + expr1400).*expr367.*expr621).*tpc.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr1416 = expr1391.*expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr630;
expr1417 = -2.*expr1325.*expr335.*expr337.*expr353.*expr387.*expr404.*expr405.*expr568.*expr569.*expr570.*expr630;
expr1418 = expr1379.*expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409.*expr568.*expr570.*expr579.*expr630;
expr1419 = expr1402.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr631;
expr1420 = -2.*expr1325.*expr321.*expr351.*expr353.*expr387.*expr404.*expr405.*expr571.*expr572.*expr573.*expr631;
expr1421 = expr1404.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr632;
expr1422 = expr1149.*expr1390.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr409.*expr574.*expr576.*expr632;
expr1423 = -2.*expr1325.*expr321.*expr337.*expr367.*expr387.*expr404.*expr405.*expr574.*expr575.*expr576.*expr632;
expr1424 = expr1389.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr409.*expr571.*expr573.*expr631.*expr891;
expr1425 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*(-((expr1407 + expr1408 + expr1409).*expr633) + expr1406.*expr332.*expr564.*expr633.*expr636.*tpc);
expr1426 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*(-((expr1410 + expr1411 + expr1412).*expr641) + expr1406.*expr348.*expr564.*expr641.*expr642.*tpc);
expr1427 = expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*(-((expr1413 + expr1414 + expr1415).*expr646) + expr1406.*expr364.*expr564.*expr646.*expr647.*tpc);
expr1428 = integrate29 + integrate30 + integrate31 + integrate32 + 200.*(expr1416 + expr1417 + expr1418 + expr1419 + expr1420 + expr1421 + expr1422 + expr1423 + expr1424 + expr1425 + expr1426 + expr1427).*expr651.*WO;
gf(7) = expr1428;

%% Derivative for d(1)
w33 = [ws:(99.*ws)./100:100.*ws];
expr1429 = ((a(1).^2 + b(1).^2).^2 + w33.^2.*(w33.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr1430 = ((a(2).^2 + b(2).^2).^2 + w33.^2.*(w33.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr1431 = ((a(3).^2 + b(3).^2).^2 + w33.^2.*(w33.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr1432 = -4.*w33.^2.*d(1) + 4.*d(1).*(c(1).^2 + d(1).^2);
expr1433 = (c(2).^2 + d(2).^2).^2 + w33.^2.*(w33.^2 + 2.*(c(2).^2 - d(2).^2));
expr1434 = (c(3).^2 + d(3).^2).^2 + w33.^2.*(w33.^2 + 2.*(c(3).^2 - d(3).^2));
expr1435 = d(1);
expr1436 = (c(1).^2 + d(1).^2).^2 + w33.^2.*(w33.^2 + 2.*(c(1).^2 - d(1).^2));
expr1437 = expr1324.*expr1326.*expr1429.*expr1430.*expr1431.*expr1433.*expr1434.*expr1435.*expr1436.*expr379.*expr380.*expr383.*expr385.*expr389.*expr391.*Wms + expr1317.*expr1429.*expr1430.*expr1431.*expr1432.*expr1433.*expr1434.*expr379.*expr380.*expr383.*expr385.*expr387.*expr389.*expr391.*Wms;
integrate33 = trapz(w33, expr1437);
w34 = [0:wp./100:wp];
expr1438 = (a(1).^2 + b(1).^2).^2 + w34.^2.*(w34.^2 + 2.*(a(1).^2 - b(1).^2));
expr1439 = (a(2).^2 + b(2).^2).^2 + w34.^2.*(w34.^2 + 2.*(a(2).^2 - b(2).^2));
expr1440 = (a(3).^2 + b(3).^2).^2 + w34.^2.*(w34.^2 + 2.*(a(3).^2 - b(3).^2));
expr1441 = -4.*w34.^2.*d(1) + 4.*d(1).*(c(1).^2 + d(1).^2);
expr1442 = (c(2).^2 + d(2).^2).^2 + w34.^2.*(w34.^2 + 2.*(c(2).^2 - d(2).^2));
expr1443 = (c(3).^2 + d(3).^2).^2 + w34.^2.*(w34.^2 + 2.*(c(3).^2 - d(3).^2));
expr1444 = (c(1).^2 + d(1).^2).^2 + w34.^2.*(w34.^2 + 2.*(c(1).^2 - d(1).^2));
expr1445 = -1 + (expr1438.*expr1439.*expr1440).^expr397.*(expr1442.*expr1443.*expr1444).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405;
expr1446 = -2.*expr1435.*(expr1438.*expr1439.*expr1440).^expr397.*(expr1442.*expr1443.*expr1444).^expr409.*expr321.*expr337.*expr353.*expr387.*expr404.*expr405;
expr1447 = (expr1438.*expr1439.*expr1440).^expr397.*expr1441.*expr1442.*expr1443.*(expr1442.*expr1443.*expr1444).^expr397.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr1448 = 2.*expr1445.*(expr1446 + expr1447).*expr396.*Wmp;
integrate34 = trapz(w34, expr1448);
w35 = [wp:(-wp + ws)./100:ws];
expr1449 = (a(1).^2 + b(1).^2).^2 + w35.^2.*(w35.^2 + 2.*(a(1).^2 - b(1).^2));
expr1450 = (a(2).^2 + b(2).^2).^2 + w35.^2.*(w35.^2 + 2.*(a(2).^2 - b(2).^2));
expr1451 = (a(3).^2 + b(3).^2).^2 + w35.^2.*(w35.^2 + 2.*(a(3).^2 - b(3).^2));
expr1452 = -4.*w35.^2.*d(1) + 4.*d(1).*(c(1).^2 + d(1).^2);
expr1453 = (c(2).^2 + d(2).^2).^2 + w35.^2.*(w35.^2 + 2.*(c(2).^2 - d(2).^2));
expr1454 = (c(3).^2 + d(3).^2).^2 + w35.^2.*(w35.^2 + 2.*(c(3).^2 - d(3).^2));
expr1455 = (c(1).^2 + d(1).^2).^2 + w35.^2.*(w35.^2 + 2.*(c(1).^2 - d(1).^2));
expr1456 = -(w35./(wp - ws));
expr1457 = -2.*expr1435.*(expr1449.*expr1450.*expr1451).^expr397.*(expr1453.*expr1454.*expr1455).^expr409.*expr321.*expr337.*expr353.*expr387.*expr404.*expr405;
expr1458 = (expr1449.*expr1450.*expr1451).^expr397.*expr1452.*expr1453.*expr1454.*(expr1453.*expr1454.*expr1455).^expr397.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr1459 = expr1456 + (expr1449.*expr1450.*expr1451).^expr397.*(expr1453.*expr1454.*expr1455).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405 + expr423;
expr1460 = 2.*(expr1457 + expr1458).*expr1459.*expr414.*Wmt;
integrate35 = trapz(w35, expr1460);
w36 = [0:wmax./100:wmax];
expr1461 = 1./(c(1).*(1 + (w36 - d(1)).^2./c(1).^2));
expr1462 = -(1./(c(1).*(1 + (w36 + d(1)).^2./c(1).^2)));
expr1463 = 2.*(angle(1 + (i.*(wmax - d(1)))./c(1)) + angle(1 + (i.*(wmax + d(1)))./c(1))).*d(1);
expr1464 = (-2.*(wmax - d(1)).*d(1))./(c(1).*(1 + (wmax - d(1)).^2./c(1).^2));
expr1465 = (-2.*d(1).*(wmax + d(1)))./(c(1).*(1 + (wmax + d(1)).^2./c(1).^2));
expr1466 = -(1./(c(1).*(1 + (wmax - d(1)).^2./c(1).^2)));
expr1467 = 1./(c(1).*(1 + (wmax + d(1)).^2./c(1).^2));
expr1468 = c(1).*log(1 + (wmax - d(1)).^2./c(1).^2);
expr1469 = -(c(1).*log(1 + (wmax + d(1)).^2./c(1).^2));
expr1470 = angle(1 + (i.*(w36 - b(1)))./a(1));
expr1471 = angle(1 + (i.*(w36 + b(1)))./a(1));
expr1472 = angle(1 + (i.*(w36 - b(2)))./a(2));
expr1473 = angle(1 + (i.*(w36 + b(2)))./a(2));
expr1474 = angle(1 + (i.*(w36 - b(3)))./a(3));
expr1475 = angle(1 + (i.*(w36 + b(3)))./a(3));
expr1476 = -angle(1 + (i.*(w36 - d(1)))./c(1));
expr1477 = -angle(1 + (i.*(w36 + d(1)))./c(1));
expr1478 = -angle(1 + (i.*(w36 - d(2)))./c(2));
expr1479 = -angle(1 + (i.*(w36 + d(2)))./c(2));
expr1480 = -angle(1 + (i.*(w36 - d(3)))./c(3));
expr1481 = -angle(1 + (i.*(w36 + d(3)))./c(3));
expr1482 = expr1461 + expr1462 + expr402.*expr431.*(expr1463 + expr1464 + expr1465 + expr1468 + expr1469 + (expr1466 + expr1467).*expr469).*w36;
expr1483 = 2.*expr1482.*expr428.*(expr1470 + expr1471 + expr1472 + expr1473 + expr1474 + expr1475 + expr1476 + expr1477 + expr1478 + expr1479 + expr1480 + expr1481 - 3.*expr431.*(expr483 + expr484 + expr485 + expr486 + expr487 + expr488).*w36).*Wph;
integrate36 = trapz(w36, expr1483);
expr1484 = 1./((a(1) - c(1)).*(1 + (b(1) - d(1)).^2./(a(1) - c(1)).^2));
expr1485 = 1./((a(2) - c(1)).*(1 + (b(2) - d(1)).^2./(a(2) - c(1)).^2));
expr1486 = 1./((a(3) - c(1)).*(1 + (b(3) - d(1)).^2./(a(3) - c(1)).^2));
expr1487 = -2.*expr505.*expr506.*expr507.*expr508.*expr509.*expr545 + 2.*expr504.*expr506.*expr507.*expr508.*expr509.*expr726;
expr1488 = expr332.*(expr1484 + expr732).*cos(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331) - expr320.*(expr1484 + expr732).*sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331);
expr1489 = expr1484 + expr732;
expr1490 = expr1485 + expr996;
expr1491 = expr348.*(expr1485 + expr996).*cos(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347) - expr336.*(expr1485 + expr996).*sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347);
expr1492 = (expr1254 + expr1486).*expr364.*cos(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363) - (expr1254 + expr1486).*expr352.*sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363);
expr1493 = expr1254 + expr1486;
expr1494 = 2.*expr1007.*expr514.*expr516.*expr517.*expr518.*expr519 - 2.*expr515.*expr516.*expr517.*expr518.*expr519.*expr861;
expr1495 = 2.*expr1262.*expr524.*expr526.*expr527.*expr528.*expr529 - 2.*expr1125.*expr525.*expr526.*expr527.*expr528.*expr529;
expr1496 = (expr1489.*expr320.*expr321.*expr369.*expr587)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369);
expr1497 = -((expr1488.*expr320.*expr321.*expr368.*expr589)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369));
expr1498 = -((expr320.*expr321.*expr368.*expr369.*(-(expr1489.*expr321.*expr332.*expr369.*expr587) + expr1488.*expr321.*expr332.*expr368.*expr589))./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369).^2);
expr1499 = -((expr1491.*expr336.*expr337.*expr370.*expr591)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371));
expr1500 = (expr1490.*expr336.*expr337.*expr371.*expr593)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371);
expr1501 = -((expr336.*expr337.*expr370.*expr371.*(expr1491.*expr337.*expr348.*expr370.*expr591 - expr1490.*expr337.*expr348.*expr371.*expr593))./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371).^2);
expr1502 = -((expr1492.*expr352.*expr353.*expr372.*expr597)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373));
expr1503 = (expr1493.*expr352.*expr353.*expr373.*expr599)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373);
expr1504 = -((expr352.*expr353.*expr372.*expr373.*(expr1492.*expr353.*expr364.*expr372.*expr597 - expr1493.*expr353.*expr364.*expr373.*expr599))./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373).^2);
expr1505 = -(expr1489.*expr321.*expr369.*expr587) + expr1488.*expr321.*expr368.*expr589;
expr1506 = expr1491.*expr337.*expr370.*expr591 - expr1490.*expr337.*expr371.*expr593;
expr1507 = expr1492.*expr353.*expr372.*expr597 - expr1493.*expr353.*expr373.*expr599;
expr1508 = (expr1496 + expr1497 + expr1498).*expr335.*expr611 + (expr1499 + expr1500 + expr1501).*expr351.*expr617 + (expr1502 + expr1503 + expr1504).*expr367.*expr621;
expr1509 = expr564.*expr606.*((expr1496 + expr1497 + expr1498).*expr335.*expr611 + (expr1499 + expr1500 + expr1501).*expr351.*expr617 + (expr1502 + expr1503 + expr1504).*expr367.*expr621).*tpc.*cos(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr1510 = -(expr1505.*expr335.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc));
expr1511 = expr320.*expr564.*((expr1496 + expr1497 + expr1498).*expr335.*expr611 + (expr1499 + expr1500 + expr1501).*expr351.*expr617 + (expr1502 + expr1503 + expr1504).*expr367.*expr621).*tpc.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr1512 = expr564.*expr607.*((expr1496 + expr1497 + expr1498).*expr335.*expr611 + (expr1499 + expr1500 + expr1501).*expr351.*expr617 + (expr1502 + expr1503 + expr1504).*expr367.*expr621).*tpc.*cos(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr1513 = -(expr1506.*expr351.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc));
expr1514 = expr336.*expr564.*((expr1496 + expr1497 + expr1498).*expr335.*expr611 + (expr1499 + expr1500 + expr1501).*expr351.*expr617 + (expr1502 + expr1503 + expr1504).*expr367.*expr621).*tpc.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr1515 = expr564.*expr608.*((expr1496 + expr1497 + expr1498).*expr335.*expr611 + (expr1499 + expr1500 + expr1501).*expr351.*expr617 + (expr1502 + expr1503 + expr1504).*expr367.*expr621).*tpc.*cos(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr1516 = -(expr1507.*expr367.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc));
expr1517 = expr352.*expr564.*((expr1496 + expr1497 + expr1498).*expr335.*expr611 + (expr1499 + expr1500 + expr1501).*expr351.*expr617 + (expr1502 + expr1503 + expr1504).*expr367.*expr621).*tpc.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr1518 = expr1488.*expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr630;
expr1519 = -2.*expr1435.*expr335.*expr337.*expr353.*expr387.*expr404.*expr405.*expr568.*expr569.*expr570.*expr630;
expr1520 = expr1487.*expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409.*expr568.*expr570.*expr579.*expr630;
expr1521 = expr1491.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr631;
expr1522 = -2.*expr1435.*expr321.*expr351.*expr353.*expr387.*expr404.*expr405.*expr571.*expr572.*expr573.*expr631;
expr1523 = expr1492.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr632;
expr1524 = expr1149.*expr1495.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr409.*expr574.*expr576.*expr632;
expr1525 = -2.*expr1435.*expr321.*expr337.*expr367.*expr387.*expr404.*expr405.*expr574.*expr575.*expr576.*expr632;
expr1526 = expr1494.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr409.*expr571.*expr573.*expr631.*expr891;
expr1527 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*(-((expr1509 + expr1510 + expr1511).*expr633) + expr1508.*expr332.*expr564.*expr633.*expr636.*tpc);
expr1528 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*(-((expr1512 + expr1513 + expr1514).*expr641) + expr1508.*expr348.*expr564.*expr641.*expr642.*tpc);
expr1529 = expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*(-((expr1515 + expr1516 + expr1517).*expr646) + expr1508.*expr364.*expr564.*expr646.*expr647.*tpc);
expr1530 = integrate33 + integrate34 + integrate35 + integrate36 + 200.*(expr1518 + expr1519 + expr1520 + expr1521 + expr1522 + expr1523 + expr1524 + expr1525 + expr1526 + expr1527 + expr1528 + expr1529).*expr651.*WO;
gf(10) = expr1530;

%% Derivative for c(2)
w37 = [ws:(99.*ws)./100:100.*ws];
expr1531 = ((a(1).^2 + b(1).^2).^2 + w37.^2.*(w37.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr1532 = ((a(2).^2 + b(2).^2).^2 + w37.^2.*(w37.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr1533 = ((a(3).^2 + b(3).^2).^2 + w37.^2.*(w37.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr1534 = (c(1).^2 + d(1).^2).^2 + w37.^2.*(w37.^2 + 2.*(c(1).^2 - d(1).^2));
expr1535 = 4.*w37.^2.*c(2) + 4.*c(2).*(c(2).^2 + d(2).^2);
expr1536 = (c(3).^2 + d(3).^2).^2 + w37.^2.*(w37.^2 + 2.*(c(3).^2 - d(3).^2));
expr1537 = c(2);
expr1538 = (c(2).^2 + d(2).^2).^(-3);
expr1539 = (c(2).^2 + d(2).^2).^2 + w37.^2.*(w37.^2 + 2.*(c(2).^2 - d(2).^2));
expr1540 = expr1324.*expr1531.*expr1532.*expr1533.*expr1534.*expr1536.*expr1537.*expr1538.*expr1539.*expr379.*expr380.*expr383.*expr385.*expr387.*expr391.*Wms + expr1317.*expr1531.*expr1532.*expr1533.*expr1534.*expr1535.*expr1536.*expr379.*expr380.*expr383.*expr385.*expr387.*expr389.*expr391.*Wms;
integrate37 = trapz(w37, expr1540);
w38 = [0:wp./100:wp];
expr1541 = (a(1).^2 + b(1).^2).^2 + w38.^2.*(w38.^2 + 2.*(a(1).^2 - b(1).^2));
expr1542 = (a(2).^2 + b(2).^2).^2 + w38.^2.*(w38.^2 + 2.*(a(2).^2 - b(2).^2));
expr1543 = (a(3).^2 + b(3).^2).^2 + w38.^2.*(w38.^2 + 2.*(a(3).^2 - b(3).^2));
expr1544 = (c(1).^2 + d(1).^2).^2 + w38.^2.*(w38.^2 + 2.*(c(1).^2 - d(1).^2));
expr1545 = 4.*w38.^2.*c(2) + 4.*c(2).*(c(2).^2 + d(2).^2);
expr1546 = (c(3).^2 + d(3).^2).^2 + w38.^2.*(w38.^2 + 2.*(c(3).^2 - d(3).^2));
expr1547 = (c(2).^2 + d(2).^2).^2 + w38.^2.*(w38.^2 + 2.*(c(2).^2 - d(2).^2));
expr1548 = -1 + (expr1541.*expr1542.*expr1543).^expr397.*(expr1544.*expr1546.*expr1547).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405;
expr1549 = -2.*expr1537.*(expr1541.*expr1542.*expr1543).^expr397.*(expr1544.*expr1546.*expr1547).^expr409.*expr321.*expr337.*expr353.*expr389.*expr403.*expr405;
expr1550 = (expr1541.*expr1542.*expr1543).^expr397.*expr1544.*expr1545.*expr1546.*(expr1544.*expr1546.*expr1547).^expr397.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr1551 = 2.*expr1548.*(expr1549 + expr1550).*expr396.*Wmp;
integrate38 = trapz(w38, expr1551);
w39 = [wp:(-wp + ws)./100:ws];
expr1552 = (a(1).^2 + b(1).^2).^2 + w39.^2.*(w39.^2 + 2.*(a(1).^2 - b(1).^2));
expr1553 = (a(2).^2 + b(2).^2).^2 + w39.^2.*(w39.^2 + 2.*(a(2).^2 - b(2).^2));
expr1554 = (a(3).^2 + b(3).^2).^2 + w39.^2.*(w39.^2 + 2.*(a(3).^2 - b(3).^2));
expr1555 = (c(1).^2 + d(1).^2).^2 + w39.^2.*(w39.^2 + 2.*(c(1).^2 - d(1).^2));
expr1556 = 4.*w39.^2.*c(2) + 4.*c(2).*(c(2).^2 + d(2).^2);
expr1557 = (c(3).^2 + d(3).^2).^2 + w39.^2.*(w39.^2 + 2.*(c(3).^2 - d(3).^2));
expr1558 = (c(2).^2 + d(2).^2).^2 + w39.^2.*(w39.^2 + 2.*(c(2).^2 - d(2).^2));
expr1559 = -(w39./(wp - ws));
expr1560 = -2.*expr1537.*(expr1552.*expr1553.*expr1554).^expr397.*(expr1555.*expr1557.*expr1558).^expr409.*expr321.*expr337.*expr353.*expr389.*expr403.*expr405;
expr1561 = (expr1552.*expr1553.*expr1554).^expr397.*expr1555.*expr1556.*expr1557.*(expr1555.*expr1557.*expr1558).^expr397.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr1562 = expr1559 + (expr1552.*expr1553.*expr1554).^expr397.*(expr1555.*expr1557.*expr1558).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405 + expr423;
expr1563 = 2.*(expr1560 + expr1561).*expr1562.*expr414.*Wmt;
integrate39 = trapz(w39, expr1563);
w40 = [0:wmax./100:wmax];
expr1564 = (w40 - d(2))./(c(2).^2.*(1 + (w40 - d(2)).^2./c(2).^2));
expr1565 = (w40 + d(2))./(c(2).^2.*(1 + (w40 + d(2)).^2./c(2).^2));
expr1566 = -2.*(angle(1 + (i.*(wmax - d(2)))./c(2)) + angle(1 + (i.*(wmax + d(2)))./c(2))).*c(2);
expr1567 = (-2.*(wmax - d(2)).^2.*d(2))./(c(2).^2.*(1 + (wmax - d(2)).^2./c(2).^2));
expr1568 = (2.*d(2).*(wmax + d(2)).^2)./(c(2).^2.*(1 + (wmax + d(2)).^2./c(2).^2));
expr1569 = -((wmax - d(2))./(c(2).^2.*(1 + (wmax - d(2)).^2./c(2).^2)));
expr1570 = -((wmax + d(2))./(c(2).^2.*(1 + (wmax + d(2)).^2./c(2).^2)));
expr1571 = d(2).*log(1 + (wmax - d(2)).^2./c(2).^2);
expr1572 = -(d(2).*log(1 + (wmax + d(2)).^2./c(2).^2));
expr1573 = angle(1 + (i.*(w40 - b(1)))./a(1));
expr1574 = angle(1 + (i.*(w40 + b(1)))./a(1));
expr1575 = angle(1 + (i.*(w40 - b(2)))./a(2));
expr1576 = angle(1 + (i.*(w40 + b(2)))./a(2));
expr1577 = angle(1 + (i.*(w40 - b(3)))./a(3));
expr1578 = angle(1 + (i.*(w40 + b(3)))./a(3));
expr1579 = -angle(1 + (i.*(w40 - d(1)))./c(1));
expr1580 = -angle(1 + (i.*(w40 + d(1)))./c(1));
expr1581 = -angle(1 + (i.*(w40 - d(2)))./c(2));
expr1582 = -angle(1 + (i.*(w40 + d(2)))./c(2));
expr1583 = -angle(1 + (i.*(w40 - d(3)))./c(3));
expr1584 = -angle(1 + (i.*(w40 + d(3)))./c(3));
expr1585 = expr1564 + expr1565 + expr402.*expr431.*(expr1354 + expr1566 + expr1567 + expr1568 + expr1571 + expr1572 + (expr1569 + expr1570).*expr474).*w40;
expr1586 = 2.*expr1585.*expr428.*(expr1573 + expr1574 + expr1575 + expr1576 + expr1577 + expr1578 + expr1579 + expr1580 + expr1581 + expr1582 + expr1583 + expr1584 - 3.*expr431.*(expr483 + expr484 + expr485 + expr486 + expr487 + expr488).*w40).*Wph;
integrate40 = trapz(w40, expr1586);
expr1587 = -((b(1) + d(2))./((a(1) - c(2)).^2.*(1 + (b(1) + d(2)).^2./(a(1) - c(2)).^2)));
expr1588 = -((b(2) + d(2))./((a(2) - c(2)).^2.*(1 + (b(2) + d(2)).^2./(a(2) - c(2)).^2)));
expr1589 = -((b(3) + d(2))./((a(3) - c(2)).^2.*(1 + (b(3) + d(2)).^2./(a(3) - c(2)).^2)));
expr1590 = -2.*expr504.*expr505.*expr506.*expr508.*expr509.*expr533 - 2.*expr504.*expr505.*expr507.*expr508.*expr509.*expr533;
expr1591 = expr332.*(expr1587 - expr547.*expr548.*expr549).*cos(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331);
expr1592 = -(expr320.*(expr1587 - expr547.*expr548.*expr549).*sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331));
expr1593 = expr1587 - expr547.*expr548.*expr549;
expr1594 = expr1588 - expr863.*expr864.*expr865;
expr1595 = expr348.*(expr1588 - expr863.*expr864.*expr865).*cos(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347);
expr1596 = -(expr336.*(expr1588 - expr863.*expr864.*expr865).*sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347));
expr1597 = (-(expr1127.*expr1128.*expr1129) + expr1589).*expr364.*cos(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363);
expr1598 = -((-(expr1127.*expr1128.*expr1129) + expr1589).*expr352.*sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363));
expr1599 = -(expr1127.*expr1128.*expr1129) + expr1589;
expr1600 = -2.*expr514.*expr515.*expr516.*expr518.*expr519.*expr878 - 2.*expr514.*expr515.*expr517.*expr518.*expr519.*expr878;
expr1601 = -2.*expr1137.*expr524.*expr525.*expr526.*expr528.*expr529 - 2.*expr1137.*expr524.*expr525.*expr527.*expr528.*expr529;
expr1602 = expr1591 + expr1592;
expr1603 = (expr1593.*expr320.*expr321.*expr369.*expr587)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369);
expr1604 = -(((expr1591 + expr1592).*expr320.*expr321.*expr368.*expr589)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369));
expr1605 = -((expr320.*expr321.*expr368.*expr369.*(-(expr1593.*expr321.*expr332.*expr369.*expr587) + (expr1591 + expr1592).*expr321.*expr332.*expr368.*expr589))./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369).^2);
expr1606 = -(((expr1595 + expr1596).*expr336.*expr337.*expr370.*expr591)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371));
expr1607 = (expr1594.*expr336.*expr337.*expr371.*expr593)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371);
expr1608 = -((expr336.*expr337.*expr370.*expr371.*((expr1595 + expr1596).*expr337.*expr348.*expr370.*expr591 - expr1594.*expr337.*expr348.*expr371.*expr593))./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371).^2);
expr1609 = -(((expr1597 + expr1598).*expr352.*expr353.*expr372.*expr597)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373));
expr1610 = (expr1599.*expr352.*expr353.*expr373.*expr599)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373);
expr1611 = -((expr352.*expr353.*expr372.*expr373.*((expr1597 + expr1598).*expr353.*expr364.*expr372.*expr597 - expr1599.*expr353.*expr364.*expr373.*expr599))./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373).^2);
expr1612 = -(expr1593.*expr321.*expr369.*expr587) + (expr1591 + expr1592).*expr321.*expr368.*expr589;
expr1613 = expr1595 + expr1596;
expr1614 = (expr1595 + expr1596).*expr337.*expr370.*expr591 - expr1594.*expr337.*expr371.*expr593;
expr1615 = expr1597 + expr1598;
expr1616 = (expr1597 + expr1598).*expr353.*expr372.*expr597 - expr1599.*expr353.*expr373.*expr599;
expr1617 = (expr1603 + expr1604 + expr1605).*expr335.*expr611 + (expr1606 + expr1607 + expr1608).*expr351.*expr617 + (expr1609 + expr1610 + expr1611).*expr367.*expr621;
expr1618 = expr564.*expr606.*((expr1603 + expr1604 + expr1605).*expr335.*expr611 + (expr1606 + expr1607 + expr1608).*expr351.*expr617 + (expr1609 + expr1610 + expr1611).*expr367.*expr621).*tpc.*cos(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr1619 = -(expr1612.*expr335.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc));
expr1620 = expr320.*expr564.*((expr1603 + expr1604 + expr1605).*expr335.*expr611 + (expr1606 + expr1607 + expr1608).*expr351.*expr617 + (expr1609 + expr1610 + expr1611).*expr367.*expr621).*tpc.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr1621 = expr564.*expr607.*((expr1603 + expr1604 + expr1605).*expr335.*expr611 + (expr1606 + expr1607 + expr1608).*expr351.*expr617 + (expr1609 + expr1610 + expr1611).*expr367.*expr621).*tpc.*cos(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr1622 = -(expr1614.*expr351.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc));
expr1623 = expr336.*expr564.*((expr1603 + expr1604 + expr1605).*expr335.*expr611 + (expr1606 + expr1607 + expr1608).*expr351.*expr617 + (expr1609 + expr1610 + expr1611).*expr367.*expr621).*tpc.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr1624 = expr564.*expr608.*((expr1603 + expr1604 + expr1605).*expr335.*expr611 + (expr1606 + expr1607 + expr1608).*expr351.*expr617 + (expr1609 + expr1610 + expr1611).*expr367.*expr621).*tpc.*cos(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr1625 = -(expr1616.*expr367.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc));
expr1626 = expr352.*expr564.*((expr1603 + expr1604 + expr1605).*expr335.*expr611 + (expr1606 + expr1607 + expr1608).*expr351.*expr617 + (expr1609 + expr1610 + expr1611).*expr367.*expr621).*tpc.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr1627 = expr1602.*expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr630;
expr1628 = -2.*expr1537.*expr335.*expr337.*expr353.*expr389.*expr403.*expr405.*expr568.*expr569.*expr570.*expr630;
expr1629 = expr1590.*expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409.*expr568.*expr570.*expr579.*expr630;
expr1630 = expr1613.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr631;
expr1631 = -2.*expr1537.*expr321.*expr351.*expr353.*expr389.*expr403.*expr405.*expr571.*expr572.*expr573.*expr631;
expr1632 = expr1615.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr632;
expr1633 = expr1149.*expr1601.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr409.*expr574.*expr576.*expr632;
expr1634 = -2.*expr1537.*expr321.*expr337.*expr367.*expr389.*expr403.*expr405.*expr574.*expr575.*expr576.*expr632;
expr1635 = expr1600.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr409.*expr571.*expr573.*expr631.*expr891;
expr1636 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*(-((expr1618 + expr1619 + expr1620).*expr633) + expr1617.*expr332.*expr564.*expr633.*expr636.*tpc);
expr1637 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*(-((expr1621 + expr1622 + expr1623).*expr641) + expr1617.*expr348.*expr564.*expr641.*expr642.*tpc);
expr1638 = expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*(-((expr1624 + expr1625 + expr1626).*expr646) + expr1617.*expr364.*expr564.*expr646.*expr647.*tpc);
expr1639 = integrate37 + integrate38 + integrate39 + integrate40 + 200.*(expr1627 + expr1628 + expr1629 + expr1630 + expr1631 + expr1632 + expr1633 + expr1634 + expr1635 + expr1636 + expr1637 + expr1638).*expr651.*WO;
gf(8) = expr1639;

%% Derivative for d(2)
w41 = [ws:(99.*ws)./100:100.*ws];
expr1640 = ((a(1).^2 + b(1).^2).^2 + w41.^2.*(w41.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr1641 = ((a(2).^2 + b(2).^2).^2 + w41.^2.*(w41.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr1642 = ((a(3).^2 + b(3).^2).^2 + w41.^2.*(w41.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr1643 = (c(1).^2 + d(1).^2).^2 + w41.^2.*(w41.^2 + 2.*(c(1).^2 - d(1).^2));
expr1644 = -4.*w41.^2.*d(2) + 4.*d(2).*(c(2).^2 + d(2).^2);
expr1645 = (c(3).^2 + d(3).^2).^2 + w41.^2.*(w41.^2 + 2.*(c(3).^2 - d(3).^2));
expr1646 = d(2);
expr1647 = (c(2).^2 + d(2).^2).^2 + w41.^2.*(w41.^2 + 2.*(c(2).^2 - d(2).^2));
expr1648 = expr1324.*expr1538.*expr1640.*expr1641.*expr1642.*expr1643.*expr1645.*expr1646.*expr1647.*expr379.*expr380.*expr383.*expr385.*expr387.*expr391.*Wms + expr1317.*expr1640.*expr1641.*expr1642.*expr1643.*expr1644.*expr1645.*expr379.*expr380.*expr383.*expr385.*expr387.*expr389.*expr391.*Wms;
integrate41 = trapz(w41, expr1648);
w42 = [0:wp./100:wp];
expr1649 = (a(1).^2 + b(1).^2).^2 + w42.^2.*(w42.^2 + 2.*(a(1).^2 - b(1).^2));
expr1650 = (a(2).^2 + b(2).^2).^2 + w42.^2.*(w42.^2 + 2.*(a(2).^2 - b(2).^2));
expr1651 = (a(3).^2 + b(3).^2).^2 + w42.^2.*(w42.^2 + 2.*(a(3).^2 - b(3).^2));
expr1652 = (c(1).^2 + d(1).^2).^2 + w42.^2.*(w42.^2 + 2.*(c(1).^2 - d(1).^2));
expr1653 = -4.*w42.^2.*d(2) + 4.*d(2).*(c(2).^2 + d(2).^2);
expr1654 = (c(3).^2 + d(3).^2).^2 + w42.^2.*(w42.^2 + 2.*(c(3).^2 - d(3).^2));
expr1655 = (c(2).^2 + d(2).^2).^2 + w42.^2.*(w42.^2 + 2.*(c(2).^2 - d(2).^2));
expr1656 = -1 + (expr1649.*expr1650.*expr1651).^expr397.*(expr1652.*expr1654.*expr1655).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405;
expr1657 = -2.*expr1646.*(expr1649.*expr1650.*expr1651).^expr397.*(expr1652.*expr1654.*expr1655).^expr409.*expr321.*expr337.*expr353.*expr389.*expr403.*expr405;
expr1658 = (expr1649.*expr1650.*expr1651).^expr397.*expr1652.*expr1653.*expr1654.*(expr1652.*expr1654.*expr1655).^expr397.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr1659 = 2.*expr1656.*(expr1657 + expr1658).*expr396.*Wmp;
integrate42 = trapz(w42, expr1659);
w43 = [wp:(-wp + ws)./100:ws];
expr1660 = (a(1).^2 + b(1).^2).^2 + w43.^2.*(w43.^2 + 2.*(a(1).^2 - b(1).^2));
expr1661 = (a(2).^2 + b(2).^2).^2 + w43.^2.*(w43.^2 + 2.*(a(2).^2 - b(2).^2));
expr1662 = (a(3).^2 + b(3).^2).^2 + w43.^2.*(w43.^2 + 2.*(a(3).^2 - b(3).^2));
expr1663 = (c(1).^2 + d(1).^2).^2 + w43.^2.*(w43.^2 + 2.*(c(1).^2 - d(1).^2));
expr1664 = -4.*w43.^2.*d(2) + 4.*d(2).*(c(2).^2 + d(2).^2);
expr1665 = (c(3).^2 + d(3).^2).^2 + w43.^2.*(w43.^2 + 2.*(c(3).^2 - d(3).^2));
expr1666 = (c(2).^2 + d(2).^2).^2 + w43.^2.*(w43.^2 + 2.*(c(2).^2 - d(2).^2));
expr1667 = -(w43./(wp - ws));
expr1668 = -2.*expr1646.*(expr1660.*expr1661.*expr1662).^expr397.*(expr1663.*expr1665.*expr1666).^expr409.*expr321.*expr337.*expr353.*expr389.*expr403.*expr405;
expr1669 = (expr1660.*expr1661.*expr1662).^expr397.*expr1663.*expr1664.*expr1665.*(expr1663.*expr1665.*expr1666).^expr397.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr1670 = expr1667 + (expr1660.*expr1661.*expr1662).^expr397.*(expr1663.*expr1665.*expr1666).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405 + expr423;
expr1671 = 2.*(expr1668 + expr1669).*expr1670.*expr414.*Wmt;
integrate43 = trapz(w43, expr1671);
w44 = [0:wmax./100:wmax];
expr1672 = 1./(c(2).*(1 + (w44 - d(2)).^2./c(2).^2));
expr1673 = -(1./(c(2).*(1 + (w44 + d(2)).^2./c(2).^2)));
expr1674 = 2.*(angle(1 + (i.*(wmax - d(2)))./c(2)) + angle(1 + (i.*(wmax + d(2)))./c(2))).*d(2);
expr1675 = (-2.*(wmax - d(2)).*d(2))./(c(2).*(1 + (wmax - d(2)).^2./c(2).^2));
expr1676 = (-2.*d(2).*(wmax + d(2)))./(c(2).*(1 + (wmax + d(2)).^2./c(2).^2));
expr1677 = -(1./(c(2).*(1 + (wmax - d(2)).^2./c(2).^2)));
expr1678 = 1./(c(2).*(1 + (wmax + d(2)).^2./c(2).^2));
expr1679 = c(2).*log(1 + (wmax - d(2)).^2./c(2).^2);
expr1680 = -(c(2).*log(1 + (wmax + d(2)).^2./c(2).^2));
expr1681 = angle(1 + (i.*(w44 - b(1)))./a(1));
expr1682 = angle(1 + (i.*(w44 + b(1)))./a(1));
expr1683 = angle(1 + (i.*(w44 - b(2)))./a(2));
expr1684 = angle(1 + (i.*(w44 + b(2)))./a(2));
expr1685 = angle(1 + (i.*(w44 - b(3)))./a(3));
expr1686 = angle(1 + (i.*(w44 + b(3)))./a(3));
expr1687 = -angle(1 + (i.*(w44 - d(1)))./c(1));
expr1688 = -angle(1 + (i.*(w44 + d(1)))./c(1));
expr1689 = -angle(1 + (i.*(w44 - d(2)))./c(2));
expr1690 = -angle(1 + (i.*(w44 + d(2)))./c(2));
expr1691 = -angle(1 + (i.*(w44 - d(3)))./c(3));
expr1692 = -angle(1 + (i.*(w44 + d(3)))./c(3));
expr1693 = expr1672 + expr1673 + expr402.*expr431.*(expr1674 + expr1675 + expr1676 + expr1679 + expr1680 + (expr1677 + expr1678).*expr474).*w44;
expr1694 = 2.*expr1693.*expr428.*(expr1681 + expr1682 + expr1683 + expr1684 + expr1685 + expr1686 + expr1687 + expr1688 + expr1689 + expr1690 + expr1691 + expr1692 - 3.*expr431.*(expr483 + expr484 + expr485 + expr486 + expr487 + expr488).*w44).*Wph;
integrate44 = trapz(w44, expr1694);
expr1695 = 1./((a(1) - c(2)).*(1 + (b(1) - d(2)).^2./(a(1) - c(2)).^2));
expr1696 = 1./((a(2) - c(2)).*(1 + (b(2) - d(2)).^2./(a(2) - c(2)).^2));
expr1697 = 1./((a(3) - c(2)).*(1 + (b(3) - d(2)).^2./(a(3) - c(2)).^2));
expr1698 = -2.*expr504.*expr505.*expr507.*expr508.*expr509.*expr549 + 2.*expr504.*expr505.*expr506.*expr508.*expr509.*expr725;
expr1699 = expr332.*(expr1695 + expr734).*cos(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331) - expr320.*(expr1695 + expr734).*sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331);
expr1700 = expr1695 + expr734;
expr1701 = expr1696 + expr998;
expr1702 = expr348.*(expr1696 + expr998).*cos(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347) - expr336.*(expr1696 + expr998).*sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347);
expr1703 = (expr1256 + expr1697).*expr364.*cos(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363) - (expr1256 + expr1697).*expr352.*sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363);
expr1704 = expr1256 + expr1697;
expr1705 = 2.*expr1006.*expr514.*expr515.*expr516.*expr518.*expr519 - 2.*expr514.*expr515.*expr517.*expr518.*expr519.*expr865;
expr1706 = 2.*expr1261.*expr524.*expr525.*expr526.*expr528.*expr529 - 2.*expr1129.*expr524.*expr525.*expr527.*expr528.*expr529;
expr1707 = (expr1700.*expr320.*expr321.*expr369.*expr587)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369);
expr1708 = -((expr1699.*expr320.*expr321.*expr368.*expr589)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369));
expr1709 = -((expr320.*expr321.*expr368.*expr369.*(-(expr1700.*expr321.*expr332.*expr369.*expr587) + expr1699.*expr321.*expr332.*expr368.*expr589))./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369).^2);
expr1710 = -((expr1702.*expr336.*expr337.*expr370.*expr591)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371));
expr1711 = (expr1701.*expr336.*expr337.*expr371.*expr593)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371);
expr1712 = -((expr336.*expr337.*expr370.*expr371.*(expr1702.*expr337.*expr348.*expr370.*expr591 - expr1701.*expr337.*expr348.*expr371.*expr593))./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371).^2);
expr1713 = -((expr1703.*expr352.*expr353.*expr372.*expr597)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373));
expr1714 = (expr1704.*expr352.*expr353.*expr373.*expr599)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373);
expr1715 = -((expr352.*expr353.*expr372.*expr373.*(expr1703.*expr353.*expr364.*expr372.*expr597 - expr1704.*expr353.*expr364.*expr373.*expr599))./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373).^2);
expr1716 = -(expr1700.*expr321.*expr369.*expr587) + expr1699.*expr321.*expr368.*expr589;
expr1717 = expr1702.*expr337.*expr370.*expr591 - expr1701.*expr337.*expr371.*expr593;
expr1718 = expr1703.*expr353.*expr372.*expr597 - expr1704.*expr353.*expr373.*expr599;
expr1719 = (expr1707 + expr1708 + expr1709).*expr335.*expr611 + (expr1710 + expr1711 + expr1712).*expr351.*expr617 + (expr1713 + expr1714 + expr1715).*expr367.*expr621;
expr1720 = expr564.*expr606.*((expr1707 + expr1708 + expr1709).*expr335.*expr611 + (expr1710 + expr1711 + expr1712).*expr351.*expr617 + (expr1713 + expr1714 + expr1715).*expr367.*expr621).*tpc.*cos(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr1721 = -(expr1716.*expr335.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc));
expr1722 = expr320.*expr564.*((expr1707 + expr1708 + expr1709).*expr335.*expr611 + (expr1710 + expr1711 + expr1712).*expr351.*expr617 + (expr1713 + expr1714 + expr1715).*expr367.*expr621).*tpc.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr1723 = expr564.*expr607.*((expr1707 + expr1708 + expr1709).*expr335.*expr611 + (expr1710 + expr1711 + expr1712).*expr351.*expr617 + (expr1713 + expr1714 + expr1715).*expr367.*expr621).*tpc.*cos(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr1724 = -(expr1717.*expr351.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc));
expr1725 = expr336.*expr564.*((expr1707 + expr1708 + expr1709).*expr335.*expr611 + (expr1710 + expr1711 + expr1712).*expr351.*expr617 + (expr1713 + expr1714 + expr1715).*expr367.*expr621).*tpc.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr1726 = expr564.*expr608.*((expr1707 + expr1708 + expr1709).*expr335.*expr611 + (expr1710 + expr1711 + expr1712).*expr351.*expr617 + (expr1713 + expr1714 + expr1715).*expr367.*expr621).*tpc.*cos(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr1727 = -(expr1718.*expr367.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc));
expr1728 = expr352.*expr564.*((expr1707 + expr1708 + expr1709).*expr335.*expr611 + (expr1710 + expr1711 + expr1712).*expr351.*expr617 + (expr1713 + expr1714 + expr1715).*expr367.*expr621).*tpc.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr1729 = expr1699.*expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr630;
expr1730 = -2.*expr1646.*expr335.*expr337.*expr353.*expr389.*expr403.*expr405.*expr568.*expr569.*expr570.*expr630;
expr1731 = expr1698.*expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409.*expr568.*expr570.*expr579.*expr630;
expr1732 = expr1702.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr631;
expr1733 = -2.*expr1646.*expr321.*expr351.*expr353.*expr389.*expr403.*expr405.*expr571.*expr572.*expr573.*expr631;
expr1734 = expr1703.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr632;
expr1735 = expr1149.*expr1706.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr409.*expr574.*expr576.*expr632;
expr1736 = -2.*expr1646.*expr321.*expr337.*expr367.*expr389.*expr403.*expr405.*expr574.*expr575.*expr576.*expr632;
expr1737 = expr1705.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr409.*expr571.*expr573.*expr631.*expr891;
expr1738 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*(-((expr1720 + expr1721 + expr1722).*expr633) + expr1719.*expr332.*expr564.*expr633.*expr636.*tpc);
expr1739 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*(-((expr1723 + expr1724 + expr1725).*expr641) + expr1719.*expr348.*expr564.*expr641.*expr642.*tpc);
expr1740 = expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*(-((expr1726 + expr1727 + expr1728).*expr646) + expr1719.*expr364.*expr564.*expr646.*expr647.*tpc);
expr1741 = integrate41 + integrate42 + integrate43 + integrate44 + 200.*(expr1729 + expr1730 + expr1731 + expr1732 + expr1733 + expr1734 + expr1735 + expr1736 + expr1737 + expr1738 + expr1739 + expr1740).*expr651.*WO;
gf(11) = expr1741;

%% Derivative for c(3)
w45 = [ws:(99.*ws)./100:100.*ws];
expr1742 = ((a(1).^2 + b(1).^2).^2 + w45.^2.*(w45.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr1743 = ((a(2).^2 + b(2).^2).^2 + w45.^2.*(w45.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr1744 = ((a(3).^2 + b(3).^2).^2 + w45.^2.*(w45.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr1745 = (c(1).^2 + d(1).^2).^2 + w45.^2.*(w45.^2 + 2.*(c(1).^2 - d(1).^2));
expr1746 = (c(2).^2 + d(2).^2).^2 + w45.^2.*(w45.^2 + 2.*(c(2).^2 - d(2).^2));
expr1747 = 4.*w45.^2.*c(3) + 4.*c(3).*(c(3).^2 + d(3).^2);
expr1748 = c(3);
expr1749 = (c(3).^2 + d(3).^2).^(-3);
expr1750 = (c(3).^2 + d(3).^2).^2 + w45.^2.*(w45.^2 + 2.*(c(3).^2 - d(3).^2));
expr1751 = expr1324.*expr1742.*expr1743.*expr1744.*expr1745.*expr1746.*expr1748.*expr1749.*expr1750.*expr379.*expr380.*expr383.*expr385.*expr387.*expr389.*Wms + expr1317.*expr1742.*expr1743.*expr1744.*expr1745.*expr1746.*expr1747.*expr379.*expr380.*expr383.*expr385.*expr387.*expr389.*expr391.*Wms;
integrate45 = trapz(w45, expr1751);
w46 = [0:wp./100:wp];
expr1752 = (a(1).^2 + b(1).^2).^2 + w46.^2.*(w46.^2 + 2.*(a(1).^2 - b(1).^2));
expr1753 = (a(2).^2 + b(2).^2).^2 + w46.^2.*(w46.^2 + 2.*(a(2).^2 - b(2).^2));
expr1754 = (a(3).^2 + b(3).^2).^2 + w46.^2.*(w46.^2 + 2.*(a(3).^2 - b(3).^2));
expr1755 = (c(1).^2 + d(1).^2).^2 + w46.^2.*(w46.^2 + 2.*(c(1).^2 - d(1).^2));
expr1756 = (c(2).^2 + d(2).^2).^2 + w46.^2.*(w46.^2 + 2.*(c(2).^2 - d(2).^2));
expr1757 = 4.*w46.^2.*c(3) + 4.*c(3).*(c(3).^2 + d(3).^2);
expr1758 = (c(3).^2 + d(3).^2).^2 + w46.^2.*(w46.^2 + 2.*(c(3).^2 - d(3).^2));
expr1759 = -1 + (expr1752.*expr1753.*expr1754).^expr397.*(expr1755.*expr1756.*expr1758).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405;
expr1760 = -2.*expr1748.*(expr1752.*expr1753.*expr1754).^expr397.*(expr1755.*expr1756.*expr1758).^expr409.*expr321.*expr337.*expr353.*expr391.*expr403.*expr404;
expr1761 = (expr1752.*expr1753.*expr1754).^expr397.*expr1755.*expr1756.*expr1757.*(expr1755.*expr1756.*expr1758).^expr397.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr1762 = 2.*expr1759.*(expr1760 + expr1761).*expr396.*Wmp;
integrate46 = trapz(w46, expr1762);
w47 = [wp:(-wp + ws)./100:ws];
expr1763 = (a(1).^2 + b(1).^2).^2 + w47.^2.*(w47.^2 + 2.*(a(1).^2 - b(1).^2));
expr1764 = (a(2).^2 + b(2).^2).^2 + w47.^2.*(w47.^2 + 2.*(a(2).^2 - b(2).^2));
expr1765 = (a(3).^2 + b(3).^2).^2 + w47.^2.*(w47.^2 + 2.*(a(3).^2 - b(3).^2));
expr1766 = (c(1).^2 + d(1).^2).^2 + w47.^2.*(w47.^2 + 2.*(c(1).^2 - d(1).^2));
expr1767 = (c(2).^2 + d(2).^2).^2 + w47.^2.*(w47.^2 + 2.*(c(2).^2 - d(2).^2));
expr1768 = 4.*w47.^2.*c(3) + 4.*c(3).*(c(3).^2 + d(3).^2);
expr1769 = (c(3).^2 + d(3).^2).^2 + w47.^2.*(w47.^2 + 2.*(c(3).^2 - d(3).^2));
expr1770 = -(w47./(wp - ws));
expr1771 = -2.*expr1748.*(expr1763.*expr1764.*expr1765).^expr397.*(expr1766.*expr1767.*expr1769).^expr409.*expr321.*expr337.*expr353.*expr391.*expr403.*expr404;
expr1772 = (expr1763.*expr1764.*expr1765).^expr397.*expr1766.*expr1767.*expr1768.*(expr1766.*expr1767.*expr1769).^expr397.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr1773 = expr1770 + (expr1763.*expr1764.*expr1765).^expr397.*(expr1766.*expr1767.*expr1769).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405 + expr423;
expr1774 = 2.*(expr1771 + expr1772).*expr1773.*expr414.*Wmt;
integrate47 = trapz(w47, expr1774);
w48 = [0:wmax./100:wmax];
expr1775 = (w48 - d(3))./(c(3).^2.*(1 + (w48 - d(3)).^2./c(3).^2));
expr1776 = (w48 + d(3))./(c(3).^2.*(1 + (w48 + d(3)).^2./c(3).^2));
expr1777 = -2.*(angle(1 + (i.*(wmax - d(3)))./c(3)) + angle(1 + (i.*(wmax + d(3)))./c(3))).*c(3);
expr1778 = (-2.*(wmax - d(3)).^2.*d(3))./(c(3).^2.*(1 + (wmax - d(3)).^2./c(3).^2));
expr1779 = (2.*d(3).*(wmax + d(3)).^2)./(c(3).^2.*(1 + (wmax + d(3)).^2./c(3).^2));
expr1780 = -((wmax - d(3))./(c(3).^2.*(1 + (wmax - d(3)).^2./c(3).^2)));
expr1781 = -((wmax + d(3))./(c(3).^2.*(1 + (wmax + d(3)).^2./c(3).^2)));
expr1782 = d(3).*log(1 + (wmax - d(3)).^2./c(3).^2);
expr1783 = -(d(3).*log(1 + (wmax + d(3)).^2./c(3).^2));
expr1784 = angle(1 + (i.*(w48 - b(1)))./a(1));
expr1785 = angle(1 + (i.*(w48 + b(1)))./a(1));
expr1786 = angle(1 + (i.*(w48 - b(2)))./a(2));
expr1787 = angle(1 + (i.*(w48 + b(2)))./a(2));
expr1788 = angle(1 + (i.*(w48 - b(3)))./a(3));
expr1789 = angle(1 + (i.*(w48 + b(3)))./a(3));
expr1790 = -angle(1 + (i.*(w48 - d(1)))./c(1));
expr1791 = -angle(1 + (i.*(w48 + d(1)))./c(1));
expr1792 = -angle(1 + (i.*(w48 - d(2)))./c(2));
expr1793 = -angle(1 + (i.*(w48 + d(2)))./c(2));
expr1794 = -angle(1 + (i.*(w48 - d(3)))./c(3));
expr1795 = -angle(1 + (i.*(w48 + d(3)))./c(3));
expr1796 = expr1775 + expr1776 + expr402.*expr431.*(expr1354 + expr1777 + expr1778 + expr1779 + expr1782 + expr1783 + (expr1780 + expr1781).*expr479).*w48;
expr1797 = 2.*expr1796.*expr428.*(expr1784 + expr1785 + expr1786 + expr1787 + expr1788 + expr1789 + expr1790 + expr1791 + expr1792 + expr1793 + expr1794 + expr1795 - 3.*expr431.*(expr483 + expr484 + expr485 + expr486 + expr487 + expr488).*w48).*Wph;
integrate48 = trapz(w48, expr1797);
expr1798 = -((b(1) + d(3))./((a(1) - c(3)).^2.*(1 + (b(1) + d(3)).^2./(a(1) - c(3)).^2)));
expr1799 = -((b(2) + d(3))./((a(2) - c(3)).^2.*(1 + (b(2) + d(3)).^2./(a(2) - c(3)).^2)));
expr1800 = -((b(3) + d(3))./((a(3) - c(3)).^2.*(1 + (b(3) + d(3)).^2./(a(3) - c(3)).^2)));
expr1801 = -2.*expr504.*expr505.*expr506.*expr507.*expr508.*expr532 - 2.*expr504.*expr505.*expr506.*expr507.*expr509.*expr532;
expr1802 = expr332.*(expr1798 - expr551.*expr552.*expr553).*cos(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331);
expr1803 = -(expr320.*(expr1798 - expr551.*expr552.*expr553).*sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331));
expr1804 = expr1798 - expr551.*expr552.*expr553;
expr1805 = expr1799 - expr867.*expr868.*expr869;
expr1806 = expr348.*(expr1799 - expr867.*expr868.*expr869).*cos(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347);
expr1807 = -(expr336.*(expr1799 - expr867.*expr868.*expr869).*sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347));
expr1808 = (-(expr1131.*expr1132.*expr1133) + expr1800).*expr364.*cos(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363);
expr1809 = -((-(expr1131.*expr1132.*expr1133) + expr1800).*expr352.*sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363));
expr1810 = -(expr1131.*expr1132.*expr1133) + expr1800;
expr1811 = -2.*expr514.*expr515.*expr516.*expr517.*expr518.*expr877 - 2.*expr514.*expr515.*expr516.*expr517.*expr519.*expr877;
expr1812 = -2.*expr1136.*expr524.*expr525.*expr526.*expr527.*expr528 - 2.*expr1136.*expr524.*expr525.*expr526.*expr527.*expr529;
expr1813 = expr1802 + expr1803;
expr1814 = (expr1804.*expr320.*expr321.*expr369.*expr587)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369);
expr1815 = -(((expr1802 + expr1803).*expr320.*expr321.*expr368.*expr589)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369));
expr1816 = -((expr320.*expr321.*expr368.*expr369.*(-(expr1804.*expr321.*expr332.*expr369.*expr587) + (expr1802 + expr1803).*expr321.*expr332.*expr368.*expr589))./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369).^2);
expr1817 = -(((expr1806 + expr1807).*expr336.*expr337.*expr370.*expr591)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371));
expr1818 = (expr1805.*expr336.*expr337.*expr371.*expr593)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371);
expr1819 = -((expr336.*expr337.*expr370.*expr371.*((expr1806 + expr1807).*expr337.*expr348.*expr370.*expr591 - expr1805.*expr337.*expr348.*expr371.*expr593))./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371).^2);
expr1820 = -(((expr1808 + expr1809).*expr352.*expr353.*expr372.*expr597)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373));
expr1821 = (expr1810.*expr352.*expr353.*expr373.*expr599)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373);
expr1822 = -((expr352.*expr353.*expr372.*expr373.*((expr1808 + expr1809).*expr353.*expr364.*expr372.*expr597 - expr1810.*expr353.*expr364.*expr373.*expr599))./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373).^2);
expr1823 = -(expr1804.*expr321.*expr369.*expr587) + (expr1802 + expr1803).*expr321.*expr368.*expr589;
expr1824 = expr1806 + expr1807;
expr1825 = (expr1806 + expr1807).*expr337.*expr370.*expr591 - expr1805.*expr337.*expr371.*expr593;
expr1826 = expr1808 + expr1809;
expr1827 = (expr1808 + expr1809).*expr353.*expr372.*expr597 - expr1810.*expr353.*expr373.*expr599;
expr1828 = (expr1814 + expr1815 + expr1816).*expr335.*expr611 + (expr1817 + expr1818 + expr1819).*expr351.*expr617 + (expr1820 + expr1821 + expr1822).*expr367.*expr621;
expr1829 = expr564.*expr606.*((expr1814 + expr1815 + expr1816).*expr335.*expr611 + (expr1817 + expr1818 + expr1819).*expr351.*expr617 + (expr1820 + expr1821 + expr1822).*expr367.*expr621).*tpc.*cos(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr1830 = -(expr1823.*expr335.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc));
expr1831 = expr320.*expr564.*((expr1814 + expr1815 + expr1816).*expr335.*expr611 + (expr1817 + expr1818 + expr1819).*expr351.*expr617 + (expr1820 + expr1821 + expr1822).*expr367.*expr621).*tpc.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr1832 = expr564.*expr607.*((expr1814 + expr1815 + expr1816).*expr335.*expr611 + (expr1817 + expr1818 + expr1819).*expr351.*expr617 + (expr1820 + expr1821 + expr1822).*expr367.*expr621).*tpc.*cos(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr1833 = -(expr1825.*expr351.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc));
expr1834 = expr336.*expr564.*((expr1814 + expr1815 + expr1816).*expr335.*expr611 + (expr1817 + expr1818 + expr1819).*expr351.*expr617 + (expr1820 + expr1821 + expr1822).*expr367.*expr621).*tpc.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr1835 = expr564.*expr608.*((expr1814 + expr1815 + expr1816).*expr335.*expr611 + (expr1817 + expr1818 + expr1819).*expr351.*expr617 + (expr1820 + expr1821 + expr1822).*expr367.*expr621).*tpc.*cos(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr1836 = -(expr1827.*expr367.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc));
expr1837 = expr352.*expr564.*((expr1814 + expr1815 + expr1816).*expr335.*expr611 + (expr1817 + expr1818 + expr1819).*expr351.*expr617 + (expr1820 + expr1821 + expr1822).*expr367.*expr621).*tpc.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr1838 = expr1813.*expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr630;
expr1839 = -2.*expr1748.*expr335.*expr337.*expr353.*expr391.*expr403.*expr404.*expr568.*expr569.*expr570.*expr630;
expr1840 = expr1801.*expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409.*expr568.*expr570.*expr579.*expr630;
expr1841 = expr1824.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr631;
expr1842 = -2.*expr1748.*expr321.*expr351.*expr353.*expr391.*expr403.*expr404.*expr571.*expr572.*expr573.*expr631;
expr1843 = expr1826.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr632;
expr1844 = expr1149.*expr1812.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr409.*expr574.*expr576.*expr632;
expr1845 = -2.*expr1748.*expr321.*expr337.*expr367.*expr391.*expr403.*expr404.*expr574.*expr575.*expr576.*expr632;
expr1846 = expr1811.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr409.*expr571.*expr573.*expr631.*expr891;
expr1847 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*(-((expr1829 + expr1830 + expr1831).*expr633) + expr1828.*expr332.*expr564.*expr633.*expr636.*tpc);
expr1848 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*(-((expr1832 + expr1833 + expr1834).*expr641) + expr1828.*expr348.*expr564.*expr641.*expr642.*tpc);
expr1849 = expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*(-((expr1835 + expr1836 + expr1837).*expr646) + expr1828.*expr364.*expr564.*expr646.*expr647.*tpc);
expr1850 = integrate45 + integrate46 + integrate47 + integrate48 + 200.*(expr1838 + expr1839 + expr1840 + expr1841 + expr1842 + expr1843 + expr1844 + expr1845 + expr1846 + expr1847 + expr1848 + expr1849).*expr651.*WO;
gf(9) = expr1850;

%% Derivative for d(3)
w49 = [ws:(99.*ws)./100:100.*ws];
expr1851 = ((a(1).^2 + b(1).^2).^2 + w49.^2.*(w49.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr1852 = ((a(2).^2 + b(2).^2).^2 + w49.^2.*(w49.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr1853 = ((a(3).^2 + b(3).^2).^2 + w49.^2.*(w49.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr1854 = (c(1).^2 + d(1).^2).^2 + w49.^2.*(w49.^2 + 2.*(c(1).^2 - d(1).^2));
expr1855 = (c(2).^2 + d(2).^2).^2 + w49.^2.*(w49.^2 + 2.*(c(2).^2 - d(2).^2));
expr1856 = -4.*w49.^2.*d(3) + 4.*d(3).*(c(3).^2 + d(3).^2);
expr1857 = d(3);
expr1858 = (c(3).^2 + d(3).^2).^2 + w49.^2.*(w49.^2 + 2.*(c(3).^2 - d(3).^2));
expr1859 = expr1324.*expr1749.*expr1851.*expr1852.*expr1853.*expr1854.*expr1855.*expr1857.*expr1858.*expr379.*expr380.*expr383.*expr385.*expr387.*expr389.*Wms + expr1317.*expr1851.*expr1852.*expr1853.*expr1854.*expr1855.*expr1856.*expr379.*expr380.*expr383.*expr385.*expr387.*expr389.*expr391.*Wms;
integrate49 = trapz(w49, expr1859);
w50 = [0:wp./100:wp];
expr1860 = (a(1).^2 + b(1).^2).^2 + w50.^2.*(w50.^2 + 2.*(a(1).^2 - b(1).^2));
expr1861 = (a(2).^2 + b(2).^2).^2 + w50.^2.*(w50.^2 + 2.*(a(2).^2 - b(2).^2));
expr1862 = (a(3).^2 + b(3).^2).^2 + w50.^2.*(w50.^2 + 2.*(a(3).^2 - b(3).^2));
expr1863 = (c(1).^2 + d(1).^2).^2 + w50.^2.*(w50.^2 + 2.*(c(1).^2 - d(1).^2));
expr1864 = (c(2).^2 + d(2).^2).^2 + w50.^2.*(w50.^2 + 2.*(c(2).^2 - d(2).^2));
expr1865 = -4.*w50.^2.*d(3) + 4.*d(3).*(c(3).^2 + d(3).^2);
expr1866 = (c(3).^2 + d(3).^2).^2 + w50.^2.*(w50.^2 + 2.*(c(3).^2 - d(3).^2));
expr1867 = -1 + (expr1860.*expr1861.*expr1862).^expr397.*(expr1863.*expr1864.*expr1866).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405;
expr1868 = -2.*expr1857.*(expr1860.*expr1861.*expr1862).^expr397.*(expr1863.*expr1864.*expr1866).^expr409.*expr321.*expr337.*expr353.*expr391.*expr403.*expr404;
expr1869 = (expr1860.*expr1861.*expr1862).^expr397.*expr1863.*expr1864.*expr1865.*(expr1863.*expr1864.*expr1866).^expr397.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr1870 = 2.*expr1867.*(expr1868 + expr1869).*expr396.*Wmp;
integrate50 = trapz(w50, expr1870);
w51 = [wp:(-wp + ws)./100:ws];
expr1871 = (a(1).^2 + b(1).^2).^2 + w51.^2.*(w51.^2 + 2.*(a(1).^2 - b(1).^2));
expr1872 = (a(2).^2 + b(2).^2).^2 + w51.^2.*(w51.^2 + 2.*(a(2).^2 - b(2).^2));
expr1873 = (a(3).^2 + b(3).^2).^2 + w51.^2.*(w51.^2 + 2.*(a(3).^2 - b(3).^2));
expr1874 = (c(1).^2 + d(1).^2).^2 + w51.^2.*(w51.^2 + 2.*(c(1).^2 - d(1).^2));
expr1875 = (c(2).^2 + d(2).^2).^2 + w51.^2.*(w51.^2 + 2.*(c(2).^2 - d(2).^2));
expr1876 = -4.*w51.^2.*d(3) + 4.*d(3).*(c(3).^2 + d(3).^2);
expr1877 = (c(3).^2 + d(3).^2).^2 + w51.^2.*(w51.^2 + 2.*(c(3).^2 - d(3).^2));
expr1878 = -(w51./(wp - ws));
expr1879 = -2.*expr1857.*(expr1871.*expr1872.*expr1873).^expr397.*(expr1874.*expr1875.*expr1877).^expr409.*expr321.*expr337.*expr353.*expr391.*expr403.*expr404;
expr1880 = (expr1871.*expr1872.*expr1873).^expr397.*expr1874.*expr1875.*expr1876.*(expr1874.*expr1875.*expr1877).^expr397.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr1881 = expr1878 + (expr1871.*expr1872.*expr1873).^expr397.*(expr1874.*expr1875.*expr1877).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405 + expr423;
expr1882 = 2.*(expr1879 + expr1880).*expr1881.*expr414.*Wmt;
integrate51 = trapz(w51, expr1882);
w52 = [0:wmax./100:wmax];
expr1883 = 1./(c(3).*(1 + (w52 - d(3)).^2./c(3).^2));
expr1884 = -(1./(c(3).*(1 + (w52 + d(3)).^2./c(3).^2)));
expr1885 = 2.*(angle(1 + (i.*(wmax - d(3)))./c(3)) + angle(1 + (i.*(wmax + d(3)))./c(3))).*d(3);
expr1886 = (-2.*(wmax - d(3)).*d(3))./(c(3).*(1 + (wmax - d(3)).^2./c(3).^2));
expr1887 = (-2.*d(3).*(wmax + d(3)))./(c(3).*(1 + (wmax + d(3)).^2./c(3).^2));
expr1888 = -(1./(c(3).*(1 + (wmax - d(3)).^2./c(3).^2)));
expr1889 = 1./(c(3).*(1 + (wmax + d(3)).^2./c(3).^2));
expr1890 = c(3).*log(1 + (wmax - d(3)).^2./c(3).^2);
expr1891 = -(c(3).*log(1 + (wmax + d(3)).^2./c(3).^2));
expr1892 = angle(1 + (i.*(w52 - b(1)))./a(1));
expr1893 = angle(1 + (i.*(w52 + b(1)))./a(1));
expr1894 = angle(1 + (i.*(w52 - b(2)))./a(2));
expr1895 = angle(1 + (i.*(w52 + b(2)))./a(2));
expr1896 = angle(1 + (i.*(w52 - b(3)))./a(3));
expr1897 = angle(1 + (i.*(w52 + b(3)))./a(3));
expr1898 = -angle(1 + (i.*(w52 - d(1)))./c(1));
expr1899 = -angle(1 + (i.*(w52 + d(1)))./c(1));
expr1900 = -angle(1 + (i.*(w52 - d(2)))./c(2));
expr1901 = -angle(1 + (i.*(w52 + d(2)))./c(2));
expr1902 = -angle(1 + (i.*(w52 - d(3)))./c(3));
expr1903 = -angle(1 + (i.*(w52 + d(3)))./c(3));
expr1904 = expr1883 + expr1884 + expr402.*expr431.*(expr1885 + expr1886 + expr1887 + expr1890 + expr1891 + (expr1888 + expr1889).*expr479).*w52;
expr1905 = 2.*expr1904.*expr428.*(expr1892 + expr1893 + expr1894 + expr1895 + expr1896 + expr1897 + expr1898 + expr1899 + expr1900 + expr1901 + expr1902 + expr1903 - 3.*expr431.*(expr483 + expr484 + expr485 + expr486 + expr487 + expr488).*w52).*Wph;
integrate52 = trapz(w52, expr1905);
expr1906 = 1./((a(1) - c(3)).*(1 + (b(1) - d(3)).^2./(a(1) - c(3)).^2));
expr1907 = 1./((a(2) - c(3)).*(1 + (b(2) - d(3)).^2./(a(2) - c(3)).^2));
expr1908 = 1./((a(3) - c(3)).*(1 + (b(3) - d(3)).^2./(a(3) - c(3)).^2));
expr1909 = -2.*expr504.*expr505.*expr506.*expr507.*expr509.*expr553 + 2.*expr504.*expr505.*expr506.*expr507.*expr508.*expr724;
expr1910 = expr332.*(expr1906 + expr736).*cos(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331) - expr320.*(expr1906 + expr736).*sin(expr322 + expr323 + expr324 + expr325 + expr326 + expr327 + expr328 + expr329 + expr330 + expr331);
expr1911 = expr1906 + expr736;
expr1912 = (expr1000 + expr1907).*expr348.*cos(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347) - (expr1000 + expr1907).*expr336.*sin(expr338 + expr339 + expr340 + expr341 + expr342 + expr343 + expr344 + expr345 + expr346 + expr347);
expr1913 = expr1000 + expr1907;
expr1914 = (expr1258 + expr1908).*expr364.*cos(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363) - (expr1258 + expr1908).*expr352.*sin(expr354 + expr355 + expr356 + expr357 + expr358 + expr359 + expr360 + expr361 + expr362 + expr363);
expr1915 = expr1258 + expr1908;
expr1916 = 2.*expr1005.*expr514.*expr515.*expr516.*expr517.*expr518 - 2.*expr514.*expr515.*expr516.*expr517.*expr519.*expr869;
expr1917 = 2.*expr1260.*expr524.*expr525.*expr526.*expr527.*expr528 - 2.*expr1133.*expr524.*expr525.*expr526.*expr527.*expr529;
expr1918 = (expr1911.*expr320.*expr321.*expr369.*expr587)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369);
expr1919 = -((expr1910.*expr320.*expr321.*expr368.*expr589)./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369));
expr1920 = -((expr320.*expr321.*expr368.*expr369.*(-(expr1911.*expr321.*expr332.*expr369.*expr587) + expr1910.*expr321.*expr332.*expr368.*expr589))./(expr333 + expr334 - expr321.*expr332.*expr368.*expr369).^2);
expr1921 = -((expr1912.*expr336.*expr337.*expr370.*expr591)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371));
expr1922 = (expr1913.*expr336.*expr337.*expr371.*expr593)./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371);
expr1923 = -((expr336.*expr337.*expr370.*expr371.*(expr1912.*expr337.*expr348.*expr370.*expr591 - expr1913.*expr337.*expr348.*expr371.*expr593))./(expr349 + expr350 - expr337.*expr348.*expr370.*expr371).^2);
expr1924 = -((expr1914.*expr352.*expr353.*expr372.*expr597)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373));
expr1925 = (expr1915.*expr352.*expr353.*expr373.*expr599)./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373);
expr1926 = -((expr352.*expr353.*expr372.*expr373.*(expr1914.*expr353.*expr364.*expr372.*expr597 - expr1915.*expr353.*expr364.*expr373.*expr599))./(expr365 + expr366 - expr353.*expr364.*expr372.*expr373).^2);
expr1927 = -(expr1911.*expr321.*expr369.*expr587) + expr1910.*expr321.*expr368.*expr589;
expr1928 = expr1912.*expr337.*expr370.*expr591 - expr1913.*expr337.*expr371.*expr593;
expr1929 = expr1914.*expr353.*expr372.*expr597 - expr1915.*expr353.*expr373.*expr599;
expr1930 = (expr1918 + expr1919 + expr1920).*expr335.*expr611 + (expr1921 + expr1922 + expr1923).*expr351.*expr617 + (expr1924 + expr1925 + expr1926).*expr367.*expr621;
expr1931 = expr564.*expr606.*((expr1918 + expr1919 + expr1920).*expr335.*expr611 + (expr1921 + expr1922 + expr1923).*expr351.*expr617 + (expr1924 + expr1925 + expr1926).*expr367.*expr621).*tpc.*cos(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr1932 = -(expr1927.*expr335.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc));
expr1933 = expr320.*expr564.*((expr1918 + expr1919 + expr1920).*expr335.*expr611 + (expr1921 + expr1922 + expr1923).*expr351.*expr617 + (expr1924 + expr1925 + expr1926).*expr367.*expr621).*tpc.*sin(expr319.*expr320.*(expr374 + expr375 + expr376).*tpc);
expr1934 = expr564.*expr607.*((expr1918 + expr1919 + expr1920).*expr335.*expr611 + (expr1921 + expr1922 + expr1923).*expr351.*expr617 + (expr1924 + expr1925 + expr1926).*expr367.*expr621).*tpc.*cos(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr1935 = -(expr1928.*expr351.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc));
expr1936 = expr336.*expr564.*((expr1918 + expr1919 + expr1920).*expr335.*expr611 + (expr1921 + expr1922 + expr1923).*expr351.*expr617 + (expr1924 + expr1925 + expr1926).*expr367.*expr621).*tpc.*sin(expr319.*expr336.*(expr374 + expr375 + expr376).*tpc);
expr1937 = expr564.*expr608.*((expr1918 + expr1919 + expr1920).*expr335.*expr611 + (expr1921 + expr1922 + expr1923).*expr351.*expr617 + (expr1924 + expr1925 + expr1926).*expr367.*expr621).*tpc.*cos(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr1938 = -(expr1929.*expr367.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc));
expr1939 = expr352.*expr564.*((expr1918 + expr1919 + expr1920).*expr335.*expr611 + (expr1921 + expr1922 + expr1923).*expr351.*expr617 + (expr1924 + expr1925 + expr1926).*expr367.*expr621).*tpc.*sin(expr319.*expr352.*(expr374 + expr375 + expr376).*tpc);
expr1940 = expr1910.*expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr630;
expr1941 = -2.*expr1857.*expr335.*expr337.*expr353.*expr391.*expr403.*expr404.*expr568.*expr569.*expr570.*expr630;
expr1942 = expr1909.*expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409.*expr568.*expr570.*expr579.*expr630;
expr1943 = expr1912.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr631;
expr1944 = -2.*expr1857.*expr321.*expr351.*expr353.*expr391.*expr403.*expr404.*expr571.*expr572.*expr573.*expr631;
expr1945 = expr1914.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr632;
expr1946 = expr1149.*expr1917.*expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr409.*expr574.*expr576.*expr632;
expr1947 = -2.*expr1857.*expr321.*expr337.*expr367.*expr391.*expr403.*expr404.*expr574.*expr575.*expr576.*expr632;
expr1948 = expr1916.*expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr409.*expr571.*expr573.*expr631.*expr891;
expr1949 = expr335.*expr337.*expr353.*expr403.*expr404.*expr405.*expr568.*expr569.*expr570.*(-((expr1931 + expr1932 + expr1933).*expr633) + expr1930.*expr332.*expr564.*expr633.*expr636.*tpc);
expr1950 = expr321.*expr351.*expr353.*expr403.*expr404.*expr405.*expr571.*expr572.*expr573.*(-((expr1934 + expr1935 + expr1936).*expr641) + expr1930.*expr348.*expr564.*expr641.*expr642.*tpc);
expr1951 = expr321.*expr337.*expr367.*expr403.*expr404.*expr405.*expr574.*expr575.*expr576.*(-((expr1937 + expr1938 + expr1939).*expr646) + expr1930.*expr364.*expr564.*expr646.*expr647.*tpc);
expr1952 = integrate49 + integrate50 + integrate51 + integrate52 + 200.*(expr1940 + expr1941 + expr1942 + expr1943 + expr1944 + expr1945 + expr1946 + expr1947 + expr1948 + expr1949 + expr1950 + expr1951).*expr651.*WO;
gf(12) = expr1952;

%% Derivative of constraints on the cost function

%%   First derivative w/r to a(1) of constraint #1
expr1953 = -1./(2.*sqrt(a(1).^2 + b(1).^2)) + sqrt(a(1).^2 + b(1).^2)./(2.*a(1).^2);
GC(1, 1) = expr1953;

%%   First derivative w/r to a(1) of constraint #2
expr1954 = 0;
GC(1, 2) = expr1954;

%%   First derivative w/r to a(1) of constraint #3
expr1955 = 0;
GC(1, 3) = expr1955;

%%   First derivative w/r to a(1) of constraint #4
expr1956 = (wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr1957 = (wp.^2.*(wp.^2./100 + 2.*(a(2).^2 - b(2).^2)))./100;
expr1958 = (wp.^2.*(wp.^2./100 + 2.*(a(3).^2 - b(3).^2)))./100;
expr1959 = (wp.^2.*(wp.^2./100 + 2.*(a(1).^2 - b(1).^2)))./100;
expr1960 = (c(1).^2 + d(1).^2).^2;
expr1961 = (wp.^2.*(wp.^2./100 + 2.*(c(1).^2 - d(1).^2)))./100;
expr1962 = (c(2).^2 + d(2).^2).^2;
expr1963 = (wp.^2.*(wp.^2./100 + 2.*(c(2).^2 - d(2).^2)))./100;
expr1964 = (c(3).^2 + d(3).^2).^2;
expr1965 = (wp.^2.*(wp.^2./100 + 2.*(c(3).^2 - d(3).^2)))./100;
expr1966 = 2.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr332.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr1967 = expr1956.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr353.*(expr1957 + expr383).*(expr1958 + expr385).*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr1968 = expr1966 + expr1967;
GC(1, 4) = expr1968;

%%   First derivative w/r to a(1) of constraint #5
expr1969 = -2.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr332.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr1970 = expr1956.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr353.*(expr1957 + expr383).*(expr1958 + expr385).*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr1971 = expr1969 + expr1970;
GC(1, 5) = expr1971;

%%   First derivative w/r to a(1) of constraint #6
expr1972 = (4.*wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr1973 = (wp.^2.*(wp.^2./25 + 2.*(a(2).^2 - b(2).^2)))./25;
expr1974 = (wp.^2.*(wp.^2./25 + 2.*(a(3).^2 - b(3).^2)))./25;
expr1975 = (wp.^2.*(wp.^2./25 + 2.*(a(1).^2 - b(1).^2)))./25;
expr1976 = (wp.^2.*(wp.^2./25 + 2.*(c(1).^2 - d(1).^2)))./25;
expr1977 = (wp.^2.*(wp.^2./25 + 2.*(c(2).^2 - d(2).^2)))./25;
expr1978 = (wp.^2.*(wp.^2./25 + 2.*(c(3).^2 - d(3).^2)))./25;
expr1979 = 2.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr332.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr1980 = expr1972.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr353.*(expr1973 + expr383).*(expr1974 + expr385).*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr1981 = expr1979 + expr1980;
GC(1, 6) = expr1981;

%%   First derivative w/r to a(1) of constraint #7
expr1982 = -2.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr332.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr1983 = expr1972.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr353.*(expr1973 + expr383).*(expr1974 + expr385).*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr1984 = expr1982 + expr1983;
GC(1, 7) = expr1984;

%%   First derivative w/r to a(1) of constraint #8
expr1985 = (9.*wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr1986 = (9.*wp.^2.*((9.*wp.^2)./100 + 2.*(a(2).^2 - b(2).^2)))./100;
expr1987 = (9.*wp.^2.*((9.*wp.^2)./100 + 2.*(a(3).^2 - b(3).^2)))./100;
expr1988 = (9.*wp.^2.*((9.*wp.^2)./100 + 2.*(a(1).^2 - b(1).^2)))./100;
expr1989 = (9.*wp.^2.*((9.*wp.^2)./100 + 2.*(c(1).^2 - d(1).^2)))./100;
expr1990 = (9.*wp.^2.*((9.*wp.^2)./100 + 2.*(c(2).^2 - d(2).^2)))./100;
expr1991 = (9.*wp.^2.*((9.*wp.^2)./100 + 2.*(c(3).^2 - d(3).^2)))./100;
expr1992 = 2.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr332.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr1993 = expr1985.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr353.*(expr1986 + expr383).*(expr1987 + expr385).*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr1994 = expr1992 + expr1993;
GC(1, 8) = expr1994;

%%   First derivative w/r to a(1) of constraint #9
expr1995 = -2.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr332.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr1996 = expr1985.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr353.*(expr1986 + expr383).*(expr1987 + expr385).*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr1997 = expr1995 + expr1996;
GC(1, 9) = expr1997;

%%   First derivative w/r to a(1) of constraint #10
expr1998 = (16.*wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr1999 = (4.*wp.^2.*((4.*wp.^2)./25 + 2.*(a(2).^2 - b(2).^2)))./25;
expr2000 = (4.*wp.^2.*((4.*wp.^2)./25 + 2.*(a(3).^2 - b(3).^2)))./25;
expr2001 = (4.*wp.^2.*((4.*wp.^2)./25 + 2.*(a(1).^2 - b(1).^2)))./25;
expr2002 = (4.*wp.^2.*((4.*wp.^2)./25 + 2.*(c(1).^2 - d(1).^2)))./25;
expr2003 = (4.*wp.^2.*((4.*wp.^2)./25 + 2.*(c(2).^2 - d(2).^2)))./25;
expr2004 = (4.*wp.^2.*((4.*wp.^2)./25 + 2.*(c(3).^2 - d(3).^2)))./25;
expr2005 = 2.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr332.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2006 = expr1998.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr353.*(expr1999 + expr383).*(expr2000 + expr385).*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2007 = expr2005 + expr2006;
GC(1, 10) = expr2007;

%%   First derivative w/r to a(1) of constraint #11
expr2008 = -2.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr332.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2009 = expr1998.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr353.*(expr1999 + expr383).*(expr2000 + expr385).*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2010 = expr2008 + expr2009;
GC(1, 11) = expr2010;

%%   First derivative w/r to a(1) of constraint #12
expr2011 = wp.^2.*a(1) + 4.*a(1).*(a(1).^2 + b(1).^2);
expr2012 = (wp.^2.*(wp.^2./4 + 2.*(a(2).^2 - b(2).^2)))./4;
expr2013 = (wp.^2.*(wp.^2./4 + 2.*(a(3).^2 - b(3).^2)))./4;
expr2014 = (wp.^2.*(wp.^2./4 + 2.*(a(1).^2 - b(1).^2)))./4;
expr2015 = (wp.^2.*(wp.^2./4 + 2.*(c(1).^2 - d(1).^2)))./4;
expr2016 = (wp.^2.*(wp.^2./4 + 2.*(c(2).^2 - d(2).^2)))./4;
expr2017 = (wp.^2.*(wp.^2./4 + 2.*(c(3).^2 - d(3).^2)))./4;
expr2018 = 2.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr332.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2019 = expr2011.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr353.*(expr2012 + expr383).*(expr2013 + expr385).*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2020 = expr2018 + expr2019;
GC(1, 12) = expr2020;

%%   First derivative w/r to a(1) of constraint #13
expr2021 = -2.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr332.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2022 = expr2011.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr353.*(expr2012 + expr383).*(expr2013 + expr385).*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2023 = expr2021 + expr2022;
GC(1, 13) = expr2023;

%%   First derivative w/r to a(1) of constraint #14
expr2024 = (36.*wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr2025 = (9.*wp.^2.*((9.*wp.^2)./25 + 2.*(a(2).^2 - b(2).^2)))./25;
expr2026 = (9.*wp.^2.*((9.*wp.^2)./25 + 2.*(a(3).^2 - b(3).^2)))./25;
expr2027 = (9.*wp.^2.*((9.*wp.^2)./25 + 2.*(a(1).^2 - b(1).^2)))./25;
expr2028 = (9.*wp.^2.*((9.*wp.^2)./25 + 2.*(c(1).^2 - d(1).^2)))./25;
expr2029 = (9.*wp.^2.*((9.*wp.^2)./25 + 2.*(c(2).^2 - d(2).^2)))./25;
expr2030 = (9.*wp.^2.*((9.*wp.^2)./25 + 2.*(c(3).^2 - d(3).^2)))./25;
expr2031 = 2.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr332.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2032 = expr2024.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr353.*(expr2025 + expr383).*(expr2026 + expr385).*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2033 = expr2031 + expr2032;
GC(1, 14) = expr2033;

%%   First derivative w/r to a(1) of constraint #15
expr2034 = -2.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr332.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2035 = expr2024.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr353.*(expr2025 + expr383).*(expr2026 + expr385).*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2036 = expr2034 + expr2035;
GC(1, 15) = expr2036;

%%   First derivative w/r to a(1) of constraint #16
expr2037 = (49.*wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr2038 = (49.*wp.^2.*((49.*wp.^2)./100 + 2.*(a(2).^2 - b(2).^2)))./100;
expr2039 = (49.*wp.^2.*((49.*wp.^2)./100 + 2.*(a(3).^2 - b(3).^2)))./100;
expr2040 = (49.*wp.^2.*((49.*wp.^2)./100 + 2.*(a(1).^2 - b(1).^2)))./100;
expr2041 = (49.*wp.^2.*((49.*wp.^2)./100 + 2.*(c(1).^2 - d(1).^2)))./100;
expr2042 = (49.*wp.^2.*((49.*wp.^2)./100 + 2.*(c(2).^2 - d(2).^2)))./100;
expr2043 = (49.*wp.^2.*((49.*wp.^2)./100 + 2.*(c(3).^2 - d(3).^2)))./100;
expr2044 = 2.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr332.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2045 = expr2037.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr353.*(expr2038 + expr383).*(expr2039 + expr385).*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2046 = expr2044 + expr2045;
GC(1, 16) = expr2046;

%%   First derivative w/r to a(1) of constraint #17
expr2047 = -2.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr332.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2048 = expr2037.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr353.*(expr2038 + expr383).*(expr2039 + expr385).*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2049 = expr2047 + expr2048;
GC(1, 17) = expr2049;

%%   First derivative w/r to a(1) of constraint #18
expr2050 = (64.*wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr2051 = (16.*wp.^2.*((16.*wp.^2)./25 + 2.*(a(2).^2 - b(2).^2)))./25;
expr2052 = (16.*wp.^2.*((16.*wp.^2)./25 + 2.*(a(3).^2 - b(3).^2)))./25;
expr2053 = (16.*wp.^2.*((16.*wp.^2)./25 + 2.*(a(1).^2 - b(1).^2)))./25;
expr2054 = (16.*wp.^2.*((16.*wp.^2)./25 + 2.*(c(1).^2 - d(1).^2)))./25;
expr2055 = (16.*wp.^2.*((16.*wp.^2)./25 + 2.*(c(2).^2 - d(2).^2)))./25;
expr2056 = (16.*wp.^2.*((16.*wp.^2)./25 + 2.*(c(3).^2 - d(3).^2)))./25;
expr2057 = 2.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr332.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2058 = expr2050.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr353.*(expr2051 + expr383).*(expr2052 + expr385).*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2059 = expr2057 + expr2058;
GC(1, 18) = expr2059;

%%   First derivative w/r to a(1) of constraint #19
expr2060 = -2.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr332.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2061 = expr2050.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr353.*(expr2051 + expr383).*(expr2052 + expr385).*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2062 = expr2060 + expr2061;
GC(1, 19) = expr2062;

%%   First derivative w/r to a(1) of constraint #20
expr2063 = (81.*wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr2064 = (81.*wp.^2.*((81.*wp.^2)./100 + 2.*(a(2).^2 - b(2).^2)))./100;
expr2065 = (81.*wp.^2.*((81.*wp.^2)./100 + 2.*(a(3).^2 - b(3).^2)))./100;
expr2066 = (81.*wp.^2.*((81.*wp.^2)./100 + 2.*(a(1).^2 - b(1).^2)))./100;
expr2067 = (81.*wp.^2.*((81.*wp.^2)./100 + 2.*(c(1).^2 - d(1).^2)))./100;
expr2068 = (81.*wp.^2.*((81.*wp.^2)./100 + 2.*(c(2).^2 - d(2).^2)))./100;
expr2069 = (81.*wp.^2.*((81.*wp.^2)./100 + 2.*(c(3).^2 - d(3).^2)))./100;
expr2070 = 2.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr332.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2071 = expr2063.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr353.*(expr2064 + expr383).*(expr2065 + expr385).*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2072 = expr2070 + expr2071;
GC(1, 20) = expr2072;

%%   First derivative w/r to a(1) of constraint #21
expr2073 = -2.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr332.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2074 = expr2063.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr353.*(expr2064 + expr383).*(expr2065 + expr385).*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2075 = expr2073 + expr2074;
GC(1, 21) = expr2075;

%%   First derivative w/r to a(1) of constraint #22
expr2076 = 4.*wp.^2.*a(1) + 4.*a(1).*(a(1).^2 + b(1).^2);
expr2077 = (a(2).^2 + b(2).^2).^2 + wp.^2.*(wp.^2 + 2.*(a(2).^2 - b(2).^2));
expr2078 = (a(3).^2 + b(3).^2).^2 + wp.^2.*(wp.^2 + 2.*(a(3).^2 - b(3).^2));
expr2079 = (a(1).^2 + b(1).^2).^2 + wp.^2.*(wp.^2 + 2.*(a(1).^2 - b(1).^2));
expr2080 = (c(1).^2 + d(1).^2).^2 + wp.^2.*(wp.^2 + 2.*(c(1).^2 - d(1).^2));
expr2081 = (c(2).^2 + d(2).^2).^2 + wp.^2.*(wp.^2 + 2.*(c(2).^2 - d(2).^2));
expr2082 = (c(3).^2 + d(3).^2).^2 + wp.^2.*(wp.^2 + 2.*(c(3).^2 - d(3).^2));
expr2083 = 2.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr332.*expr337.*expr353.*expr403.*expr404.*expr405;
expr2084 = expr2076.*expr2077.*expr2078.*(expr2077.*expr2078.*expr2079).^expr402.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2085 = expr2083 + expr2084;
GC(1, 22) = expr2085;

%%   First derivative w/r to a(1) of constraint #23
expr2086 = -2.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr332.*expr337.*expr353.*expr403.*expr404.*expr405;
expr2087 = expr2076.*expr2077.*expr2078.*(expr2077.*expr2078.*expr2079).^expr402.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2088 = expr2086 + expr2087;
GC(1, 23) = expr2088;

%%   First derivative w/r to a(1) of constraint #24
expr2089 = 4.*ws.^2.*a(1) + 4.*a(1).*(a(1).^2 + b(1).^2);
expr2090 = (a(2).^2 + b(2).^2).^2 + ws.^2.*(ws.^2 + 2.*(a(2).^2 - b(2).^2));
expr2091 = (a(3).^2 + b(3).^2).^2 + ws.^2.*(ws.^2 + 2.*(a(3).^2 - b(3).^2));
expr2092 = (a(1).^2 + b(1).^2).^2 + ws.^2.*(ws.^2 + 2.*(a(1).^2 - b(1).^2));
expr2093 = (c(1).^2 + d(1).^2).^2 + ws.^2.*(ws.^2 + 2.*(c(1).^2 - d(1).^2));
expr2094 = (c(2).^2 + d(2).^2).^2 + ws.^2.*(ws.^2 + 2.*(c(2).^2 - d(2).^2));
expr2095 = (c(3).^2 + d(3).^2).^2 + ws.^2.*(ws.^2 + 2.*(c(3).^2 - d(3).^2));
expr2096 = 2.*(expr2090.*expr2091.*expr2092).^expr397.*(expr2093.*expr2094.*expr2095).^expr409.*expr332.*expr337.*expr353.*expr403.*expr404.*expr405;
expr2097 = expr2089.*expr2090.*expr2091.*(expr2090.*expr2091.*expr2092).^expr402.*(expr2093.*expr2094.*expr2095).^expr409.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2098 = expr2096 + expr2097;
GC(1, 24) = expr2098;

%%   First derivative w/r to a(1) of constraint #25
expr2099 = expr652 + expr653 + expr654 + expr655 + expr656 + expr657 + expr658 + expr659 + expr660 + expr661 + expr662 + expr663;
GC(1, 25) = expr2099;

%%   First derivative w/r to a(2) of constraint #1
expr2100 = 0;
GC(2, 1) = expr2100;

%%   First derivative w/r to a(2) of constraint #2
expr2101 = -1./(2.*sqrt(a(2).^2 + b(2).^2)) + sqrt(a(2).^2 + b(2).^2)./(2.*a(2).^2);
GC(2, 2) = expr2101;

%%   First derivative w/r to a(2) of constraint #3
expr2102 = 0;
GC(2, 3) = expr2102;

%%   First derivative w/r to a(2) of constraint #4
expr2103 = (wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr2104 = 2.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr348.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2105 = ((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr2103.*expr321.*expr337.*expr353.*(expr1959 + expr380).*(expr1958 + expr385).*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2106 = expr2104 + expr2105;
GC(2, 4) = expr2106;

%%   First derivative w/r to a(2) of constraint #5
expr2107 = -2.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr348.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2108 = ((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr2103.*expr321.*expr337.*expr353.*(expr1959 + expr380).*(expr1958 + expr385).*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2109 = expr2107 + expr2108;
GC(2, 5) = expr2109;

%%   First derivative w/r to a(2) of constraint #6
expr2110 = (4.*wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr2111 = 2.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr348.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2112 = ((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr2110.*expr321.*expr337.*expr353.*(expr1975 + expr380).*(expr1974 + expr385).*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2113 = expr2111 + expr2112;
GC(2, 6) = expr2113;

%%   First derivative w/r to a(2) of constraint #7
expr2114 = -2.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr348.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2115 = ((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr2110.*expr321.*expr337.*expr353.*(expr1975 + expr380).*(expr1974 + expr385).*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2116 = expr2114 + expr2115;
GC(2, 7) = expr2116;

%%   First derivative w/r to a(2) of constraint #8
expr2117 = (9.*wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr2118 = 2.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr348.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2119 = ((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr2117.*expr321.*expr337.*expr353.*(expr1988 + expr380).*(expr1987 + expr385).*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2120 = expr2118 + expr2119;
GC(2, 8) = expr2120;

%%   First derivative w/r to a(2) of constraint #9
expr2121 = -2.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr348.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2122 = ((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr2117.*expr321.*expr337.*expr353.*(expr1988 + expr380).*(expr1987 + expr385).*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2123 = expr2121 + expr2122;
GC(2, 9) = expr2123;

%%   First derivative w/r to a(2) of constraint #10
expr2124 = (16.*wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr2125 = 2.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr348.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2126 = ((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr2124.*expr321.*expr337.*expr353.*(expr2001 + expr380).*(expr2000 + expr385).*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2127 = expr2125 + expr2126;
GC(2, 10) = expr2127;

%%   First derivative w/r to a(2) of constraint #11
expr2128 = -2.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr348.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2129 = ((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr2124.*expr321.*expr337.*expr353.*(expr2001 + expr380).*(expr2000 + expr385).*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2130 = expr2128 + expr2129;
GC(2, 11) = expr2130;

%%   First derivative w/r to a(2) of constraint #12
expr2131 = wp.^2.*a(2) + 4.*a(2).*(a(2).^2 + b(2).^2);
expr2132 = 2.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr348.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2133 = ((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr2131.*expr321.*expr337.*expr353.*(expr2014 + expr380).*(expr2013 + expr385).*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2134 = expr2132 + expr2133;
GC(2, 12) = expr2134;

%%   First derivative w/r to a(2) of constraint #13
expr2135 = -2.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr348.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2136 = ((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr2131.*expr321.*expr337.*expr353.*(expr2014 + expr380).*(expr2013 + expr385).*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2137 = expr2135 + expr2136;
GC(2, 13) = expr2137;

%%   First derivative w/r to a(2) of constraint #14
expr2138 = (36.*wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr2139 = 2.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr348.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2140 = ((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr2138.*expr321.*expr337.*expr353.*(expr2027 + expr380).*(expr2026 + expr385).*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2141 = expr2139 + expr2140;
GC(2, 14) = expr2141;

%%   First derivative w/r to a(2) of constraint #15
expr2142 = -2.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr348.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2143 = ((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr2138.*expr321.*expr337.*expr353.*(expr2027 + expr380).*(expr2026 + expr385).*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2144 = expr2142 + expr2143;
GC(2, 15) = expr2144;

%%   First derivative w/r to a(2) of constraint #16
expr2145 = (49.*wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr2146 = 2.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr348.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2147 = ((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr2145.*expr321.*expr337.*expr353.*(expr2040 + expr380).*(expr2039 + expr385).*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2148 = expr2146 + expr2147;
GC(2, 16) = expr2148;

%%   First derivative w/r to a(2) of constraint #17
expr2149 = -2.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr348.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2150 = ((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr2145.*expr321.*expr337.*expr353.*(expr2040 + expr380).*(expr2039 + expr385).*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2151 = expr2149 + expr2150;
GC(2, 17) = expr2151;

%%   First derivative w/r to a(2) of constraint #18
expr2152 = (64.*wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr2153 = 2.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr348.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2154 = ((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr2152.*expr321.*expr337.*expr353.*(expr2053 + expr380).*(expr2052 + expr385).*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2155 = expr2153 + expr2154;
GC(2, 18) = expr2155;

%%   First derivative w/r to a(2) of constraint #19
expr2156 = -2.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr348.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2157 = ((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr2152.*expr321.*expr337.*expr353.*(expr2053 + expr380).*(expr2052 + expr385).*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2158 = expr2156 + expr2157;
GC(2, 19) = expr2158;

%%   First derivative w/r to a(2) of constraint #20
expr2159 = (81.*wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr2160 = 2.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr348.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2161 = ((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr2159.*expr321.*expr337.*expr353.*(expr2066 + expr380).*(expr2065 + expr385).*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2162 = expr2160 + expr2161;
GC(2, 20) = expr2162;

%%   First derivative w/r to a(2) of constraint #21
expr2163 = -2.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr348.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2164 = ((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr2159.*expr321.*expr337.*expr353.*(expr2066 + expr380).*(expr2065 + expr385).*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2165 = expr2163 + expr2164;
GC(2, 21) = expr2165;

%%   First derivative w/r to a(2) of constraint #22
expr2166 = 4.*wp.^2.*a(2) + 4.*a(2).*(a(2).^2 + b(2).^2);
expr2167 = 2.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr348.*expr353.*expr403.*expr404.*expr405;
expr2168 = expr2078.*expr2079.*(expr2077.*expr2078.*expr2079).^expr402.*(expr2080.*expr2081.*expr2082).^expr409.*expr2166.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2169 = expr2167 + expr2168;
GC(2, 22) = expr2169;

%%   First derivative w/r to a(2) of constraint #23
expr2170 = -2.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr348.*expr353.*expr403.*expr404.*expr405;
expr2171 = expr2078.*expr2079.*(expr2077.*expr2078.*expr2079).^expr402.*(expr2080.*expr2081.*expr2082).^expr409.*expr2166.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2172 = expr2170 + expr2171;
GC(2, 23) = expr2172;

%%   First derivative w/r to a(2) of constraint #24
expr2173 = 4.*ws.^2.*a(2) + 4.*a(2).*(a(2).^2 + b(2).^2);
expr2174 = 2.*(expr2090.*expr2091.*expr2092).^expr397.*(expr2093.*expr2094.*expr2095).^expr409.*expr321.*expr348.*expr353.*expr403.*expr404.*expr405;
expr2175 = expr2091.*expr2092.*(expr2090.*expr2091.*expr2092).^expr402.*(expr2093.*expr2094.*expr2095).^expr409.*expr2173.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2176 = expr2174 + expr2175;
GC(2, 24) = expr2176;

%%   First derivative w/r to a(2) of constraint #25
expr2177 = expr922 + expr923 + expr924 + expr925 + expr926 + expr927 + expr928 + expr929 + expr930 + expr931 + expr932 + expr933;
GC(2, 25) = expr2177;

%%   First derivative w/r to a(3) of constraint #1
expr2178 = 0;
GC(3, 1) = expr2178;

%%   First derivative w/r to a(3) of constraint #2
expr2179 = 0;
GC(3, 2) = expr2179;

%%   First derivative w/r to a(3) of constraint #3
expr2180 = -1./(2.*sqrt(a(3).^2 + b(3).^2)) + sqrt(a(3).^2 + b(3).^2)./(2.*a(3).^2);
GC(3, 3) = expr2180;

%%   First derivative w/r to a(3) of constraint #4
expr2181 = (wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr2182 = 2.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr364.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2183 = ((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr2181.*expr321.*expr337.*expr353.*(expr1959 + expr380).*(expr1957 + expr383).*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2184 = expr2182 + expr2183;
GC(3, 4) = expr2184;

%%   First derivative w/r to a(3) of constraint #5
expr2185 = -2.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr364.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2186 = ((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr2181.*expr321.*expr337.*expr353.*(expr1959 + expr380).*(expr1957 + expr383).*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2187 = expr2185 + expr2186;
GC(3, 5) = expr2187;

%%   First derivative w/r to a(3) of constraint #6
expr2188 = (4.*wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr2189 = 2.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr364.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2190 = ((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr2188.*expr321.*expr337.*expr353.*(expr1975 + expr380).*(expr1973 + expr383).*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2191 = expr2189 + expr2190;
GC(3, 6) = expr2191;

%%   First derivative w/r to a(3) of constraint #7
expr2192 = -2.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr364.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2193 = ((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr2188.*expr321.*expr337.*expr353.*(expr1975 + expr380).*(expr1973 + expr383).*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2194 = expr2192 + expr2193;
GC(3, 7) = expr2194;

%%   First derivative w/r to a(3) of constraint #8
expr2195 = (9.*wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr2196 = 2.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr364.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2197 = ((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr2195.*expr321.*expr337.*expr353.*(expr1988 + expr380).*(expr1986 + expr383).*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2198 = expr2196 + expr2197;
GC(3, 8) = expr2198;

%%   First derivative w/r to a(3) of constraint #9
expr2199 = -2.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr364.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2200 = ((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr2195.*expr321.*expr337.*expr353.*(expr1988 + expr380).*(expr1986 + expr383).*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2201 = expr2199 + expr2200;
GC(3, 9) = expr2201;

%%   First derivative w/r to a(3) of constraint #10
expr2202 = (16.*wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr2203 = 2.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr364.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2204 = ((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr2202.*expr321.*expr337.*expr353.*(expr2001 + expr380).*(expr1999 + expr383).*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2205 = expr2203 + expr2204;
GC(3, 10) = expr2205;

%%   First derivative w/r to a(3) of constraint #11
expr2206 = -2.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr364.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2207 = ((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr2202.*expr321.*expr337.*expr353.*(expr2001 + expr380).*(expr1999 + expr383).*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2208 = expr2206 + expr2207;
GC(3, 11) = expr2208;

%%   First derivative w/r to a(3) of constraint #12
expr2209 = wp.^2.*a(3) + 4.*a(3).*(a(3).^2 + b(3).^2);
expr2210 = 2.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr364.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2211 = ((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr2209.*expr321.*expr337.*expr353.*(expr2014 + expr380).*(expr2012 + expr383).*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2212 = expr2210 + expr2211;
GC(3, 12) = expr2212;

%%   First derivative w/r to a(3) of constraint #13
expr2213 = -2.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr364.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2214 = ((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr2209.*expr321.*expr337.*expr353.*(expr2014 + expr380).*(expr2012 + expr383).*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2215 = expr2213 + expr2214;
GC(3, 13) = expr2215;

%%   First derivative w/r to a(3) of constraint #14
expr2216 = (36.*wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr2217 = 2.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr364.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2218 = ((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr2216.*expr321.*expr337.*expr353.*(expr2027 + expr380).*(expr2025 + expr383).*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2219 = expr2217 + expr2218;
GC(3, 14) = expr2219;

%%   First derivative w/r to a(3) of constraint #15
expr2220 = -2.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr364.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2221 = ((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr2216.*expr321.*expr337.*expr353.*(expr2027 + expr380).*(expr2025 + expr383).*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2222 = expr2220 + expr2221;
GC(3, 15) = expr2222;

%%   First derivative w/r to a(3) of constraint #16
expr2223 = (49.*wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr2224 = 2.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr364.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2225 = ((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr2223.*expr321.*expr337.*expr353.*(expr2040 + expr380).*(expr2038 + expr383).*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2226 = expr2224 + expr2225;
GC(3, 16) = expr2226;

%%   First derivative w/r to a(3) of constraint #17
expr2227 = -2.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr364.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2228 = ((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr2223.*expr321.*expr337.*expr353.*(expr2040 + expr380).*(expr2038 + expr383).*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2229 = expr2227 + expr2228;
GC(3, 17) = expr2229;

%%   First derivative w/r to a(3) of constraint #18
expr2230 = (64.*wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr2231 = 2.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr364.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2232 = ((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr2230.*expr321.*expr337.*expr353.*(expr2053 + expr380).*(expr2051 + expr383).*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2233 = expr2231 + expr2232;
GC(3, 18) = expr2233;

%%   First derivative w/r to a(3) of constraint #19
expr2234 = -2.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr364.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2235 = ((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr2230.*expr321.*expr337.*expr353.*(expr2053 + expr380).*(expr2051 + expr383).*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2236 = expr2234 + expr2235;
GC(3, 19) = expr2236;

%%   First derivative w/r to a(3) of constraint #20
expr2237 = (81.*wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr2238 = 2.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr364.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2239 = ((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr2237.*expr321.*expr337.*expr353.*(expr2066 + expr380).*(expr2064 + expr383).*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2240 = expr2238 + expr2239;
GC(3, 20) = expr2240;

%%   First derivative w/r to a(3) of constraint #21
expr2241 = -2.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr364.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2242 = ((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr2237.*expr321.*expr337.*expr353.*(expr2066 + expr380).*(expr2064 + expr383).*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2243 = expr2241 + expr2242;
GC(3, 21) = expr2243;

%%   First derivative w/r to a(3) of constraint #22
expr2244 = 4.*wp.^2.*a(3) + 4.*a(3).*(a(3).^2 + b(3).^2);
expr2245 = 2.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr364.*expr403.*expr404.*expr405;
expr2246 = expr2077.*expr2079.*(expr2077.*expr2078.*expr2079).^expr402.*(expr2080.*expr2081.*expr2082).^expr409.*expr2244.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2247 = expr2245 + expr2246;
GC(3, 22) = expr2247;

%%   First derivative w/r to a(3) of constraint #23
expr2248 = -2.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr364.*expr403.*expr404.*expr405;
expr2249 = expr2077.*expr2079.*(expr2077.*expr2078.*expr2079).^expr402.*(expr2080.*expr2081.*expr2082).^expr409.*expr2244.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2250 = expr2248 + expr2249;
GC(3, 23) = expr2250;

%%   First derivative w/r to a(3) of constraint #24
expr2251 = 4.*ws.^2.*a(3) + 4.*a(3).*(a(3).^2 + b(3).^2);
expr2252 = 2.*(expr2090.*expr2091.*expr2092).^expr397.*(expr2093.*expr2094.*expr2095).^expr409.*expr321.*expr337.*expr364.*expr403.*expr404.*expr405;
expr2253 = expr2090.*expr2092.*(expr2090.*expr2091.*expr2092).^expr402.*(expr2093.*expr2094.*expr2095).^expr409.*expr2251.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2254 = expr2252 + expr2253;
GC(3, 24) = expr2254;

%%   First derivative w/r to a(3) of constraint #25
expr2255 = expr1180 + expr1181 + expr1182 + expr1183 + expr1184 + expr1185 + expr1186 + expr1187 + expr1188 + expr1189 + expr1190 + expr1191;
GC(3, 25) = expr2255;

%%   First derivative w/r to b(1) of constraint #1
expr2256 = -b(1)./(2.*a(1).*sqrt(a(1).^2 + b(1).^2));
GC(4, 1) = expr2256;

%%   First derivative w/r to b(1) of constraint #2
expr2257 = 0;
GC(4, 2) = expr2257;

%%   First derivative w/r to b(1) of constraint #3
expr2258 = 0;
GC(4, 3) = expr2258;

%%   First derivative w/r to b(1) of constraint #4
expr2259 = -(wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr2260 = 2.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr320.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2261 = ((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr2259.*expr321.*expr337.*expr353.*(expr1957 + expr383).*(expr1958 + expr385).*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2262 = expr2260 + expr2261;
GC(4, 4) = expr2262;

%%   First derivative w/r to b(1) of constraint #5
expr2263 = -2.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr320.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2264 = ((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr2259.*expr321.*expr337.*expr353.*(expr1957 + expr383).*(expr1958 + expr385).*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2265 = expr2263 + expr2264;
GC(4, 5) = expr2265;

%%   First derivative w/r to b(1) of constraint #6
expr2266 = (-4.*wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr2267 = 2.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr320.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2268 = ((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr2266.*expr321.*expr337.*expr353.*(expr1973 + expr383).*(expr1974 + expr385).*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2269 = expr2267 + expr2268;
GC(4, 6) = expr2269;

%%   First derivative w/r to b(1) of constraint #7
expr2270 = -2.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr320.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2271 = ((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr2266.*expr321.*expr337.*expr353.*(expr1973 + expr383).*(expr1974 + expr385).*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2272 = expr2270 + expr2271;
GC(4, 7) = expr2272;

%%   First derivative w/r to b(1) of constraint #8
expr2273 = (-9.*wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr2274 = 2.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr320.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2275 = ((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr2273.*expr321.*expr337.*expr353.*(expr1986 + expr383).*(expr1987 + expr385).*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2276 = expr2274 + expr2275;
GC(4, 8) = expr2276;

%%   First derivative w/r to b(1) of constraint #9
expr2277 = -2.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr320.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2278 = ((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr2273.*expr321.*expr337.*expr353.*(expr1986 + expr383).*(expr1987 + expr385).*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2279 = expr2277 + expr2278;
GC(4, 9) = expr2279;

%%   First derivative w/r to b(1) of constraint #10
expr2280 = (-16.*wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr2281 = 2.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr320.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2282 = ((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr2280.*expr321.*expr337.*expr353.*(expr1999 + expr383).*(expr2000 + expr385).*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2283 = expr2281 + expr2282;
GC(4, 10) = expr2283;

%%   First derivative w/r to b(1) of constraint #11
expr2284 = -2.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr320.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2285 = ((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr2280.*expr321.*expr337.*expr353.*(expr1999 + expr383).*(expr2000 + expr385).*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2286 = expr2284 + expr2285;
GC(4, 11) = expr2286;

%%   First derivative w/r to b(1) of constraint #12
expr2287 = -(wp.^2.*b(1)) + 4.*b(1).*(a(1).^2 + b(1).^2);
expr2288 = 2.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr320.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2289 = ((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr2287.*expr321.*expr337.*expr353.*(expr2012 + expr383).*(expr2013 + expr385).*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2290 = expr2288 + expr2289;
GC(4, 12) = expr2290;

%%   First derivative w/r to b(1) of constraint #13
expr2291 = -2.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr320.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2292 = ((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr2287.*expr321.*expr337.*expr353.*(expr2012 + expr383).*(expr2013 + expr385).*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2293 = expr2291 + expr2292;
GC(4, 13) = expr2293;

%%   First derivative w/r to b(1) of constraint #14
expr2294 = (-36.*wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr2295 = 2.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr320.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2296 = ((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr2294.*expr321.*expr337.*expr353.*(expr2025 + expr383).*(expr2026 + expr385).*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2297 = expr2295 + expr2296;
GC(4, 14) = expr2297;

%%   First derivative w/r to b(1) of constraint #15
expr2298 = -2.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr320.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2299 = ((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr2294.*expr321.*expr337.*expr353.*(expr2025 + expr383).*(expr2026 + expr385).*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2300 = expr2298 + expr2299;
GC(4, 15) = expr2300;

%%   First derivative w/r to b(1) of constraint #16
expr2301 = (-49.*wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr2302 = 2.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr320.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2303 = ((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr2301.*expr321.*expr337.*expr353.*(expr2038 + expr383).*(expr2039 + expr385).*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2304 = expr2302 + expr2303;
GC(4, 16) = expr2304;

%%   First derivative w/r to b(1) of constraint #17
expr2305 = -2.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr320.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2306 = ((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr2301.*expr321.*expr337.*expr353.*(expr2038 + expr383).*(expr2039 + expr385).*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2307 = expr2305 + expr2306;
GC(4, 17) = expr2307;

%%   First derivative w/r to b(1) of constraint #18
expr2308 = (-64.*wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr2309 = 2.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr320.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2310 = ((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr2308.*expr321.*expr337.*expr353.*(expr2051 + expr383).*(expr2052 + expr385).*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2311 = expr2309 + expr2310;
GC(4, 18) = expr2311;

%%   First derivative w/r to b(1) of constraint #19
expr2312 = -2.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr320.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2313 = ((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr2308.*expr321.*expr337.*expr353.*(expr2051 + expr383).*(expr2052 + expr385).*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2314 = expr2312 + expr2313;
GC(4, 19) = expr2314;

%%   First derivative w/r to b(1) of constraint #20
expr2315 = (-81.*wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr2316 = 2.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr320.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2317 = ((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr2315.*expr321.*expr337.*expr353.*(expr2064 + expr383).*(expr2065 + expr385).*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2318 = expr2316 + expr2317;
GC(4, 20) = expr2318;

%%   First derivative w/r to b(1) of constraint #21
expr2319 = -2.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr320.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2320 = ((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr2315.*expr321.*expr337.*expr353.*(expr2064 + expr383).*(expr2065 + expr385).*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2321 = expr2319 + expr2320;
GC(4, 21) = expr2321;

%%   First derivative w/r to b(1) of constraint #22
expr2322 = -4.*wp.^2.*b(1) + 4.*b(1).*(a(1).^2 + b(1).^2);
expr2323 = 2.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr320.*expr337.*expr353.*expr403.*expr404.*expr405;
expr2324 = expr2077.*expr2078.*(expr2077.*expr2078.*expr2079).^expr402.*(expr2080.*expr2081.*expr2082).^expr409.*expr2322.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2325 = expr2323 + expr2324;
GC(4, 22) = expr2325;

%%   First derivative w/r to b(1) of constraint #23
expr2326 = -2.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr320.*expr337.*expr353.*expr403.*expr404.*expr405;
expr2327 = expr2077.*expr2078.*(expr2077.*expr2078.*expr2079).^expr402.*(expr2080.*expr2081.*expr2082).^expr409.*expr2322.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2328 = expr2326 + expr2327;
GC(4, 23) = expr2328;

%%   First derivative w/r to b(1) of constraint #24
expr2329 = -4.*ws.^2.*b(1) + 4.*b(1).*(a(1).^2 + b(1).^2);
expr2330 = 2.*(expr2090.*expr2091.*expr2092).^expr397.*(expr2093.*expr2094.*expr2095).^expr409.*expr320.*expr337.*expr353.*expr403.*expr404.*expr405;
expr2331 = expr2090.*expr2091.*(expr2090.*expr2091.*expr2092).^expr402.*(expr2093.*expr2094.*expr2095).^expr409.*expr2329.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2332 = expr2330 + expr2331;
GC(4, 24) = expr2332;

%%   First derivative w/r to b(1) of constraint #25
expr2333 = expr782 + expr783 + expr784 + expr785 + expr786 + expr787 + expr788 + expr789 + expr790 + expr791 + expr792 + expr793 + expr794;
GC(4, 25) = expr2333;

%%   First derivative w/r to b(2) of constraint #1
expr2334 = 0;
GC(5, 1) = expr2334;

%%   First derivative w/r to b(2) of constraint #2
expr2335 = -b(2)./(2.*a(2).*sqrt(a(2).^2 + b(2).^2));
GC(5, 2) = expr2335;

%%   First derivative w/r to b(2) of constraint #3
expr2336 = 0;
GC(5, 3) = expr2336;

%%   First derivative w/r to b(2) of constraint #4
expr2337 = -(wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr2338 = 2.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr336.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2339 = ((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr2337.*expr321.*expr337.*expr353.*(expr1959 + expr380).*(expr1958 + expr385).*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2340 = expr2338 + expr2339;
GC(5, 4) = expr2340;

%%   First derivative w/r to b(2) of constraint #5
expr2341 = -2.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr336.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2342 = ((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr2337.*expr321.*expr337.*expr353.*(expr1959 + expr380).*(expr1958 + expr385).*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2343 = expr2341 + expr2342;
GC(5, 5) = expr2343;

%%   First derivative w/r to b(2) of constraint #6
expr2344 = (-4.*wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr2345 = 2.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr336.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2346 = ((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr2344.*expr321.*expr337.*expr353.*(expr1975 + expr380).*(expr1974 + expr385).*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2347 = expr2345 + expr2346;
GC(5, 6) = expr2347;

%%   First derivative w/r to b(2) of constraint #7
expr2348 = -2.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr336.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2349 = ((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr2344.*expr321.*expr337.*expr353.*(expr1975 + expr380).*(expr1974 + expr385).*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2350 = expr2348 + expr2349;
GC(5, 7) = expr2350;

%%   First derivative w/r to b(2) of constraint #8
expr2351 = (-9.*wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr2352 = 2.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr336.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2353 = ((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr2351.*expr321.*expr337.*expr353.*(expr1988 + expr380).*(expr1987 + expr385).*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2354 = expr2352 + expr2353;
GC(5, 8) = expr2354;

%%   First derivative w/r to b(2) of constraint #9
expr2355 = -2.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr336.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2356 = ((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr2351.*expr321.*expr337.*expr353.*(expr1988 + expr380).*(expr1987 + expr385).*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2357 = expr2355 + expr2356;
GC(5, 9) = expr2357;

%%   First derivative w/r to b(2) of constraint #10
expr2358 = (-16.*wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr2359 = 2.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr336.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2360 = ((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr2358.*expr321.*expr337.*expr353.*(expr2001 + expr380).*(expr2000 + expr385).*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2361 = expr2359 + expr2360;
GC(5, 10) = expr2361;

%%   First derivative w/r to b(2) of constraint #11
expr2362 = -2.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr336.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2363 = ((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr2358.*expr321.*expr337.*expr353.*(expr2001 + expr380).*(expr2000 + expr385).*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2364 = expr2362 + expr2363;
GC(5, 11) = expr2364;

%%   First derivative w/r to b(2) of constraint #12
expr2365 = -(wp.^2.*b(2)) + 4.*b(2).*(a(2).^2 + b(2).^2);
expr2366 = 2.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr336.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2367 = ((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr2365.*expr321.*expr337.*expr353.*(expr2014 + expr380).*(expr2013 + expr385).*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2368 = expr2366 + expr2367;
GC(5, 12) = expr2368;

%%   First derivative w/r to b(2) of constraint #13
expr2369 = -2.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr336.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2370 = ((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr2365.*expr321.*expr337.*expr353.*(expr2014 + expr380).*(expr2013 + expr385).*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2371 = expr2369 + expr2370;
GC(5, 13) = expr2371;

%%   First derivative w/r to b(2) of constraint #14
expr2372 = (-36.*wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr2373 = 2.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr336.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2374 = ((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr2372.*expr321.*expr337.*expr353.*(expr2027 + expr380).*(expr2026 + expr385).*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2375 = expr2373 + expr2374;
GC(5, 14) = expr2375;

%%   First derivative w/r to b(2) of constraint #15
expr2376 = -2.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr336.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2377 = ((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr2372.*expr321.*expr337.*expr353.*(expr2027 + expr380).*(expr2026 + expr385).*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2378 = expr2376 + expr2377;
GC(5, 15) = expr2378;

%%   First derivative w/r to b(2) of constraint #16
expr2379 = (-49.*wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr2380 = 2.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr336.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2381 = ((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr2379.*expr321.*expr337.*expr353.*(expr2040 + expr380).*(expr2039 + expr385).*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2382 = expr2380 + expr2381;
GC(5, 16) = expr2382;

%%   First derivative w/r to b(2) of constraint #17
expr2383 = -2.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr336.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2384 = ((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr2379.*expr321.*expr337.*expr353.*(expr2040 + expr380).*(expr2039 + expr385).*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2385 = expr2383 + expr2384;
GC(5, 17) = expr2385;

%%   First derivative w/r to b(2) of constraint #18
expr2386 = (-64.*wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr2387 = 2.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr336.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2388 = ((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr2386.*expr321.*expr337.*expr353.*(expr2053 + expr380).*(expr2052 + expr385).*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2389 = expr2387 + expr2388;
GC(5, 18) = expr2389;

%%   First derivative w/r to b(2) of constraint #19
expr2390 = -2.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr336.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2391 = ((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr2386.*expr321.*expr337.*expr353.*(expr2053 + expr380).*(expr2052 + expr385).*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2392 = expr2390 + expr2391;
GC(5, 19) = expr2392;

%%   First derivative w/r to b(2) of constraint #20
expr2393 = (-81.*wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr2394 = 2.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr336.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2395 = ((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr2393.*expr321.*expr337.*expr353.*(expr2066 + expr380).*(expr2065 + expr385).*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2396 = expr2394 + expr2395;
GC(5, 20) = expr2396;

%%   First derivative w/r to b(2) of constraint #21
expr2397 = -2.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr336.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2398 = ((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr2393.*expr321.*expr337.*expr353.*(expr2066 + expr380).*(expr2065 + expr385).*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2399 = expr2397 + expr2398;
GC(5, 21) = expr2399;

%%   First derivative w/r to b(2) of constraint #22
expr2400 = -4.*wp.^2.*b(2) + 4.*b(2).*(a(2).^2 + b(2).^2);
expr2401 = 2.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr336.*expr353.*expr403.*expr404.*expr405;
expr2402 = expr2078.*expr2079.*(expr2077.*expr2078.*expr2079).^expr402.*(expr2080.*expr2081.*expr2082).^expr409.*expr2400.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2403 = expr2401 + expr2402;
GC(5, 22) = expr2403;

%%   First derivative w/r to b(2) of constraint #23
expr2404 = -2.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr336.*expr353.*expr403.*expr404.*expr405;
expr2405 = expr2078.*expr2079.*(expr2077.*expr2078.*expr2079).^expr402.*(expr2080.*expr2081.*expr2082).^expr409.*expr2400.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2406 = expr2404 + expr2405;
GC(5, 23) = expr2406;

%%   First derivative w/r to b(2) of constraint #24
expr2407 = -4.*ws.^2.*b(2) + 4.*b(2).*(a(2).^2 + b(2).^2);
expr2408 = 2.*(expr2090.*expr2091.*expr2092).^expr397.*(expr2093.*expr2094.*expr2095).^expr409.*expr321.*expr336.*expr353.*expr403.*expr404.*expr405;
expr2409 = expr2091.*expr2092.*(expr2090.*expr2091.*expr2092).^expr402.*(expr2093.*expr2094.*expr2095).^expr409.*expr2407.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2410 = expr2408 + expr2409;
GC(5, 24) = expr2410;

%%   First derivative w/r to b(2) of constraint #25
expr2411 = expr1048 + expr1049 + expr1050 + expr1051 + expr1052 + expr1053 + expr1054 + expr1055 + expr1056 + expr1057 + expr1058 + expr1059 + expr1060;
GC(5, 25) = expr2411;

%%   First derivative w/r to b(3) of constraint #1
expr2412 = 0;
GC(6, 1) = expr2412;

%%   First derivative w/r to b(3) of constraint #2
expr2413 = 0;
GC(6, 2) = expr2413;

%%   First derivative w/r to b(3) of constraint #3
expr2414 = -b(3)./(2.*a(3).*sqrt(a(3).^2 + b(3).^2));
GC(6, 3) = expr2414;

%%   First derivative w/r to b(3) of constraint #4
expr2415 = -(wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr2416 = 2.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr352.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2417 = ((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr2415.*expr321.*expr337.*expr353.*(expr1959 + expr380).*(expr1957 + expr383).*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2418 = expr2416 + expr2417;
GC(6, 4) = expr2418;

%%   First derivative w/r to b(3) of constraint #5
expr2419 = -2.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr352.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2420 = ((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr2415.*expr321.*expr337.*expr353.*(expr1959 + expr380).*(expr1957 + expr383).*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2421 = expr2419 + expr2420;
GC(6, 5) = expr2421;

%%   First derivative w/r to b(3) of constraint #6
expr2422 = (-4.*wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr2423 = 2.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr352.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2424 = ((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr2422.*expr321.*expr337.*expr353.*(expr1975 + expr380).*(expr1973 + expr383).*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2425 = expr2423 + expr2424;
GC(6, 6) = expr2425;

%%   First derivative w/r to b(3) of constraint #7
expr2426 = -2.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr352.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2427 = ((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr2422.*expr321.*expr337.*expr353.*(expr1975 + expr380).*(expr1973 + expr383).*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2428 = expr2426 + expr2427;
GC(6, 7) = expr2428;

%%   First derivative w/r to b(3) of constraint #8
expr2429 = (-9.*wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr2430 = 2.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr352.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2431 = ((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr2429.*expr321.*expr337.*expr353.*(expr1988 + expr380).*(expr1986 + expr383).*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2432 = expr2430 + expr2431;
GC(6, 8) = expr2432;

%%   First derivative w/r to b(3) of constraint #9
expr2433 = -2.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr352.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2434 = ((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr2429.*expr321.*expr337.*expr353.*(expr1988 + expr380).*(expr1986 + expr383).*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2435 = expr2433 + expr2434;
GC(6, 9) = expr2435;

%%   First derivative w/r to b(3) of constraint #10
expr2436 = (-16.*wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr2437 = 2.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr352.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2438 = ((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr2436.*expr321.*expr337.*expr353.*(expr2001 + expr380).*(expr1999 + expr383).*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2439 = expr2437 + expr2438;
GC(6, 10) = expr2439;

%%   First derivative w/r to b(3) of constraint #11
expr2440 = -2.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr352.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2441 = ((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr2436.*expr321.*expr337.*expr353.*(expr2001 + expr380).*(expr1999 + expr383).*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2442 = expr2440 + expr2441;
GC(6, 11) = expr2442;

%%   First derivative w/r to b(3) of constraint #12
expr2443 = -(wp.^2.*b(3)) + 4.*b(3).*(a(3).^2 + b(3).^2);
expr2444 = 2.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr352.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2445 = ((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr2443.*expr321.*expr337.*expr353.*(expr2014 + expr380).*(expr2012 + expr383).*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2446 = expr2444 + expr2445;
GC(6, 12) = expr2446;

%%   First derivative w/r to b(3) of constraint #13
expr2447 = -2.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr352.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2448 = ((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr2443.*expr321.*expr337.*expr353.*(expr2014 + expr380).*(expr2012 + expr383).*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2449 = expr2447 + expr2448;
GC(6, 13) = expr2449;

%%   First derivative w/r to b(3) of constraint #14
expr2450 = (-36.*wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr2451 = 2.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr352.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2452 = ((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr2450.*expr321.*expr337.*expr353.*(expr2027 + expr380).*(expr2025 + expr383).*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2453 = expr2451 + expr2452;
GC(6, 14) = expr2453;

%%   First derivative w/r to b(3) of constraint #15
expr2454 = -2.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr352.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2455 = ((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr2450.*expr321.*expr337.*expr353.*(expr2027 + expr380).*(expr2025 + expr383).*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2456 = expr2454 + expr2455;
GC(6, 15) = expr2456;

%%   First derivative w/r to b(3) of constraint #16
expr2457 = (-49.*wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr2458 = 2.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr352.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2459 = ((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr2457.*expr321.*expr337.*expr353.*(expr2040 + expr380).*(expr2038 + expr383).*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2460 = expr2458 + expr2459;
GC(6, 16) = expr2460;

%%   First derivative w/r to b(3) of constraint #17
expr2461 = -2.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr352.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2462 = ((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr2457.*expr321.*expr337.*expr353.*(expr2040 + expr380).*(expr2038 + expr383).*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2463 = expr2461 + expr2462;
GC(6, 17) = expr2463;

%%   First derivative w/r to b(3) of constraint #18
expr2464 = (-64.*wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr2465 = 2.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr352.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2466 = ((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr2464.*expr321.*expr337.*expr353.*(expr2053 + expr380).*(expr2051 + expr383).*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2467 = expr2465 + expr2466;
GC(6, 18) = expr2467;

%%   First derivative w/r to b(3) of constraint #19
expr2468 = -2.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr352.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2469 = ((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr2464.*expr321.*expr337.*expr353.*(expr2053 + expr380).*(expr2051 + expr383).*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2470 = expr2468 + expr2469;
GC(6, 19) = expr2470;

%%   First derivative w/r to b(3) of constraint #20
expr2471 = (-81.*wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr2472 = 2.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr352.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2473 = ((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr2471.*expr321.*expr337.*expr353.*(expr2066 + expr380).*(expr2064 + expr383).*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr402.*expr397.*expr403.*expr404.*expr405;
expr2474 = expr2472 + expr2473;
GC(6, 20) = expr2474;

%%   First derivative w/r to b(3) of constraint #21
expr2475 = -2.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr352.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405;
expr2476 = ((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr2471.*expr321.*expr337.*expr353.*(expr2066 + expr380).*(expr2064 + expr383).*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr402.*expr403.*expr404.*expr405.*expr409;
expr2477 = expr2475 + expr2476;
GC(6, 21) = expr2477;

%%   First derivative w/r to b(3) of constraint #22
expr2478 = -4.*wp.^2.*b(3) + 4.*b(3).*(a(3).^2 + b(3).^2);
expr2479 = 2.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr352.*expr403.*expr404.*expr405;
expr2480 = expr2077.*expr2079.*(expr2077.*expr2078.*expr2079).^expr402.*(expr2080.*expr2081.*expr2082).^expr409.*expr2478.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2481 = expr2479 + expr2480;
GC(6, 22) = expr2481;

%%   First derivative w/r to b(3) of constraint #23
expr2482 = -2.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr352.*expr403.*expr404.*expr405;
expr2483 = expr2077.*expr2079.*(expr2077.*expr2078.*expr2079).^expr402.*(expr2080.*expr2081.*expr2082).^expr409.*expr2478.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2484 = expr2482 + expr2483;
GC(6, 23) = expr2484;

%%   First derivative w/r to b(3) of constraint #24
expr2485 = -4.*ws.^2.*b(3) + 4.*b(3).*(a(3).^2 + b(3).^2);
expr2486 = 2.*(expr2090.*expr2091.*expr2092).^expr397.*(expr2093.*expr2094.*expr2095).^expr409.*expr321.*expr337.*expr352.*expr403.*expr404.*expr405;
expr2487 = expr2090.*expr2092.*(expr2090.*expr2091.*expr2092).^expr402.*(expr2093.*expr2094.*expr2095).^expr409.*expr2485.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2488 = expr2486 + expr2487;
GC(6, 24) = expr2488;

%%   First derivative w/r to b(3) of constraint #25
expr2489 = expr1303 + expr1304 + expr1305 + expr1306 + expr1307 + expr1308 + expr1309 + expr1310 + expr1311 + expr1312 + expr1313 + expr1314 + expr1315;
GC(6, 25) = expr2489;

%%   First derivative w/r to c(1) of constraint #1
expr2490 = 0;
GC(7, 1) = expr2490;

%%   First derivative w/r to c(1) of constraint #2
expr2491 = 0;
GC(7, 2) = expr2491;

%%   First derivative w/r to c(1) of constraint #3
expr2492 = 0;
GC(7, 3) = expr2492;

%%   First derivative w/r to c(1) of constraint #4
expr2493 = (wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr2494 = -2.*expr1325.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2495 = (expr1962 + expr1963).*(expr1964 + expr1965).*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr397.*expr2493.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2496 = expr2494 + expr2495;
GC(7, 4) = expr2496;

%%   First derivative w/r to c(1) of constraint #5
expr2497 = 2.*expr1325.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2498 = (expr1962 + expr1963).*(expr1964 + expr1965).*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr397.*expr2493.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2499 = expr2497 + expr2498;
GC(7, 5) = expr2499;

%%   First derivative w/r to c(1) of constraint #6
expr2500 = (4.*wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr2501 = -2.*expr1325.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2502 = (expr1962 + expr1977).*(expr1964 + expr1978).*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr397.*expr2500.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2503 = expr2501 + expr2502;
GC(7, 6) = expr2503;

%%   First derivative w/r to c(1) of constraint #7
expr2504 = 2.*expr1325.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2505 = (expr1962 + expr1977).*(expr1964 + expr1978).*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr397.*expr2500.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2506 = expr2504 + expr2505;
GC(7, 7) = expr2506;

%%   First derivative w/r to c(1) of constraint #8
expr2507 = (9.*wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr2508 = -2.*expr1325.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2509 = (expr1962 + expr1990).*(expr1964 + expr1991).*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr397.*expr2507.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2510 = expr2508 + expr2509;
GC(7, 8) = expr2510;

%%   First derivative w/r to c(1) of constraint #9
expr2511 = 2.*expr1325.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2512 = (expr1962 + expr1990).*(expr1964 + expr1991).*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr397.*expr2507.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2513 = expr2511 + expr2512;
GC(7, 9) = expr2513;

%%   First derivative w/r to c(1) of constraint #10
expr2514 = (16.*wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr2515 = -2.*expr1325.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2516 = (expr1962 + expr2003).*(expr1964 + expr2004).*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr397.*expr2514.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2517 = expr2515 + expr2516;
GC(7, 10) = expr2517;

%%   First derivative w/r to c(1) of constraint #11
expr2518 = 2.*expr1325.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2519 = (expr1962 + expr2003).*(expr1964 + expr2004).*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr397.*expr2514.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2520 = expr2518 + expr2519;
GC(7, 11) = expr2520;

%%   First derivative w/r to c(1) of constraint #12
expr2521 = wp.^2.*c(1) + 4.*c(1).*(c(1).^2 + d(1).^2);
expr2522 = -2.*expr1325.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2523 = (expr1962 + expr2016).*(expr1964 + expr2017).*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr397.*expr2521.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2524 = expr2522 + expr2523;
GC(7, 12) = expr2524;

%%   First derivative w/r to c(1) of constraint #13
expr2525 = 2.*expr1325.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2526 = (expr1962 + expr2016).*(expr1964 + expr2017).*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr397.*expr2521.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2527 = expr2525 + expr2526;
GC(7, 13) = expr2527;

%%   First derivative w/r to c(1) of constraint #14
expr2528 = (36.*wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr2529 = -2.*expr1325.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2530 = (expr1962 + expr2029).*(expr1964 + expr2030).*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr397.*expr2528.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2531 = expr2529 + expr2530;
GC(7, 14) = expr2531;

%%   First derivative w/r to c(1) of constraint #15
expr2532 = 2.*expr1325.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2533 = (expr1962 + expr2029).*(expr1964 + expr2030).*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr397.*expr2528.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2534 = expr2532 + expr2533;
GC(7, 15) = expr2534;

%%   First derivative w/r to c(1) of constraint #16
expr2535 = (49.*wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr2536 = -2.*expr1325.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2537 = (expr1962 + expr2042).*(expr1964 + expr2043).*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr397.*expr2535.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2538 = expr2536 + expr2537;
GC(7, 16) = expr2538;

%%   First derivative w/r to c(1) of constraint #17
expr2539 = 2.*expr1325.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2540 = (expr1962 + expr2042).*(expr1964 + expr2043).*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr397.*expr2535.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2541 = expr2539 + expr2540;
GC(7, 17) = expr2541;

%%   First derivative w/r to c(1) of constraint #18
expr2542 = (64.*wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr2543 = -2.*expr1325.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2544 = (expr1962 + expr2055).*(expr1964 + expr2056).*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr397.*expr2542.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2545 = expr2543 + expr2544;
GC(7, 18) = expr2545;

%%   First derivative w/r to c(1) of constraint #19
expr2546 = 2.*expr1325.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2547 = (expr1962 + expr2055).*(expr1964 + expr2056).*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr397.*expr2542.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2548 = expr2546 + expr2547;
GC(7, 19) = expr2548;

%%   First derivative w/r to c(1) of constraint #20
expr2549 = (81.*wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr2550 = -2.*expr1325.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2551 = (expr1962 + expr2068).*(expr1964 + expr2069).*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr397.*expr2549.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2552 = expr2550 + expr2551;
GC(7, 20) = expr2552;

%%   First derivative w/r to c(1) of constraint #21
expr2553 = 2.*expr1325.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2554 = (expr1962 + expr2068).*(expr1964 + expr2069).*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr397.*expr2549.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2555 = expr2553 + expr2554;
GC(7, 21) = expr2555;

%%   First derivative w/r to c(1) of constraint #22
expr2556 = 4.*wp.^2.*c(1) + 4.*c(1).*(c(1).^2 + d(1).^2);
expr2557 = -2.*expr1325.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr353.*expr387.*expr404.*expr405;
expr2558 = (expr2077.*expr2078.*expr2079).^expr397.*expr2081.*expr2082.*(expr2080.*expr2081.*expr2082).^expr397.*expr2556.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2559 = expr2557 + expr2558;
GC(7, 22) = expr2559;

%%   First derivative w/r to c(1) of constraint #23
expr2560 = 2.*expr1325.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr353.*expr387.*expr404.*expr405;
expr2561 = (expr2077.*expr2078.*expr2079).^expr397.*expr2081.*expr2082.*(expr2080.*expr2081.*expr2082).^expr397.*expr2556.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2562 = expr2560 + expr2561;
GC(7, 23) = expr2562;

%%   First derivative w/r to c(1) of constraint #24
expr2563 = 4.*ws.^2.*c(1) + 4.*c(1).*(c(1).^2 + d(1).^2);
expr2564 = -2.*expr1325.*(expr2090.*expr2091.*expr2092).^expr397.*(expr2093.*expr2094.*expr2095).^expr409.*expr321.*expr337.*expr353.*expr387.*expr404.*expr405;
expr2565 = (expr2090.*expr2091.*expr2092).^expr397.*expr2094.*expr2095.*(expr2093.*expr2094.*expr2095).^expr397.*expr2563.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2566 = expr2564 + expr2565;
GC(7, 24) = expr2566;

%%   First derivative w/r to c(1) of constraint #25
expr2567 = expr1416 + expr1417 + expr1418 + expr1419 + expr1420 + expr1421 + expr1422 + expr1423 + expr1424 + expr1425 + expr1426 + expr1427;
GC(7, 25) = expr2567;

%%   First derivative w/r to c(2) of constraint #1
expr2568 = 0;
GC(8, 1) = expr2568;

%%   First derivative w/r to c(2) of constraint #2
expr2569 = 0;
GC(8, 2) = expr2569;

%%   First derivative w/r to c(2) of constraint #3
expr2570 = 0;
GC(8, 3) = expr2570;

%%   First derivative w/r to c(2) of constraint #4
expr2571 = (wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr2572 = -2.*expr1537.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2573 = (expr1960 + expr1961).*(expr1964 + expr1965).*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr397.*expr2571.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2574 = expr2572 + expr2573;
GC(8, 4) = expr2574;

%%   First derivative w/r to c(2) of constraint #5
expr2575 = 2.*expr1537.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2576 = (expr1960 + expr1961).*(expr1964 + expr1965).*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr397.*expr2571.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2577 = expr2575 + expr2576;
GC(8, 5) = expr2577;

%%   First derivative w/r to c(2) of constraint #6
expr2578 = (4.*wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr2579 = -2.*expr1537.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2580 = (expr1960 + expr1976).*(expr1964 + expr1978).*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr397.*expr2578.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2581 = expr2579 + expr2580;
GC(8, 6) = expr2581;

%%   First derivative w/r to c(2) of constraint #7
expr2582 = 2.*expr1537.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2583 = (expr1960 + expr1976).*(expr1964 + expr1978).*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr397.*expr2578.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2584 = expr2582 + expr2583;
GC(8, 7) = expr2584;

%%   First derivative w/r to c(2) of constraint #8
expr2585 = (9.*wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr2586 = -2.*expr1537.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2587 = (expr1960 + expr1989).*(expr1964 + expr1991).*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr397.*expr2585.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2588 = expr2586 + expr2587;
GC(8, 8) = expr2588;

%%   First derivative w/r to c(2) of constraint #9
expr2589 = 2.*expr1537.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2590 = (expr1960 + expr1989).*(expr1964 + expr1991).*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr397.*expr2585.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2591 = expr2589 + expr2590;
GC(8, 9) = expr2591;

%%   First derivative w/r to c(2) of constraint #10
expr2592 = (16.*wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr2593 = -2.*expr1537.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2594 = (expr1960 + expr2002).*(expr1964 + expr2004).*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr397.*expr2592.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2595 = expr2593 + expr2594;
GC(8, 10) = expr2595;

%%   First derivative w/r to c(2) of constraint #11
expr2596 = 2.*expr1537.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2597 = (expr1960 + expr2002).*(expr1964 + expr2004).*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr397.*expr2592.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2598 = expr2596 + expr2597;
GC(8, 11) = expr2598;

%%   First derivative w/r to c(2) of constraint #12
expr2599 = wp.^2.*c(2) + 4.*c(2).*(c(2).^2 + d(2).^2);
expr2600 = -2.*expr1537.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2601 = (expr1960 + expr2015).*(expr1964 + expr2017).*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr397.*expr2599.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2602 = expr2600 + expr2601;
GC(8, 12) = expr2602;

%%   First derivative w/r to c(2) of constraint #13
expr2603 = 2.*expr1537.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2604 = (expr1960 + expr2015).*(expr1964 + expr2017).*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr397.*expr2599.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2605 = expr2603 + expr2604;
GC(8, 13) = expr2605;

%%   First derivative w/r to c(2) of constraint #14
expr2606 = (36.*wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr2607 = -2.*expr1537.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2608 = (expr1960 + expr2028).*(expr1964 + expr2030).*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr397.*expr2606.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2609 = expr2607 + expr2608;
GC(8, 14) = expr2609;

%%   First derivative w/r to c(2) of constraint #15
expr2610 = 2.*expr1537.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2611 = (expr1960 + expr2028).*(expr1964 + expr2030).*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr397.*expr2606.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2612 = expr2610 + expr2611;
GC(8, 15) = expr2612;

%%   First derivative w/r to c(2) of constraint #16
expr2613 = (49.*wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr2614 = -2.*expr1537.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2615 = (expr1960 + expr2041).*(expr1964 + expr2043).*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr397.*expr2613.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2616 = expr2614 + expr2615;
GC(8, 16) = expr2616;

%%   First derivative w/r to c(2) of constraint #17
expr2617 = 2.*expr1537.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2618 = (expr1960 + expr2041).*(expr1964 + expr2043).*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr397.*expr2613.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2619 = expr2617 + expr2618;
GC(8, 17) = expr2619;

%%   First derivative w/r to c(2) of constraint #18
expr2620 = (64.*wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr2621 = -2.*expr1537.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2622 = (expr1960 + expr2054).*(expr1964 + expr2056).*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr397.*expr2620.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2623 = expr2621 + expr2622;
GC(8, 18) = expr2623;

%%   First derivative w/r to c(2) of constraint #19
expr2624 = 2.*expr1537.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2625 = (expr1960 + expr2054).*(expr1964 + expr2056).*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr397.*expr2620.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2626 = expr2624 + expr2625;
GC(8, 19) = expr2626;

%%   First derivative w/r to c(2) of constraint #20
expr2627 = (81.*wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr2628 = -2.*expr1537.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2629 = (expr1960 + expr2067).*(expr1964 + expr2069).*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr397.*expr2627.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2630 = expr2628 + expr2629;
GC(8, 20) = expr2630;

%%   First derivative w/r to c(2) of constraint #21
expr2631 = 2.*expr1537.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2632 = (expr1960 + expr2067).*(expr1964 + expr2069).*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr397.*expr2627.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2633 = expr2631 + expr2632;
GC(8, 21) = expr2633;

%%   First derivative w/r to c(2) of constraint #22
expr2634 = 4.*wp.^2.*c(2) + 4.*c(2).*(c(2).^2 + d(2).^2);
expr2635 = -2.*expr1537.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr353.*expr389.*expr403.*expr405;
expr2636 = (expr2077.*expr2078.*expr2079).^expr397.*expr2080.*expr2082.*(expr2080.*expr2081.*expr2082).^expr397.*expr2634.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2637 = expr2635 + expr2636;
GC(8, 22) = expr2637;

%%   First derivative w/r to c(2) of constraint #23
expr2638 = 2.*expr1537.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr353.*expr389.*expr403.*expr405;
expr2639 = (expr2077.*expr2078.*expr2079).^expr397.*expr2080.*expr2082.*(expr2080.*expr2081.*expr2082).^expr397.*expr2634.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2640 = expr2638 + expr2639;
GC(8, 23) = expr2640;

%%   First derivative w/r to c(2) of constraint #24
expr2641 = 4.*ws.^2.*c(2) + 4.*c(2).*(c(2).^2 + d(2).^2);
expr2642 = -2.*expr1537.*(expr2090.*expr2091.*expr2092).^expr397.*(expr2093.*expr2094.*expr2095).^expr409.*expr321.*expr337.*expr353.*expr389.*expr403.*expr405;
expr2643 = (expr2090.*expr2091.*expr2092).^expr397.*expr2093.*expr2095.*(expr2093.*expr2094.*expr2095).^expr397.*expr2641.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2644 = expr2642 + expr2643;
GC(8, 24) = expr2644;

%%   First derivative w/r to c(2) of constraint #25
expr2645 = expr1627 + expr1628 + expr1629 + expr1630 + expr1631 + expr1632 + expr1633 + expr1634 + expr1635 + expr1636 + expr1637 + expr1638;
GC(8, 25) = expr2645;

%%   First derivative w/r to c(3) of constraint #1
expr2646 = 0;
GC(9, 1) = expr2646;

%%   First derivative w/r to c(3) of constraint #2
expr2647 = 0;
GC(9, 2) = expr2647;

%%   First derivative w/r to c(3) of constraint #3
expr2648 = 0;
GC(9, 3) = expr2648;

%%   First derivative w/r to c(3) of constraint #4
expr2649 = (wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr2650 = -2.*expr1748.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2651 = (expr1960 + expr1961).*(expr1962 + expr1963).*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr397.*expr2649.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2652 = expr2650 + expr2651;
GC(9, 4) = expr2652;

%%   First derivative w/r to c(3) of constraint #5
expr2653 = 2.*expr1748.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2654 = (expr1960 + expr1961).*(expr1962 + expr1963).*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr397.*expr2649.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2655 = expr2653 + expr2654;
GC(9, 5) = expr2655;

%%   First derivative w/r to c(3) of constraint #6
expr2656 = (4.*wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr2657 = -2.*expr1748.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2658 = (expr1960 + expr1976).*(expr1962 + expr1977).*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr397.*expr2656.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2659 = expr2657 + expr2658;
GC(9, 6) = expr2659;

%%   First derivative w/r to c(3) of constraint #7
expr2660 = 2.*expr1748.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2661 = (expr1960 + expr1976).*(expr1962 + expr1977).*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr397.*expr2656.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2662 = expr2660 + expr2661;
GC(9, 7) = expr2662;

%%   First derivative w/r to c(3) of constraint #8
expr2663 = (9.*wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr2664 = -2.*expr1748.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2665 = (expr1960 + expr1989).*(expr1962 + expr1990).*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr397.*expr2663.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2666 = expr2664 + expr2665;
GC(9, 8) = expr2666;

%%   First derivative w/r to c(3) of constraint #9
expr2667 = 2.*expr1748.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2668 = (expr1960 + expr1989).*(expr1962 + expr1990).*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr397.*expr2663.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2669 = expr2667 + expr2668;
GC(9, 9) = expr2669;

%%   First derivative w/r to c(3) of constraint #10
expr2670 = (16.*wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr2671 = -2.*expr1748.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2672 = (expr1960 + expr2002).*(expr1962 + expr2003).*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr397.*expr2670.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2673 = expr2671 + expr2672;
GC(9, 10) = expr2673;

%%   First derivative w/r to c(3) of constraint #11
expr2674 = 2.*expr1748.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2675 = (expr1960 + expr2002).*(expr1962 + expr2003).*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr397.*expr2670.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2676 = expr2674 + expr2675;
GC(9, 11) = expr2676;

%%   First derivative w/r to c(3) of constraint #12
expr2677 = wp.^2.*c(3) + 4.*c(3).*(c(3).^2 + d(3).^2);
expr2678 = -2.*expr1748.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2679 = (expr1960 + expr2015).*(expr1962 + expr2016).*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr397.*expr2677.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2680 = expr2678 + expr2679;
GC(9, 12) = expr2680;

%%   First derivative w/r to c(3) of constraint #13
expr2681 = 2.*expr1748.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2682 = (expr1960 + expr2015).*(expr1962 + expr2016).*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr397.*expr2677.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2683 = expr2681 + expr2682;
GC(9, 13) = expr2683;

%%   First derivative w/r to c(3) of constraint #14
expr2684 = (36.*wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr2685 = -2.*expr1748.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2686 = (expr1960 + expr2028).*(expr1962 + expr2029).*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr397.*expr2684.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2687 = expr2685 + expr2686;
GC(9, 14) = expr2687;

%%   First derivative w/r to c(3) of constraint #15
expr2688 = 2.*expr1748.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2689 = (expr1960 + expr2028).*(expr1962 + expr2029).*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr397.*expr2684.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2690 = expr2688 + expr2689;
GC(9, 15) = expr2690;

%%   First derivative w/r to c(3) of constraint #16
expr2691 = (49.*wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr2692 = -2.*expr1748.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2693 = (expr1960 + expr2041).*(expr1962 + expr2042).*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr397.*expr2691.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2694 = expr2692 + expr2693;
GC(9, 16) = expr2694;

%%   First derivative w/r to c(3) of constraint #17
expr2695 = 2.*expr1748.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2696 = (expr1960 + expr2041).*(expr1962 + expr2042).*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr397.*expr2691.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2697 = expr2695 + expr2696;
GC(9, 17) = expr2697;

%%   First derivative w/r to c(3) of constraint #18
expr2698 = (64.*wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr2699 = -2.*expr1748.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2700 = (expr1960 + expr2054).*(expr1962 + expr2055).*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr397.*expr2698.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2701 = expr2699 + expr2700;
GC(9, 18) = expr2701;

%%   First derivative w/r to c(3) of constraint #19
expr2702 = 2.*expr1748.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2703 = (expr1960 + expr2054).*(expr1962 + expr2055).*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr397.*expr2698.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2704 = expr2702 + expr2703;
GC(9, 19) = expr2704;

%%   First derivative w/r to c(3) of constraint #20
expr2705 = (81.*wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr2706 = -2.*expr1748.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2707 = (expr1960 + expr2067).*(expr1962 + expr2068).*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr397.*expr2705.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2708 = expr2706 + expr2707;
GC(9, 20) = expr2708;

%%   First derivative w/r to c(3) of constraint #21
expr2709 = 2.*expr1748.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2710 = (expr1960 + expr2067).*(expr1962 + expr2068).*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr397.*expr2705.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2711 = expr2709 + expr2710;
GC(9, 21) = expr2711;

%%   First derivative w/r to c(3) of constraint #22
expr2712 = 4.*wp.^2.*c(3) + 4.*c(3).*(c(3).^2 + d(3).^2);
expr2713 = -2.*expr1748.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr353.*expr391.*expr403.*expr404;
expr2714 = (expr2077.*expr2078.*expr2079).^expr397.*expr2080.*expr2081.*(expr2080.*expr2081.*expr2082).^expr397.*expr2712.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2715 = expr2713 + expr2714;
GC(9, 22) = expr2715;

%%   First derivative w/r to c(3) of constraint #23
expr2716 = 2.*expr1748.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr353.*expr391.*expr403.*expr404;
expr2717 = (expr2077.*expr2078.*expr2079).^expr397.*expr2080.*expr2081.*(expr2080.*expr2081.*expr2082).^expr397.*expr2712.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2718 = expr2716 + expr2717;
GC(9, 23) = expr2718;

%%   First derivative w/r to c(3) of constraint #24
expr2719 = 4.*ws.^2.*c(3) + 4.*c(3).*(c(3).^2 + d(3).^2);
expr2720 = -2.*expr1748.*(expr2090.*expr2091.*expr2092).^expr397.*(expr2093.*expr2094.*expr2095).^expr409.*expr321.*expr337.*expr353.*expr391.*expr403.*expr404;
expr2721 = (expr2090.*expr2091.*expr2092).^expr397.*expr2093.*expr2094.*(expr2093.*expr2094.*expr2095).^expr397.*expr2719.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2722 = expr2720 + expr2721;
GC(9, 24) = expr2722;

%%   First derivative w/r to c(3) of constraint #25
expr2723 = expr1838 + expr1839 + expr1840 + expr1841 + expr1842 + expr1843 + expr1844 + expr1845 + expr1846 + expr1847 + expr1848 + expr1849;
GC(9, 25) = expr2723;

%%   First derivative w/r to d(1) of constraint #1
expr2724 = 0;
GC(10, 1) = expr2724;

%%   First derivative w/r to d(1) of constraint #2
expr2725 = 0;
GC(10, 2) = expr2725;

%%   First derivative w/r to d(1) of constraint #3
expr2726 = 0;
GC(10, 3) = expr2726;

%%   First derivative w/r to d(1) of constraint #4
expr2727 = -(wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr2728 = -2.*expr1435.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2729 = (expr1962 + expr1963).*(expr1964 + expr1965).*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr397.*expr2727.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2730 = expr2728 + expr2729;
GC(10, 4) = expr2730;

%%   First derivative w/r to d(1) of constraint #5
expr2731 = 2.*expr1435.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2732 = (expr1962 + expr1963).*(expr1964 + expr1965).*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr397.*expr2727.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2733 = expr2731 + expr2732;
GC(10, 5) = expr2733;

%%   First derivative w/r to d(1) of constraint #6
expr2734 = (-4.*wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr2735 = -2.*expr1435.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2736 = (expr1962 + expr1977).*(expr1964 + expr1978).*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr397.*expr2734.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2737 = expr2735 + expr2736;
GC(10, 6) = expr2737;

%%   First derivative w/r to d(1) of constraint #7
expr2738 = 2.*expr1435.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2739 = (expr1962 + expr1977).*(expr1964 + expr1978).*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr397.*expr2734.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2740 = expr2738 + expr2739;
GC(10, 7) = expr2740;

%%   First derivative w/r to d(1) of constraint #8
expr2741 = (-9.*wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr2742 = -2.*expr1435.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2743 = (expr1962 + expr1990).*(expr1964 + expr1991).*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr397.*expr2741.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2744 = expr2742 + expr2743;
GC(10, 8) = expr2744;

%%   First derivative w/r to d(1) of constraint #9
expr2745 = 2.*expr1435.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2746 = (expr1962 + expr1990).*(expr1964 + expr1991).*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr397.*expr2741.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2747 = expr2745 + expr2746;
GC(10, 9) = expr2747;

%%   First derivative w/r to d(1) of constraint #10
expr2748 = (-16.*wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr2749 = -2.*expr1435.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2750 = (expr1962 + expr2003).*(expr1964 + expr2004).*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr397.*expr2748.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2751 = expr2749 + expr2750;
GC(10, 10) = expr2751;

%%   First derivative w/r to d(1) of constraint #11
expr2752 = 2.*expr1435.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2753 = (expr1962 + expr2003).*(expr1964 + expr2004).*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr397.*expr2748.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2754 = expr2752 + expr2753;
GC(10, 11) = expr2754;

%%   First derivative w/r to d(1) of constraint #12
expr2755 = -(wp.^2.*d(1)) + 4.*d(1).*(c(1).^2 + d(1).^2);
expr2756 = -2.*expr1435.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2757 = (expr1962 + expr2016).*(expr1964 + expr2017).*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr397.*expr2755.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2758 = expr2756 + expr2757;
GC(10, 12) = expr2758;

%%   First derivative w/r to d(1) of constraint #13
expr2759 = 2.*expr1435.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2760 = (expr1962 + expr2016).*(expr1964 + expr2017).*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr397.*expr2755.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2761 = expr2759 + expr2760;
GC(10, 13) = expr2761;

%%   First derivative w/r to d(1) of constraint #14
expr2762 = (-36.*wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr2763 = -2.*expr1435.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2764 = (expr1962 + expr2029).*(expr1964 + expr2030).*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr397.*expr2762.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2765 = expr2763 + expr2764;
GC(10, 14) = expr2765;

%%   First derivative w/r to d(1) of constraint #15
expr2766 = 2.*expr1435.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2767 = (expr1962 + expr2029).*(expr1964 + expr2030).*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr397.*expr2762.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2768 = expr2766 + expr2767;
GC(10, 15) = expr2768;

%%   First derivative w/r to d(1) of constraint #16
expr2769 = (-49.*wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr2770 = -2.*expr1435.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2771 = (expr1962 + expr2042).*(expr1964 + expr2043).*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr397.*expr2769.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2772 = expr2770 + expr2771;
GC(10, 16) = expr2772;

%%   First derivative w/r to d(1) of constraint #17
expr2773 = 2.*expr1435.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2774 = (expr1962 + expr2042).*(expr1964 + expr2043).*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr397.*expr2769.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2775 = expr2773 + expr2774;
GC(10, 17) = expr2775;

%%   First derivative w/r to d(1) of constraint #18
expr2776 = (-64.*wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr2777 = -2.*expr1435.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2778 = (expr1962 + expr2055).*(expr1964 + expr2056).*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr397.*expr2776.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2779 = expr2777 + expr2778;
GC(10, 18) = expr2779;

%%   First derivative w/r to d(1) of constraint #19
expr2780 = 2.*expr1435.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2781 = (expr1962 + expr2055).*(expr1964 + expr2056).*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr397.*expr2776.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2782 = expr2780 + expr2781;
GC(10, 19) = expr2782;

%%   First derivative w/r to d(1) of constraint #20
expr2783 = (-81.*wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr2784 = -2.*expr1435.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2785 = (expr1962 + expr2068).*(expr1964 + expr2069).*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr397.*expr2783.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2786 = expr2784 + expr2785;
GC(10, 20) = expr2786;

%%   First derivative w/r to d(1) of constraint #21
expr2787 = 2.*expr1435.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr387.*expr404.*expr405;
expr2788 = (expr1962 + expr2068).*(expr1964 + expr2069).*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr397.*expr2783.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2789 = expr2787 + expr2788;
GC(10, 21) = expr2789;

%%   First derivative w/r to d(1) of constraint #22
expr2790 = -4.*wp.^2.*d(1) + 4.*d(1).*(c(1).^2 + d(1).^2);
expr2791 = -2.*expr1435.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr353.*expr387.*expr404.*expr405;
expr2792 = (expr2077.*expr2078.*expr2079).^expr397.*expr2081.*expr2082.*(expr2080.*expr2081.*expr2082).^expr397.*expr2790.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2793 = expr2791 + expr2792;
GC(10, 22) = expr2793;

%%   First derivative w/r to d(1) of constraint #23
expr2794 = 2.*expr1435.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr353.*expr387.*expr404.*expr405;
expr2795 = (expr2077.*expr2078.*expr2079).^expr397.*expr2081.*expr2082.*(expr2080.*expr2081.*expr2082).^expr397.*expr2790.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2796 = expr2794 + expr2795;
GC(10, 23) = expr2796;

%%   First derivative w/r to d(1) of constraint #24
expr2797 = -4.*ws.^2.*d(1) + 4.*d(1).*(c(1).^2 + d(1).^2);
expr2798 = -2.*expr1435.*(expr2090.*expr2091.*expr2092).^expr397.*(expr2093.*expr2094.*expr2095).^expr409.*expr321.*expr337.*expr353.*expr387.*expr404.*expr405;
expr2799 = (expr2090.*expr2091.*expr2092).^expr397.*expr2094.*expr2095.*(expr2093.*expr2094.*expr2095).^expr397.*expr2797.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2800 = expr2798 + expr2799;
GC(10, 24) = expr2800;

%%   First derivative w/r to d(1) of constraint #25
expr2801 = expr1518 + expr1519 + expr1520 + expr1521 + expr1522 + expr1523 + expr1524 + expr1525 + expr1526 + expr1527 + expr1528 + expr1529;
GC(10, 25) = expr2801;

%%   First derivative w/r to d(2) of constraint #1
expr2802 = 0;
GC(11, 1) = expr2802;

%%   First derivative w/r to d(2) of constraint #2
expr2803 = 0;
GC(11, 2) = expr2803;

%%   First derivative w/r to d(2) of constraint #3
expr2804 = 0;
GC(11, 3) = expr2804;

%%   First derivative w/r to d(2) of constraint #4
expr2805 = -(wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr2806 = -2.*expr1646.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2807 = (expr1960 + expr1961).*(expr1964 + expr1965).*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr397.*expr2805.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2808 = expr2806 + expr2807;
GC(11, 4) = expr2808;

%%   First derivative w/r to d(2) of constraint #5
expr2809 = 2.*expr1646.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2810 = (expr1960 + expr1961).*(expr1964 + expr1965).*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr397.*expr2805.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2811 = expr2809 + expr2810;
GC(11, 5) = expr2811;

%%   First derivative w/r to d(2) of constraint #6
expr2812 = (-4.*wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr2813 = -2.*expr1646.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2814 = (expr1960 + expr1976).*(expr1964 + expr1978).*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr397.*expr2812.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2815 = expr2813 + expr2814;
GC(11, 6) = expr2815;

%%   First derivative w/r to d(2) of constraint #7
expr2816 = 2.*expr1646.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2817 = (expr1960 + expr1976).*(expr1964 + expr1978).*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr397.*expr2812.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2818 = expr2816 + expr2817;
GC(11, 7) = expr2818;

%%   First derivative w/r to d(2) of constraint #8
expr2819 = (-9.*wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr2820 = -2.*expr1646.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2821 = (expr1960 + expr1989).*(expr1964 + expr1991).*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr397.*expr2819.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2822 = expr2820 + expr2821;
GC(11, 8) = expr2822;

%%   First derivative w/r to d(2) of constraint #9
expr2823 = 2.*expr1646.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2824 = (expr1960 + expr1989).*(expr1964 + expr1991).*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr397.*expr2819.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2825 = expr2823 + expr2824;
GC(11, 9) = expr2825;

%%   First derivative w/r to d(2) of constraint #10
expr2826 = (-16.*wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr2827 = -2.*expr1646.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2828 = (expr1960 + expr2002).*(expr1964 + expr2004).*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr397.*expr2826.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2829 = expr2827 + expr2828;
GC(11, 10) = expr2829;

%%   First derivative w/r to d(2) of constraint #11
expr2830 = 2.*expr1646.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2831 = (expr1960 + expr2002).*(expr1964 + expr2004).*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr397.*expr2826.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2832 = expr2830 + expr2831;
GC(11, 11) = expr2832;

%%   First derivative w/r to d(2) of constraint #12
expr2833 = -(wp.^2.*d(2)) + 4.*d(2).*(c(2).^2 + d(2).^2);
expr2834 = -2.*expr1646.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2835 = (expr1960 + expr2015).*(expr1964 + expr2017).*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr397.*expr2833.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2836 = expr2834 + expr2835;
GC(11, 12) = expr2836;

%%   First derivative w/r to d(2) of constraint #13
expr2837 = 2.*expr1646.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2838 = (expr1960 + expr2015).*(expr1964 + expr2017).*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr397.*expr2833.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2839 = expr2837 + expr2838;
GC(11, 13) = expr2839;

%%   First derivative w/r to d(2) of constraint #14
expr2840 = (-36.*wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr2841 = -2.*expr1646.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2842 = (expr1960 + expr2028).*(expr1964 + expr2030).*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr397.*expr2840.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2843 = expr2841 + expr2842;
GC(11, 14) = expr2843;

%%   First derivative w/r to d(2) of constraint #15
expr2844 = 2.*expr1646.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2845 = (expr1960 + expr2028).*(expr1964 + expr2030).*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr397.*expr2840.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2846 = expr2844 + expr2845;
GC(11, 15) = expr2846;

%%   First derivative w/r to d(2) of constraint #16
expr2847 = (-49.*wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr2848 = -2.*expr1646.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2849 = (expr1960 + expr2041).*(expr1964 + expr2043).*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr397.*expr2847.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2850 = expr2848 + expr2849;
GC(11, 16) = expr2850;

%%   First derivative w/r to d(2) of constraint #17
expr2851 = 2.*expr1646.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2852 = (expr1960 + expr2041).*(expr1964 + expr2043).*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr397.*expr2847.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2853 = expr2851 + expr2852;
GC(11, 17) = expr2853;

%%   First derivative w/r to d(2) of constraint #18
expr2854 = (-64.*wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr2855 = -2.*expr1646.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2856 = (expr1960 + expr2054).*(expr1964 + expr2056).*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr397.*expr2854.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2857 = expr2855 + expr2856;
GC(11, 18) = expr2857;

%%   First derivative w/r to d(2) of constraint #19
expr2858 = 2.*expr1646.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2859 = (expr1960 + expr2054).*(expr1964 + expr2056).*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr397.*expr2854.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2860 = expr2858 + expr2859;
GC(11, 19) = expr2860;

%%   First derivative w/r to d(2) of constraint #20
expr2861 = (-81.*wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr2862 = -2.*expr1646.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2863 = (expr1960 + expr2067).*(expr1964 + expr2069).*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr397.*expr2861.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2864 = expr2862 + expr2863;
GC(11, 20) = expr2864;

%%   First derivative w/r to d(2) of constraint #21
expr2865 = 2.*expr1646.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr389.*expr403.*expr405;
expr2866 = (expr1960 + expr2067).*(expr1964 + expr2069).*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr397.*expr2861.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2867 = expr2865 + expr2866;
GC(11, 21) = expr2867;

%%   First derivative w/r to d(2) of constraint #22
expr2868 = -4.*wp.^2.*d(2) + 4.*d(2).*(c(2).^2 + d(2).^2);
expr2869 = -2.*expr1646.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr353.*expr389.*expr403.*expr405;
expr2870 = (expr2077.*expr2078.*expr2079).^expr397.*expr2080.*expr2082.*(expr2080.*expr2081.*expr2082).^expr397.*expr2868.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2871 = expr2869 + expr2870;
GC(11, 22) = expr2871;

%%   First derivative w/r to d(2) of constraint #23
expr2872 = 2.*expr1646.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr353.*expr389.*expr403.*expr405;
expr2873 = (expr2077.*expr2078.*expr2079).^expr397.*expr2080.*expr2082.*(expr2080.*expr2081.*expr2082).^expr397.*expr2868.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2874 = expr2872 + expr2873;
GC(11, 23) = expr2874;

%%   First derivative w/r to d(2) of constraint #24
expr2875 = -4.*ws.^2.*d(2) + 4.*d(2).*(c(2).^2 + d(2).^2);
expr2876 = -2.*expr1646.*(expr2090.*expr2091.*expr2092).^expr397.*(expr2093.*expr2094.*expr2095).^expr409.*expr321.*expr337.*expr353.*expr389.*expr403.*expr405;
expr2877 = (expr2090.*expr2091.*expr2092).^expr397.*expr2093.*expr2095.*(expr2093.*expr2094.*expr2095).^expr397.*expr2875.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2878 = expr2876 + expr2877;
GC(11, 24) = expr2878;

%%   First derivative w/r to d(2) of constraint #25
expr2879 = expr1729 + expr1730 + expr1731 + expr1732 + expr1733 + expr1734 + expr1735 + expr1736 + expr1737 + expr1738 + expr1739 + expr1740;
GC(11, 25) = expr2879;

%%   First derivative w/r to d(3) of constraint #1
expr2880 = 0;
GC(12, 1) = expr2880;

%%   First derivative w/r to d(3) of constraint #2
expr2881 = 0;
GC(12, 2) = expr2881;

%%   First derivative w/r to d(3) of constraint #3
expr2882 = 0;
GC(12, 3) = expr2882;

%%   First derivative w/r to d(3) of constraint #4
expr2883 = -(wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr2884 = -2.*expr1857.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2885 = (expr1960 + expr1961).*(expr1962 + expr1963).*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr397.*expr2883.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2886 = expr2884 + expr2885;
GC(12, 4) = expr2886;

%%   First derivative w/r to d(3) of constraint #5
expr2887 = 2.*expr1857.*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr409.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2888 = (expr1960 + expr1961).*(expr1962 + expr1963).*((expr1960 + expr1961).*(expr1962 + expr1963).*(expr1964 + expr1965)).^expr397.*expr2883.*expr321.*expr337.*expr353.*((expr1959 + expr380).*(expr1957 + expr383).*(expr1958 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2889 = expr2887 + expr2888;
GC(12, 5) = expr2889;

%%   First derivative w/r to d(3) of constraint #6
expr2890 = (-4.*wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr2891 = -2.*expr1857.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2892 = (expr1960 + expr1976).*(expr1962 + expr1977).*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr397.*expr2890.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2893 = expr2891 + expr2892;
GC(12, 6) = expr2893;

%%   First derivative w/r to d(3) of constraint #7
expr2894 = 2.*expr1857.*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr409.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2895 = (expr1960 + expr1976).*(expr1962 + expr1977).*((expr1960 + expr1976).*(expr1962 + expr1977).*(expr1964 + expr1978)).^expr397.*expr2890.*expr321.*expr337.*expr353.*((expr1975 + expr380).*(expr1973 + expr383).*(expr1974 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2896 = expr2894 + expr2895;
GC(12, 7) = expr2896;

%%   First derivative w/r to d(3) of constraint #8
expr2897 = (-9.*wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr2898 = -2.*expr1857.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2899 = (expr1960 + expr1989).*(expr1962 + expr1990).*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr397.*expr2897.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2900 = expr2898 + expr2899;
GC(12, 8) = expr2900;

%%   First derivative w/r to d(3) of constraint #9
expr2901 = 2.*expr1857.*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr409.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2902 = (expr1960 + expr1989).*(expr1962 + expr1990).*((expr1960 + expr1989).*(expr1962 + expr1990).*(expr1964 + expr1991)).^expr397.*expr2897.*expr321.*expr337.*expr353.*((expr1988 + expr380).*(expr1986 + expr383).*(expr1987 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2903 = expr2901 + expr2902;
GC(12, 9) = expr2903;

%%   First derivative w/r to d(3) of constraint #10
expr2904 = (-16.*wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr2905 = -2.*expr1857.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2906 = (expr1960 + expr2002).*(expr1962 + expr2003).*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr397.*expr2904.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2907 = expr2905 + expr2906;
GC(12, 10) = expr2907;

%%   First derivative w/r to d(3) of constraint #11
expr2908 = 2.*expr1857.*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr409.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2909 = (expr1960 + expr2002).*(expr1962 + expr2003).*((expr1960 + expr2002).*(expr1962 + expr2003).*(expr1964 + expr2004)).^expr397.*expr2904.*expr321.*expr337.*expr353.*((expr2001 + expr380).*(expr1999 + expr383).*(expr2000 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2910 = expr2908 + expr2909;
GC(12, 11) = expr2910;

%%   First derivative w/r to d(3) of constraint #12
expr2911 = -(wp.^2.*d(3)) + 4.*d(3).*(c(3).^2 + d(3).^2);
expr2912 = -2.*expr1857.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2913 = (expr1960 + expr2015).*(expr1962 + expr2016).*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr397.*expr2911.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2914 = expr2912 + expr2913;
GC(12, 12) = expr2914;

%%   First derivative w/r to d(3) of constraint #13
expr2915 = 2.*expr1857.*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr409.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2916 = (expr1960 + expr2015).*(expr1962 + expr2016).*((expr1960 + expr2015).*(expr1962 + expr2016).*(expr1964 + expr2017)).^expr397.*expr2911.*expr321.*expr337.*expr353.*((expr2014 + expr380).*(expr2012 + expr383).*(expr2013 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2917 = expr2915 + expr2916;
GC(12, 13) = expr2917;

%%   First derivative w/r to d(3) of constraint #14
expr2918 = (-36.*wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr2919 = -2.*expr1857.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2920 = (expr1960 + expr2028).*(expr1962 + expr2029).*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr397.*expr2918.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2921 = expr2919 + expr2920;
GC(12, 14) = expr2921;

%%   First derivative w/r to d(3) of constraint #15
expr2922 = 2.*expr1857.*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr409.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2923 = (expr1960 + expr2028).*(expr1962 + expr2029).*((expr1960 + expr2028).*(expr1962 + expr2029).*(expr1964 + expr2030)).^expr397.*expr2918.*expr321.*expr337.*expr353.*((expr2027 + expr380).*(expr2025 + expr383).*(expr2026 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2924 = expr2922 + expr2923;
GC(12, 15) = expr2924;

%%   First derivative w/r to d(3) of constraint #16
expr2925 = (-49.*wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr2926 = -2.*expr1857.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2927 = (expr1960 + expr2041).*(expr1962 + expr2042).*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr397.*expr2925.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2928 = expr2926 + expr2927;
GC(12, 16) = expr2928;

%%   First derivative w/r to d(3) of constraint #17
expr2929 = 2.*expr1857.*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr409.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2930 = (expr1960 + expr2041).*(expr1962 + expr2042).*((expr1960 + expr2041).*(expr1962 + expr2042).*(expr1964 + expr2043)).^expr397.*expr2925.*expr321.*expr337.*expr353.*((expr2040 + expr380).*(expr2038 + expr383).*(expr2039 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2931 = expr2929 + expr2930;
GC(12, 17) = expr2931;

%%   First derivative w/r to d(3) of constraint #18
expr2932 = (-64.*wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr2933 = -2.*expr1857.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2934 = (expr1960 + expr2054).*(expr1962 + expr2055).*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr397.*expr2932.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2935 = expr2933 + expr2934;
GC(12, 18) = expr2935;

%%   First derivative w/r to d(3) of constraint #19
expr2936 = 2.*expr1857.*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr409.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2937 = (expr1960 + expr2054).*(expr1962 + expr2055).*((expr1960 + expr2054).*(expr1962 + expr2055).*(expr1964 + expr2056)).^expr397.*expr2932.*expr321.*expr337.*expr353.*((expr2053 + expr380).*(expr2051 + expr383).*(expr2052 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2938 = expr2936 + expr2937;
GC(12, 19) = expr2938;

%%   First derivative w/r to d(3) of constraint #20
expr2939 = (-81.*wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr2940 = -2.*expr1857.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2941 = (expr1960 + expr2067).*(expr1962 + expr2068).*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr397.*expr2939.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr403.*expr404.*expr405.*expr409;
expr2942 = expr2940 + expr2941;
GC(12, 20) = expr2942;

%%   First derivative w/r to d(3) of constraint #21
expr2943 = 2.*expr1857.*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr409.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr391.*expr403.*expr404;
expr2944 = (expr1960 + expr2067).*(expr1962 + expr2068).*((expr1960 + expr2067).*(expr1962 + expr2068).*(expr1964 + expr2069)).^expr397.*expr2939.*expr321.*expr337.*expr353.*((expr2066 + expr380).*(expr2064 + expr383).*(expr2065 + expr385)).^expr397.*expr397.*expr403.*expr404.*expr405;
expr2945 = expr2943 + expr2944;
GC(12, 21) = expr2945;

%%   First derivative w/r to d(3) of constraint #22
expr2946 = -4.*wp.^2.*d(3) + 4.*d(3).*(c(3).^2 + d(3).^2);
expr2947 = -2.*expr1857.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr353.*expr391.*expr403.*expr404;
expr2948 = (expr2077.*expr2078.*expr2079).^expr397.*expr2080.*expr2081.*(expr2080.*expr2081.*expr2082).^expr397.*expr2946.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2949 = expr2947 + expr2948;
GC(12, 22) = expr2949;

%%   First derivative w/r to d(3) of constraint #23
expr2950 = 2.*expr1857.*(expr2077.*expr2078.*expr2079).^expr397.*(expr2080.*expr2081.*expr2082).^expr409.*expr321.*expr337.*expr353.*expr391.*expr403.*expr404;
expr2951 = (expr2077.*expr2078.*expr2079).^expr397.*expr2080.*expr2081.*(expr2080.*expr2081.*expr2082).^expr397.*expr2946.*expr321.*expr337.*expr353.*expr397.*expr403.*expr404.*expr405;
expr2952 = expr2950 + expr2951;
GC(12, 23) = expr2952;

%%   First derivative w/r to d(3) of constraint #24
expr2953 = -4.*ws.^2.*d(3) + 4.*d(3).*(c(3).^2 + d(3).^2);
expr2954 = -2.*expr1857.*(expr2090.*expr2091.*expr2092).^expr397.*(expr2093.*expr2094.*expr2095).^expr409.*expr321.*expr337.*expr353.*expr391.*expr403.*expr404;
expr2955 = (expr2090.*expr2091.*expr2092).^expr397.*expr2093.*expr2094.*(expr2093.*expr2094.*expr2095).^expr397.*expr2953.*expr321.*expr337.*expr353.*expr403.*expr404.*expr405.*expr409;
expr2956 = expr2954 + expr2955;
GC(12, 24) = expr2956;

%%   First derivative w/r to d(3) of constraint #25
expr2957 = expr1940 + expr1941 + expr1942 + expr1943 + expr1944 + expr1945 + expr1946 + expr1947 + expr1948 + expr1949 + expr1950 + expr1951;
GC(12, 25) = expr2957;

end
