function [gf,GC]=costder4(x)
% COSTDER4 computes the gradient of the cost function
%	for an analog filter having 4 complex pole pairs.
%
%	Code Generated by Mathematica packages written by Brian L. Evans
%	Copyright 1993 by the Regents of the University of California

%% Extract real and imaginary components of the filters's poles a +/- j b

%% Extract real and imaginary components of the filters's zeros c +/- j d
a = x(1:4);
b = x(5:8);
c = x(9:12);
d = x(13:16);

%% Global parameters
global dp ds maxO wmax Wmp Wms Wmt WO wp Wph WQ ws tpeak1;

%% Approximate tpeak by a differentiable function and assign it to tpa
expr481 = 1./4;
expr482 = b(1);
expr483 = a(1).^2 + b(1).^2;
expr484 = angle(1 + (i.*(b(1) - b(2)))./(a(1) - a(2)));
expr485 = angle(1 + (i.*(b(1) + b(2)))./(a(1) - a(2)));
expr486 = angle(1 + (i.*(b(1) - b(3)))./(a(1) - a(3)));
expr487 = angle(1 + (i.*(b(1) + b(3)))./(a(1) - a(3)));
expr488 = angle(1 + (i.*(b(1) - b(4)))./(a(1) - a(4)));
expr489 = angle(1 + (i.*(b(1) + b(4)))./(a(1) - a(4)));
expr490 = -angle(1 + (i.*(b(1) - d(1)))./(a(1) - c(1)));
expr491 = -angle(1 + (i.*(b(1) + d(1)))./(a(1) - c(1)));
expr492 = -angle(1 + (i.*(b(1) - d(2)))./(a(1) - c(2)));
expr493 = -angle(1 + (i.*(b(1) + d(2)))./(a(1) - c(2)));
expr494 = -angle(1 + (i.*(b(1) - d(3)))./(a(1) - c(3)));
expr495 = -angle(1 + (i.*(b(1) + d(3)))./(a(1) - c(3)));
expr496 = -angle(1 + (i.*(b(1) - d(4)))./(a(1) - c(4)));
expr497 = -angle(1 + (i.*(b(1) + d(4)))./(a(1) - c(4)));
expr498 = a(1);
expr499 = a(1).^2;
expr500 = b(1).^2;
expr501 = b(1).^(-1);
expr502 = b(2);
expr503 = a(2).^2 + b(2).^2;
expr504 = angle(1 + (i.*(-b(1) + b(2)))./(-a(1) + a(2)));
expr505 = angle(1 + (i.*(b(1) + b(2)))./(-a(1) + a(2)));
expr506 = angle(1 + (i.*(b(2) - b(3)))./(a(2) - a(3)));
expr507 = angle(1 + (i.*(b(2) + b(3)))./(a(2) - a(3)));
expr508 = angle(1 + (i.*(b(2) - b(4)))./(a(2) - a(4)));
expr509 = angle(1 + (i.*(b(2) + b(4)))./(a(2) - a(4)));
expr510 = -angle(1 + (i.*(b(2) - d(1)))./(a(2) - c(1)));
expr511 = -angle(1 + (i.*(b(2) + d(1)))./(a(2) - c(1)));
expr512 = -angle(1 + (i.*(b(2) - d(2)))./(a(2) - c(2)));
expr513 = -angle(1 + (i.*(b(2) + d(2)))./(a(2) - c(2)));
expr514 = -angle(1 + (i.*(b(2) - d(3)))./(a(2) - c(3)));
expr515 = -angle(1 + (i.*(b(2) + d(3)))./(a(2) - c(3)));
expr516 = -angle(1 + (i.*(b(2) - d(4)))./(a(2) - c(4)));
expr517 = -angle(1 + (i.*(b(2) + d(4)))./(a(2) - c(4)));
expr518 = a(2);
expr519 = a(2).^2;
expr520 = b(2).^2;
expr521 = b(2).^(-1);
expr522 = b(3);
expr523 = a(3).^2 + b(3).^2;
expr524 = angle(1 + (i.*(-b(1) + b(3)))./(-a(1) + a(3)));
expr525 = angle(1 + (i.*(b(1) + b(3)))./(-a(1) + a(3)));
expr526 = angle(1 + (i.*(-b(2) + b(3)))./(-a(2) + a(3)));
expr527 = angle(1 + (i.*(b(2) + b(3)))./(-a(2) + a(3)));
expr528 = angle(1 + (i.*(b(3) - b(4)))./(a(3) - a(4)));
expr529 = angle(1 + (i.*(b(3) + b(4)))./(a(3) - a(4)));
expr530 = -angle(1 + (i.*(b(3) - d(1)))./(a(3) - c(1)));
expr531 = -angle(1 + (i.*(b(3) + d(1)))./(a(3) - c(1)));
expr532 = -angle(1 + (i.*(b(3) - d(2)))./(a(3) - c(2)));
expr533 = -angle(1 + (i.*(b(3) + d(2)))./(a(3) - c(2)));
expr534 = -angle(1 + (i.*(b(3) - d(3)))./(a(3) - c(3)));
expr535 = -angle(1 + (i.*(b(3) + d(3)))./(a(3) - c(3)));
expr536 = -angle(1 + (i.*(b(3) - d(4)))./(a(3) - c(4)));
expr537 = -angle(1 + (i.*(b(3) + d(4)))./(a(3) - c(4)));
expr538 = a(3);
expr539 = a(3).^2;
expr540 = b(3).^2;
expr541 = b(3).^(-1);
expr542 = b(4);
expr543 = a(4).^2 + b(4).^2;
expr544 = angle(1 + (i.*(-b(1) + b(4)))./(-a(1) + a(4)));
expr545 = angle(1 + (i.*(b(1) + b(4)))./(-a(1) + a(4)));
expr546 = angle(1 + (i.*(-b(2) + b(4)))./(-a(2) + a(4)));
expr547 = angle(1 + (i.*(b(2) + b(4)))./(-a(2) + a(4)));
expr548 = angle(1 + (i.*(-b(3) + b(4)))./(-a(3) + a(4)));
expr549 = angle(1 + (i.*(b(3) + b(4)))./(-a(3) + a(4)));
expr550 = -angle(1 + (i.*(b(4) - d(1)))./(a(4) - c(1)));
expr551 = -angle(1 + (i.*(b(4) + d(1)))./(a(4) - c(1)));
expr552 = -angle(1 + (i.*(b(4) - d(2)))./(a(4) - c(2)));
expr553 = -angle(1 + (i.*(b(4) + d(2)))./(a(4) - c(2)));
expr554 = -angle(1 + (i.*(b(4) - d(3)))./(a(4) - c(3)));
expr555 = -angle(1 + (i.*(b(4) + d(3)))./(a(4) - c(3)));
expr556 = -angle(1 + (i.*(b(4) - d(4)))./(a(4) - c(4)));
expr557 = -angle(1 + (i.*(b(4) + d(4)))./(a(4) - c(4)));
expr558 = a(4);
expr559 = a(4).^2;
expr560 = b(4).^2;
expr561 = b(4).^(-1);
expr562 = sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr563 = (expr482.*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497) + expr498.*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497)).^(-1);
expr564 = sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr565 = (expr502.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517) + expr518.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517)).^(-1);
expr566 = sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr567 = (expr522.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537) + expr538.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537)).^(-1);
expr568 = sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr569 = (expr542.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557) + expr558.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557)).^(-1);
expr570 = -(expr501.*(pi - angle(1 + (expr482.*expr483.*expr562.*expr563.*i)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563))));
expr571 = -(expr521.*(pi - angle(1 + (expr502.*expr503.*expr564.*expr565.*i)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565))));
expr572 = -(expr541.*(pi - angle(1 + (expr522.*expr523.*expr566.*expr567.*i)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567))));
expr573 = -(expr561.*(pi - angle(1 + (expr542.*expr543.*expr568.*expr569.*i)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569))));
expr574 = expr481.*(expr570 + expr571 + expr572 + expr573);
tpa = expr574;

%% Correction to approximation of tpeak is tpc
tpc = tpeak1./tpa;


%% Derivative for a(1)
w5 = [ws:(99.*ws)./100:100.*ws];
expr575 = -1./99;
expr576 = ws.^(-1);
expr577 = (a(1).^2 + b(1).^2).^2;
expr578 = 4.*w5.^2.*a(1) + 4.*a(1).*(a(1).^2 + b(1).^2);
expr579 = ((a(1).^2 + b(1).^2).^2 + w5.^2.*(w5.^2 + 2.*(a(1).^2 - b(1).^2))).^(-2);
expr580 = (a(2).^2 + b(2).^2).^2;
expr581 = ((a(2).^2 + b(2).^2).^2 + w5.^2.*(w5.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr582 = (a(3).^2 + b(3).^2).^2;
expr583 = ((a(3).^2 + b(3).^2).^2 + w5.^2.*(w5.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr584 = (a(4).^2 + b(4).^2).^2;
expr585 = ((a(4).^2 + b(4).^2).^2 + w5.^2.*(w5.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr586 = (c(1).^2 + d(1).^2).^(-2);
expr587 = (c(1).^2 + d(1).^2).^2 + w5.^2.*(w5.^2 + 2.*(c(1).^2 - d(1).^2));
expr588 = (c(2).^2 + d(2).^2).^(-2);
expr589 = (c(2).^2 + d(2).^2).^2 + w5.^2.*(w5.^2 + 2.*(c(2).^2 - d(2).^2));
expr590 = (c(3).^2 + d(3).^2).^(-2);
expr591 = (c(3).^2 + d(3).^2).^2 + w5.^2.*(w5.^2 + 2.*(c(3).^2 - d(3).^2));
expr592 = (c(4).^2 + d(4).^2).^(-2);
expr593 = (c(4).^2 + d(4).^2).^2 + w5.^2.*(w5.^2 + 2.*(c(4).^2 - d(4).^2));
expr594 = 4./99;
expr595 = ((a(1).^2 + b(1).^2).^2 + w5.^2.*(w5.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr596 = expr575.*expr576.*expr577.*expr578.*expr579.*expr580.*expr581.*expr582.*expr583.*expr584.*expr585.*expr586.*expr587.*expr588.*expr589.*expr590.*expr591.*expr592.*expr593.*Wms;
expr597 = expr483.*expr498.*expr576.*expr580.*expr581.*expr582.*expr583.*expr584.*expr585.*expr586.*expr587.*expr588.*expr589.*expr590.*expr591.*expr592.*expr593.*expr594.*expr595.*Wms;
expr598 = expr596 + expr597;
integrate5 = trapz(w5, expr598);
w6 = [0:wp./100:wp];
expr599 = wp.^(-1);
expr600 = -1./2;
expr601 = 4.*w6.^2.*a(1) + 4.*a(1).*(a(1).^2 + b(1).^2);
expr602 = (a(2).^2 + b(2).^2).^2 + w6.^2.*(w6.^2 + 2.*(a(2).^2 - b(2).^2));
expr603 = (a(3).^2 + b(3).^2).^2 + w6.^2.*(w6.^2 + 2.*(a(3).^2 - b(3).^2));
expr604 = (a(4).^2 + b(4).^2).^2 + w6.^2.*(w6.^2 + 2.*(a(4).^2 - b(4).^2));
expr605 = (a(1).^2 + b(1).^2).^2 + w6.^2.*(w6.^2 + 2.*(a(1).^2 - b(1).^2));
expr606 = -3./2;
expr607 = (c(1).^2 + d(1).^2).^(-1);
expr608 = (c(2).^2 + d(2).^2).^(-1);
expr609 = (c(3).^2 + d(3).^2).^(-1);
expr610 = (c(4).^2 + d(4).^2).^(-1);
expr611 = (c(1).^2 + d(1).^2).^2 + w6.^2.*(w6.^2 + 2.*(c(1).^2 - d(1).^2));
expr612 = (c(2).^2 + d(2).^2).^2 + w6.^2.*(w6.^2 + 2.*(c(2).^2 - d(2).^2));
expr613 = (c(3).^2 + d(3).^2).^2 + w6.^2.*(w6.^2 + 2.*(c(3).^2 - d(3).^2));
expr614 = (c(4).^2 + d(4).^2).^2 + w6.^2.*(w6.^2 + 2.*(c(4).^2 - d(4).^2));
expr615 = 1./2;
expr616 = -1 + expr483.*expr503.*expr523.*expr543.*(expr602.*expr603.*expr604.*expr605).^expr600.*expr607.*expr608.*expr609.*expr610.*(expr611.*expr612.*expr613.*expr614).^expr615;
expr617 = 2.*expr498.*expr503.*expr523.*expr543.*(expr602.*expr603.*expr604.*expr605).^expr600.*expr607.*expr608.*expr609.*expr610.*(expr611.*expr612.*expr613.*expr614).^expr615;
expr618 = expr483.*expr503.*expr523.*expr543.*expr600.*expr601.*expr602.*expr603.*expr604.*(expr602.*expr603.*expr604.*expr605).^expr606.*expr607.*expr608.*expr609.*expr610.*(expr611.*expr612.*expr613.*expr614).^expr615;
expr619 = 2.*expr599.*expr616.*(expr617 + expr618).*Wmp;
integrate6 = trapz(w6, expr619);
w7 = [wp:(-wp + ws)./100:ws];
expr620 = (-wp + ws).^(-1);
expr621 = 4.*w7.^2.*a(1) + 4.*a(1).*(a(1).^2 + b(1).^2);
expr622 = (a(2).^2 + b(2).^2).^2 + w7.^2.*(w7.^2 + 2.*(a(2).^2 - b(2).^2));
expr623 = (a(3).^2 + b(3).^2).^2 + w7.^2.*(w7.^2 + 2.*(a(3).^2 - b(3).^2));
expr624 = (a(4).^2 + b(4).^2).^2 + w7.^2.*(w7.^2 + 2.*(a(4).^2 - b(4).^2));
expr625 = (a(1).^2 + b(1).^2).^2 + w7.^2.*(w7.^2 + 2.*(a(1).^2 - b(1).^2));
expr626 = (c(1).^2 + d(1).^2).^2 + w7.^2.*(w7.^2 + 2.*(c(1).^2 - d(1).^2));
expr627 = (c(2).^2 + d(2).^2).^2 + w7.^2.*(w7.^2 + 2.*(c(2).^2 - d(2).^2));
expr628 = (c(3).^2 + d(3).^2).^2 + w7.^2.*(w7.^2 + 2.*(c(3).^2 - d(3).^2));
expr629 = (c(4).^2 + d(4).^2).^2 + w7.^2.*(w7.^2 + 2.*(c(4).^2 - d(4).^2));
expr630 = -(w7./(wp - ws));
expr631 = ws./(wp - ws);
expr632 = 2.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*(expr622.*expr623.*expr624.*expr625).^expr600.*(expr626.*expr627.*expr628.*expr629).^expr615;
expr633 = expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr621.*expr622.*expr623.*expr624.*(expr622.*expr623.*expr624.*expr625).^expr606.*(expr626.*expr627.*expr628.*expr629).^expr615;
expr634 = expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*(expr622.*expr623.*expr624.*expr625).^expr600.*(expr626.*expr627.*expr628.*expr629).^expr615 + expr630 + expr631;
expr635 = 2.*expr620.*(expr632 + expr633).*expr634.*Wmt;
integrate7 = trapz(w7, expr635);
w8 = [0:wmax./100:wmax];
expr636 = wmax.^(-1);
expr637 = -((w8 - b(1))./(a(1).^2.*(1 + (w8 - b(1)).^2./a(1).^2)));
expr638 = -((w8 + b(1))./(a(1).^2.*(1 + (w8 + b(1)).^2./a(1).^2)));
expr639 = wmax.^(-3);
expr640 = -2.*wmax;
expr641 = 2.*a(1).*(angle(1 + (i.*(wmax - b(1)))./a(1)) + angle(1 + (i.*(wmax + b(1)))./a(1)));
expr642 = (2.*(wmax - b(1)).^2.*b(1))./(a(1).^2.*(1 + (wmax - b(1)).^2./a(1).^2));
expr643 = (-2.*b(1).*(wmax + b(1)).^2)./(a(1).^2.*(1 + (wmax + b(1)).^2./a(1).^2));
expr644 = -wmax.^2 - a(1).^2 + b(1).^2;
expr645 = -((wmax - b(1))./(a(1).^2.*(1 + (wmax - b(1)).^2./a(1).^2)));
expr646 = -((wmax + b(1))./(a(1).^2.*(1 + (wmax + b(1)).^2./a(1).^2)));
expr647 = -(b(1).*log(1 + (wmax - b(1)).^2./a(1).^2));
expr648 = b(1).*log(1 + (wmax + b(1)).^2./a(1).^2);
expr649 = angle(1 + (i.*(w8 - b(1)))./a(1));
expr650 = angle(1 + (i.*(w8 + b(1)))./a(1));
expr651 = angle(1 + (i.*(w8 - b(2)))./a(2));
expr652 = angle(1 + (i.*(w8 + b(2)))./a(2));
expr653 = angle(1 + (i.*(w8 - b(3)))./a(3));
expr654 = angle(1 + (i.*(w8 + b(3)))./a(3));
expr655 = angle(1 + (i.*(w8 - b(4)))./a(4));
expr656 = angle(1 + (i.*(w8 + b(4)))./a(4));
expr657 = -angle(1 + (i.*(w8 - d(1)))./c(1));
expr658 = -angle(1 + (i.*(w8 + d(1)))./c(1));
expr659 = -angle(1 + (i.*(w8 - d(2)))./c(2));
expr660 = -angle(1 + (i.*(w8 + d(2)))./c(2));
expr661 = -angle(1 + (i.*(w8 - d(3)))./c(3));
expr662 = -angle(1 + (i.*(w8 + d(3)))./c(3));
expr663 = -angle(1 + (i.*(w8 - d(4)))./c(4));
expr664 = -angle(1 + (i.*(w8 + d(4)))./c(4));
expr665 = -2.*wmax.*a(1);
expr666 = angle(1 + (i.*(wmax - b(1)))./a(1)) + angle(1 + (i.*(wmax + b(1)))./a(1));
expr667 = -(a(1).*b(1).*log(1 + (wmax - b(1)).^2./a(1).^2));
expr668 = a(1).*b(1).*log(1 + (wmax + b(1)).^2./a(1).^2);
expr669 = -2.*wmax.*a(2);
expr670 = angle(1 + (i.*(wmax - b(2)))./a(2)) + angle(1 + (i.*(wmax + b(2)))./a(2));
expr671 = -wmax.^2 - a(2).^2 + b(2).^2;
expr672 = -(a(2).*b(2).*log(1 + (wmax - b(2)).^2./a(2).^2));
expr673 = a(2).*b(2).*log(1 + (wmax + b(2)).^2./a(2).^2);
expr674 = -2.*wmax.*a(3);
expr675 = angle(1 + (i.*(wmax - b(3)))./a(3)) + angle(1 + (i.*(wmax + b(3)))./a(3));
expr676 = -wmax.^2 - a(3).^2 + b(3).^2;
expr677 = -(a(3).*b(3).*log(1 + (wmax - b(3)).^2./a(3).^2));
expr678 = a(3).*b(3).*log(1 + (wmax + b(3)).^2./a(3).^2);
expr679 = -2.*wmax.*a(4);
expr680 = angle(1 + (i.*(wmax - b(4)))./a(4)) + angle(1 + (i.*(wmax + b(4)))./a(4));
expr681 = -wmax.^2 - a(4).^2 + b(4).^2;
expr682 = -(a(4).*b(4).*log(1 + (wmax - b(4)).^2./a(4).^2));
expr683 = a(4).*b(4).*log(1 + (wmax + b(4)).^2./a(4).^2);
expr684 = 2.*wmax.*c(1);
expr685 = angle(1 + (i.*(wmax - d(1)))./c(1)) + angle(1 + (i.*(wmax + d(1)))./c(1));
expr686 = -wmax.^2 - c(1).^2 + d(1).^2;
expr687 = c(1).*d(1).*log(1 + (wmax - d(1)).^2./c(1).^2);
expr688 = -(c(1).*d(1).*log(1 + (wmax + d(1)).^2./c(1).^2));
expr689 = 2.*wmax.*c(2);
expr690 = angle(1 + (i.*(wmax - d(2)))./c(2)) + angle(1 + (i.*(wmax + d(2)))./c(2));
expr691 = -wmax.^2 - c(2).^2 + d(2).^2;
expr692 = c(2).*d(2).*log(1 + (wmax - d(2)).^2./c(2).^2);
expr693 = -(c(2).*d(2).*log(1 + (wmax + d(2)).^2./c(2).^2));
expr694 = 2.*wmax.*c(3);
expr695 = angle(1 + (i.*(wmax - d(3)))./c(3)) + angle(1 + (i.*(wmax + d(3)))./c(3));
expr696 = -wmax.^2 - c(3).^2 + d(3).^2;
expr697 = c(3).*d(3).*log(1 + (wmax - d(3)).^2./c(3).^2);
expr698 = -(c(3).*d(3).*log(1 + (wmax + d(3)).^2./c(3).^2));
expr699 = 2.*wmax.*c(4);
expr700 = angle(1 + (i.*(wmax - d(4)))./c(4)) + angle(1 + (i.*(wmax + d(4)))./c(4));
expr701 = -wmax.^2 - c(4).^2 + d(4).^2;
expr702 = c(4).*d(4).*log(1 + (wmax - d(4)).^2./c(4).^2);
expr703 = -(c(4).*d(4).*log(1 + (wmax + d(4)).^2./c(4).^2));
expr704 = expr637 + expr638 + expr606.*expr639.*(expr640 + expr641 + expr642 + expr643 - expr644.*(expr645 + expr646) + expr647 + expr648).*w8;
expr705 = expr615.*(expr665 - expr644.*expr666 + expr667 + expr668);
expr706 = expr615.*(expr669 - expr670.*expr671 + expr672 + expr673);
expr707 = expr615.*(expr674 - expr675.*expr676 + expr677 + expr678);
expr708 = expr615.*(expr679 - expr680.*expr681 + expr682 + expr683);
expr709 = expr615.*(expr684 + expr685.*expr686 + expr687 + expr688);
expr710 = expr615.*(expr689 + expr690.*expr691 + expr692 + expr693);
expr711 = expr615.*(expr694 + expr695.*expr696 + expr697 + expr698);
expr712 = expr615.*(expr699 + expr700.*expr701 + expr702 + expr703);
expr713 = 2.*expr636.*expr704.*(expr649 + expr650 + expr651 + expr652 + expr653 + expr654 + expr655 + expr656 + expr657 + expr658 + expr659 + expr660 + expr661 + expr662 + expr663 + expr664 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w8).*Wph;
integrate8 = trapz(w8, expr713);
expr714 = 1./8;
expr715 = a(1).^(-1);
expr716 = a(2).^(-1);
expr717 = a(3).^(-1);
expr718 = a(4).^(-1);
expr719 = sqrt(a(1).^2 + b(1).^2);
expr720 = sqrt(a(2).^2 + b(2).^2);
expr721 = sqrt(a(3).^2 + b(3).^2);
expr722 = sqrt(a(4).^2 + b(4).^2);
expr723 = -3./4;
expr724 = sqrt(a(1).^2 + b(1).^2).^(-1);
expr725 = a(1).^(-2);
expr726 = (a(1) - a(2)).^2 + (b(1) - b(2)).^2;
expr727 = (a(1) - a(2)).^2 + (b(1) + b(2)).^2;
expr728 = (a(1) - a(3)).^2 + (b(1) - b(3)).^2;
expr729 = (a(1) - a(3)).^2 + (b(1) + b(3)).^2;
expr730 = (a(1) - a(4)).^2 + (b(1) - b(4)).^2;
expr731 = (a(1) - a(4)).^2 + (b(1) + b(4)).^2;
expr732 = (a(1) - c(1)).^2 + (b(1) - d(1)).^2;
expr733 = (a(1) - c(1)).^2 + (b(1) + d(1)).^2;
expr734 = (a(1) - c(2)).^2 + (b(1) - d(2)).^2;
expr735 = (a(1) - c(2)).^2 + (b(1) + d(2)).^2;
expr736 = (a(1) - c(3)).^2 + (b(1) - d(3)).^2;
expr737 = (a(1) - c(3)).^2 + (b(1) + d(3)).^2;
expr738 = (a(1) - c(4)).^2 + (b(1) - d(4)).^2;
expr739 = (a(1) - c(4)).^2 + (b(1) + d(4)).^2;
expr740 = (-a(1) + a(2)).^2 + (-b(1) + b(2)).^2;
expr741 = (-a(1) + a(2)).^2 + (b(1) + b(2)).^2;
expr742 = (a(2) - a(3)).^2 + (b(2) - b(3)).^2;
expr743 = (a(2) - a(3)).^2 + (b(2) + b(3)).^2;
expr744 = (a(2) - a(4)).^2 + (b(2) - b(4)).^2;
expr745 = (a(2) - a(4)).^2 + (b(2) + b(4)).^2;
expr746 = (a(2) - c(1)).^2 + (b(2) - d(1)).^2;
expr747 = (a(2) - c(1)).^2 + (b(2) + d(1)).^2;
expr748 = (a(2) - c(2)).^2 + (b(2) - d(2)).^2;
expr749 = (a(2) - c(2)).^2 + (b(2) + d(2)).^2;
expr750 = (a(2) - c(3)).^2 + (b(2) - d(3)).^2;
expr751 = (a(2) - c(3)).^2 + (b(2) + d(3)).^2;
expr752 = (a(2) - c(4)).^2 + (b(2) - d(4)).^2;
expr753 = (a(2) - c(4)).^2 + (b(2) + d(4)).^2;
expr754 = (-a(1) + a(3)).^2 + (-b(1) + b(3)).^2;
expr755 = (-a(1) + a(3)).^2 + (b(1) + b(3)).^2;
expr756 = (-a(2) + a(3)).^2 + (-b(2) + b(3)).^2;
expr757 = (-a(2) + a(3)).^2 + (b(2) + b(3)).^2;
expr758 = (a(3) - a(4)).^2 + (b(3) - b(4)).^2;
expr759 = (a(3) - a(4)).^2 + (b(3) + b(4)).^2;
expr760 = (a(3) - c(1)).^2 + (b(3) - d(1)).^2;
expr761 = (a(3) - c(1)).^2 + (b(3) + d(1)).^2;
expr762 = (a(3) - c(2)).^2 + (b(3) - d(2)).^2;
expr763 = (a(3) - c(2)).^2 + (b(3) + d(2)).^2;
expr764 = (a(3) - c(3)).^2 + (b(3) - d(3)).^2;
expr765 = (a(3) - c(3)).^2 + (b(3) + d(3)).^2;
expr766 = (a(3) - c(4)).^2 + (b(3) - d(4)).^2;
expr767 = (a(3) - c(4)).^2 + (b(3) + d(4)).^2;
expr768 = (-a(1) + a(4)).^2 + (-b(1) + b(4)).^2;
expr769 = (-a(1) + a(4)).^2 + (b(1) + b(4)).^2;
expr770 = (-a(2) + a(4)).^2 + (-b(2) + b(4)).^2;
expr771 = (-a(2) + a(4)).^2 + (b(2) + b(4)).^2;
expr772 = (-a(3) + a(4)).^2 + (-b(3) + b(4)).^2;
expr773 = (-a(3) + a(4)).^2 + (b(3) + b(4)).^2;
expr774 = (a(4) - c(1)).^2 + (b(4) - d(1)).^2;
expr775 = (a(4) - c(1)).^2 + (b(4) + d(1)).^2;
expr776 = (a(4) - c(2)).^2 + (b(4) - d(2)).^2;
expr777 = (a(4) - c(2)).^2 + (b(4) + d(2)).^2;
expr778 = (a(4) - c(3)).^2 + (b(4) - d(3)).^2;
expr779 = (a(4) - c(3)).^2 + (b(4) + d(3)).^2;
expr780 = (a(4) - c(4)).^2 + (b(4) - d(4)).^2;
expr781 = (a(4) - c(4)).^2 + (b(4) + d(4)).^2;
expr782 = a(1) - a(4);
expr783 = a(1) - a(3);
expr784 = a(1) - a(2);
expr785 = a(1) - c(4);
expr786 = a(1) - c(3);
expr787 = a(1) - c(2);
expr788 = a(1) - c(1);
expr789 = (a(1) - a(2)).^(-2);
expr790 = (1 + (b(1) - b(2)).^2./(a(1) - a(2)).^2).^(-1);
expr791 = b(1) - b(2);
expr792 = -((b(1) + b(2))./((a(1) - a(2)).^2.*(1 + (b(1) + b(2)).^2./(a(1) - a(2)).^2)));
expr793 = (a(1) - a(3)).^(-2);
expr794 = (1 + (b(1) - b(3)).^2./(a(1) - a(3)).^2).^(-1);
expr795 = b(1) - b(3);
expr796 = -((b(1) + b(3))./((a(1) - a(3)).^2.*(1 + (b(1) + b(3)).^2./(a(1) - a(3)).^2)));
expr797 = (a(1) - a(4)).^(-2);
expr798 = (1 + (b(1) - b(4)).^2./(a(1) - a(4)).^2).^(-1);
expr799 = b(1) - b(4);
expr800 = -((b(1) + b(4))./((a(1) - a(4)).^2.*(1 + (b(1) + b(4)).^2./(a(1) - a(4)).^2)));
expr801 = (a(1) - c(1)).^(-2);
expr802 = (1 + (b(1) - d(1)).^2./(a(1) - c(1)).^2).^(-1);
expr803 = b(1) - d(1);
expr804 = (b(1) + d(1))./((a(1) - c(1)).^2.*(1 + (b(1) + d(1)).^2./(a(1) - c(1)).^2));
expr805 = (a(1) - c(2)).^(-2);
expr806 = (1 + (b(1) - d(2)).^2./(a(1) - c(2)).^2).^(-1);
expr807 = b(1) - d(2);
expr808 = (b(1) + d(2))./((a(1) - c(2)).^2.*(1 + (b(1) + d(2)).^2./(a(1) - c(2)).^2));
expr809 = (a(1) - c(3)).^(-2);
expr810 = (1 + (b(1) - d(3)).^2./(a(1) - c(3)).^2).^(-1);
expr811 = b(1) - d(3);
expr812 = (b(1) + d(3))./((a(1) - c(3)).^2.*(1 + (b(1) + d(3)).^2./(a(1) - c(3)).^2));
expr813 = (a(1) - c(4)).^(-2);
expr814 = (1 + (b(1) - d(4)).^2./(a(1) - c(4)).^2).^(-1);
expr815 = b(1) - d(4);
expr816 = (b(1) + d(4))./((a(1) - c(4)).^2.*(1 + (b(1) + d(4)).^2./(a(1) - c(4)).^2));
expr817 = 2.*a(1);
expr818 = (-a(1) + a(2)).^(-2);
expr819 = -b(1) + b(2);
expr820 = (1 + (-b(1) + b(2)).^2./(-a(1) + a(2)).^2).^(-1);
expr821 = (b(1) + b(2))./((-a(1) + a(2)).^2.*(1 + (b(1) + b(2)).^2./(-a(1) + a(2)).^2));
expr822 = (-a(1) + a(3)).^(-2);
expr823 = -b(1) + b(3);
expr824 = (1 + (-b(1) + b(3)).^2./(-a(1) + a(3)).^2).^(-1);
expr825 = (b(1) + b(3))./((-a(1) + a(3)).^2.*(1 + (b(1) + b(3)).^2./(-a(1) + a(3)).^2));
expr826 = (-a(1) + a(4)).^(-2);
expr827 = -b(1) + b(4);
expr828 = (1 + (-b(1) + b(4)).^2./(-a(1) + a(4)).^2).^(-1);
expr829 = (b(1) + b(4))./((-a(1) + a(4)).^2.*(1 + (b(1) + b(4)).^2./(-a(1) + a(4)).^2));
expr830 = -1./4;
expr831 = -a(1) + a(2);
expr832 = -a(1) + a(3);
expr833 = -a(1) + a(4);
expr834 = expr714.*(expr715.*expr716.*expr717.*expr718.*expr719.*expr720.*expr721.*expr722).^expr723.*(expr716.*expr717.*expr718.*expr720.*expr721.*expr722.*expr724 - expr716.*expr717.*expr718.*expr719.*expr720.*expr721.*expr722.*expr725).*WQ;
expr835 = (expr726.*expr727.*expr728.*expr729.*expr730.*expr731).^expr600;
expr836 = (expr732.*expr733.*expr734.*expr735.*expr736.*expr737.*expr738.*expr739).^expr615;
expr837 = expr482.*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497) + expr498.*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr838 = (expr740.*expr741.*expr742.*expr743.*expr744.*expr745).^expr600;
expr839 = (expr746.*expr747.*expr748.*expr749.*expr750.*expr751.*expr752.*expr753).^expr615;
expr840 = expr502.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517) + expr518.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr841 = (expr754.*expr755.*expr756.*expr757.*expr758.*expr759).^expr600;
expr842 = (expr760.*expr761.*expr762.*expr763.*expr764.*expr765.*expr766.*expr767).^expr615;
expr843 = expr522.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537) + expr538.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr844 = (expr768.*expr769.*expr770.*expr771.*expr772.*expr773).^expr600;
expr845 = (expr774.*expr775.*expr776.*expr777.*expr778.*expr779.*expr780.*expr781).^expr615;
expr846 = expr542.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557) + expr558.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr847 = (expr726.*expr727.*expr728.*expr729.*expr730.*expr731).^expr606;
expr848 = 2.*expr726.*expr727.*expr728.*expr729.*expr730.*expr782;
expr849 = 2.*expr726.*expr727.*expr728.*expr729.*expr731.*expr782;
expr850 = 2.*expr726.*expr727.*expr728.*expr730.*expr731.*expr783;
expr851 = 2.*expr726.*expr727.*expr729.*expr730.*expr731.*expr783;
expr852 = 2.*expr726.*expr728.*expr729.*expr730.*expr731.*expr784;
expr853 = 2.*expr727.*expr728.*expr729.*expr730.*expr731.*expr784;
expr854 = (expr732.*expr733.*expr734.*expr735.*expr736.*expr737.*expr738.*expr739).^expr600;
expr855 = 2.*expr732.*expr733.*expr734.*expr735.*expr736.*expr737.*expr738.*expr785;
expr856 = 2.*expr732.*expr733.*expr734.*expr735.*expr736.*expr737.*expr739.*expr785;
expr857 = 2.*expr732.*expr733.*expr734.*expr735.*expr736.*expr738.*expr739.*expr786;
expr858 = 2.*expr732.*expr733.*expr734.*expr735.*expr737.*expr738.*expr739.*expr786;
expr859 = 2.*expr732.*expr733.*expr734.*expr736.*expr737.*expr738.*expr739.*expr787;
expr860 = 2.*expr732.*expr733.*expr735.*expr736.*expr737.*expr738.*expr739.*expr787;
expr861 = 2.*expr732.*expr734.*expr735.*expr736.*expr737.*expr738.*expr739.*expr788;
expr862 = 2.*expr733.*expr734.*expr735.*expr736.*expr737.*expr738.*expr739.*expr788;
expr863 = -(expr789.*expr790.*expr791) + expr792 - expr793.*expr794.*expr795 + expr796 - expr797.*expr798.*expr799 + expr800 + expr801.*expr802.*expr803 + expr804 + expr805.*expr806.*expr807 + expr808 + expr809.*expr810.*expr811 + expr812 + expr813.*expr814.*expr815 + expr816;
expr864 = cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr865 = sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497).^2;
expr866 = (expr482.*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497) + expr498.*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497)).^(-2);
expr867 = sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517).^2;
expr868 = (expr502.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517) + expr518.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517)).^(-2);
expr869 = expr818.*expr819.*expr820 + expr821;
expr870 = cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr871 = expr518.*(expr818.*expr819.*expr820 + expr821).*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr872 = -(expr502.*(expr818.*expr819.*expr820 + expr821).*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517));
expr873 = sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537).^2;
expr874 = (expr522.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537) + expr538.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537)).^(-2);
expr875 = expr822.*expr823.*expr824 + expr825;
expr876 = cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr877 = expr538.*(expr822.*expr823.*expr824 + expr825).*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr878 = -(expr522.*(expr822.*expr823.*expr824 + expr825).*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537));
expr879 = sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557).^2;
expr880 = (expr542.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557) + expr558.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557)).^(-2);
expr881 = expr826.*expr827.*expr828 + expr829;
expr882 = cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr883 = expr558.*(expr826.*expr827.*expr828 + expr829).*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr884 = -(expr542.*(expr826.*expr827.*expr828 + expr829).*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557));
expr885 = (expr740.*expr741.*expr742.*expr743.*expr744.*expr745).^expr606;
expr886 = -2.*expr740.*expr742.*expr743.*expr744.*expr745.*expr831 - 2.*expr741.*expr742.*expr743.*expr744.*expr745.*expr831;
expr887 = (expr754.*expr755.*expr756.*expr757.*expr758.*expr759).^expr606;
expr888 = -2.*expr754.*expr756.*expr757.*expr758.*expr759.*expr832 - 2.*expr755.*expr756.*expr757.*expr758.*expr759.*expr832;
expr889 = (expr768.*expr769.*expr770.*expr771.*expr772.*expr773).^expr606;
expr890 = -2.*expr768.*expr770.*expr771.*expr772.*expr773.*expr833 - 2.*expr769.*expr770.*expr771.*expr772.*expr773.*expr833;
expr891 = expr498 - expr483.*expr562.*expr563;
expr892 = expr518 - expr503.*expr564.*expr565;
expr893 = expr538 - expr523.*expr566.*expr567;
expr894 = expr558 - expr543.*expr568.*expr569;
expr895 = expr848 + expr849 + expr850 + expr851 + expr852 + expr853;
expr896 = expr855 + expr856 + expr857 + expr858 + expr859 + expr860 + expr861 + expr862;
expr897 = expr562 - expr482.*expr562.*expr863 + expr498.*expr863.*expr864;
expr898 = (1 + (expr500.*expr577.*expr865.*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^2).^(-1);
expr899 = (2.*expr482.*expr498.*expr562.*expr563)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr900 = (expr482.*expr483.*expr563.*expr863.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr901 = -((expr482.*expr483.*expr562.*(expr562 - expr482.*expr562.*expr863 + expr498.*expr863.*expr864).*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr902 = (expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^(-2);
expr903 = -(expr483.*expr562.*expr563) - 2.*expr499.*expr562.*expr563 + expr817 - expr483.*expr498.*expr563.*expr863.*expr864 + expr483.*expr498.*expr562.*(expr562 - expr482.*expr562.*expr863 + expr498.*expr863.*expr864).*expr866;
expr904 = (1 + (expr520.*expr580.*expr867.*expr868)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^2).^(-1);
expr905 = (expr502.*expr503.*expr565.*expr869.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr906 = -((expr502.*expr503.*expr564.*expr868.*(expr871 + expr872))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr907 = -((expr502.*expr503.*expr564.*expr565.*(-(expr503.*expr518.*expr565.*expr869.*expr870) + expr503.*expr518.*expr564.*expr868.*(expr871 + expr872)))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^2);
expr908 = (1 + (expr540.*expr582.*expr873.*expr874)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^2).^(-1);
expr909 = (expr522.*expr523.*expr567.*expr875.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr910 = -((expr522.*expr523.*expr566.*expr874.*(expr877 + expr878))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr911 = -((expr522.*expr523.*expr566.*expr567.*(-(expr523.*expr538.*expr567.*expr875.*expr876) + expr523.*expr538.*expr566.*expr874.*(expr877 + expr878)))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^2);
expr912 = (1 + (expr560.*expr584.*expr879.*expr880)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^2).^(-1);
expr913 = (expr542.*expr543.*expr569.*expr881.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr914 = -((expr542.*expr543.*expr568.*expr880.*(expr883 + expr884))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr915 = -((expr542.*expr543.*expr568.*expr569.*(-(expr543.*expr558.*expr569.*expr881.*expr882) + expr543.*expr558.*expr568.*expr880.*(expr883 + expr884)))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^2);
expr916 = 1 - 2.*expr498.*expr562.*expr563 - expr483.*expr563.*expr863.*expr864 + expr483.*expr562.*(expr562 - expr482.*expr562.*expr863 + expr498.*expr863.*expr864).*expr866;
expr917 = expr871 + expr872;
expr918 = -(expr503.*expr565.*expr869.*expr870) + expr503.*expr564.*expr868.*(expr871 + expr872);
expr919 = expr877 + expr878;
expr920 = -(expr523.*expr567.*expr875.*expr876) + expr523.*expr566.*expr874.*(expr877 + expr878);
expr921 = expr883 + expr884;
expr922 = -(expr543.*expr569.*expr881.*expr882) + expr543.*expr568.*expr880.*(expr883 + expr884);
expr923 = -(exp(expr481.*expr498.*(expr570 + expr571 + expr572 + expr573).*tpc).*(cos(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc) - expr501.*expr891.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc)));
expr924 = -(exp(expr481.*expr518.*(expr570 + expr571 + expr572 + expr573).*tpc).*(cos(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc) - expr521.*expr892.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc)));
expr925 = -(exp(expr481.*expr538.*(expr570 + expr571 + expr572 + expr573).*tpc).*(cos(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc) - expr541.*expr893.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc)));
expr926 = -(exp(expr481.*expr558.*(expr570 + expr571 + expr572 + expr573).*tpc).*(cos(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc) - expr561.*expr894.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc)));
expr927 = exp(expr481.*expr498.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr928 = expr481.*(expr570 + expr571 + expr572 + expr573).*tpc;
expr929 = expr501.*expr898.*(expr899 + expr900 + expr901 - expr482.*expr483.*expr562.*expr563.*expr902.*expr903) + expr521.*expr904.*(expr905 + expr906 + expr907) + expr541.*expr908.*(expr909 + expr910 + expr911) + expr561.*expr912.*(expr913 + expr914 + expr915);
expr930 = cos(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc) - expr501.*expr891.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr931 = cos(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr932 = -(expr501.*expr916.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr933 = sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr934 = exp(expr481.*expr518.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr935 = cos(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc) - expr521.*expr892.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr936 = cos(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr937 = -(expr521.*expr918.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr938 = sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr939 = exp(expr481.*expr538.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr940 = cos(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc) - expr541.*expr893.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr941 = cos(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr942 = -(expr541.*expr920.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr943 = sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr944 = exp(expr481.*expr558.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr945 = cos(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc) - expr561.*expr894.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr946 = cos(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr947 = -(expr561.*expr922.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr948 = sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr949 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(1 + expr923);
expr950 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(1 + expr924);
expr951 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(1 + expr925);
expr952 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(1 + expr926);
expr953 = expr501.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr836.*expr837.*expr847.*expr895.*(1 + expr923);
expr954 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr835.*expr837.*expr854.*expr896.*(1 + expr923);
expr955 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr897.*(1 + expr923);
expr956 = 2.*expr498.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(1 + expr924);
expr957 = expr483.*expr521.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr839.*expr840.*expr885.*expr886.*(1 + expr924);
expr958 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr917.*(1 + expr924);
expr959 = 2.*expr498.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(1 + expr925);
expr960 = expr483.*expr503.*expr541.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr842.*expr843.*expr887.*expr888.*(1 + expr925);
expr961 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr919.*(1 + expr925);
expr962 = 2.*expr498.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(1 + expr926);
expr963 = expr483.*expr503.*expr523.*expr561.*expr600.*expr607.*expr608.*expr609.*expr610.*expr845.*expr846.*expr889.*expr890.*(1 + expr926);
expr964 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr921.*(1 + expr926);
expr965 = -(expr927.*expr930.*(expr928 + expr481.*expr498.*expr929.*tpc)) - expr927.*(expr932 + expr830.*expr891.*expr929.*expr931.*tpc + expr482.*expr830.*expr929.*expr933.*tpc);
expr966 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(expr518.*expr830.*expr929.*expr934.*expr935.*tpc - expr934.*(expr937 + expr830.*expr892.*expr929.*expr936.*tpc + expr502.*expr830.*expr929.*expr938.*tpc));
expr967 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(expr538.*expr830.*expr929.*expr939.*expr940.*tpc - expr939.*(expr942 + expr830.*expr893.*expr929.*expr941.*tpc + expr522.*expr830.*expr929.*expr943.*tpc));
expr968 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(expr558.*expr830.*expr929.*expr944.*expr945.*tpc - expr944.*(expr947 + expr830.*expr894.*expr929.*expr946.*tpc + expr542.*expr830.*expr929.*expr948.*tpc));
expr969 = 200.*(-1 + expr949 + expr950 + expr951 + expr952).*(expr953 + expr954 + expr955 + expr956 + expr957 + expr958 + expr959 + expr960 + expr961 + expr962 + expr963 + expr964 + expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*expr965 + expr966 + expr967 + expr968).*WO;
expr970 = expr834 + expr969 + integrate5 + integrate6 + integrate7 + integrate8;
gf(1) = expr970;

%% Derivative for b(1)
w9 = [ws:(99.*ws)./100:100.*ws];
expr971 = -4.*w9.^2.*b(1) + 4.*b(1).*(a(1).^2 + b(1).^2);
expr972 = ((a(1).^2 + b(1).^2).^2 + w9.^2.*(w9.^2 + 2.*(a(1).^2 - b(1).^2))).^(-2);
expr973 = ((a(2).^2 + b(2).^2).^2 + w9.^2.*(w9.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr974 = ((a(3).^2 + b(3).^2).^2 + w9.^2.*(w9.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr975 = ((a(4).^2 + b(4).^2).^2 + w9.^2.*(w9.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr976 = (c(1).^2 + d(1).^2).^2 + w9.^2.*(w9.^2 + 2.*(c(1).^2 - d(1).^2));
expr977 = (c(2).^2 + d(2).^2).^2 + w9.^2.*(w9.^2 + 2.*(c(2).^2 - d(2).^2));
expr978 = (c(3).^2 + d(3).^2).^2 + w9.^2.*(w9.^2 + 2.*(c(3).^2 - d(3).^2));
expr979 = (c(4).^2 + d(4).^2).^2 + w9.^2.*(w9.^2 + 2.*(c(4).^2 - d(4).^2));
expr980 = ((a(1).^2 + b(1).^2).^2 + w9.^2.*(w9.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr981 = expr575.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*expr971.*expr972.*expr973.*expr974.*expr975.*expr976.*expr977.*expr978.*expr979.*Wms;
expr982 = expr482.*expr483.*expr576.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*expr594.*expr973.*expr974.*expr975.*expr976.*expr977.*expr978.*expr979.*expr980.*Wms;
expr983 = expr981 + expr982;
integrate9 = trapz(w9, expr983);
w10 = [0:wp./100:wp];
expr984 = -4.*w10.^2.*b(1) + 4.*b(1).*(a(1).^2 + b(1).^2);
expr985 = (a(2).^2 + b(2).^2).^2 + w10.^2.*(w10.^2 + 2.*(a(2).^2 - b(2).^2));
expr986 = (a(3).^2 + b(3).^2).^2 + w10.^2.*(w10.^2 + 2.*(a(3).^2 - b(3).^2));
expr987 = (a(4).^2 + b(4).^2).^2 + w10.^2.*(w10.^2 + 2.*(a(4).^2 - b(4).^2));
expr988 = (a(1).^2 + b(1).^2).^2 + w10.^2.*(w10.^2 + 2.*(a(1).^2 - b(1).^2));
expr989 = (c(1).^2 + d(1).^2).^2 + w10.^2.*(w10.^2 + 2.*(c(1).^2 - d(1).^2));
expr990 = (c(2).^2 + d(2).^2).^2 + w10.^2.*(w10.^2 + 2.*(c(2).^2 - d(2).^2));
expr991 = (c(3).^2 + d(3).^2).^2 + w10.^2.*(w10.^2 + 2.*(c(3).^2 - d(3).^2));
expr992 = (c(4).^2 + d(4).^2).^2 + w10.^2.*(w10.^2 + 2.*(c(4).^2 - d(4).^2));
expr993 = -1 + expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*(expr985.*expr986.*expr987.*expr988).^expr600.*(expr989.*expr990.*expr991.*expr992).^expr615;
expr994 = 2.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*(expr985.*expr986.*expr987.*expr988).^expr600.*(expr989.*expr990.*expr991.*expr992).^expr615;
expr995 = expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr984.*expr985.*expr986.*expr987.*(expr985.*expr986.*expr987.*expr988).^expr606.*(expr989.*expr990.*expr991.*expr992).^expr615;
expr996 = 2.*expr599.*expr993.*(expr994 + expr995).*Wmp;
integrate10 = trapz(w10, expr996);
w11 = [wp:(-wp + ws)./100:ws];
expr997 = -4.*w11.^2.*b(1) + 4.*b(1).*(a(1).^2 + b(1).^2);
expr998 = (a(2).^2 + b(2).^2).^2 + w11.^2.*(w11.^2 + 2.*(a(2).^2 - b(2).^2));
expr999 = (a(3).^2 + b(3).^2).^2 + w11.^2.*(w11.^2 + 2.*(a(3).^2 - b(3).^2));
expr1000 = (a(4).^2 + b(4).^2).^2 + w11.^2.*(w11.^2 + 2.*(a(4).^2 - b(4).^2));
expr1001 = (a(1).^2 + b(1).^2).^2 + w11.^2.*(w11.^2 + 2.*(a(1).^2 - b(1).^2));
expr1002 = (c(1).^2 + d(1).^2).^2 + w11.^2.*(w11.^2 + 2.*(c(1).^2 - d(1).^2));
expr1003 = (c(2).^2 + d(2).^2).^2 + w11.^2.*(w11.^2 + 2.*(c(2).^2 - d(2).^2));
expr1004 = (c(3).^2 + d(3).^2).^2 + w11.^2.*(w11.^2 + 2.*(c(3).^2 - d(3).^2));
expr1005 = (c(4).^2 + d(4).^2).^2 + w11.^2.*(w11.^2 + 2.*(c(4).^2 - d(4).^2));
expr1006 = -(w11./(wp - ws));
expr1007 = expr1006 + expr631 + (expr1002.*expr1003.*expr1004.*expr1005).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*(expr1000.*expr1001.*expr998.*expr999).^expr600;
expr1008 = 2.*(expr1002.*expr1003.*expr1004.*expr1005).^expr615.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*(expr1000.*expr1001.*expr998.*expr999).^expr600;
expr1009 = expr1000.*(expr1002.*expr1003.*expr1004.*expr1005).^expr615.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr997.*expr998.*expr999.*(expr1000.*expr1001.*expr998.*expr999).^expr606;
expr1010 = 2.*expr1007.*(expr1008 + expr1009).*expr620.*Wmt;
integrate11 = trapz(w11, expr1010);
w12 = [0:wmax./100:wmax];
expr1011 = -(1./(a(1).*(1 + (w12 - b(1)).^2./a(1).^2)));
expr1012 = 1./(a(1).*(1 + (w12 + b(1)).^2./a(1).^2));
expr1013 = -2.*(angle(1 + (i.*(wmax - b(1)))./a(1)) + angle(1 + (i.*(wmax + b(1)))./a(1))).*b(1);
expr1014 = (2.*(wmax - b(1)).*b(1))./(a(1).*(1 + (wmax - b(1)).^2./a(1).^2));
expr1015 = (2.*b(1).*(wmax + b(1)))./(a(1).*(1 + (wmax + b(1)).^2./a(1).^2));
expr1016 = -(1./(a(1).*(1 + (wmax - b(1)).^2./a(1).^2)));
expr1017 = 1./(a(1).*(1 + (wmax + b(1)).^2./a(1).^2));
expr1018 = -(a(1).*log(1 + (wmax - b(1)).^2./a(1).^2));
expr1019 = a(1).*log(1 + (wmax + b(1)).^2./a(1).^2);
expr1020 = angle(1 + (i.*(w12 - b(1)))./a(1));
expr1021 = angle(1 + (i.*(w12 + b(1)))./a(1));
expr1022 = angle(1 + (i.*(w12 - b(2)))./a(2));
expr1023 = angle(1 + (i.*(w12 + b(2)))./a(2));
expr1024 = angle(1 + (i.*(w12 - b(3)))./a(3));
expr1025 = angle(1 + (i.*(w12 + b(3)))./a(3));
expr1026 = angle(1 + (i.*(w12 - b(4)))./a(4));
expr1027 = angle(1 + (i.*(w12 + b(4)))./a(4));
expr1028 = -angle(1 + (i.*(w12 - d(1)))./c(1));
expr1029 = -angle(1 + (i.*(w12 + d(1)))./c(1));
expr1030 = -angle(1 + (i.*(w12 - d(2)))./c(2));
expr1031 = -angle(1 + (i.*(w12 + d(2)))./c(2));
expr1032 = -angle(1 + (i.*(w12 - d(3)))./c(3));
expr1033 = -angle(1 + (i.*(w12 + d(3)))./c(3));
expr1034 = -angle(1 + (i.*(w12 - d(4)))./c(4));
expr1035 = -angle(1 + (i.*(w12 + d(4)))./c(4));
expr1036 = expr1011 + expr1012 + expr606.*expr639.*(expr1013 + expr1014 + expr1015 + expr1018 + expr1019 - (expr1016 + expr1017).*expr644).*w12;
expr1037 = 2.*expr1036.*expr636.*(expr1020 + expr1021 + expr1022 + expr1023 + expr1024 + expr1025 + expr1026 + expr1027 + expr1028 + expr1029 + expr1030 + expr1031 + expr1032 + expr1033 + expr1034 + expr1035 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w12).*Wph;
integrate12 = trapz(w12, expr1037);
expr1038 = b(1).^(-2);
expr1039 = b(1) + b(4);
expr1040 = b(1) + b(3);
expr1041 = b(1) + b(2);
expr1042 = b(1) + d(4);
expr1043 = b(1) + d(3);
expr1044 = b(1) + d(2);
expr1045 = b(1) + d(1);
expr1046 = 1./((a(1) - a(2)).*(1 + (b(1) - b(2)).^2./(a(1) - a(2)).^2));
expr1047 = 1./((a(1) - a(2)).*(1 + (b(1) + b(2)).^2./(a(1) - a(2)).^2));
expr1048 = 1./((a(1) - a(3)).*(1 + (b(1) - b(3)).^2./(a(1) - a(3)).^2));
expr1049 = 1./((a(1) - a(3)).*(1 + (b(1) + b(3)).^2./(a(1) - a(3)).^2));
expr1050 = 1./((a(1) - a(4)).*(1 + (b(1) - b(4)).^2./(a(1) - a(4)).^2));
expr1051 = 1./((a(1) - a(4)).*(1 + (b(1) + b(4)).^2./(a(1) - a(4)).^2));
expr1052 = -(1./((a(1) - c(1)).*(1 + (b(1) - d(1)).^2./(a(1) - c(1)).^2)));
expr1053 = -(1./((a(1) - c(1)).*(1 + (b(1) + d(1)).^2./(a(1) - c(1)).^2)));
expr1054 = -(1./((a(1) - c(2)).*(1 + (b(1) - d(2)).^2./(a(1) - c(2)).^2)));
expr1055 = -(1./((a(1) - c(2)).*(1 + (b(1) + d(2)).^2./(a(1) - c(2)).^2)));
expr1056 = -(1./((a(1) - c(3)).*(1 + (b(1) - d(3)).^2./(a(1) - c(3)).^2)));
expr1057 = -(1./((a(1) - c(3)).*(1 + (b(1) + d(3)).^2./(a(1) - c(3)).^2)));
expr1058 = -(1./((a(1) - c(4)).*(1 + (b(1) - d(4)).^2./(a(1) - c(4)).^2)));
expr1059 = -(1./((a(1) - c(4)).*(1 + (b(1) + d(4)).^2./(a(1) - c(4)).^2)));
expr1060 = 2.*b(1);
expr1061 = -(1./((-a(1) + a(2)).*(1 + (-b(1) + b(2)).^2./(-a(1) + a(2)).^2)));
expr1062 = 1./((-a(1) + a(2)).*(1 + (b(1) + b(2)).^2./(-a(1) + a(2)).^2));
expr1063 = -(1./((-a(1) + a(3)).*(1 + (-b(1) + b(3)).^2./(-a(1) + a(3)).^2)));
expr1064 = 1./((-a(1) + a(3)).*(1 + (b(1) + b(3)).^2./(-a(1) + a(3)).^2));
expr1065 = -(1./((-a(1) + a(4)).*(1 + (-b(1) + b(4)).^2./(-a(1) + a(4)).^2)));
expr1066 = 1./((-a(1) + a(4)).*(1 + (b(1) + b(4)).^2./(-a(1) + a(4)).^2));
expr1067 = expr482.*expr714.*expr715.*expr716.*expr717.*expr718.*expr720.*expr721.*expr722.*(expr715.*expr716.*expr717.*expr718.*expr719.*expr720.*expr721.*expr722).^expr723.*expr724.*WQ;
expr1068 = (expr1046 + expr1047 + expr1048 + expr1049 + expr1050 + expr1051 + expr1052 + expr1053 + expr1054 + expr1055 + expr1056 + expr1057 + expr1058 + expr1059).*expr498.*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr1069 = -((expr1046 + expr1047 + expr1048 + expr1049 + expr1050 + expr1051 + expr1052 + expr1053 + expr1054 + expr1055 + expr1056 + expr1057 + expr1058 + expr1059).*expr482.*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497));
expr1070 = 2.*expr1039.*expr726.*expr727.*expr728.*expr729.*expr730;
expr1071 = 2.*expr1040.*expr726.*expr727.*expr728.*expr730.*expr731;
expr1072 = 2.*expr1041.*expr726.*expr728.*expr729.*expr730.*expr731;
expr1073 = 2.*expr727.*expr728.*expr729.*expr730.*expr731.*expr791;
expr1074 = 2.*expr726.*expr727.*expr729.*expr730.*expr731.*expr795;
expr1075 = 2.*expr726.*expr727.*expr728.*expr729.*expr731.*expr799;
expr1076 = 2.*expr1042.*expr732.*expr733.*expr734.*expr735.*expr736.*expr737.*expr738;
expr1077 = 2.*expr1043.*expr732.*expr733.*expr734.*expr735.*expr736.*expr738.*expr739;
expr1078 = 2.*expr1044.*expr732.*expr733.*expr734.*expr736.*expr737.*expr738.*expr739;
expr1079 = 2.*expr1045.*expr732.*expr734.*expr735.*expr736.*expr737.*expr738.*expr739;
expr1080 = 2.*expr733.*expr734.*expr735.*expr736.*expr737.*expr738.*expr739.*expr803;
expr1081 = 2.*expr732.*expr733.*expr735.*expr736.*expr737.*expr738.*expr739.*expr807;
expr1082 = 2.*expr732.*expr733.*expr734.*expr735.*expr737.*expr738.*expr739.*expr811;
expr1083 = 2.*expr732.*expr733.*expr734.*expr735.*expr736.*expr737.*expr739.*expr815;
expr1084 = expr1046 + expr1047 + expr1048 + expr1049 + expr1050 + expr1051 + expr1052 + expr1053 + expr1054 + expr1055 + expr1056 + expr1057 + expr1058 + expr1059;
expr1085 = (expr1061 + expr1062).*expr518.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr1086 = -((expr1061 + expr1062).*expr502.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517));
expr1087 = expr1061 + expr1062;
expr1088 = (expr1063 + expr1064).*expr538.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr1089 = -((expr1063 + expr1064).*expr522.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537));
expr1090 = expr1063 + expr1064;
expr1091 = (expr1065 + expr1066).*expr558.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr1092 = -((expr1065 + expr1066).*expr542.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557));
expr1093 = expr1065 + expr1066;
expr1094 = 2.*expr1041.*expr740.*expr742.*expr743.*expr744.*expr745 - 2.*expr741.*expr742.*expr743.*expr744.*expr745.*expr819;
expr1095 = 2.*expr1040.*expr754.*expr756.*expr757.*expr758.*expr759 - 2.*expr755.*expr756.*expr757.*expr758.*expr759.*expr823;
expr1096 = 2.*expr1039.*expr768.*expr770.*expr771.*expr772.*expr773 - 2.*expr769.*expr770.*expr771.*expr772.*expr773.*expr827;
expr1097 = expr1070 + expr1071 + expr1072 + expr1073 + expr1074 + expr1075;
expr1098 = expr1076 + expr1077 + expr1078 + expr1079 + expr1080 + expr1081 + expr1082 + expr1083;
expr1099 = expr1068 + expr1069 + expr864;
expr1100 = (expr483.*expr562.*expr563)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr1101 = (2.*expr500.*expr562.*expr563)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr1102 = (expr1084.*expr482.*expr483.*expr563.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr1103 = -((expr482.*expr483.*expr562.*(expr1068 + expr1069 + expr864).*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr1104 = expr1060 - 2.*expr482.*expr498.*expr562.*expr563 - expr1084.*expr483.*expr498.*expr563.*expr864 + expr483.*expr498.*expr562.*(expr1068 + expr1069 + expr864).*expr866;
expr1105 = -(((expr1085 + expr1086).*expr502.*expr503.*expr564.*expr868)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr1106 = (expr1087.*expr502.*expr503.*expr565.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr1107 = -((expr502.*expr503.*expr564.*expr565.*((expr1085 + expr1086).*expr503.*expr518.*expr564.*expr868 - expr1087.*expr503.*expr518.*expr565.*expr870))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^2);
expr1108 = -(((expr1088 + expr1089).*expr522.*expr523.*expr566.*expr874)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr1109 = (expr1090.*expr522.*expr523.*expr567.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr1110 = -((expr522.*expr523.*expr566.*expr567.*((expr1088 + expr1089).*expr523.*expr538.*expr566.*expr874 - expr1090.*expr523.*expr538.*expr567.*expr876))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^2);
expr1111 = -(((expr1091 + expr1092).*expr542.*expr543.*expr568.*expr880)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr1112 = (expr1093.*expr542.*expr543.*expr569.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr1113 = -((expr542.*expr543.*expr568.*expr569.*((expr1091 + expr1092).*expr543.*expr558.*expr568.*expr880 - expr1093.*expr543.*expr558.*expr569.*expr882))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^2);
expr1114 = expr1038.*(pi - angle(1 + (expr482.*expr483.*expr562.*expr563.*i)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563)));
expr1115 = -2.*expr482.*expr562.*expr563 - expr1084.*expr483.*expr563.*expr864 + expr483.*expr562.*(expr1068 + expr1069 + expr864).*expr866;
expr1116 = expr1085 + expr1086;
expr1117 = (expr1085 + expr1086).*expr503.*expr564.*expr868 - expr1087.*expr503.*expr565.*expr870;
expr1118 = expr1088 + expr1089;
expr1119 = (expr1088 + expr1089).*expr523.*expr566.*expr874 - expr1090.*expr523.*expr567.*expr876;
expr1120 = expr1091 + expr1092;
expr1121 = (expr1091 + expr1092).*expr543.*expr568.*expr880 - expr1093.*expr543.*expr569.*expr882;
expr1122 = expr1114 + expr501.*expr898.*(expr1100 + expr1101 + expr1102 + expr1103 - expr1104.*expr482.*expr483.*expr562.*expr563.*expr902) + (expr1105 + expr1106 + expr1107).*expr521.*expr904 + (expr1108 + expr1109 + expr1110).*expr541.*expr908 + (expr1111 + expr1112 + expr1113).*expr561.*expr912;
expr1123 = -(expr1115.*expr501.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1124 = expr1038.*expr891.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr1125 = -(expr1117.*expr521.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1126 = -(expr1119.*expr541.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1127 = -(expr1121.*expr561.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1128 = expr1099.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*(1 + expr923);
expr1129 = -(expr1038.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(1 + expr923));
expr1130 = expr1097.*expr501.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr836.*expr837.*expr847.*(1 + expr923);
expr1131 = expr1098.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr835.*expr837.*expr854.*(1 + expr923);
expr1132 = expr1116.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*(1 + expr924);
expr1133 = 2.*expr482.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(1 + expr924);
expr1134 = expr1094.*expr483.*expr521.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr839.*expr840.*expr885.*(1 + expr924);
expr1135 = expr1118.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*(1 + expr925);
expr1136 = 2.*expr482.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(1 + expr925);
expr1137 = expr1095.*expr483.*expr503.*expr541.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr842.*expr843.*expr887.*(1 + expr925);
expr1138 = expr1120.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*(1 + expr926);
expr1139 = 2.*expr482.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(1 + expr926);
expr1140 = expr1096.*expr483.*expr503.*expr523.*expr561.*expr600.*expr607.*expr608.*expr609.*expr610.*expr845.*expr846.*expr889.*(1 + expr926);
expr1141 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(expr1122.*expr518.*expr830.*expr934.*expr935.*tpc - expr934.*(expr1125 + expr1122.*expr830.*expr892.*expr936.*tpc + expr1122.*expr502.*expr830.*expr938.*tpc));
expr1142 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(expr1122.*expr538.*expr830.*expr939.*expr940.*tpc - expr939.*(expr1126 + expr1122.*expr830.*expr893.*expr941.*tpc + expr1122.*expr522.*expr830.*expr943.*tpc));
expr1143 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(expr1122.*expr558.*expr830.*expr944.*expr945.*tpc - expr944.*(expr1127 + expr1122.*expr830.*expr894.*expr946.*tpc + expr1122.*expr542.*expr830.*expr948.*tpc));
expr1144 = expr1122.*expr498.*expr830.*expr927.*expr930.*tpc - expr927.*(expr1123 + expr1124 - expr501.*expr891.*expr931.*(expr928 + expr1122.*expr481.*expr482.*tpc) - expr933.*(expr928 + expr1122.*expr481.*expr482.*tpc));
expr1145 = 200.*(expr1128 + expr1129 + expr1130 + expr1131 + expr1132 + expr1133 + expr1134 + expr1135 + expr1136 + expr1137 + expr1138 + expr1139 + expr1140 + expr1141 + expr1142 + expr1143 + expr1144.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837).*(-1 + expr949 + expr950 + expr951 + expr952).*WO;
expr1146 = expr1067 + expr1145 + integrate10 + integrate11 + integrate12 + integrate9;
gf(5) = expr1146;

%% Derivative for a(2)
w13 = [ws:(99.*ws)./100:100.*ws];
expr1147 = ((a(1).^2 + b(1).^2).^2 + w13.^2.*(w13.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr1148 = 4.*w13.^2.*a(2) + 4.*a(2).*(a(2).^2 + b(2).^2);
expr1149 = ((a(2).^2 + b(2).^2).^2 + w13.^2.*(w13.^2 + 2.*(a(2).^2 - b(2).^2))).^(-2);
expr1150 = ((a(3).^2 + b(3).^2).^2 + w13.^2.*(w13.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr1151 = ((a(4).^2 + b(4).^2).^2 + w13.^2.*(w13.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr1152 = (c(1).^2 + d(1).^2).^2 + w13.^2.*(w13.^2 + 2.*(c(1).^2 - d(1).^2));
expr1153 = (c(2).^2 + d(2).^2).^2 + w13.^2.*(w13.^2 + 2.*(c(2).^2 - d(2).^2));
expr1154 = (c(3).^2 + d(3).^2).^2 + w13.^2.*(w13.^2 + 2.*(c(3).^2 - d(3).^2));
expr1155 = (c(4).^2 + d(4).^2).^2 + w13.^2.*(w13.^2 + 2.*(c(4).^2 - d(4).^2));
expr1156 = ((a(2).^2 + b(2).^2).^2 + w13.^2.*(w13.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr1157 = expr1147.*expr1148.*expr1149.*expr1150.*expr1151.*expr1152.*expr1153.*expr1154.*expr1155.*expr575.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*Wms;
expr1158 = expr1147.*expr1150.*expr1151.*expr1152.*expr1153.*expr1154.*expr1155.*expr1156.*expr503.*expr518.*expr576.*expr577.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*expr594.*Wms;
expr1159 = expr1157 + expr1158;
integrate13 = trapz(w13, expr1159);
w14 = [0:wp./100:wp];
expr1160 = (a(1).^2 + b(1).^2).^2 + w14.^2.*(w14.^2 + 2.*(a(1).^2 - b(1).^2));
expr1161 = 4.*w14.^2.*a(2) + 4.*a(2).*(a(2).^2 + b(2).^2);
expr1162 = (a(3).^2 + b(3).^2).^2 + w14.^2.*(w14.^2 + 2.*(a(3).^2 - b(3).^2));
expr1163 = (a(4).^2 + b(4).^2).^2 + w14.^2.*(w14.^2 + 2.*(a(4).^2 - b(4).^2));
expr1164 = (a(2).^2 + b(2).^2).^2 + w14.^2.*(w14.^2 + 2.*(a(2).^2 - b(2).^2));
expr1165 = (c(1).^2 + d(1).^2).^2 + w14.^2.*(w14.^2 + 2.*(c(1).^2 - d(1).^2));
expr1166 = (c(2).^2 + d(2).^2).^2 + w14.^2.*(w14.^2 + 2.*(c(2).^2 - d(2).^2));
expr1167 = (c(3).^2 + d(3).^2).^2 + w14.^2.*(w14.^2 + 2.*(c(3).^2 - d(3).^2));
expr1168 = (c(4).^2 + d(4).^2).^2 + w14.^2.*(w14.^2 + 2.*(c(4).^2 - d(4).^2));
expr1169 = -1 + (expr1160.*expr1162.*expr1163.*expr1164).^expr600.*(expr1165.*expr1166.*expr1167.*expr1168).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr1170 = 2.*(expr1160.*expr1162.*expr1163.*expr1164).^expr600.*(expr1165.*expr1166.*expr1167.*expr1168).^expr615.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr1171 = expr1160.*expr1161.*expr1162.*expr1163.*(expr1160.*expr1162.*expr1163.*expr1164).^expr606.*(expr1165.*expr1166.*expr1167.*expr1168).^expr615.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr1172 = 2.*expr1169.*(expr1170 + expr1171).*expr599.*Wmp;
integrate14 = trapz(w14, expr1172);
w15 = [wp:(-wp + ws)./100:ws];
expr1173 = (a(1).^2 + b(1).^2).^2 + w15.^2.*(w15.^2 + 2.*(a(1).^2 - b(1).^2));
expr1174 = 4.*w15.^2.*a(2) + 4.*a(2).*(a(2).^2 + b(2).^2);
expr1175 = (a(3).^2 + b(3).^2).^2 + w15.^2.*(w15.^2 + 2.*(a(3).^2 - b(3).^2));
expr1176 = (a(4).^2 + b(4).^2).^2 + w15.^2.*(w15.^2 + 2.*(a(4).^2 - b(4).^2));
expr1177 = (a(2).^2 + b(2).^2).^2 + w15.^2.*(w15.^2 + 2.*(a(2).^2 - b(2).^2));
expr1178 = (c(1).^2 + d(1).^2).^2 + w15.^2.*(w15.^2 + 2.*(c(1).^2 - d(1).^2));
expr1179 = (c(2).^2 + d(2).^2).^2 + w15.^2.*(w15.^2 + 2.*(c(2).^2 - d(2).^2));
expr1180 = (c(3).^2 + d(3).^2).^2 + w15.^2.*(w15.^2 + 2.*(c(3).^2 - d(3).^2));
expr1181 = (c(4).^2 + d(4).^2).^2 + w15.^2.*(w15.^2 + 2.*(c(4).^2 - d(4).^2));
expr1182 = -(w15./(wp - ws));
expr1183 = 2.*(expr1173.*expr1175.*expr1176.*expr1177).^expr600.*(expr1178.*expr1179.*expr1180.*expr1181).^expr615.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr1184 = expr1173.*expr1174.*expr1175.*expr1176.*(expr1173.*expr1175.*expr1176.*expr1177).^expr606.*(expr1178.*expr1179.*expr1180.*expr1181).^expr615.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr1185 = expr1182 + (expr1173.*expr1175.*expr1176.*expr1177).^expr600.*(expr1178.*expr1179.*expr1180.*expr1181).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr631;
expr1186 = 2.*(expr1183 + expr1184).*expr1185.*expr620.*Wmt;
integrate15 = trapz(w15, expr1186);
w16 = [0:wmax./100:wmax];
expr1187 = -((w16 - b(2))./(a(2).^2.*(1 + (w16 - b(2)).^2./a(2).^2)));
expr1188 = -((w16 + b(2))./(a(2).^2.*(1 + (w16 + b(2)).^2./a(2).^2)));
expr1189 = 2.*a(2).*(angle(1 + (i.*(wmax - b(2)))./a(2)) + angle(1 + (i.*(wmax + b(2)))./a(2)));
expr1190 = (2.*(wmax - b(2)).^2.*b(2))./(a(2).^2.*(1 + (wmax - b(2)).^2./a(2).^2));
expr1191 = (-2.*b(2).*(wmax + b(2)).^2)./(a(2).^2.*(1 + (wmax + b(2)).^2./a(2).^2));
expr1192 = -((wmax - b(2))./(a(2).^2.*(1 + (wmax - b(2)).^2./a(2).^2)));
expr1193 = -((wmax + b(2))./(a(2).^2.*(1 + (wmax + b(2)).^2./a(2).^2)));
expr1194 = -(b(2).*log(1 + (wmax - b(2)).^2./a(2).^2));
expr1195 = b(2).*log(1 + (wmax + b(2)).^2./a(2).^2);
expr1196 = angle(1 + (i.*(w16 - b(1)))./a(1));
expr1197 = angle(1 + (i.*(w16 + b(1)))./a(1));
expr1198 = angle(1 + (i.*(w16 - b(2)))./a(2));
expr1199 = angle(1 + (i.*(w16 + b(2)))./a(2));
expr1200 = angle(1 + (i.*(w16 - b(3)))./a(3));
expr1201 = angle(1 + (i.*(w16 + b(3)))./a(3));
expr1202 = angle(1 + (i.*(w16 - b(4)))./a(4));
expr1203 = angle(1 + (i.*(w16 + b(4)))./a(4));
expr1204 = -angle(1 + (i.*(w16 - d(1)))./c(1));
expr1205 = -angle(1 + (i.*(w16 + d(1)))./c(1));
expr1206 = -angle(1 + (i.*(w16 - d(2)))./c(2));
expr1207 = -angle(1 + (i.*(w16 + d(2)))./c(2));
expr1208 = -angle(1 + (i.*(w16 - d(3)))./c(3));
expr1209 = -angle(1 + (i.*(w16 + d(3)))./c(3));
expr1210 = -angle(1 + (i.*(w16 - d(4)))./c(4));
expr1211 = -angle(1 + (i.*(w16 + d(4)))./c(4));
expr1212 = expr1187 + expr1188 + expr606.*expr639.*(expr1189 + expr1190 + expr1191 + expr1194 + expr1195 + expr640 - (expr1192 + expr1193).*expr671).*w16;
expr1213 = 2.*expr1212.*expr636.*(expr1196 + expr1197 + expr1198 + expr1199 + expr1200 + expr1201 + expr1202 + expr1203 + expr1204 + expr1205 + expr1206 + expr1207 + expr1208 + expr1209 + expr1210 + expr1211 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w16).*Wph;
integrate16 = trapz(w16, expr1213);
expr1214 = sqrt(a(2).^2 + b(2).^2).^(-1);
expr1215 = a(2).^(-2);
expr1216 = (b(1) + b(2))./((a(1) - a(2)).^2.*(1 + (b(1) + b(2)).^2./(a(1) - a(2)).^2));
expr1217 = -((b(1) + b(2))./((-a(1) + a(2)).^2.*(1 + (b(1) + b(2)).^2./(-a(1) + a(2)).^2)));
expr1218 = (a(2) - a(3)).^(-2);
expr1219 = (1 + (b(2) - b(3)).^2./(a(2) - a(3)).^2).^(-1);
expr1220 = b(2) - b(3);
expr1221 = -((b(2) + b(3))./((a(2) - a(3)).^2.*(1 + (b(2) + b(3)).^2./(a(2) - a(3)).^2)));
expr1222 = (a(2) - a(4)).^(-2);
expr1223 = (1 + (b(2) - b(4)).^2./(a(2) - a(4)).^2).^(-1);
expr1224 = b(2) - b(4);
expr1225 = -((b(2) + b(4))./((a(2) - a(4)).^2.*(1 + (b(2) + b(4)).^2./(a(2) - a(4)).^2)));
expr1226 = (a(2) - c(1)).^(-2);
expr1227 = (1 + (b(2) - d(1)).^2./(a(2) - c(1)).^2).^(-1);
expr1228 = b(2) - d(1);
expr1229 = (b(2) + d(1))./((a(2) - c(1)).^2.*(1 + (b(2) + d(1)).^2./(a(2) - c(1)).^2));
expr1230 = (a(2) - c(2)).^(-2);
expr1231 = (1 + (b(2) - d(2)).^2./(a(2) - c(2)).^2).^(-1);
expr1232 = b(2) - d(2);
expr1233 = (b(2) + d(2))./((a(2) - c(2)).^2.*(1 + (b(2) + d(2)).^2./(a(2) - c(2)).^2));
expr1234 = (a(2) - c(3)).^(-2);
expr1235 = (1 + (b(2) - d(3)).^2./(a(2) - c(3)).^2).^(-1);
expr1236 = b(2) - d(3);
expr1237 = (b(2) + d(3))./((a(2) - c(3)).^2.*(1 + (b(2) + d(3)).^2./(a(2) - c(3)).^2));
expr1238 = (a(2) - c(4)).^(-2);
expr1239 = (1 + (b(2) - d(4)).^2./(a(2) - c(4)).^2).^(-1);
expr1240 = b(2) - d(4);
expr1241 = (b(2) + d(4))./((a(2) - c(4)).^2.*(1 + (b(2) + d(4)).^2./(a(2) - c(4)).^2));
expr1242 = 2.*a(2);
expr1243 = (-a(2) + a(3)).^(-2);
expr1244 = -b(2) + b(3);
expr1245 = (1 + (-b(2) + b(3)).^2./(-a(2) + a(3)).^2).^(-1);
expr1246 = (b(2) + b(3))./((-a(2) + a(3)).^2.*(1 + (b(2) + b(3)).^2./(-a(2) + a(3)).^2));
expr1247 = (-a(2) + a(4)).^(-2);
expr1248 = -b(2) + b(4);
expr1249 = (1 + (-b(2) + b(4)).^2./(-a(2) + a(4)).^2).^(-1);
expr1250 = (b(2) + b(4))./((-a(2) + a(4)).^2.*(1 + (b(2) + b(4)).^2./(-a(2) + a(4)).^2));
expr1251 = a(2) - a(4);
expr1252 = a(2) - a(3);
expr1253 = a(2) - c(4);
expr1254 = a(2) - c(3);
expr1255 = a(2) - c(2);
expr1256 = a(2) - c(1);
expr1257 = -a(2) + a(3);
expr1258 = -a(2) + a(4);
expr1259 = expr714.*(expr715.*expr716.*expr717.*expr718.*expr719.*expr720.*expr721.*expr722).^expr723.*(expr1214.*expr715.*expr717.*expr718.*expr719.*expr721.*expr722 - expr1215.*expr715.*expr717.*expr718.*expr719.*expr720.*expr721.*expr722).*WQ;
expr1260 = -2.*expr726.*expr728.*expr729.*expr730.*expr731.*expr784 - 2.*expr727.*expr728.*expr729.*expr730.*expr731.*expr784;
expr1261 = expr498.*(expr1216 + expr789.*expr790.*expr791).*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr1262 = -(expr482.*(expr1216 + expr789.*expr790.*expr791).*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497));
expr1263 = expr1216 + expr789.*expr790.*expr791;
expr1264 = expr1217 - expr1218.*expr1219.*expr1220 + expr1221 - expr1222.*expr1223.*expr1224 + expr1225 + expr1226.*expr1227.*expr1228 + expr1229 + expr1230.*expr1231.*expr1232 + expr1233 + expr1234.*expr1235.*expr1236 + expr1237 + expr1238.*expr1239.*expr1240 + expr1241 - expr818.*expr819.*expr820;
expr1265 = (expr1243.*expr1244.*expr1245 + expr1246).*expr538.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr1266 = -((expr1243.*expr1244.*expr1245 + expr1246).*expr522.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537));
expr1267 = expr1243.*expr1244.*expr1245 + expr1246;
expr1268 = (expr1247.*expr1248.*expr1249 + expr1250).*expr558.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr1269 = -((expr1247.*expr1248.*expr1249 + expr1250).*expr542.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557));
expr1270 = expr1247.*expr1248.*expr1249 + expr1250;
expr1271 = (expr746.*expr747.*expr748.*expr749.*expr750.*expr751.*expr752.*expr753).^expr600;
expr1272 = 2.*expr1253.*expr746.*expr747.*expr748.*expr749.*expr750.*expr751.*expr752;
expr1273 = 2.*expr1253.*expr746.*expr747.*expr748.*expr749.*expr750.*expr751.*expr753;
expr1274 = 2.*expr1254.*expr746.*expr747.*expr748.*expr749.*expr750.*expr752.*expr753;
expr1275 = 2.*expr1254.*expr746.*expr747.*expr748.*expr749.*expr751.*expr752.*expr753;
expr1276 = 2.*expr1255.*expr746.*expr747.*expr748.*expr750.*expr751.*expr752.*expr753;
expr1277 = 2.*expr1255.*expr746.*expr747.*expr749.*expr750.*expr751.*expr752.*expr753;
expr1278 = 2.*expr1256.*expr746.*expr748.*expr749.*expr750.*expr751.*expr752.*expr753;
expr1279 = 2.*expr1256.*expr747.*expr748.*expr749.*expr750.*expr751.*expr752.*expr753;
expr1280 = 2.*expr1251.*expr740.*expr741.*expr742.*expr743.*expr744;
expr1281 = 2.*expr1251.*expr740.*expr741.*expr742.*expr743.*expr745;
expr1282 = 2.*expr1252.*expr740.*expr741.*expr742.*expr744.*expr745;
expr1283 = 2.*expr1252.*expr740.*expr741.*expr743.*expr744.*expr745;
expr1284 = 2.*expr740.*expr742.*expr743.*expr744.*expr745.*expr831;
expr1285 = 2.*expr741.*expr742.*expr743.*expr744.*expr745.*expr831;
expr1286 = -2.*expr1257.*expr754.*expr755.*expr756.*expr758.*expr759 - 2.*expr1257.*expr754.*expr755.*expr757.*expr758.*expr759;
expr1287 = -2.*expr1258.*expr768.*expr769.*expr770.*expr772.*expr773 - 2.*expr1258.*expr768.*expr769.*expr771.*expr772.*expr773;
expr1288 = expr1261 + expr1262;
expr1289 = (expr1263.*expr482.*expr483.*expr563.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr1290 = -(((expr1261 + expr1262).*expr482.*expr483.*expr562.*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr1291 = -((expr482.*expr483.*expr562.*expr563.*(-(expr1263.*expr483.*expr498.*expr563.*expr864) + (expr1261 + expr1262).*expr483.*expr498.*expr562.*expr866))./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^2);
expr1292 = (2.*expr502.*expr518.*expr564.*expr565)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr1293 = (expr1264.*expr502.*expr503.*expr565.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr1294 = -((expr502.*expr503.*expr564.*expr868.*(expr564 - expr1264.*expr502.*expr564 + expr1264.*expr518.*expr870))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr1295 = (expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^(-2);
expr1296 = expr1242 - expr503.*expr564.*expr565 - 2.*expr519.*expr564.*expr565 - expr1264.*expr503.*expr518.*expr565.*expr870 + expr503.*expr518.*expr564.*expr868.*(expr564 - expr1264.*expr502.*expr564 + expr1264.*expr518.*expr870);
expr1297 = -(((expr1265 + expr1266).*expr522.*expr523.*expr566.*expr874)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr1298 = (expr1267.*expr522.*expr523.*expr567.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr1299 = -((expr522.*expr523.*expr566.*expr567.*((expr1265 + expr1266).*expr523.*expr538.*expr566.*expr874 - expr1267.*expr523.*expr538.*expr567.*expr876))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^2);
expr1300 = -(((expr1268 + expr1269).*expr542.*expr543.*expr568.*expr880)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr1301 = (expr1270.*expr542.*expr543.*expr569.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr1302 = -((expr542.*expr543.*expr568.*expr569.*((expr1268 + expr1269).*expr543.*expr558.*expr568.*expr880 - expr1270.*expr543.*expr558.*expr569.*expr882))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^2);
expr1303 = -(expr1263.*expr483.*expr563.*expr864) + (expr1261 + expr1262).*expr483.*expr562.*expr866;
expr1304 = expr1272 + expr1273 + expr1274 + expr1275 + expr1276 + expr1277 + expr1278 + expr1279;
expr1305 = expr564 - expr1264.*expr502.*expr564 + expr1264.*expr518.*expr870;
expr1306 = expr1280 + expr1281 + expr1282 + expr1283 + expr1284 + expr1285;
expr1307 = 1 - 2.*expr518.*expr564.*expr565 - expr1264.*expr503.*expr565.*expr870 + expr503.*expr564.*expr868.*(expr564 - expr1264.*expr502.*expr564 + expr1264.*expr518.*expr870);
expr1308 = expr1265 + expr1266;
expr1309 = (expr1265 + expr1266).*expr523.*expr566.*expr874 - expr1267.*expr523.*expr567.*expr876;
expr1310 = expr1268 + expr1269;
expr1311 = (expr1268 + expr1269).*expr543.*expr568.*expr880 - expr1270.*expr543.*expr569.*expr882;
expr1312 = (expr1289 + expr1290 + expr1291).*expr501.*expr898 + expr521.*(expr1292 + expr1293 + expr1294 - expr1295.*expr1296.*expr502.*expr503.*expr564.*expr565).*expr904 + (expr1297 + expr1298 + expr1299).*expr541.*expr908 + (expr1300 + expr1301 + expr1302).*expr561.*expr912;
expr1313 = -(expr1303.*expr501.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1314 = -(expr1307.*expr521.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1315 = -(expr1309.*expr541.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1316 = -(expr1311.*expr561.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1317 = expr1288.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*(1 + expr923);
expr1318 = 2.*expr501.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(1 + expr923);
expr1319 = expr1260.*expr501.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr836.*expr837.*expr847.*(1 + expr923);
expr1320 = expr1305.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*(1 + expr924);
expr1321 = expr1271.*expr1304.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr838.*expr840.*(1 + expr924);
expr1322 = expr1306.*expr483.*expr521.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr839.*expr840.*expr885.*(1 + expr924);
expr1323 = expr1308.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*(1 + expr925);
expr1324 = 2.*expr483.*expr518.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(1 + expr925);
expr1325 = expr1286.*expr483.*expr503.*expr541.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr842.*expr843.*expr887.*(1 + expr925);
expr1326 = expr1310.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*(1 + expr926);
expr1327 = 2.*expr483.*expr518.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(1 + expr926);
expr1328 = expr1287.*expr483.*expr503.*expr523.*expr561.*expr600.*expr607.*expr608.*expr609.*expr610.*expr845.*expr846.*expr889.*(1 + expr926);
expr1329 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(expr1312.*expr498.*expr830.*expr927.*expr930.*tpc - expr927.*(expr1313 + expr1312.*expr830.*expr891.*expr931.*tpc + expr1312.*expr482.*expr830.*expr933.*tpc));
expr1330 = -(expr934.*expr935.*(expr928 + expr1312.*expr481.*expr518.*tpc)) - expr934.*(expr1314 + expr1312.*expr830.*expr892.*expr936.*tpc + expr1312.*expr502.*expr830.*expr938.*tpc);
expr1331 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(expr1312.*expr538.*expr830.*expr939.*expr940.*tpc - expr939.*(expr1315 + expr1312.*expr830.*expr893.*expr941.*tpc + expr1312.*expr522.*expr830.*expr943.*tpc));
expr1332 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(expr1312.*expr558.*expr830.*expr944.*expr945.*tpc - expr944.*(expr1316 + expr1312.*expr830.*expr894.*expr946.*tpc + expr1312.*expr542.*expr830.*expr948.*tpc));
expr1333 = 200.*(expr1317 + expr1318 + expr1319 + expr1320 + expr1321 + expr1322 + expr1323 + expr1324 + expr1325 + expr1326 + expr1327 + expr1328 + expr1329 + expr1331 + expr1332 + expr1330.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840).*(-1 + expr949 + expr950 + expr951 + expr952).*WO;
expr1334 = expr1259 + expr1333 + integrate13 + integrate14 + integrate15 + integrate16;
gf(2) = expr1334;

%% Derivative for b(2)
w17 = [ws:(99.*ws)./100:100.*ws];
expr1335 = ((a(1).^2 + b(1).^2).^2 + w17.^2.*(w17.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr1336 = -4.*w17.^2.*b(2) + 4.*b(2).*(a(2).^2 + b(2).^2);
expr1337 = ((a(2).^2 + b(2).^2).^2 + w17.^2.*(w17.^2 + 2.*(a(2).^2 - b(2).^2))).^(-2);
expr1338 = ((a(3).^2 + b(3).^2).^2 + w17.^2.*(w17.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr1339 = ((a(4).^2 + b(4).^2).^2 + w17.^2.*(w17.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr1340 = (c(1).^2 + d(1).^2).^2 + w17.^2.*(w17.^2 + 2.*(c(1).^2 - d(1).^2));
expr1341 = (c(2).^2 + d(2).^2).^2 + w17.^2.*(w17.^2 + 2.*(c(2).^2 - d(2).^2));
expr1342 = (c(3).^2 + d(3).^2).^2 + w17.^2.*(w17.^2 + 2.*(c(3).^2 - d(3).^2));
expr1343 = (c(4).^2 + d(4).^2).^2 + w17.^2.*(w17.^2 + 2.*(c(4).^2 - d(4).^2));
expr1344 = ((a(2).^2 + b(2).^2).^2 + w17.^2.*(w17.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr1345 = expr1335.*expr1336.*expr1337.*expr1338.*expr1339.*expr1340.*expr1341.*expr1342.*expr1343.*expr575.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*Wms;
expr1346 = expr1335.*expr1338.*expr1339.*expr1340.*expr1341.*expr1342.*expr1343.*expr1344.*expr502.*expr503.*expr576.*expr577.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*expr594.*Wms;
expr1347 = expr1345 + expr1346;
integrate17 = trapz(w17, expr1347);
w18 = [0:wp./100:wp];
expr1348 = (a(1).^2 + b(1).^2).^2 + w18.^2.*(w18.^2 + 2.*(a(1).^2 - b(1).^2));
expr1349 = -4.*w18.^2.*b(2) + 4.*b(2).*(a(2).^2 + b(2).^2);
expr1350 = (a(3).^2 + b(3).^2).^2 + w18.^2.*(w18.^2 + 2.*(a(3).^2 - b(3).^2));
expr1351 = (a(4).^2 + b(4).^2).^2 + w18.^2.*(w18.^2 + 2.*(a(4).^2 - b(4).^2));
expr1352 = (a(2).^2 + b(2).^2).^2 + w18.^2.*(w18.^2 + 2.*(a(2).^2 - b(2).^2));
expr1353 = (c(1).^2 + d(1).^2).^2 + w18.^2.*(w18.^2 + 2.*(c(1).^2 - d(1).^2));
expr1354 = (c(2).^2 + d(2).^2).^2 + w18.^2.*(w18.^2 + 2.*(c(2).^2 - d(2).^2));
expr1355 = (c(3).^2 + d(3).^2).^2 + w18.^2.*(w18.^2 + 2.*(c(3).^2 - d(3).^2));
expr1356 = (c(4).^2 + d(4).^2).^2 + w18.^2.*(w18.^2 + 2.*(c(4).^2 - d(4).^2));
expr1357 = -1 + (expr1348.*expr1350.*expr1351.*expr1352).^expr600.*(expr1353.*expr1354.*expr1355.*expr1356).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr1358 = 2.*(expr1348.*expr1350.*expr1351.*expr1352).^expr600.*(expr1353.*expr1354.*expr1355.*expr1356).^expr615.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr1359 = expr1348.*expr1349.*expr1350.*expr1351.*(expr1348.*expr1350.*expr1351.*expr1352).^expr606.*(expr1353.*expr1354.*expr1355.*expr1356).^expr615.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr1360 = 2.*expr1357.*(expr1358 + expr1359).*expr599.*Wmp;
integrate18 = trapz(w18, expr1360);
w19 = [wp:(-wp + ws)./100:ws];
expr1361 = (a(1).^2 + b(1).^2).^2 + w19.^2.*(w19.^2 + 2.*(a(1).^2 - b(1).^2));
expr1362 = -4.*w19.^2.*b(2) + 4.*b(2).*(a(2).^2 + b(2).^2);
expr1363 = (a(3).^2 + b(3).^2).^2 + w19.^2.*(w19.^2 + 2.*(a(3).^2 - b(3).^2));
expr1364 = (a(4).^2 + b(4).^2).^2 + w19.^2.*(w19.^2 + 2.*(a(4).^2 - b(4).^2));
expr1365 = (a(2).^2 + b(2).^2).^2 + w19.^2.*(w19.^2 + 2.*(a(2).^2 - b(2).^2));
expr1366 = (c(1).^2 + d(1).^2).^2 + w19.^2.*(w19.^2 + 2.*(c(1).^2 - d(1).^2));
expr1367 = (c(2).^2 + d(2).^2).^2 + w19.^2.*(w19.^2 + 2.*(c(2).^2 - d(2).^2));
expr1368 = (c(3).^2 + d(3).^2).^2 + w19.^2.*(w19.^2 + 2.*(c(3).^2 - d(3).^2));
expr1369 = (c(4).^2 + d(4).^2).^2 + w19.^2.*(w19.^2 + 2.*(c(4).^2 - d(4).^2));
expr1370 = -(w19./(wp - ws));
expr1371 = 2.*(expr1361.*expr1363.*expr1364.*expr1365).^expr600.*(expr1366.*expr1367.*expr1368.*expr1369).^expr615.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr1372 = expr1361.*expr1362.*expr1363.*expr1364.*(expr1361.*expr1363.*expr1364.*expr1365).^expr606.*(expr1366.*expr1367.*expr1368.*expr1369).^expr615.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr1373 = expr1370 + (expr1361.*expr1363.*expr1364.*expr1365).^expr600.*(expr1366.*expr1367.*expr1368.*expr1369).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr631;
expr1374 = 2.*(expr1371 + expr1372).*expr1373.*expr620.*Wmt;
integrate19 = trapz(w19, expr1374);
w20 = [0:wmax./100:wmax];
expr1375 = -(1./(a(2).*(1 + (w20 - b(2)).^2./a(2).^2)));
expr1376 = 1./(a(2).*(1 + (w20 + b(2)).^2./a(2).^2));
expr1377 = -2.*(angle(1 + (i.*(wmax - b(2)))./a(2)) + angle(1 + (i.*(wmax + b(2)))./a(2))).*b(2);
expr1378 = (2.*(wmax - b(2)).*b(2))./(a(2).*(1 + (wmax - b(2)).^2./a(2).^2));
expr1379 = (2.*b(2).*(wmax + b(2)))./(a(2).*(1 + (wmax + b(2)).^2./a(2).^2));
expr1380 = -(1./(a(2).*(1 + (wmax - b(2)).^2./a(2).^2)));
expr1381 = 1./(a(2).*(1 + (wmax + b(2)).^2./a(2).^2));
expr1382 = -(a(2).*log(1 + (wmax - b(2)).^2./a(2).^2));
expr1383 = a(2).*log(1 + (wmax + b(2)).^2./a(2).^2);
expr1384 = angle(1 + (i.*(w20 - b(1)))./a(1));
expr1385 = angle(1 + (i.*(w20 + b(1)))./a(1));
expr1386 = angle(1 + (i.*(w20 - b(2)))./a(2));
expr1387 = angle(1 + (i.*(w20 + b(2)))./a(2));
expr1388 = angle(1 + (i.*(w20 - b(3)))./a(3));
expr1389 = angle(1 + (i.*(w20 + b(3)))./a(3));
expr1390 = angle(1 + (i.*(w20 - b(4)))./a(4));
expr1391 = angle(1 + (i.*(w20 + b(4)))./a(4));
expr1392 = -angle(1 + (i.*(w20 - d(1)))./c(1));
expr1393 = -angle(1 + (i.*(w20 + d(1)))./c(1));
expr1394 = -angle(1 + (i.*(w20 - d(2)))./c(2));
expr1395 = -angle(1 + (i.*(w20 + d(2)))./c(2));
expr1396 = -angle(1 + (i.*(w20 - d(3)))./c(3));
expr1397 = -angle(1 + (i.*(w20 + d(3)))./c(3));
expr1398 = -angle(1 + (i.*(w20 - d(4)))./c(4));
expr1399 = -angle(1 + (i.*(w20 + d(4)))./c(4));
expr1400 = expr1375 + expr1376 + expr606.*expr639.*(expr1377 + expr1378 + expr1379 + expr1382 + expr1383 - (expr1380 + expr1381).*expr671).*w20;
expr1401 = 2.*expr1400.*expr636.*(expr1384 + expr1385 + expr1386 + expr1387 + expr1388 + expr1389 + expr1390 + expr1391 + expr1392 + expr1393 + expr1394 + expr1395 + expr1396 + expr1397 + expr1398 + expr1399 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w20).*Wph;
integrate20 = trapz(w20, expr1401);
expr1402 = -(1./((a(1) - a(2)).*(1 + (b(1) - b(2)).^2./(a(1) - a(2)).^2)));
expr1403 = b(2).^(-2);
expr1404 = 1./((-a(1) + a(2)).*(1 + (-b(1) + b(2)).^2./(-a(1) + a(2)).^2));
expr1405 = 1./((a(2) - a(3)).*(1 + (b(2) - b(3)).^2./(a(2) - a(3)).^2));
expr1406 = 1./((a(2) - a(3)).*(1 + (b(2) + b(3)).^2./(a(2) - a(3)).^2));
expr1407 = 1./((a(2) - a(4)).*(1 + (b(2) - b(4)).^2./(a(2) - a(4)).^2));
expr1408 = 1./((a(2) - a(4)).*(1 + (b(2) + b(4)).^2./(a(2) - a(4)).^2));
expr1409 = -(1./((a(2) - c(1)).*(1 + (b(2) - d(1)).^2./(a(2) - c(1)).^2)));
expr1410 = -(1./((a(2) - c(1)).*(1 + (b(2) + d(1)).^2./(a(2) - c(1)).^2)));
expr1411 = -(1./((a(2) - c(2)).*(1 + (b(2) - d(2)).^2./(a(2) - c(2)).^2)));
expr1412 = -(1./((a(2) - c(2)).*(1 + (b(2) + d(2)).^2./(a(2) - c(2)).^2)));
expr1413 = -(1./((a(2) - c(3)).*(1 + (b(2) - d(3)).^2./(a(2) - c(3)).^2)));
expr1414 = -(1./((a(2) - c(3)).*(1 + (b(2) + d(3)).^2./(a(2) - c(3)).^2)));
expr1415 = -(1./((a(2) - c(4)).*(1 + (b(2) - d(4)).^2./(a(2) - c(4)).^2)));
expr1416 = -(1./((a(2) - c(4)).*(1 + (b(2) + d(4)).^2./(a(2) - c(4)).^2)));
expr1417 = 2.*b(2);
expr1418 = -(1./((-a(2) + a(3)).*(1 + (-b(2) + b(3)).^2./(-a(2) + a(3)).^2)));
expr1419 = 1./((-a(2) + a(3)).*(1 + (b(2) + b(3)).^2./(-a(2) + a(3)).^2));
expr1420 = -(1./((-a(2) + a(4)).*(1 + (-b(2) + b(4)).^2./(-a(2) + a(4)).^2)));
expr1421 = 1./((-a(2) + a(4)).*(1 + (b(2) + b(4)).^2./(-a(2) + a(4)).^2));
expr1422 = b(2) + b(4);
expr1423 = b(2) + b(3);
expr1424 = b(2) + d(4);
expr1425 = b(2) + d(3);
expr1426 = b(2) + d(2);
expr1427 = b(2) + d(1);
expr1428 = expr1214.*expr502.*expr714.*expr715.*expr716.*expr717.*expr718.*expr719.*expr721.*expr722.*(expr715.*expr716.*expr717.*expr718.*expr719.*expr720.*expr721.*expr722).^expr723.*WQ;
expr1429 = (expr1047 + expr1402).*expr498.*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr1430 = -((expr1047 + expr1402).*expr482.*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497));
expr1431 = 2.*expr1041.*expr726.*expr728.*expr729.*expr730.*expr731 - 2.*expr727.*expr728.*expr729.*expr730.*expr731.*expr791;
expr1432 = expr1047 + expr1402;
expr1433 = (expr1062 + expr1404 + expr1405 + expr1406 + expr1407 + expr1408 + expr1409 + expr1410 + expr1411 + expr1412 + expr1413 + expr1414 + expr1415 + expr1416).*expr518.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr1434 = -((expr1062 + expr1404 + expr1405 + expr1406 + expr1407 + expr1408 + expr1409 + expr1410 + expr1411 + expr1412 + expr1413 + expr1414 + expr1415 + expr1416).*expr502.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517));
expr1435 = expr1062 + expr1404 + expr1405 + expr1406 + expr1407 + expr1408 + expr1409 + expr1410 + expr1411 + expr1412 + expr1413 + expr1414 + expr1415 + expr1416;
expr1436 = (expr1418 + expr1419).*expr538.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr1437 = -((expr1418 + expr1419).*expr522.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537));
expr1438 = expr1418 + expr1419;
expr1439 = (expr1420 + expr1421).*expr558.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr1440 = -((expr1420 + expr1421).*expr542.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557));
expr1441 = expr1420 + expr1421;
expr1442 = 2.*expr1424.*expr746.*expr747.*expr748.*expr749.*expr750.*expr751.*expr752;
expr1443 = 2.*expr1240.*expr746.*expr747.*expr748.*expr749.*expr750.*expr751.*expr753;
expr1444 = 2.*expr1425.*expr746.*expr747.*expr748.*expr749.*expr750.*expr752.*expr753;
expr1445 = 2.*expr1236.*expr746.*expr747.*expr748.*expr749.*expr751.*expr752.*expr753;
expr1446 = 2.*expr1426.*expr746.*expr747.*expr748.*expr750.*expr751.*expr752.*expr753;
expr1447 = 2.*expr1232.*expr746.*expr747.*expr749.*expr750.*expr751.*expr752.*expr753;
expr1448 = 2.*expr1427.*expr746.*expr748.*expr749.*expr750.*expr751.*expr752.*expr753;
expr1449 = 2.*expr1228.*expr747.*expr748.*expr749.*expr750.*expr751.*expr752.*expr753;
expr1450 = 2.*expr1422.*expr740.*expr741.*expr742.*expr743.*expr744;
expr1451 = 2.*expr1224.*expr740.*expr741.*expr742.*expr743.*expr745;
expr1452 = 2.*expr1423.*expr740.*expr741.*expr742.*expr744.*expr745;
expr1453 = 2.*expr1220.*expr740.*expr741.*expr743.*expr744.*expr745;
expr1454 = 2.*expr1041.*expr740.*expr742.*expr743.*expr744.*expr745;
expr1455 = 2.*expr741.*expr742.*expr743.*expr744.*expr745.*expr819;
expr1456 = 2.*expr1423.*expr754.*expr755.*expr756.*expr758.*expr759 - 2.*expr1244.*expr754.*expr755.*expr757.*expr758.*expr759;
expr1457 = 2.*expr1422.*expr768.*expr769.*expr770.*expr772.*expr773 - 2.*expr1248.*expr768.*expr769.*expr771.*expr772.*expr773;
expr1458 = expr1429 + expr1430;
expr1459 = (expr1432.*expr482.*expr483.*expr563.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr1460 = -(((expr1429 + expr1430).*expr482.*expr483.*expr562.*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr1461 = -((expr482.*expr483.*expr562.*expr563.*(-(expr1432.*expr483.*expr498.*expr563.*expr864) + (expr1429 + expr1430).*expr483.*expr498.*expr562.*expr866))./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^2);
expr1462 = (expr503.*expr564.*expr565)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr1463 = (2.*expr520.*expr564.*expr565)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr1464 = (expr1435.*expr502.*expr503.*expr565.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr1465 = -((expr502.*expr503.*expr564.*expr868.*(expr1433 + expr1434 + expr870))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr1466 = expr1417 - 2.*expr502.*expr518.*expr564.*expr565 - expr1435.*expr503.*expr518.*expr565.*expr870 + expr503.*expr518.*expr564.*expr868.*(expr1433 + expr1434 + expr870);
expr1467 = -(((expr1436 + expr1437).*expr522.*expr523.*expr566.*expr874)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr1468 = (expr1438.*expr522.*expr523.*expr567.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr1469 = -((expr522.*expr523.*expr566.*expr567.*((expr1436 + expr1437).*expr523.*expr538.*expr566.*expr874 - expr1438.*expr523.*expr538.*expr567.*expr876))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^2);
expr1470 = -(((expr1439 + expr1440).*expr542.*expr543.*expr568.*expr880)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr1471 = (expr1441.*expr542.*expr543.*expr569.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr1472 = -((expr542.*expr543.*expr568.*expr569.*((expr1439 + expr1440).*expr543.*expr558.*expr568.*expr880 - expr1441.*expr543.*expr558.*expr569.*expr882))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^2);
expr1473 = expr1403.*(pi - angle(1 + (expr502.*expr503.*expr564.*expr565.*i)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565)));
expr1474 = -(expr1432.*expr483.*expr563.*expr864) + (expr1429 + expr1430).*expr483.*expr562.*expr866;
expr1475 = expr1442 + expr1443 + expr1444 + expr1445 + expr1446 + expr1447 + expr1448 + expr1449;
expr1476 = expr1433 + expr1434 + expr870;
expr1477 = expr1450 + expr1451 + expr1452 + expr1453 + expr1454 + expr1455;
expr1478 = -2.*expr502.*expr564.*expr565 - expr1435.*expr503.*expr565.*expr870 + expr503.*expr564.*expr868.*(expr1433 + expr1434 + expr870);
expr1479 = expr1436 + expr1437;
expr1480 = (expr1436 + expr1437).*expr523.*expr566.*expr874 - expr1438.*expr523.*expr567.*expr876;
expr1481 = expr1439 + expr1440;
expr1482 = (expr1439 + expr1440).*expr543.*expr568.*expr880 - expr1441.*expr543.*expr569.*expr882;
expr1483 = expr1473 + (expr1459 + expr1460 + expr1461).*expr501.*expr898 + expr521.*(expr1462 + expr1463 + expr1464 + expr1465 - expr1295.*expr1466.*expr502.*expr503.*expr564.*expr565).*expr904 + (expr1467 + expr1468 + expr1469).*expr541.*expr908 + (expr1470 + expr1471 + expr1472).*expr561.*expr912;
expr1484 = -(expr1474.*expr501.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1485 = -(expr1478.*expr521.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1486 = expr1403.*expr892.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr1487 = -(expr1480.*expr541.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1488 = -(expr1482.*expr561.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1489 = expr1458.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*(1 + expr923);
expr1490 = 2.*expr501.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(1 + expr923);
expr1491 = expr1431.*expr501.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr836.*expr837.*expr847.*(1 + expr923);
expr1492 = expr1476.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*(1 + expr924);
expr1493 = expr1271.*expr1475.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr838.*expr840.*(1 + expr924);
expr1494 = -(expr1403.*expr483.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(1 + expr924));
expr1495 = expr1477.*expr483.*expr521.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr839.*expr840.*expr885.*(1 + expr924);
expr1496 = expr1479.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*(1 + expr925);
expr1497 = 2.*expr483.*expr502.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(1 + expr925);
expr1498 = expr1456.*expr483.*expr503.*expr541.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr842.*expr843.*expr887.*(1 + expr925);
expr1499 = expr1481.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*(1 + expr926);
expr1500 = 2.*expr483.*expr502.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(1 + expr926);
expr1501 = expr1457.*expr483.*expr503.*expr523.*expr561.*expr600.*expr607.*expr608.*expr609.*expr610.*expr845.*expr846.*expr889.*(1 + expr926);
expr1502 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(expr1483.*expr498.*expr830.*expr927.*expr930.*tpc - expr927.*(expr1484 + expr1483.*expr830.*expr891.*expr931.*tpc + expr1483.*expr482.*expr830.*expr933.*tpc));
expr1503 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(expr1483.*expr538.*expr830.*expr939.*expr940.*tpc - expr939.*(expr1487 + expr1483.*expr830.*expr893.*expr941.*tpc + expr1483.*expr522.*expr830.*expr943.*tpc));
expr1504 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(expr1483.*expr558.*expr830.*expr944.*expr945.*tpc - expr944.*(expr1488 + expr1483.*expr830.*expr894.*expr946.*tpc + expr1483.*expr542.*expr830.*expr948.*tpc));
expr1505 = expr1483.*expr518.*expr830.*expr934.*expr935.*tpc - expr934.*(expr1485 + expr1486 - expr521.*expr892.*expr936.*(expr928 + expr1483.*expr481.*expr502.*tpc) - expr938.*(expr928 + expr1483.*expr481.*expr502.*tpc));
expr1506 = 200.*(expr1489 + expr1490 + expr1491 + expr1492 + expr1493 + expr1494 + expr1495 + expr1496 + expr1497 + expr1498 + expr1499 + expr1500 + expr1501 + expr1502 + expr1503 + expr1504 + expr1505.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840).*(-1 + expr949 + expr950 + expr951 + expr952).*WO;
expr1507 = expr1428 + expr1506 + integrate17 + integrate18 + integrate19 + integrate20;
gf(6) = expr1507;

%% Derivative for a(3)
w21 = [ws:(99.*ws)./100:100.*ws];
expr1508 = ((a(1).^2 + b(1).^2).^2 + w21.^2.*(w21.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr1509 = ((a(2).^2 + b(2).^2).^2 + w21.^2.*(w21.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr1510 = 4.*w21.^2.*a(3) + 4.*a(3).*(a(3).^2 + b(3).^2);
expr1511 = ((a(3).^2 + b(3).^2).^2 + w21.^2.*(w21.^2 + 2.*(a(3).^2 - b(3).^2))).^(-2);
expr1512 = ((a(4).^2 + b(4).^2).^2 + w21.^2.*(w21.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr1513 = (c(1).^2 + d(1).^2).^2 + w21.^2.*(w21.^2 + 2.*(c(1).^2 - d(1).^2));
expr1514 = (c(2).^2 + d(2).^2).^2 + w21.^2.*(w21.^2 + 2.*(c(2).^2 - d(2).^2));
expr1515 = (c(3).^2 + d(3).^2).^2 + w21.^2.*(w21.^2 + 2.*(c(3).^2 - d(3).^2));
expr1516 = (c(4).^2 + d(4).^2).^2 + w21.^2.*(w21.^2 + 2.*(c(4).^2 - d(4).^2));
expr1517 = ((a(3).^2 + b(3).^2).^2 + w21.^2.*(w21.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr1518 = expr1508.*expr1509.*expr1510.*expr1511.*expr1512.*expr1513.*expr1514.*expr1515.*expr1516.*expr575.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*Wms;
expr1519 = expr1508.*expr1509.*expr1512.*expr1513.*expr1514.*expr1515.*expr1516.*expr1517.*expr523.*expr538.*expr576.*expr577.*expr580.*expr584.*expr586.*expr588.*expr590.*expr592.*expr594.*Wms;
expr1520 = expr1518 + expr1519;
integrate21 = trapz(w21, expr1520);
w22 = [0:wp./100:wp];
expr1521 = (a(1).^2 + b(1).^2).^2 + w22.^2.*(w22.^2 + 2.*(a(1).^2 - b(1).^2));
expr1522 = (a(2).^2 + b(2).^2).^2 + w22.^2.*(w22.^2 + 2.*(a(2).^2 - b(2).^2));
expr1523 = 4.*w22.^2.*a(3) + 4.*a(3).*(a(3).^2 + b(3).^2);
expr1524 = (a(4).^2 + b(4).^2).^2 + w22.^2.*(w22.^2 + 2.*(a(4).^2 - b(4).^2));
expr1525 = (a(3).^2 + b(3).^2).^2 + w22.^2.*(w22.^2 + 2.*(a(3).^2 - b(3).^2));
expr1526 = (c(1).^2 + d(1).^2).^2 + w22.^2.*(w22.^2 + 2.*(c(1).^2 - d(1).^2));
expr1527 = (c(2).^2 + d(2).^2).^2 + w22.^2.*(w22.^2 + 2.*(c(2).^2 - d(2).^2));
expr1528 = (c(3).^2 + d(3).^2).^2 + w22.^2.*(w22.^2 + 2.*(c(3).^2 - d(3).^2));
expr1529 = (c(4).^2 + d(4).^2).^2 + w22.^2.*(w22.^2 + 2.*(c(4).^2 - d(4).^2));
expr1530 = -1 + (expr1521.*expr1522.*expr1524.*expr1525).^expr600.*(expr1526.*expr1527.*expr1528.*expr1529).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr1531 = 2.*(expr1521.*expr1522.*expr1524.*expr1525).^expr600.*(expr1526.*expr1527.*expr1528.*expr1529).^expr615.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610;
expr1532 = expr1521.*expr1522.*expr1523.*expr1524.*(expr1521.*expr1522.*expr1524.*expr1525).^expr606.*(expr1526.*expr1527.*expr1528.*expr1529).^expr615.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr1533 = 2.*expr1530.*(expr1531 + expr1532).*expr599.*Wmp;
integrate22 = trapz(w22, expr1533);
w23 = [wp:(-wp + ws)./100:ws];
expr1534 = (a(1).^2 + b(1).^2).^2 + w23.^2.*(w23.^2 + 2.*(a(1).^2 - b(1).^2));
expr1535 = (a(2).^2 + b(2).^2).^2 + w23.^2.*(w23.^2 + 2.*(a(2).^2 - b(2).^2));
expr1536 = 4.*w23.^2.*a(3) + 4.*a(3).*(a(3).^2 + b(3).^2);
expr1537 = (a(4).^2 + b(4).^2).^2 + w23.^2.*(w23.^2 + 2.*(a(4).^2 - b(4).^2));
expr1538 = (a(3).^2 + b(3).^2).^2 + w23.^2.*(w23.^2 + 2.*(a(3).^2 - b(3).^2));
expr1539 = (c(1).^2 + d(1).^2).^2 + w23.^2.*(w23.^2 + 2.*(c(1).^2 - d(1).^2));
expr1540 = (c(2).^2 + d(2).^2).^2 + w23.^2.*(w23.^2 + 2.*(c(2).^2 - d(2).^2));
expr1541 = (c(3).^2 + d(3).^2).^2 + w23.^2.*(w23.^2 + 2.*(c(3).^2 - d(3).^2));
expr1542 = (c(4).^2 + d(4).^2).^2 + w23.^2.*(w23.^2 + 2.*(c(4).^2 - d(4).^2));
expr1543 = -(w23./(wp - ws));
expr1544 = 2.*(expr1534.*expr1535.*expr1537.*expr1538).^expr600.*(expr1539.*expr1540.*expr1541.*expr1542).^expr615.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610;
expr1545 = expr1534.*expr1535.*expr1536.*expr1537.*(expr1534.*expr1535.*expr1537.*expr1538).^expr606.*(expr1539.*expr1540.*expr1541.*expr1542).^expr615.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr1546 = expr1543 + (expr1534.*expr1535.*expr1537.*expr1538).^expr600.*(expr1539.*expr1540.*expr1541.*expr1542).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr631;
expr1547 = 2.*(expr1544 + expr1545).*expr1546.*expr620.*Wmt;
integrate23 = trapz(w23, expr1547);
w24 = [0:wmax./100:wmax];
expr1548 = -((w24 - b(3))./(a(3).^2.*(1 + (w24 - b(3)).^2./a(3).^2)));
expr1549 = -((w24 + b(3))./(a(3).^2.*(1 + (w24 + b(3)).^2./a(3).^2)));
expr1550 = 2.*a(3).*(angle(1 + (i.*(wmax - b(3)))./a(3)) + angle(1 + (i.*(wmax + b(3)))./a(3)));
expr1551 = (2.*(wmax - b(3)).^2.*b(3))./(a(3).^2.*(1 + (wmax - b(3)).^2./a(3).^2));
expr1552 = (-2.*b(3).*(wmax + b(3)).^2)./(a(3).^2.*(1 + (wmax + b(3)).^2./a(3).^2));
expr1553 = -((wmax - b(3))./(a(3).^2.*(1 + (wmax - b(3)).^2./a(3).^2)));
expr1554 = -((wmax + b(3))./(a(3).^2.*(1 + (wmax + b(3)).^2./a(3).^2)));
expr1555 = -(b(3).*log(1 + (wmax - b(3)).^2./a(3).^2));
expr1556 = b(3).*log(1 + (wmax + b(3)).^2./a(3).^2);
expr1557 = angle(1 + (i.*(w24 - b(1)))./a(1));
expr1558 = angle(1 + (i.*(w24 + b(1)))./a(1));
expr1559 = angle(1 + (i.*(w24 - b(2)))./a(2));
expr1560 = angle(1 + (i.*(w24 + b(2)))./a(2));
expr1561 = angle(1 + (i.*(w24 - b(3)))./a(3));
expr1562 = angle(1 + (i.*(w24 + b(3)))./a(3));
expr1563 = angle(1 + (i.*(w24 - b(4)))./a(4));
expr1564 = angle(1 + (i.*(w24 + b(4)))./a(4));
expr1565 = -angle(1 + (i.*(w24 - d(1)))./c(1));
expr1566 = -angle(1 + (i.*(w24 + d(1)))./c(1));
expr1567 = -angle(1 + (i.*(w24 - d(2)))./c(2));
expr1568 = -angle(1 + (i.*(w24 + d(2)))./c(2));
expr1569 = -angle(1 + (i.*(w24 - d(3)))./c(3));
expr1570 = -angle(1 + (i.*(w24 + d(3)))./c(3));
expr1571 = -angle(1 + (i.*(w24 - d(4)))./c(4));
expr1572 = -angle(1 + (i.*(w24 + d(4)))./c(4));
expr1573 = expr1548 + expr1549 + expr606.*expr639.*(expr1550 + expr1551 + expr1552 + expr1555 + expr1556 + expr640 - (expr1553 + expr1554).*expr676).*w24;
expr1574 = 2.*expr1573.*expr636.*(expr1557 + expr1558 + expr1559 + expr1560 + expr1561 + expr1562 + expr1563 + expr1564 + expr1565 + expr1566 + expr1567 + expr1568 + expr1569 + expr1570 + expr1571 + expr1572 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w24).*Wph;
integrate24 = trapz(w24, expr1574);
expr1575 = sqrt(a(3).^2 + b(3).^2).^(-1);
expr1576 = a(3).^(-2);
expr1577 = (b(1) + b(3))./((a(1) - a(3)).^2.*(1 + (b(1) + b(3)).^2./(a(1) - a(3)).^2));
expr1578 = (b(2) + b(3))./((a(2) - a(3)).^2.*(1 + (b(2) + b(3)).^2./(a(2) - a(3)).^2));
expr1579 = -((b(1) + b(3))./((-a(1) + a(3)).^2.*(1 + (b(1) + b(3)).^2./(-a(1) + a(3)).^2)));
expr1580 = -((b(2) + b(3))./((-a(2) + a(3)).^2.*(1 + (b(2) + b(3)).^2./(-a(2) + a(3)).^2)));
expr1581 = (a(3) - a(4)).^(-2);
expr1582 = (1 + (b(3) - b(4)).^2./(a(3) - a(4)).^2).^(-1);
expr1583 = b(3) - b(4);
expr1584 = -((b(3) + b(4))./((a(3) - a(4)).^2.*(1 + (b(3) + b(4)).^2./(a(3) - a(4)).^2)));
expr1585 = (a(3) - c(1)).^(-2);
expr1586 = (1 + (b(3) - d(1)).^2./(a(3) - c(1)).^2).^(-1);
expr1587 = b(3) - d(1);
expr1588 = (b(3) + d(1))./((a(3) - c(1)).^2.*(1 + (b(3) + d(1)).^2./(a(3) - c(1)).^2));
expr1589 = (a(3) - c(2)).^(-2);
expr1590 = (1 + (b(3) - d(2)).^2./(a(3) - c(2)).^2).^(-1);
expr1591 = b(3) - d(2);
expr1592 = (b(3) + d(2))./((a(3) - c(2)).^2.*(1 + (b(3) + d(2)).^2./(a(3) - c(2)).^2));
expr1593 = (a(3) - c(3)).^(-2);
expr1594 = (1 + (b(3) - d(3)).^2./(a(3) - c(3)).^2).^(-1);
expr1595 = b(3) - d(3);
expr1596 = (b(3) + d(3))./((a(3) - c(3)).^2.*(1 + (b(3) + d(3)).^2./(a(3) - c(3)).^2));
expr1597 = (a(3) - c(4)).^(-2);
expr1598 = (1 + (b(3) - d(4)).^2./(a(3) - c(4)).^2).^(-1);
expr1599 = b(3) - d(4);
expr1600 = (b(3) + d(4))./((a(3) - c(4)).^2.*(1 + (b(3) + d(4)).^2./(a(3) - c(4)).^2));
expr1601 = 2.*a(3);
expr1602 = (-a(3) + a(4)).^(-2);
expr1603 = -b(3) + b(4);
expr1604 = (1 + (-b(3) + b(4)).^2./(-a(3) + a(4)).^2).^(-1);
expr1605 = (b(3) + b(4))./((-a(3) + a(4)).^2.*(1 + (b(3) + b(4)).^2./(-a(3) + a(4)).^2));
expr1606 = a(3) - a(4);
expr1607 = a(3) - c(4);
expr1608 = a(3) - c(3);
expr1609 = a(3) - c(2);
expr1610 = a(3) - c(1);
expr1611 = -a(3) + a(4);
expr1612 = expr714.*(expr715.*expr716.*expr717.*expr718.*expr719.*expr720.*expr721.*expr722).^expr723.*(expr1575.*expr715.*expr716.*expr718.*expr719.*expr720.*expr722 - expr1576.*expr715.*expr716.*expr718.*expr719.*expr720.*expr721.*expr722).*WQ;
expr1613 = -2.*expr726.*expr727.*expr728.*expr730.*expr731.*expr783 - 2.*expr726.*expr727.*expr729.*expr730.*expr731.*expr783;
expr1614 = expr498.*(expr1577 + expr793.*expr794.*expr795).*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr1615 = -(expr482.*(expr1577 + expr793.*expr794.*expr795).*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497));
expr1616 = expr1577 + expr793.*expr794.*expr795;
expr1617 = (expr1218.*expr1219.*expr1220 + expr1578).*expr518.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr1618 = -((expr1218.*expr1219.*expr1220 + expr1578).*expr502.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517));
expr1619 = expr1218.*expr1219.*expr1220 + expr1578;
expr1620 = -(expr1243.*expr1244.*expr1245) + expr1579 + expr1580 - expr1581.*expr1582.*expr1583 + expr1584 + expr1585.*expr1586.*expr1587 + expr1588 + expr1589.*expr1590.*expr1591 + expr1592 + expr1593.*expr1594.*expr1595 + expr1596 + expr1597.*expr1598.*expr1599 + expr1600 - expr822.*expr823.*expr824;
expr1621 = (expr1602.*expr1603.*expr1604 + expr1605).*expr558.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr1622 = -((expr1602.*expr1603.*expr1604 + expr1605).*expr542.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557));
expr1623 = expr1602.*expr1603.*expr1604 + expr1605;
expr1624 = -2.*expr1252.*expr740.*expr741.*expr742.*expr744.*expr745 - 2.*expr1252.*expr740.*expr741.*expr743.*expr744.*expr745;
expr1625 = (expr760.*expr761.*expr762.*expr763.*expr764.*expr765.*expr766.*expr767).^expr600;
expr1626 = 2.*expr1607.*expr760.*expr761.*expr762.*expr763.*expr764.*expr765.*expr766;
expr1627 = 2.*expr1607.*expr760.*expr761.*expr762.*expr763.*expr764.*expr765.*expr767;
expr1628 = 2.*expr1608.*expr760.*expr761.*expr762.*expr763.*expr764.*expr766.*expr767;
expr1629 = 2.*expr1608.*expr760.*expr761.*expr762.*expr763.*expr765.*expr766.*expr767;
expr1630 = 2.*expr1609.*expr760.*expr761.*expr762.*expr764.*expr765.*expr766.*expr767;
expr1631 = 2.*expr1609.*expr760.*expr761.*expr763.*expr764.*expr765.*expr766.*expr767;
expr1632 = 2.*expr1610.*expr760.*expr762.*expr763.*expr764.*expr765.*expr766.*expr767;
expr1633 = 2.*expr1610.*expr761.*expr762.*expr763.*expr764.*expr765.*expr766.*expr767;
expr1634 = 2.*expr1606.*expr754.*expr755.*expr756.*expr757.*expr758;
expr1635 = 2.*expr1606.*expr754.*expr755.*expr756.*expr757.*expr759;
expr1636 = 2.*expr1257.*expr754.*expr755.*expr756.*expr758.*expr759;
expr1637 = 2.*expr1257.*expr754.*expr755.*expr757.*expr758.*expr759;
expr1638 = 2.*expr754.*expr756.*expr757.*expr758.*expr759.*expr832;
expr1639 = 2.*expr755.*expr756.*expr757.*expr758.*expr759.*expr832;
expr1640 = -2.*expr1611.*expr768.*expr769.*expr770.*expr771.*expr772 - 2.*expr1611.*expr768.*expr769.*expr770.*expr771.*expr773;
expr1641 = expr1614 + expr1615;
expr1642 = (expr1616.*expr482.*expr483.*expr563.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr1643 = -(((expr1614 + expr1615).*expr482.*expr483.*expr562.*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr1644 = -((expr482.*expr483.*expr562.*expr563.*(-(expr1616.*expr483.*expr498.*expr563.*expr864) + (expr1614 + expr1615).*expr483.*expr498.*expr562.*expr866))./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^2);
expr1645 = -(((expr1617 + expr1618).*expr502.*expr503.*expr564.*expr868)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr1646 = (expr1619.*expr502.*expr503.*expr565.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr1647 = -((expr502.*expr503.*expr564.*expr565.*((expr1617 + expr1618).*expr503.*expr518.*expr564.*expr868 - expr1619.*expr503.*expr518.*expr565.*expr870))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^2);
expr1648 = (2.*expr522.*expr538.*expr566.*expr567)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr1649 = (expr1620.*expr522.*expr523.*expr567.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr1650 = -((expr522.*expr523.*expr566.*expr874.*(expr566 - expr1620.*expr522.*expr566 + expr1620.*expr538.*expr876))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr1651 = (expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^(-2);
expr1652 = expr1601 - expr523.*expr566.*expr567 - 2.*expr539.*expr566.*expr567 - expr1620.*expr523.*expr538.*expr567.*expr876 + expr523.*expr538.*expr566.*expr874.*(expr566 - expr1620.*expr522.*expr566 + expr1620.*expr538.*expr876);
expr1653 = -(((expr1621 + expr1622).*expr542.*expr543.*expr568.*expr880)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr1654 = (expr1623.*expr542.*expr543.*expr569.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr1655 = -((expr542.*expr543.*expr568.*expr569.*((expr1621 + expr1622).*expr543.*expr558.*expr568.*expr880 - expr1623.*expr543.*expr558.*expr569.*expr882))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^2);
expr1656 = -(expr1616.*expr483.*expr563.*expr864) + (expr1614 + expr1615).*expr483.*expr562.*expr866;
expr1657 = expr1617 + expr1618;
expr1658 = (expr1617 + expr1618).*expr503.*expr564.*expr868 - expr1619.*expr503.*expr565.*expr870;
expr1659 = expr1626 + expr1627 + expr1628 + expr1629 + expr1630 + expr1631 + expr1632 + expr1633;
expr1660 = expr566 - expr1620.*expr522.*expr566 + expr1620.*expr538.*expr876;
expr1661 = expr1634 + expr1635 + expr1636 + expr1637 + expr1638 + expr1639;
expr1662 = 1 - 2.*expr538.*expr566.*expr567 - expr1620.*expr523.*expr567.*expr876 + expr523.*expr566.*expr874.*(expr566 - expr1620.*expr522.*expr566 + expr1620.*expr538.*expr876);
expr1663 = expr1621 + expr1622;
expr1664 = (expr1621 + expr1622).*expr543.*expr568.*expr880 - expr1623.*expr543.*expr569.*expr882;
expr1665 = (expr1642 + expr1643 + expr1644).*expr501.*expr898 + (expr1645 + expr1646 + expr1647).*expr521.*expr904 + expr541.*(expr1648 + expr1649 + expr1650 - expr1651.*expr1652.*expr522.*expr523.*expr566.*expr567).*expr908 + (expr1653 + expr1654 + expr1655).*expr561.*expr912;
expr1666 = -(expr1656.*expr501.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1667 = -(expr1658.*expr521.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1668 = -(expr1662.*expr541.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1669 = -(expr1664.*expr561.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1670 = expr1641.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*(1 + expr923);
expr1671 = 2.*expr501.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(1 + expr923);
expr1672 = expr1613.*expr501.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr836.*expr837.*expr847.*(1 + expr923);
expr1673 = expr1657.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*(1 + expr924);
expr1674 = 2.*expr483.*expr521.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(1 + expr924);
expr1675 = expr1624.*expr483.*expr521.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr839.*expr840.*expr885.*(1 + expr924);
expr1676 = expr1660.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*(1 + expr925);
expr1677 = expr1625.*expr1659.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr841.*expr843.*(1 + expr925);
expr1678 = expr1661.*expr483.*expr503.*expr541.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr842.*expr843.*expr887.*(1 + expr925);
expr1679 = expr1663.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*(1 + expr926);
expr1680 = 2.*expr483.*expr503.*expr538.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(1 + expr926);
expr1681 = expr1640.*expr483.*expr503.*expr523.*expr561.*expr600.*expr607.*expr608.*expr609.*expr610.*expr845.*expr846.*expr889.*(1 + expr926);
expr1682 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(expr1665.*expr498.*expr830.*expr927.*expr930.*tpc - expr927.*(expr1666 + expr1665.*expr830.*expr891.*expr931.*tpc + expr1665.*expr482.*expr830.*expr933.*tpc));
expr1683 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(expr1665.*expr518.*expr830.*expr934.*expr935.*tpc - expr934.*(expr1667 + expr1665.*expr830.*expr892.*expr936.*tpc + expr1665.*expr502.*expr830.*expr938.*tpc));
expr1684 = -(expr939.*expr940.*(expr928 + expr1665.*expr481.*expr538.*tpc)) - expr939.*(expr1668 + expr1665.*expr830.*expr893.*expr941.*tpc + expr1665.*expr522.*expr830.*expr943.*tpc);
expr1685 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(expr1665.*expr558.*expr830.*expr944.*expr945.*tpc - expr944.*(expr1669 + expr1665.*expr830.*expr894.*expr946.*tpc + expr1665.*expr542.*expr830.*expr948.*tpc));
expr1686 = 200.*(expr1670 + expr1671 + expr1672 + expr1673 + expr1674 + expr1675 + expr1676 + expr1677 + expr1678 + expr1679 + expr1680 + expr1681 + expr1682 + expr1683 + expr1685 + expr1684.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843).*(-1 + expr949 + expr950 + expr951 + expr952).*WO;
expr1687 = expr1612 + expr1686 + integrate21 + integrate22 + integrate23 + integrate24;
gf(3) = expr1687;

%% Derivative for b(3)
w25 = [ws:(99.*ws)./100:100.*ws];
expr1688 = ((a(1).^2 + b(1).^2).^2 + w25.^2.*(w25.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr1689 = ((a(2).^2 + b(2).^2).^2 + w25.^2.*(w25.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr1690 = -4.*w25.^2.*b(3) + 4.*b(3).*(a(3).^2 + b(3).^2);
expr1691 = ((a(3).^2 + b(3).^2).^2 + w25.^2.*(w25.^2 + 2.*(a(3).^2 - b(3).^2))).^(-2);
expr1692 = ((a(4).^2 + b(4).^2).^2 + w25.^2.*(w25.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr1693 = (c(1).^2 + d(1).^2).^2 + w25.^2.*(w25.^2 + 2.*(c(1).^2 - d(1).^2));
expr1694 = (c(2).^2 + d(2).^2).^2 + w25.^2.*(w25.^2 + 2.*(c(2).^2 - d(2).^2));
expr1695 = (c(3).^2 + d(3).^2).^2 + w25.^2.*(w25.^2 + 2.*(c(3).^2 - d(3).^2));
expr1696 = (c(4).^2 + d(4).^2).^2 + w25.^2.*(w25.^2 + 2.*(c(4).^2 - d(4).^2));
expr1697 = ((a(3).^2 + b(3).^2).^2 + w25.^2.*(w25.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr1698 = expr1688.*expr1689.*expr1690.*expr1691.*expr1692.*expr1693.*expr1694.*expr1695.*expr1696.*expr575.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*Wms;
expr1699 = expr1688.*expr1689.*expr1692.*expr1693.*expr1694.*expr1695.*expr1696.*expr1697.*expr522.*expr523.*expr576.*expr577.*expr580.*expr584.*expr586.*expr588.*expr590.*expr592.*expr594.*Wms;
expr1700 = expr1698 + expr1699;
integrate25 = trapz(w25, expr1700);
w26 = [0:wp./100:wp];
expr1701 = (a(1).^2 + b(1).^2).^2 + w26.^2.*(w26.^2 + 2.*(a(1).^2 - b(1).^2));
expr1702 = (a(2).^2 + b(2).^2).^2 + w26.^2.*(w26.^2 + 2.*(a(2).^2 - b(2).^2));
expr1703 = -4.*w26.^2.*b(3) + 4.*b(3).*(a(3).^2 + b(3).^2);
expr1704 = (a(4).^2 + b(4).^2).^2 + w26.^2.*(w26.^2 + 2.*(a(4).^2 - b(4).^2));
expr1705 = (a(3).^2 + b(3).^2).^2 + w26.^2.*(w26.^2 + 2.*(a(3).^2 - b(3).^2));
expr1706 = (c(1).^2 + d(1).^2).^2 + w26.^2.*(w26.^2 + 2.*(c(1).^2 - d(1).^2));
expr1707 = (c(2).^2 + d(2).^2).^2 + w26.^2.*(w26.^2 + 2.*(c(2).^2 - d(2).^2));
expr1708 = (c(3).^2 + d(3).^2).^2 + w26.^2.*(w26.^2 + 2.*(c(3).^2 - d(3).^2));
expr1709 = (c(4).^2 + d(4).^2).^2 + w26.^2.*(w26.^2 + 2.*(c(4).^2 - d(4).^2));
expr1710 = -1 + (expr1701.*expr1702.*expr1704.*expr1705).^expr600.*(expr1706.*expr1707.*expr1708.*expr1709).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr1711 = 2.*(expr1701.*expr1702.*expr1704.*expr1705).^expr600.*(expr1706.*expr1707.*expr1708.*expr1709).^expr615.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610;
expr1712 = expr1701.*expr1702.*expr1703.*expr1704.*(expr1701.*expr1702.*expr1704.*expr1705).^expr606.*(expr1706.*expr1707.*expr1708.*expr1709).^expr615.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr1713 = 2.*expr1710.*(expr1711 + expr1712).*expr599.*Wmp;
integrate26 = trapz(w26, expr1713);
w27 = [wp:(-wp + ws)./100:ws];
expr1714 = (a(1).^2 + b(1).^2).^2 + w27.^2.*(w27.^2 + 2.*(a(1).^2 - b(1).^2));
expr1715 = (a(2).^2 + b(2).^2).^2 + w27.^2.*(w27.^2 + 2.*(a(2).^2 - b(2).^2));
expr1716 = -4.*w27.^2.*b(3) + 4.*b(3).*(a(3).^2 + b(3).^2);
expr1717 = (a(4).^2 + b(4).^2).^2 + w27.^2.*(w27.^2 + 2.*(a(4).^2 - b(4).^2));
expr1718 = (a(3).^2 + b(3).^2).^2 + w27.^2.*(w27.^2 + 2.*(a(3).^2 - b(3).^2));
expr1719 = (c(1).^2 + d(1).^2).^2 + w27.^2.*(w27.^2 + 2.*(c(1).^2 - d(1).^2));
expr1720 = (c(2).^2 + d(2).^2).^2 + w27.^2.*(w27.^2 + 2.*(c(2).^2 - d(2).^2));
expr1721 = (c(3).^2 + d(3).^2).^2 + w27.^2.*(w27.^2 + 2.*(c(3).^2 - d(3).^2));
expr1722 = (c(4).^2 + d(4).^2).^2 + w27.^2.*(w27.^2 + 2.*(c(4).^2 - d(4).^2));
expr1723 = -(w27./(wp - ws));
expr1724 = 2.*(expr1714.*expr1715.*expr1717.*expr1718).^expr600.*(expr1719.*expr1720.*expr1721.*expr1722).^expr615.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610;
expr1725 = expr1714.*expr1715.*expr1716.*expr1717.*(expr1714.*expr1715.*expr1717.*expr1718).^expr606.*(expr1719.*expr1720.*expr1721.*expr1722).^expr615.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr1726 = expr1723 + (expr1714.*expr1715.*expr1717.*expr1718).^expr600.*(expr1719.*expr1720.*expr1721.*expr1722).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr631;
expr1727 = 2.*(expr1724 + expr1725).*expr1726.*expr620.*Wmt;
integrate27 = trapz(w27, expr1727);
w28 = [0:wmax./100:wmax];
expr1728 = -(1./(a(3).*(1 + (w28 - b(3)).^2./a(3).^2)));
expr1729 = 1./(a(3).*(1 + (w28 + b(3)).^2./a(3).^2));
expr1730 = -2.*(angle(1 + (i.*(wmax - b(3)))./a(3)) + angle(1 + (i.*(wmax + b(3)))./a(3))).*b(3);
expr1731 = (2.*(wmax - b(3)).*b(3))./(a(3).*(1 + (wmax - b(3)).^2./a(3).^2));
expr1732 = (2.*b(3).*(wmax + b(3)))./(a(3).*(1 + (wmax + b(3)).^2./a(3).^2));
expr1733 = -(1./(a(3).*(1 + (wmax - b(3)).^2./a(3).^2)));
expr1734 = 1./(a(3).*(1 + (wmax + b(3)).^2./a(3).^2));
expr1735 = -(a(3).*log(1 + (wmax - b(3)).^2./a(3).^2));
expr1736 = a(3).*log(1 + (wmax + b(3)).^2./a(3).^2);
expr1737 = angle(1 + (i.*(w28 - b(1)))./a(1));
expr1738 = angle(1 + (i.*(w28 + b(1)))./a(1));
expr1739 = angle(1 + (i.*(w28 - b(2)))./a(2));
expr1740 = angle(1 + (i.*(w28 + b(2)))./a(2));
expr1741 = angle(1 + (i.*(w28 - b(3)))./a(3));
expr1742 = angle(1 + (i.*(w28 + b(3)))./a(3));
expr1743 = angle(1 + (i.*(w28 - b(4)))./a(4));
expr1744 = angle(1 + (i.*(w28 + b(4)))./a(4));
expr1745 = -angle(1 + (i.*(w28 - d(1)))./c(1));
expr1746 = -angle(1 + (i.*(w28 + d(1)))./c(1));
expr1747 = -angle(1 + (i.*(w28 - d(2)))./c(2));
expr1748 = -angle(1 + (i.*(w28 + d(2)))./c(2));
expr1749 = -angle(1 + (i.*(w28 - d(3)))./c(3));
expr1750 = -angle(1 + (i.*(w28 + d(3)))./c(3));
expr1751 = -angle(1 + (i.*(w28 - d(4)))./c(4));
expr1752 = -angle(1 + (i.*(w28 + d(4)))./c(4));
expr1753 = expr1728 + expr1729 + expr606.*expr639.*(expr1730 + expr1731 + expr1732 + expr1735 + expr1736 - (expr1733 + expr1734).*expr676).*w28;
expr1754 = 2.*expr1753.*expr636.*(expr1737 + expr1738 + expr1739 + expr1740 + expr1741 + expr1742 + expr1743 + expr1744 + expr1745 + expr1746 + expr1747 + expr1748 + expr1749 + expr1750 + expr1751 + expr1752 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w28).*Wph;
integrate28 = trapz(w28, expr1754);
expr1755 = -(1./((a(1) - a(3)).*(1 + (b(1) - b(3)).^2./(a(1) - a(3)).^2)));
expr1756 = b(3).^(-2);
expr1757 = -(1./((a(2) - a(3)).*(1 + (b(2) - b(3)).^2./(a(2) - a(3)).^2)));
expr1758 = 1./((-a(1) + a(3)).*(1 + (-b(1) + b(3)).^2./(-a(1) + a(3)).^2));
expr1759 = 1./((-a(2) + a(3)).*(1 + (-b(2) + b(3)).^2./(-a(2) + a(3)).^2));
expr1760 = 1./((a(3) - a(4)).*(1 + (b(3) - b(4)).^2./(a(3) - a(4)).^2));
expr1761 = 1./((a(3) - a(4)).*(1 + (b(3) + b(4)).^2./(a(3) - a(4)).^2));
expr1762 = -(1./((a(3) - c(1)).*(1 + (b(3) - d(1)).^2./(a(3) - c(1)).^2)));
expr1763 = -(1./((a(3) - c(1)).*(1 + (b(3) + d(1)).^2./(a(3) - c(1)).^2)));
expr1764 = -(1./((a(3) - c(2)).*(1 + (b(3) - d(2)).^2./(a(3) - c(2)).^2)));
expr1765 = -(1./((a(3) - c(2)).*(1 + (b(3) + d(2)).^2./(a(3) - c(2)).^2)));
expr1766 = -(1./((a(3) - c(3)).*(1 + (b(3) - d(3)).^2./(a(3) - c(3)).^2)));
expr1767 = -(1./((a(3) - c(3)).*(1 + (b(3) + d(3)).^2./(a(3) - c(3)).^2)));
expr1768 = -(1./((a(3) - c(4)).*(1 + (b(3) - d(4)).^2./(a(3) - c(4)).^2)));
expr1769 = -(1./((a(3) - c(4)).*(1 + (b(3) + d(4)).^2./(a(3) - c(4)).^2)));
expr1770 = 2.*b(3);
expr1771 = -(1./((-a(3) + a(4)).*(1 + (-b(3) + b(4)).^2./(-a(3) + a(4)).^2)));
expr1772 = 1./((-a(3) + a(4)).*(1 + (b(3) + b(4)).^2./(-a(3) + a(4)).^2));
expr1773 = b(3) + b(4);
expr1774 = b(3) + d(4);
expr1775 = b(3) + d(3);
expr1776 = b(3) + d(2);
expr1777 = b(3) + d(1);
expr1778 = expr1575.*expr522.*expr714.*expr715.*expr716.*expr717.*expr718.*expr719.*expr720.*expr722.*(expr715.*expr716.*expr717.*expr718.*expr719.*expr720.*expr721.*expr722).^expr723.*WQ;
expr1779 = (expr1049 + expr1755).*expr498.*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr1780 = -((expr1049 + expr1755).*expr482.*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497));
expr1781 = 2.*expr1040.*expr726.*expr727.*expr728.*expr730.*expr731 - 2.*expr726.*expr727.*expr729.*expr730.*expr731.*expr795;
expr1782 = expr1049 + expr1755;
expr1783 = (expr1406 + expr1757).*expr518.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr1784 = -((expr1406 + expr1757).*expr502.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517));
expr1785 = expr1406 + expr1757;
expr1786 = (expr1064 + expr1419 + expr1758 + expr1759 + expr1760 + expr1761 + expr1762 + expr1763 + expr1764 + expr1765 + expr1766 + expr1767 + expr1768 + expr1769).*expr538.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr1787 = -((expr1064 + expr1419 + expr1758 + expr1759 + expr1760 + expr1761 + expr1762 + expr1763 + expr1764 + expr1765 + expr1766 + expr1767 + expr1768 + expr1769).*expr522.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537));
expr1788 = expr1064 + expr1419 + expr1758 + expr1759 + expr1760 + expr1761 + expr1762 + expr1763 + expr1764 + expr1765 + expr1766 + expr1767 + expr1768 + expr1769;
expr1789 = (expr1771 + expr1772).*expr558.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr1790 = -((expr1771 + expr1772).*expr542.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557));
expr1791 = expr1771 + expr1772;
expr1792 = 2.*expr1423.*expr740.*expr741.*expr742.*expr744.*expr745 - 2.*expr1220.*expr740.*expr741.*expr743.*expr744.*expr745;
expr1793 = 2.*expr1774.*expr760.*expr761.*expr762.*expr763.*expr764.*expr765.*expr766;
expr1794 = 2.*expr1599.*expr760.*expr761.*expr762.*expr763.*expr764.*expr765.*expr767;
expr1795 = 2.*expr1775.*expr760.*expr761.*expr762.*expr763.*expr764.*expr766.*expr767;
expr1796 = 2.*expr1595.*expr760.*expr761.*expr762.*expr763.*expr765.*expr766.*expr767;
expr1797 = 2.*expr1776.*expr760.*expr761.*expr762.*expr764.*expr765.*expr766.*expr767;
expr1798 = 2.*expr1591.*expr760.*expr761.*expr763.*expr764.*expr765.*expr766.*expr767;
expr1799 = 2.*expr1777.*expr760.*expr762.*expr763.*expr764.*expr765.*expr766.*expr767;
expr1800 = 2.*expr1587.*expr761.*expr762.*expr763.*expr764.*expr765.*expr766.*expr767;
expr1801 = 2.*expr1773.*expr754.*expr755.*expr756.*expr757.*expr758;
expr1802 = 2.*expr1583.*expr754.*expr755.*expr756.*expr757.*expr759;
expr1803 = 2.*expr1423.*expr754.*expr755.*expr756.*expr758.*expr759;
expr1804 = 2.*expr1244.*expr754.*expr755.*expr757.*expr758.*expr759;
expr1805 = 2.*expr1040.*expr754.*expr756.*expr757.*expr758.*expr759;
expr1806 = 2.*expr755.*expr756.*expr757.*expr758.*expr759.*expr823;
expr1807 = 2.*expr1773.*expr768.*expr769.*expr770.*expr771.*expr772 - 2.*expr1603.*expr768.*expr769.*expr770.*expr771.*expr773;
expr1808 = expr1779 + expr1780;
expr1809 = (expr1782.*expr482.*expr483.*expr563.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr1810 = -(((expr1779 + expr1780).*expr482.*expr483.*expr562.*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr1811 = -((expr482.*expr483.*expr562.*expr563.*(-(expr1782.*expr483.*expr498.*expr563.*expr864) + (expr1779 + expr1780).*expr483.*expr498.*expr562.*expr866))./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^2);
expr1812 = -(((expr1783 + expr1784).*expr502.*expr503.*expr564.*expr868)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr1813 = (expr1785.*expr502.*expr503.*expr565.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr1814 = -((expr502.*expr503.*expr564.*expr565.*((expr1783 + expr1784).*expr503.*expr518.*expr564.*expr868 - expr1785.*expr503.*expr518.*expr565.*expr870))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^2);
expr1815 = (expr523.*expr566.*expr567)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr1816 = (2.*expr540.*expr566.*expr567)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr1817 = (expr1788.*expr522.*expr523.*expr567.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr1818 = -((expr522.*expr523.*expr566.*expr874.*(expr1786 + expr1787 + expr876))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr1819 = expr1770 - 2.*expr522.*expr538.*expr566.*expr567 - expr1788.*expr523.*expr538.*expr567.*expr876 + expr523.*expr538.*expr566.*expr874.*(expr1786 + expr1787 + expr876);
expr1820 = -(((expr1789 + expr1790).*expr542.*expr543.*expr568.*expr880)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr1821 = (expr1791.*expr542.*expr543.*expr569.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr1822 = -((expr542.*expr543.*expr568.*expr569.*((expr1789 + expr1790).*expr543.*expr558.*expr568.*expr880 - expr1791.*expr543.*expr558.*expr569.*expr882))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^2);
expr1823 = expr1756.*(pi - angle(1 + (expr522.*expr523.*expr566.*expr567.*i)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567)));
expr1824 = -(expr1782.*expr483.*expr563.*expr864) + (expr1779 + expr1780).*expr483.*expr562.*expr866;
expr1825 = expr1783 + expr1784;
expr1826 = (expr1783 + expr1784).*expr503.*expr564.*expr868 - expr1785.*expr503.*expr565.*expr870;
expr1827 = expr1793 + expr1794 + expr1795 + expr1796 + expr1797 + expr1798 + expr1799 + expr1800;
expr1828 = expr1786 + expr1787 + expr876;
expr1829 = expr1801 + expr1802 + expr1803 + expr1804 + expr1805 + expr1806;
expr1830 = -2.*expr522.*expr566.*expr567 - expr1788.*expr523.*expr567.*expr876 + expr523.*expr566.*expr874.*(expr1786 + expr1787 + expr876);
expr1831 = expr1789 + expr1790;
expr1832 = (expr1789 + expr1790).*expr543.*expr568.*expr880 - expr1791.*expr543.*expr569.*expr882;
expr1833 = expr1823 + (expr1809 + expr1810 + expr1811).*expr501.*expr898 + (expr1812 + expr1813 + expr1814).*expr521.*expr904 + expr541.*(expr1815 + expr1816 + expr1817 + expr1818 - expr1651.*expr1819.*expr522.*expr523.*expr566.*expr567).*expr908 + (expr1820 + expr1821 + expr1822).*expr561.*expr912;
expr1834 = -(expr1824.*expr501.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1835 = -(expr1826.*expr521.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1836 = -(expr1830.*expr541.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1837 = expr1756.*expr893.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr1838 = -(expr1832.*expr561.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr1839 = expr1808.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*(1 + expr923);
expr1840 = 2.*expr501.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(1 + expr923);
expr1841 = expr1781.*expr501.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr836.*expr837.*expr847.*(1 + expr923);
expr1842 = expr1825.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*(1 + expr924);
expr1843 = 2.*expr483.*expr521.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(1 + expr924);
expr1844 = expr1792.*expr483.*expr521.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr839.*expr840.*expr885.*(1 + expr924);
expr1845 = expr1828.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*(1 + expr925);
expr1846 = expr1625.*expr1827.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr841.*expr843.*(1 + expr925);
expr1847 = -(expr1756.*expr483.*expr503.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(1 + expr925));
expr1848 = expr1829.*expr483.*expr503.*expr541.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr842.*expr843.*expr887.*(1 + expr925);
expr1849 = expr1831.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*(1 + expr926);
expr1850 = 2.*expr483.*expr503.*expr522.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(1 + expr926);
expr1851 = expr1807.*expr483.*expr503.*expr523.*expr561.*expr600.*expr607.*expr608.*expr609.*expr610.*expr845.*expr846.*expr889.*(1 + expr926);
expr1852 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(expr1833.*expr498.*expr830.*expr927.*expr930.*tpc - expr927.*(expr1834 + expr1833.*expr830.*expr891.*expr931.*tpc + expr1833.*expr482.*expr830.*expr933.*tpc));
expr1853 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(expr1833.*expr518.*expr830.*expr934.*expr935.*tpc - expr934.*(expr1835 + expr1833.*expr830.*expr892.*expr936.*tpc + expr1833.*expr502.*expr830.*expr938.*tpc));
expr1854 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(expr1833.*expr558.*expr830.*expr944.*expr945.*tpc - expr944.*(expr1838 + expr1833.*expr830.*expr894.*expr946.*tpc + expr1833.*expr542.*expr830.*expr948.*tpc));
expr1855 = expr1833.*expr538.*expr830.*expr939.*expr940.*tpc - expr939.*(expr1836 + expr1837 - expr541.*expr893.*expr941.*(expr928 + expr1833.*expr481.*expr522.*tpc) - expr943.*(expr928 + expr1833.*expr481.*expr522.*tpc));
expr1856 = 200.*(expr1839 + expr1840 + expr1841 + expr1842 + expr1843 + expr1844 + expr1845 + expr1846 + expr1847 + expr1848 + expr1849 + expr1850 + expr1851 + expr1852 + expr1853 + expr1854 + expr1855.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843).*(-1 + expr949 + expr950 + expr951 + expr952).*WO;
expr1857 = expr1778 + expr1856 + integrate25 + integrate26 + integrate27 + integrate28;
gf(7) = expr1857;

%% Derivative for a(4)
w29 = [ws:(99.*ws)./100:100.*ws];
expr1858 = ((a(1).^2 + b(1).^2).^2 + w29.^2.*(w29.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr1859 = ((a(2).^2 + b(2).^2).^2 + w29.^2.*(w29.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr1860 = ((a(3).^2 + b(3).^2).^2 + w29.^2.*(w29.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr1861 = 4.*w29.^2.*a(4) + 4.*a(4).*(a(4).^2 + b(4).^2);
expr1862 = ((a(4).^2 + b(4).^2).^2 + w29.^2.*(w29.^2 + 2.*(a(4).^2 - b(4).^2))).^(-2);
expr1863 = (c(1).^2 + d(1).^2).^2 + w29.^2.*(w29.^2 + 2.*(c(1).^2 - d(1).^2));
expr1864 = (c(2).^2 + d(2).^2).^2 + w29.^2.*(w29.^2 + 2.*(c(2).^2 - d(2).^2));
expr1865 = (c(3).^2 + d(3).^2).^2 + w29.^2.*(w29.^2 + 2.*(c(3).^2 - d(3).^2));
expr1866 = (c(4).^2 + d(4).^2).^2 + w29.^2.*(w29.^2 + 2.*(c(4).^2 - d(4).^2));
expr1867 = ((a(4).^2 + b(4).^2).^2 + w29.^2.*(w29.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr1868 = expr1858.*expr1859.*expr1860.*expr1861.*expr1862.*expr1863.*expr1864.*expr1865.*expr1866.*expr575.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*Wms;
expr1869 = expr1858.*expr1859.*expr1860.*expr1863.*expr1864.*expr1865.*expr1866.*expr1867.*expr543.*expr558.*expr576.*expr577.*expr580.*expr582.*expr586.*expr588.*expr590.*expr592.*expr594.*Wms;
expr1870 = expr1868 + expr1869;
integrate29 = trapz(w29, expr1870);
w30 = [0:wp./100:wp];
expr1871 = (a(1).^2 + b(1).^2).^2 + w30.^2.*(w30.^2 + 2.*(a(1).^2 - b(1).^2));
expr1872 = (a(2).^2 + b(2).^2).^2 + w30.^2.*(w30.^2 + 2.*(a(2).^2 - b(2).^2));
expr1873 = (a(3).^2 + b(3).^2).^2 + w30.^2.*(w30.^2 + 2.*(a(3).^2 - b(3).^2));
expr1874 = 4.*w30.^2.*a(4) + 4.*a(4).*(a(4).^2 + b(4).^2);
expr1875 = (a(4).^2 + b(4).^2).^2 + w30.^2.*(w30.^2 + 2.*(a(4).^2 - b(4).^2));
expr1876 = (c(1).^2 + d(1).^2).^2 + w30.^2.*(w30.^2 + 2.*(c(1).^2 - d(1).^2));
expr1877 = (c(2).^2 + d(2).^2).^2 + w30.^2.*(w30.^2 + 2.*(c(2).^2 - d(2).^2));
expr1878 = (c(3).^2 + d(3).^2).^2 + w30.^2.*(w30.^2 + 2.*(c(3).^2 - d(3).^2));
expr1879 = (c(4).^2 + d(4).^2).^2 + w30.^2.*(w30.^2 + 2.*(c(4).^2 - d(4).^2));
expr1880 = -1 + (expr1871.*expr1872.*expr1873.*expr1875).^expr600.*(expr1876.*expr1877.*expr1878.*expr1879).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr1881 = 2.*(expr1871.*expr1872.*expr1873.*expr1875).^expr600.*(expr1876.*expr1877.*expr1878.*expr1879).^expr615.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610;
expr1882 = expr1871.*expr1872.*expr1873.*expr1874.*(expr1871.*expr1872.*expr1873.*expr1875).^expr606.*(expr1876.*expr1877.*expr1878.*expr1879).^expr615.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr1883 = 2.*expr1880.*(expr1881 + expr1882).*expr599.*Wmp;
integrate30 = trapz(w30, expr1883);
w31 = [wp:(-wp + ws)./100:ws];
expr1884 = (a(1).^2 + b(1).^2).^2 + w31.^2.*(w31.^2 + 2.*(a(1).^2 - b(1).^2));
expr1885 = (a(2).^2 + b(2).^2).^2 + w31.^2.*(w31.^2 + 2.*(a(2).^2 - b(2).^2));
expr1886 = (a(3).^2 + b(3).^2).^2 + w31.^2.*(w31.^2 + 2.*(a(3).^2 - b(3).^2));
expr1887 = 4.*w31.^2.*a(4) + 4.*a(4).*(a(4).^2 + b(4).^2);
expr1888 = (a(4).^2 + b(4).^2).^2 + w31.^2.*(w31.^2 + 2.*(a(4).^2 - b(4).^2));
expr1889 = (c(1).^2 + d(1).^2).^2 + w31.^2.*(w31.^2 + 2.*(c(1).^2 - d(1).^2));
expr1890 = (c(2).^2 + d(2).^2).^2 + w31.^2.*(w31.^2 + 2.*(c(2).^2 - d(2).^2));
expr1891 = (c(3).^2 + d(3).^2).^2 + w31.^2.*(w31.^2 + 2.*(c(3).^2 - d(3).^2));
expr1892 = (c(4).^2 + d(4).^2).^2 + w31.^2.*(w31.^2 + 2.*(c(4).^2 - d(4).^2));
expr1893 = -(w31./(wp - ws));
expr1894 = 2.*(expr1884.*expr1885.*expr1886.*expr1888).^expr600.*(expr1889.*expr1890.*expr1891.*expr1892).^expr615.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610;
expr1895 = expr1884.*expr1885.*expr1886.*expr1887.*(expr1884.*expr1885.*expr1886.*expr1888).^expr606.*(expr1889.*expr1890.*expr1891.*expr1892).^expr615.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr1896 = expr1893 + (expr1884.*expr1885.*expr1886.*expr1888).^expr600.*(expr1889.*expr1890.*expr1891.*expr1892).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr631;
expr1897 = 2.*(expr1894 + expr1895).*expr1896.*expr620.*Wmt;
integrate31 = trapz(w31, expr1897);
w32 = [0:wmax./100:wmax];
expr1898 = -((w32 - b(4))./(a(4).^2.*(1 + (w32 - b(4)).^2./a(4).^2)));
expr1899 = -((w32 + b(4))./(a(4).^2.*(1 + (w32 + b(4)).^2./a(4).^2)));
expr1900 = 2.*a(4).*(angle(1 + (i.*(wmax - b(4)))./a(4)) + angle(1 + (i.*(wmax + b(4)))./a(4)));
expr1901 = (2.*(wmax - b(4)).^2.*b(4))./(a(4).^2.*(1 + (wmax - b(4)).^2./a(4).^2));
expr1902 = (-2.*b(4).*(wmax + b(4)).^2)./(a(4).^2.*(1 + (wmax + b(4)).^2./a(4).^2));
expr1903 = -((wmax - b(4))./(a(4).^2.*(1 + (wmax - b(4)).^2./a(4).^2)));
expr1904 = -((wmax + b(4))./(a(4).^2.*(1 + (wmax + b(4)).^2./a(4).^2)));
expr1905 = -(b(4).*log(1 + (wmax - b(4)).^2./a(4).^2));
expr1906 = b(4).*log(1 + (wmax + b(4)).^2./a(4).^2);
expr1907 = angle(1 + (i.*(w32 - b(1)))./a(1));
expr1908 = angle(1 + (i.*(w32 + b(1)))./a(1));
expr1909 = angle(1 + (i.*(w32 - b(2)))./a(2));
expr1910 = angle(1 + (i.*(w32 + b(2)))./a(2));
expr1911 = angle(1 + (i.*(w32 - b(3)))./a(3));
expr1912 = angle(1 + (i.*(w32 + b(3)))./a(3));
expr1913 = angle(1 + (i.*(w32 - b(4)))./a(4));
expr1914 = angle(1 + (i.*(w32 + b(4)))./a(4));
expr1915 = -angle(1 + (i.*(w32 - d(1)))./c(1));
expr1916 = -angle(1 + (i.*(w32 + d(1)))./c(1));
expr1917 = -angle(1 + (i.*(w32 - d(2)))./c(2));
expr1918 = -angle(1 + (i.*(w32 + d(2)))./c(2));
expr1919 = -angle(1 + (i.*(w32 - d(3)))./c(3));
expr1920 = -angle(1 + (i.*(w32 + d(3)))./c(3));
expr1921 = -angle(1 + (i.*(w32 - d(4)))./c(4));
expr1922 = -angle(1 + (i.*(w32 + d(4)))./c(4));
expr1923 = expr1898 + expr1899 + expr606.*expr639.*(expr1900 + expr1901 + expr1902 + expr1905 + expr1906 + expr640 - (expr1903 + expr1904).*expr681).*w32;
expr1924 = 2.*expr1923.*expr636.*(expr1907 + expr1908 + expr1909 + expr1910 + expr1911 + expr1912 + expr1913 + expr1914 + expr1915 + expr1916 + expr1917 + expr1918 + expr1919 + expr1920 + expr1921 + expr1922 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w32).*Wph;
integrate32 = trapz(w32, expr1924);
expr1925 = sqrt(a(4).^2 + b(4).^2).^(-1);
expr1926 = a(4).^(-2);
expr1927 = (b(1) + b(4))./((a(1) - a(4)).^2.*(1 + (b(1) + b(4)).^2./(a(1) - a(4)).^2));
expr1928 = (b(2) + b(4))./((a(2) - a(4)).^2.*(1 + (b(2) + b(4)).^2./(a(2) - a(4)).^2));
expr1929 = (b(3) + b(4))./((a(3) - a(4)).^2.*(1 + (b(3) + b(4)).^2./(a(3) - a(4)).^2));
expr1930 = -((b(1) + b(4))./((-a(1) + a(4)).^2.*(1 + (b(1) + b(4)).^2./(-a(1) + a(4)).^2)));
expr1931 = -((b(2) + b(4))./((-a(2) + a(4)).^2.*(1 + (b(2) + b(4)).^2./(-a(2) + a(4)).^2)));
expr1932 = -((b(3) + b(4))./((-a(3) + a(4)).^2.*(1 + (b(3) + b(4)).^2./(-a(3) + a(4)).^2)));
expr1933 = (a(4) - c(1)).^(-2);
expr1934 = (1 + (b(4) - d(1)).^2./(a(4) - c(1)).^2).^(-1);
expr1935 = b(4) - d(1);
expr1936 = (b(4) + d(1))./((a(4) - c(1)).^2.*(1 + (b(4) + d(1)).^2./(a(4) - c(1)).^2));
expr1937 = (a(4) - c(2)).^(-2);
expr1938 = (1 + (b(4) - d(2)).^2./(a(4) - c(2)).^2).^(-1);
expr1939 = b(4) - d(2);
expr1940 = (b(4) + d(2))./((a(4) - c(2)).^2.*(1 + (b(4) + d(2)).^2./(a(4) - c(2)).^2));
expr1941 = (a(4) - c(3)).^(-2);
expr1942 = (1 + (b(4) - d(3)).^2./(a(4) - c(3)).^2).^(-1);
expr1943 = b(4) - d(3);
expr1944 = (b(4) + d(3))./((a(4) - c(3)).^2.*(1 + (b(4) + d(3)).^2./(a(4) - c(3)).^2));
expr1945 = (a(4) - c(4)).^(-2);
expr1946 = (1 + (b(4) - d(4)).^2./(a(4) - c(4)).^2).^(-1);
expr1947 = b(4) - d(4);
expr1948 = (b(4) + d(4))./((a(4) - c(4)).^2.*(1 + (b(4) + d(4)).^2./(a(4) - c(4)).^2));
expr1949 = 2.*a(4);
expr1950 = a(4) - c(4);
expr1951 = a(4) - c(3);
expr1952 = a(4) - c(2);
expr1953 = a(4) - c(1);
expr1954 = expr714.*(expr715.*expr716.*expr717.*expr718.*expr719.*expr720.*expr721.*expr722).^expr723.*(expr1925.*expr715.*expr716.*expr717.*expr719.*expr720.*expr721 - expr1926.*expr715.*expr716.*expr717.*expr719.*expr720.*expr721.*expr722).*WQ;
expr1955 = -2.*expr726.*expr727.*expr728.*expr729.*expr730.*expr782 - 2.*expr726.*expr727.*expr728.*expr729.*expr731.*expr782;
expr1956 = expr498.*(expr1927 + expr797.*expr798.*expr799).*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr1957 = -(expr482.*(expr1927 + expr797.*expr798.*expr799).*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497));
expr1958 = expr1927 + expr797.*expr798.*expr799;
expr1959 = (expr1222.*expr1223.*expr1224 + expr1928).*expr518.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr1960 = -((expr1222.*expr1223.*expr1224 + expr1928).*expr502.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517));
expr1961 = expr1222.*expr1223.*expr1224 + expr1928;
expr1962 = (expr1581.*expr1582.*expr1583 + expr1929).*expr538.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr1963 = -((expr1581.*expr1582.*expr1583 + expr1929).*expr522.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537));
expr1964 = expr1581.*expr1582.*expr1583 + expr1929;
expr1965 = -(expr1247.*expr1248.*expr1249) - expr1602.*expr1603.*expr1604 + expr1930 + expr1931 + expr1932 + expr1933.*expr1934.*expr1935 + expr1936 + expr1937.*expr1938.*expr1939 + expr1940 + expr1941.*expr1942.*expr1943 + expr1944 + expr1945.*expr1946.*expr1947 + expr1948 - expr826.*expr827.*expr828;
expr1966 = -2.*expr1251.*expr740.*expr741.*expr742.*expr743.*expr744 - 2.*expr1251.*expr740.*expr741.*expr742.*expr743.*expr745;
expr1967 = -2.*expr1606.*expr754.*expr755.*expr756.*expr757.*expr758 - 2.*expr1606.*expr754.*expr755.*expr756.*expr757.*expr759;
expr1968 = (expr774.*expr775.*expr776.*expr777.*expr778.*expr779.*expr780.*expr781).^expr600;
expr1969 = 2.*expr1950.*expr774.*expr775.*expr776.*expr777.*expr778.*expr779.*expr780;
expr1970 = 2.*expr1950.*expr774.*expr775.*expr776.*expr777.*expr778.*expr779.*expr781;
expr1971 = 2.*expr1951.*expr774.*expr775.*expr776.*expr777.*expr778.*expr780.*expr781;
expr1972 = 2.*expr1951.*expr774.*expr775.*expr776.*expr777.*expr779.*expr780.*expr781;
expr1973 = 2.*expr1952.*expr774.*expr775.*expr776.*expr778.*expr779.*expr780.*expr781;
expr1974 = 2.*expr1952.*expr774.*expr775.*expr777.*expr778.*expr779.*expr780.*expr781;
expr1975 = 2.*expr1953.*expr774.*expr776.*expr777.*expr778.*expr779.*expr780.*expr781;
expr1976 = 2.*expr1953.*expr775.*expr776.*expr777.*expr778.*expr779.*expr780.*expr781;
expr1977 = 2.*expr1611.*expr768.*expr769.*expr770.*expr771.*expr772;
expr1978 = 2.*expr1611.*expr768.*expr769.*expr770.*expr771.*expr773;
expr1979 = 2.*expr1258.*expr768.*expr769.*expr770.*expr772.*expr773;
expr1980 = 2.*expr1258.*expr768.*expr769.*expr771.*expr772.*expr773;
expr1981 = 2.*expr768.*expr770.*expr771.*expr772.*expr773.*expr833;
expr1982 = 2.*expr769.*expr770.*expr771.*expr772.*expr773.*expr833;
expr1983 = expr1956 + expr1957;
expr1984 = (expr1958.*expr482.*expr483.*expr563.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr1985 = -(((expr1956 + expr1957).*expr482.*expr483.*expr562.*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr1986 = -((expr482.*expr483.*expr562.*expr563.*(-(expr1958.*expr483.*expr498.*expr563.*expr864) + (expr1956 + expr1957).*expr483.*expr498.*expr562.*expr866))./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^2);
expr1987 = -(((expr1959 + expr1960).*expr502.*expr503.*expr564.*expr868)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr1988 = (expr1961.*expr502.*expr503.*expr565.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr1989 = -((expr502.*expr503.*expr564.*expr565.*((expr1959 + expr1960).*expr503.*expr518.*expr564.*expr868 - expr1961.*expr503.*expr518.*expr565.*expr870))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^2);
expr1990 = -(((expr1962 + expr1963).*expr522.*expr523.*expr566.*expr874)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr1991 = (expr1964.*expr522.*expr523.*expr567.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr1992 = -((expr522.*expr523.*expr566.*expr567.*((expr1962 + expr1963).*expr523.*expr538.*expr566.*expr874 - expr1964.*expr523.*expr538.*expr567.*expr876))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^2);
expr1993 = (2.*expr542.*expr558.*expr568.*expr569)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr1994 = (expr1965.*expr542.*expr543.*expr569.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr1995 = -((expr542.*expr543.*expr568.*expr880.*(expr568 - expr1965.*expr542.*expr568 + expr1965.*expr558.*expr882))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr1996 = (expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^(-2);
expr1997 = expr1949 - expr543.*expr568.*expr569 - 2.*expr559.*expr568.*expr569 - expr1965.*expr543.*expr558.*expr569.*expr882 + expr543.*expr558.*expr568.*expr880.*(expr568 - expr1965.*expr542.*expr568 + expr1965.*expr558.*expr882);
expr1998 = -(expr1958.*expr483.*expr563.*expr864) + (expr1956 + expr1957).*expr483.*expr562.*expr866;
expr1999 = expr1959 + expr1960;
expr2000 = (expr1959 + expr1960).*expr503.*expr564.*expr868 - expr1961.*expr503.*expr565.*expr870;
expr2001 = expr1962 + expr1963;
expr2002 = (expr1962 + expr1963).*expr523.*expr566.*expr874 - expr1964.*expr523.*expr567.*expr876;
expr2003 = expr1969 + expr1970 + expr1971 + expr1972 + expr1973 + expr1974 + expr1975 + expr1976;
expr2004 = expr568 - expr1965.*expr542.*expr568 + expr1965.*expr558.*expr882;
expr2005 = expr1977 + expr1978 + expr1979 + expr1980 + expr1981 + expr1982;
expr2006 = 1 - 2.*expr558.*expr568.*expr569 - expr1965.*expr543.*expr569.*expr882 + expr543.*expr568.*expr880.*(expr568 - expr1965.*expr542.*expr568 + expr1965.*expr558.*expr882);
expr2007 = (expr1984 + expr1985 + expr1986).*expr501.*expr898 + (expr1987 + expr1988 + expr1989).*expr521.*expr904 + (expr1990 + expr1991 + expr1992).*expr541.*expr908 + expr561.*(expr1993 + expr1994 + expr1995 - expr1996.*expr1997.*expr542.*expr543.*expr568.*expr569).*expr912;
expr2008 = -(expr1998.*expr501.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2009 = -(expr2000.*expr521.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2010 = -(expr2002.*expr541.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2011 = -(expr2006.*expr561.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2012 = expr1983.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*(1 + expr923);
expr2013 = 2.*expr501.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(1 + expr923);
expr2014 = expr1955.*expr501.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr836.*expr837.*expr847.*(1 + expr923);
expr2015 = expr1999.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*(1 + expr924);
expr2016 = 2.*expr483.*expr521.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(1 + expr924);
expr2017 = expr1966.*expr483.*expr521.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr839.*expr840.*expr885.*(1 + expr924);
expr2018 = expr2001.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*(1 + expr925);
expr2019 = 2.*expr483.*expr503.*expr541.*expr558.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(1 + expr925);
expr2020 = expr1967.*expr483.*expr503.*expr541.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr842.*expr843.*expr887.*(1 + expr925);
expr2021 = expr2004.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*(1 + expr926);
expr2022 = expr1968.*expr2003.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr615.*expr844.*expr846.*(1 + expr926);
expr2023 = expr2005.*expr483.*expr503.*expr523.*expr561.*expr600.*expr607.*expr608.*expr609.*expr610.*expr845.*expr846.*expr889.*(1 + expr926);
expr2024 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(expr2007.*expr498.*expr830.*expr927.*expr930.*tpc - expr927.*(expr2008 + expr2007.*expr830.*expr891.*expr931.*tpc + expr2007.*expr482.*expr830.*expr933.*tpc));
expr2025 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(expr2007.*expr518.*expr830.*expr934.*expr935.*tpc - expr934.*(expr2009 + expr2007.*expr830.*expr892.*expr936.*tpc + expr2007.*expr502.*expr830.*expr938.*tpc));
expr2026 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(expr2007.*expr538.*expr830.*expr939.*expr940.*tpc - expr939.*(expr2010 + expr2007.*expr830.*expr893.*expr941.*tpc + expr2007.*expr522.*expr830.*expr943.*tpc));
expr2027 = -(expr944.*expr945.*(expr928 + expr2007.*expr481.*expr558.*tpc)) - expr944.*(expr2011 + expr2007.*expr830.*expr894.*expr946.*tpc + expr2007.*expr542.*expr830.*expr948.*tpc);
expr2028 = 200.*(expr2012 + expr2013 + expr2014 + expr2015 + expr2016 + expr2017 + expr2018 + expr2019 + expr2020 + expr2021 + expr2022 + expr2023 + expr2024 + expr2025 + expr2026 + expr2027.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846).*(-1 + expr949 + expr950 + expr951 + expr952).*WO;
expr2029 = expr1954 + expr2028 + integrate29 + integrate30 + integrate31 + integrate32;
gf(4) = expr2029;

%% Derivative for b(4)
w33 = [ws:(99.*ws)./100:100.*ws];
expr2030 = ((a(1).^2 + b(1).^2).^2 + w33.^2.*(w33.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr2031 = ((a(2).^2 + b(2).^2).^2 + w33.^2.*(w33.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr2032 = ((a(3).^2 + b(3).^2).^2 + w33.^2.*(w33.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr2033 = -4.*w33.^2.*b(4) + 4.*b(4).*(a(4).^2 + b(4).^2);
expr2034 = ((a(4).^2 + b(4).^2).^2 + w33.^2.*(w33.^2 + 2.*(a(4).^2 - b(4).^2))).^(-2);
expr2035 = (c(1).^2 + d(1).^2).^2 + w33.^2.*(w33.^2 + 2.*(c(1).^2 - d(1).^2));
expr2036 = (c(2).^2 + d(2).^2).^2 + w33.^2.*(w33.^2 + 2.*(c(2).^2 - d(2).^2));
expr2037 = (c(3).^2 + d(3).^2).^2 + w33.^2.*(w33.^2 + 2.*(c(3).^2 - d(3).^2));
expr2038 = (c(4).^2 + d(4).^2).^2 + w33.^2.*(w33.^2 + 2.*(c(4).^2 - d(4).^2));
expr2039 = ((a(4).^2 + b(4).^2).^2 + w33.^2.*(w33.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr2040 = expr2030.*expr2031.*expr2032.*expr2033.*expr2034.*expr2035.*expr2036.*expr2037.*expr2038.*expr575.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*Wms;
expr2041 = expr2030.*expr2031.*expr2032.*expr2035.*expr2036.*expr2037.*expr2038.*expr2039.*expr542.*expr543.*expr576.*expr577.*expr580.*expr582.*expr586.*expr588.*expr590.*expr592.*expr594.*Wms;
expr2042 = expr2040 + expr2041;
integrate33 = trapz(w33, expr2042);
w34 = [0:wp./100:wp];
expr2043 = (a(1).^2 + b(1).^2).^2 + w34.^2.*(w34.^2 + 2.*(a(1).^2 - b(1).^2));
expr2044 = (a(2).^2 + b(2).^2).^2 + w34.^2.*(w34.^2 + 2.*(a(2).^2 - b(2).^2));
expr2045 = (a(3).^2 + b(3).^2).^2 + w34.^2.*(w34.^2 + 2.*(a(3).^2 - b(3).^2));
expr2046 = -4.*w34.^2.*b(4) + 4.*b(4).*(a(4).^2 + b(4).^2);
expr2047 = (a(4).^2 + b(4).^2).^2 + w34.^2.*(w34.^2 + 2.*(a(4).^2 - b(4).^2));
expr2048 = (c(1).^2 + d(1).^2).^2 + w34.^2.*(w34.^2 + 2.*(c(1).^2 - d(1).^2));
expr2049 = (c(2).^2 + d(2).^2).^2 + w34.^2.*(w34.^2 + 2.*(c(2).^2 - d(2).^2));
expr2050 = (c(3).^2 + d(3).^2).^2 + w34.^2.*(w34.^2 + 2.*(c(3).^2 - d(3).^2));
expr2051 = (c(4).^2 + d(4).^2).^2 + w34.^2.*(w34.^2 + 2.*(c(4).^2 - d(4).^2));
expr2052 = -1 + (expr2043.*expr2044.*expr2045.*expr2047).^expr600.*(expr2048.*expr2049.*expr2050.*expr2051).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr2053 = 2.*(expr2043.*expr2044.*expr2045.*expr2047).^expr600.*(expr2048.*expr2049.*expr2050.*expr2051).^expr615.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610;
expr2054 = expr2043.*expr2044.*expr2045.*expr2046.*(expr2043.*expr2044.*expr2045.*expr2047).^expr606.*(expr2048.*expr2049.*expr2050.*expr2051).^expr615.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr2055 = 2.*expr2052.*(expr2053 + expr2054).*expr599.*Wmp;
integrate34 = trapz(w34, expr2055);
w35 = [wp:(-wp + ws)./100:ws];
expr2056 = (a(1).^2 + b(1).^2).^2 + w35.^2.*(w35.^2 + 2.*(a(1).^2 - b(1).^2));
expr2057 = (a(2).^2 + b(2).^2).^2 + w35.^2.*(w35.^2 + 2.*(a(2).^2 - b(2).^2));
expr2058 = (a(3).^2 + b(3).^2).^2 + w35.^2.*(w35.^2 + 2.*(a(3).^2 - b(3).^2));
expr2059 = -4.*w35.^2.*b(4) + 4.*b(4).*(a(4).^2 + b(4).^2);
expr2060 = (a(4).^2 + b(4).^2).^2 + w35.^2.*(w35.^2 + 2.*(a(4).^2 - b(4).^2));
expr2061 = (c(1).^2 + d(1).^2).^2 + w35.^2.*(w35.^2 + 2.*(c(1).^2 - d(1).^2));
expr2062 = (c(2).^2 + d(2).^2).^2 + w35.^2.*(w35.^2 + 2.*(c(2).^2 - d(2).^2));
expr2063 = (c(3).^2 + d(3).^2).^2 + w35.^2.*(w35.^2 + 2.*(c(3).^2 - d(3).^2));
expr2064 = (c(4).^2 + d(4).^2).^2 + w35.^2.*(w35.^2 + 2.*(c(4).^2 - d(4).^2));
expr2065 = -(w35./(wp - ws));
expr2066 = 2.*(expr2056.*expr2057.*expr2058.*expr2060).^expr600.*(expr2061.*expr2062.*expr2063.*expr2064).^expr615.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610;
expr2067 = expr2056.*expr2057.*expr2058.*expr2059.*(expr2056.*expr2057.*expr2058.*expr2060).^expr606.*(expr2061.*expr2062.*expr2063.*expr2064).^expr615.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr2068 = expr2065 + (expr2056.*expr2057.*expr2058.*expr2060).^expr600.*(expr2061.*expr2062.*expr2063.*expr2064).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr631;
expr2069 = 2.*(expr2066 + expr2067).*expr2068.*expr620.*Wmt;
integrate35 = trapz(w35, expr2069);
w36 = [0:wmax./100:wmax];
expr2070 = -(1./(a(4).*(1 + (w36 - b(4)).^2./a(4).^2)));
expr2071 = 1./(a(4).*(1 + (w36 + b(4)).^2./a(4).^2));
expr2072 = -2.*(angle(1 + (i.*(wmax - b(4)))./a(4)) + angle(1 + (i.*(wmax + b(4)))./a(4))).*b(4);
expr2073 = (2.*(wmax - b(4)).*b(4))./(a(4).*(1 + (wmax - b(4)).^2./a(4).^2));
expr2074 = (2.*b(4).*(wmax + b(4)))./(a(4).*(1 + (wmax + b(4)).^2./a(4).^2));
expr2075 = -(1./(a(4).*(1 + (wmax - b(4)).^2./a(4).^2)));
expr2076 = 1./(a(4).*(1 + (wmax + b(4)).^2./a(4).^2));
expr2077 = -(a(4).*log(1 + (wmax - b(4)).^2./a(4).^2));
expr2078 = a(4).*log(1 + (wmax + b(4)).^2./a(4).^2);
expr2079 = angle(1 + (i.*(w36 - b(1)))./a(1));
expr2080 = angle(1 + (i.*(w36 + b(1)))./a(1));
expr2081 = angle(1 + (i.*(w36 - b(2)))./a(2));
expr2082 = angle(1 + (i.*(w36 + b(2)))./a(2));
expr2083 = angle(1 + (i.*(w36 - b(3)))./a(3));
expr2084 = angle(1 + (i.*(w36 + b(3)))./a(3));
expr2085 = angle(1 + (i.*(w36 - b(4)))./a(4));
expr2086 = angle(1 + (i.*(w36 + b(4)))./a(4));
expr2087 = -angle(1 + (i.*(w36 - d(1)))./c(1));
expr2088 = -angle(1 + (i.*(w36 + d(1)))./c(1));
expr2089 = -angle(1 + (i.*(w36 - d(2)))./c(2));
expr2090 = -angle(1 + (i.*(w36 + d(2)))./c(2));
expr2091 = -angle(1 + (i.*(w36 - d(3)))./c(3));
expr2092 = -angle(1 + (i.*(w36 + d(3)))./c(3));
expr2093 = -angle(1 + (i.*(w36 - d(4)))./c(4));
expr2094 = -angle(1 + (i.*(w36 + d(4)))./c(4));
expr2095 = expr2070 + expr2071 + expr606.*expr639.*(expr2072 + expr2073 + expr2074 + expr2077 + expr2078 - (expr2075 + expr2076).*expr681).*w36;
expr2096 = 2.*expr2095.*expr636.*(expr2079 + expr2080 + expr2081 + expr2082 + expr2083 + expr2084 + expr2085 + expr2086 + expr2087 + expr2088 + expr2089 + expr2090 + expr2091 + expr2092 + expr2093 + expr2094 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w36).*Wph;
integrate36 = trapz(w36, expr2096);
expr2097 = -(1./((a(1) - a(4)).*(1 + (b(1) - b(4)).^2./(a(1) - a(4)).^2)));
expr2098 = b(4).^(-2);
expr2099 = -(1./((a(2) - a(4)).*(1 + (b(2) - b(4)).^2./(a(2) - a(4)).^2)));
expr2100 = -(1./((a(3) - a(4)).*(1 + (b(3) - b(4)).^2./(a(3) - a(4)).^2)));
expr2101 = 1./((-a(1) + a(4)).*(1 + (-b(1) + b(4)).^2./(-a(1) + a(4)).^2));
expr2102 = 1./((-a(2) + a(4)).*(1 + (-b(2) + b(4)).^2./(-a(2) + a(4)).^2));
expr2103 = 1./((-a(3) + a(4)).*(1 + (-b(3) + b(4)).^2./(-a(3) + a(4)).^2));
expr2104 = -(1./((a(4) - c(1)).*(1 + (b(4) - d(1)).^2./(a(4) - c(1)).^2)));
expr2105 = -(1./((a(4) - c(1)).*(1 + (b(4) + d(1)).^2./(a(4) - c(1)).^2)));
expr2106 = -(1./((a(4) - c(2)).*(1 + (b(4) - d(2)).^2./(a(4) - c(2)).^2)));
expr2107 = -(1./((a(4) - c(2)).*(1 + (b(4) + d(2)).^2./(a(4) - c(2)).^2)));
expr2108 = -(1./((a(4) - c(3)).*(1 + (b(4) - d(3)).^2./(a(4) - c(3)).^2)));
expr2109 = -(1./((a(4) - c(3)).*(1 + (b(4) + d(3)).^2./(a(4) - c(3)).^2)));
expr2110 = -(1./((a(4) - c(4)).*(1 + (b(4) - d(4)).^2./(a(4) - c(4)).^2)));
expr2111 = -(1./((a(4) - c(4)).*(1 + (b(4) + d(4)).^2./(a(4) - c(4)).^2)));
expr2112 = 2.*b(4);
expr2113 = b(4) + d(4);
expr2114 = b(4) + d(3);
expr2115 = b(4) + d(2);
expr2116 = b(4) + d(1);
expr2117 = expr1925.*expr542.*expr714.*expr715.*expr716.*expr717.*expr718.*expr719.*expr720.*expr721.*(expr715.*expr716.*expr717.*expr718.*expr719.*expr720.*expr721.*expr722).^expr723.*WQ;
expr2118 = (expr1051 + expr2097).*expr498.*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr2119 = -((expr1051 + expr2097).*expr482.*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497));
expr2120 = 2.*expr1039.*expr726.*expr727.*expr728.*expr729.*expr730 - 2.*expr726.*expr727.*expr728.*expr729.*expr731.*expr799;
expr2121 = expr1051 + expr2097;
expr2122 = (expr1408 + expr2099).*expr518.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr2123 = -((expr1408 + expr2099).*expr502.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517));
expr2124 = expr1408 + expr2099;
expr2125 = (expr1761 + expr2100).*expr538.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr2126 = -((expr1761 + expr2100).*expr522.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537));
expr2127 = expr1761 + expr2100;
expr2128 = (expr1066 + expr1421 + expr1772 + expr2101 + expr2102 + expr2103 + expr2104 + expr2105 + expr2106 + expr2107 + expr2108 + expr2109 + expr2110 + expr2111).*expr558.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr2129 = -((expr1066 + expr1421 + expr1772 + expr2101 + expr2102 + expr2103 + expr2104 + expr2105 + expr2106 + expr2107 + expr2108 + expr2109 + expr2110 + expr2111).*expr542.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557));
expr2130 = expr1066 + expr1421 + expr1772 + expr2101 + expr2102 + expr2103 + expr2104 + expr2105 + expr2106 + expr2107 + expr2108 + expr2109 + expr2110 + expr2111;
expr2131 = 2.*expr1422.*expr740.*expr741.*expr742.*expr743.*expr744 - 2.*expr1224.*expr740.*expr741.*expr742.*expr743.*expr745;
expr2132 = 2.*expr1773.*expr754.*expr755.*expr756.*expr757.*expr758 - 2.*expr1583.*expr754.*expr755.*expr756.*expr757.*expr759;
expr2133 = 2.*expr2113.*expr774.*expr775.*expr776.*expr777.*expr778.*expr779.*expr780;
expr2134 = 2.*expr1947.*expr774.*expr775.*expr776.*expr777.*expr778.*expr779.*expr781;
expr2135 = 2.*expr2114.*expr774.*expr775.*expr776.*expr777.*expr778.*expr780.*expr781;
expr2136 = 2.*expr1943.*expr774.*expr775.*expr776.*expr777.*expr779.*expr780.*expr781;
expr2137 = 2.*expr2115.*expr774.*expr775.*expr776.*expr778.*expr779.*expr780.*expr781;
expr2138 = 2.*expr1939.*expr774.*expr775.*expr777.*expr778.*expr779.*expr780.*expr781;
expr2139 = 2.*expr2116.*expr774.*expr776.*expr777.*expr778.*expr779.*expr780.*expr781;
expr2140 = 2.*expr1935.*expr775.*expr776.*expr777.*expr778.*expr779.*expr780.*expr781;
expr2141 = 2.*expr1773.*expr768.*expr769.*expr770.*expr771.*expr772;
expr2142 = 2.*expr1603.*expr768.*expr769.*expr770.*expr771.*expr773;
expr2143 = 2.*expr1422.*expr768.*expr769.*expr770.*expr772.*expr773;
expr2144 = 2.*expr1248.*expr768.*expr769.*expr771.*expr772.*expr773;
expr2145 = 2.*expr1039.*expr768.*expr770.*expr771.*expr772.*expr773;
expr2146 = 2.*expr769.*expr770.*expr771.*expr772.*expr773.*expr827;
expr2147 = expr2118 + expr2119;
expr2148 = (expr2121.*expr482.*expr483.*expr563.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr2149 = -(((expr2118 + expr2119).*expr482.*expr483.*expr562.*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr2150 = -((expr482.*expr483.*expr562.*expr563.*(-(expr2121.*expr483.*expr498.*expr563.*expr864) + (expr2118 + expr2119).*expr483.*expr498.*expr562.*expr866))./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^2);
expr2151 = -(((expr2122 + expr2123).*expr502.*expr503.*expr564.*expr868)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr2152 = (expr2124.*expr502.*expr503.*expr565.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr2153 = -((expr502.*expr503.*expr564.*expr565.*((expr2122 + expr2123).*expr503.*expr518.*expr564.*expr868 - expr2124.*expr503.*expr518.*expr565.*expr870))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^2);
expr2154 = -(((expr2125 + expr2126).*expr522.*expr523.*expr566.*expr874)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr2155 = (expr2127.*expr522.*expr523.*expr567.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr2156 = -((expr522.*expr523.*expr566.*expr567.*((expr2125 + expr2126).*expr523.*expr538.*expr566.*expr874 - expr2127.*expr523.*expr538.*expr567.*expr876))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^2);
expr2157 = (expr543.*expr568.*expr569)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr2158 = (2.*expr560.*expr568.*expr569)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr2159 = (expr2130.*expr542.*expr543.*expr569.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr2160 = -((expr542.*expr543.*expr568.*expr880.*(expr2128 + expr2129 + expr882))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr2161 = expr2112 - 2.*expr542.*expr558.*expr568.*expr569 - expr2130.*expr543.*expr558.*expr569.*expr882 + expr543.*expr558.*expr568.*expr880.*(expr2128 + expr2129 + expr882);
expr2162 = expr2098.*(pi - angle(1 + (expr542.*expr543.*expr568.*expr569.*i)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569)));
expr2163 = -(expr2121.*expr483.*expr563.*expr864) + (expr2118 + expr2119).*expr483.*expr562.*expr866;
expr2164 = expr2122 + expr2123;
expr2165 = (expr2122 + expr2123).*expr503.*expr564.*expr868 - expr2124.*expr503.*expr565.*expr870;
expr2166 = expr2125 + expr2126;
expr2167 = (expr2125 + expr2126).*expr523.*expr566.*expr874 - expr2127.*expr523.*expr567.*expr876;
expr2168 = expr2133 + expr2134 + expr2135 + expr2136 + expr2137 + expr2138 + expr2139 + expr2140;
expr2169 = expr2128 + expr2129 + expr882;
expr2170 = expr2141 + expr2142 + expr2143 + expr2144 + expr2145 + expr2146;
expr2171 = -2.*expr542.*expr568.*expr569 - expr2130.*expr543.*expr569.*expr882 + expr543.*expr568.*expr880.*(expr2128 + expr2129 + expr882);
expr2172 = expr2162 + (expr2148 + expr2149 + expr2150).*expr501.*expr898 + (expr2151 + expr2152 + expr2153).*expr521.*expr904 + (expr2154 + expr2155 + expr2156).*expr541.*expr908 + expr561.*(expr2157 + expr2158 + expr2159 + expr2160 - expr1996.*expr2161.*expr542.*expr543.*expr568.*expr569).*expr912;
expr2173 = -(expr2163.*expr501.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2174 = -(expr2165.*expr521.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2175 = -(expr2167.*expr541.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2176 = -(expr2171.*expr561.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2177 = expr2098.*expr894.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc);
expr2178 = expr2147.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*(1 + expr923);
expr2179 = 2.*expr501.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(1 + expr923);
expr2180 = expr2120.*expr501.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr836.*expr837.*expr847.*(1 + expr923);
expr2181 = expr2164.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*(1 + expr924);
expr2182 = 2.*expr483.*expr521.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(1 + expr924);
expr2183 = expr2131.*expr483.*expr521.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr839.*expr840.*expr885.*(1 + expr924);
expr2184 = expr2166.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*(1 + expr925);
expr2185 = 2.*expr483.*expr503.*expr541.*expr542.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(1 + expr925);
expr2186 = expr2132.*expr483.*expr503.*expr541.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610.*expr842.*expr843.*expr887.*(1 + expr925);
expr2187 = expr2169.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*(1 + expr926);
expr2188 = expr1968.*expr2168.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr615.*expr844.*expr846.*(1 + expr926);
expr2189 = -(expr2098.*expr483.*expr503.*expr523.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(1 + expr926));
expr2190 = expr2170.*expr483.*expr503.*expr523.*expr561.*expr600.*expr607.*expr608.*expr609.*expr610.*expr845.*expr846.*expr889.*(1 + expr926);
expr2191 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(expr2172.*expr498.*expr830.*expr927.*expr930.*tpc - expr927.*(expr2173 + expr2172.*expr830.*expr891.*expr931.*tpc + expr2172.*expr482.*expr830.*expr933.*tpc));
expr2192 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(expr2172.*expr518.*expr830.*expr934.*expr935.*tpc - expr934.*(expr2174 + expr2172.*expr830.*expr892.*expr936.*tpc + expr2172.*expr502.*expr830.*expr938.*tpc));
expr2193 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(expr2172.*expr538.*expr830.*expr939.*expr940.*tpc - expr939.*(expr2175 + expr2172.*expr830.*expr893.*expr941.*tpc + expr2172.*expr522.*expr830.*expr943.*tpc));
expr2194 = expr2172.*expr558.*expr830.*expr944.*expr945.*tpc - expr944.*(expr2176 + expr2177 - expr561.*expr894.*expr946.*(expr928 + expr2172.*expr481.*expr542.*tpc) - expr948.*(expr928 + expr2172.*expr481.*expr542.*tpc));
expr2195 = 200.*(expr2178 + expr2179 + expr2180 + expr2181 + expr2182 + expr2183 + expr2184 + expr2185 + expr2186 + expr2187 + expr2188 + expr2189 + expr2190 + expr2191 + expr2192 + expr2193 + expr2194.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846).*(-1 + expr949 + expr950 + expr951 + expr952).*WO;
expr2196 = expr2117 + expr2195 + integrate33 + integrate34 + integrate35 + integrate36;
gf(8) = expr2196;

%% Derivative for c(1)
w37 = [ws:(99.*ws)./100:100.*ws];
expr2197 = 1./99;
expr2198 = ((a(1).^2 + b(1).^2).^2 + w37.^2.*(w37.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr2199 = ((a(2).^2 + b(2).^2).^2 + w37.^2.*(w37.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr2200 = ((a(3).^2 + b(3).^2).^2 + w37.^2.*(w37.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr2201 = ((a(4).^2 + b(4).^2).^2 + w37.^2.*(w37.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr2202 = 4.*w37.^2.*c(1) + 4.*c(1).*(c(1).^2 + d(1).^2);
expr2203 = (c(2).^2 + d(2).^2).^2 + w37.^2.*(w37.^2 + 2.*(c(2).^2 - d(2).^2));
expr2204 = (c(3).^2 + d(3).^2).^2 + w37.^2.*(w37.^2 + 2.*(c(3).^2 - d(3).^2));
expr2205 = (c(4).^2 + d(4).^2).^2 + w37.^2.*(w37.^2 + 2.*(c(4).^2 - d(4).^2));
expr2206 = -4./99;
expr2207 = c(1);
expr2208 = (c(1).^2 + d(1).^2).^(-3);
expr2209 = (c(1).^2 + d(1).^2).^2 + w37.^2.*(w37.^2 + 2.*(c(1).^2 - d(1).^2));
expr2210 = expr2198.*expr2199.*expr2200.*expr2201.*expr2203.*expr2204.*expr2205.*expr2206.*expr2207.*expr2208.*expr2209.*expr576.*expr577.*expr580.*expr582.*expr584.*expr588.*expr590.*expr592.*Wms;
expr2211 = expr2197.*expr2198.*expr2199.*expr2200.*expr2201.*expr2202.*expr2203.*expr2204.*expr2205.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*Wms;
expr2212 = expr2210 + expr2211;
integrate37 = trapz(w37, expr2212);
w38 = [0:wp./100:wp];
expr2213 = (a(1).^2 + b(1).^2).^2 + w38.^2.*(w38.^2 + 2.*(a(1).^2 - b(1).^2));
expr2214 = (a(2).^2 + b(2).^2).^2 + w38.^2.*(w38.^2 + 2.*(a(2).^2 - b(2).^2));
expr2215 = (a(3).^2 + b(3).^2).^2 + w38.^2.*(w38.^2 + 2.*(a(3).^2 - b(3).^2));
expr2216 = (a(4).^2 + b(4).^2).^2 + w38.^2.*(w38.^2 + 2.*(a(4).^2 - b(4).^2));
expr2217 = 4.*w38.^2.*c(1) + 4.*c(1).*(c(1).^2 + d(1).^2);
expr2218 = (c(2).^2 + d(2).^2).^2 + w38.^2.*(w38.^2 + 2.*(c(2).^2 - d(2).^2));
expr2219 = (c(3).^2 + d(3).^2).^2 + w38.^2.*(w38.^2 + 2.*(c(3).^2 - d(3).^2));
expr2220 = (c(4).^2 + d(4).^2).^2 + w38.^2.*(w38.^2 + 2.*(c(4).^2 - d(4).^2));
expr2221 = (c(1).^2 + d(1).^2).^2 + w38.^2.*(w38.^2 + 2.*(c(1).^2 - d(1).^2));
expr2222 = -1 + (expr2213.*expr2214.*expr2215.*expr2216).^expr600.*(expr2218.*expr2219.*expr2220.*expr2221).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr2223 = -2.*expr2207.*(expr2213.*expr2214.*expr2215.*expr2216).^expr600.*(expr2218.*expr2219.*expr2220.*expr2221).^expr615.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610;
expr2224 = (expr2213.*expr2214.*expr2215.*expr2216).^expr600.*expr2217.*expr2218.*expr2219.*expr2220.*(expr2218.*expr2219.*expr2220.*expr2221).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr2225 = 2.*expr2222.*(expr2223 + expr2224).*expr599.*Wmp;
integrate38 = trapz(w38, expr2225);
w39 = [wp:(-wp + ws)./100:ws];
expr2226 = (a(1).^2 + b(1).^2).^2 + w39.^2.*(w39.^2 + 2.*(a(1).^2 - b(1).^2));
expr2227 = (a(2).^2 + b(2).^2).^2 + w39.^2.*(w39.^2 + 2.*(a(2).^2 - b(2).^2));
expr2228 = (a(3).^2 + b(3).^2).^2 + w39.^2.*(w39.^2 + 2.*(a(3).^2 - b(3).^2));
expr2229 = (a(4).^2 + b(4).^2).^2 + w39.^2.*(w39.^2 + 2.*(a(4).^2 - b(4).^2));
expr2230 = 4.*w39.^2.*c(1) + 4.*c(1).*(c(1).^2 + d(1).^2);
expr2231 = (c(2).^2 + d(2).^2).^2 + w39.^2.*(w39.^2 + 2.*(c(2).^2 - d(2).^2));
expr2232 = (c(3).^2 + d(3).^2).^2 + w39.^2.*(w39.^2 + 2.*(c(3).^2 - d(3).^2));
expr2233 = (c(4).^2 + d(4).^2).^2 + w39.^2.*(w39.^2 + 2.*(c(4).^2 - d(4).^2));
expr2234 = (c(1).^2 + d(1).^2).^2 + w39.^2.*(w39.^2 + 2.*(c(1).^2 - d(1).^2));
expr2235 = -(w39./(wp - ws));
expr2236 = -2.*expr2207.*(expr2226.*expr2227.*expr2228.*expr2229).^expr600.*(expr2231.*expr2232.*expr2233.*expr2234).^expr615.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610;
expr2237 = (expr2226.*expr2227.*expr2228.*expr2229).^expr600.*expr2230.*expr2231.*expr2232.*expr2233.*(expr2231.*expr2232.*expr2233.*expr2234).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr2238 = expr2235 + (expr2226.*expr2227.*expr2228.*expr2229).^expr600.*(expr2231.*expr2232.*expr2233.*expr2234).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr631;
expr2239 = 2.*(expr2236 + expr2237).*expr2238.*expr620.*Wmt;
integrate39 = trapz(w39, expr2239);
w40 = [0:wmax./100:wmax];
expr2240 = (w40 - d(1))./(c(1).^2.*(1 + (w40 - d(1)).^2./c(1).^2));
expr2241 = (w40 + d(1))./(c(1).^2.*(1 + (w40 + d(1)).^2./c(1).^2));
expr2242 = 2.*wmax;
expr2243 = -2.*(angle(1 + (i.*(wmax - d(1)))./c(1)) + angle(1 + (i.*(wmax + d(1)))./c(1))).*c(1);
expr2244 = (-2.*(wmax - d(1)).^2.*d(1))./(c(1).^2.*(1 + (wmax - d(1)).^2./c(1).^2));
expr2245 = (2.*d(1).*(wmax + d(1)).^2)./(c(1).^2.*(1 + (wmax + d(1)).^2./c(1).^2));
expr2246 = -((wmax - d(1))./(c(1).^2.*(1 + (wmax - d(1)).^2./c(1).^2)));
expr2247 = -((wmax + d(1))./(c(1).^2.*(1 + (wmax + d(1)).^2./c(1).^2)));
expr2248 = d(1).*log(1 + (wmax - d(1)).^2./c(1).^2);
expr2249 = -(d(1).*log(1 + (wmax + d(1)).^2./c(1).^2));
expr2250 = angle(1 + (i.*(w40 - b(1)))./a(1));
expr2251 = angle(1 + (i.*(w40 + b(1)))./a(1));
expr2252 = angle(1 + (i.*(w40 - b(2)))./a(2));
expr2253 = angle(1 + (i.*(w40 + b(2)))./a(2));
expr2254 = angle(1 + (i.*(w40 - b(3)))./a(3));
expr2255 = angle(1 + (i.*(w40 + b(3)))./a(3));
expr2256 = angle(1 + (i.*(w40 - b(4)))./a(4));
expr2257 = angle(1 + (i.*(w40 + b(4)))./a(4));
expr2258 = -angle(1 + (i.*(w40 - d(1)))./c(1));
expr2259 = -angle(1 + (i.*(w40 + d(1)))./c(1));
expr2260 = -angle(1 + (i.*(w40 - d(2)))./c(2));
expr2261 = -angle(1 + (i.*(w40 + d(2)))./c(2));
expr2262 = -angle(1 + (i.*(w40 - d(3)))./c(3));
expr2263 = -angle(1 + (i.*(w40 + d(3)))./c(3));
expr2264 = -angle(1 + (i.*(w40 - d(4)))./c(4));
expr2265 = -angle(1 + (i.*(w40 + d(4)))./c(4));
expr2266 = expr2240 + expr2241 + expr606.*expr639.*(expr2242 + expr2243 + expr2244 + expr2245 + expr2248 + expr2249 + (expr2246 + expr2247).*expr686).*w40;
expr2267 = 2.*expr2266.*expr636.*(expr2250 + expr2251 + expr2252 + expr2253 + expr2254 + expr2255 + expr2256 + expr2257 + expr2258 + expr2259 + expr2260 + expr2261 + expr2262 + expr2263 + expr2264 + expr2265 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w40).*Wph;
integrate40 = trapz(w40, expr2267);
expr2268 = -((b(1) + d(1))./((a(1) - c(1)).^2.*(1 + (b(1) + d(1)).^2./(a(1) - c(1)).^2)));
expr2269 = -((b(2) + d(1))./((a(2) - c(1)).^2.*(1 + (b(2) + d(1)).^2./(a(2) - c(1)).^2)));
expr2270 = -((b(3) + d(1))./((a(3) - c(1)).^2.*(1 + (b(3) + d(1)).^2./(a(3) - c(1)).^2)));
expr2271 = -((b(4) + d(1))./((a(4) - c(1)).^2.*(1 + (b(4) + d(1)).^2./(a(4) - c(1)).^2)));
expr2272 = -2.*expr732.*expr734.*expr735.*expr736.*expr737.*expr738.*expr739.*expr788 - 2.*expr733.*expr734.*expr735.*expr736.*expr737.*expr738.*expr739.*expr788;
expr2273 = expr498.*(expr2268 - expr801.*expr802.*expr803).*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr2274 = -(expr482.*(expr2268 - expr801.*expr802.*expr803).*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497));
expr2275 = expr2268 - expr801.*expr802.*expr803;
expr2276 = (-(expr1226.*expr1227.*expr1228) + expr2269).*expr518.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr2277 = -((-(expr1226.*expr1227.*expr1228) + expr2269).*expr502.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517));
expr2278 = -(expr1226.*expr1227.*expr1228) + expr2269;
expr2279 = (-(expr1585.*expr1586.*expr1587) + expr2270).*expr538.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr2280 = -((-(expr1585.*expr1586.*expr1587) + expr2270).*expr522.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537));
expr2281 = -(expr1585.*expr1586.*expr1587) + expr2270;
expr2282 = (-(expr1933.*expr1934.*expr1935) + expr2271).*expr558.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr2283 = -((-(expr1933.*expr1934.*expr1935) + expr2271).*expr542.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557));
expr2284 = -(expr1933.*expr1934.*expr1935) + expr2271;
expr2285 = -2.*expr1256.*expr746.*expr748.*expr749.*expr750.*expr751.*expr752.*expr753 - 2.*expr1256.*expr747.*expr748.*expr749.*expr750.*expr751.*expr752.*expr753;
expr2286 = -2.*expr1610.*expr760.*expr762.*expr763.*expr764.*expr765.*expr766.*expr767 - 2.*expr1610.*expr761.*expr762.*expr763.*expr764.*expr765.*expr766.*expr767;
expr2287 = -2.*expr1953.*expr774.*expr776.*expr777.*expr778.*expr779.*expr780.*expr781 - 2.*expr1953.*expr775.*expr776.*expr777.*expr778.*expr779.*expr780.*expr781;
expr2288 = expr2273 + expr2274;
expr2289 = (expr2275.*expr482.*expr483.*expr563.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr2290 = -(((expr2273 + expr2274).*expr482.*expr483.*expr562.*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr2291 = -((expr482.*expr483.*expr562.*expr563.*(-(expr2275.*expr483.*expr498.*expr563.*expr864) + (expr2273 + expr2274).*expr483.*expr498.*expr562.*expr866))./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^2);
expr2292 = -(((expr2276 + expr2277).*expr502.*expr503.*expr564.*expr868)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr2293 = (expr2278.*expr502.*expr503.*expr565.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr2294 = -((expr502.*expr503.*expr564.*expr565.*((expr2276 + expr2277).*expr503.*expr518.*expr564.*expr868 - expr2278.*expr503.*expr518.*expr565.*expr870))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^2);
expr2295 = -(((expr2279 + expr2280).*expr522.*expr523.*expr566.*expr874)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr2296 = (expr2281.*expr522.*expr523.*expr567.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr2297 = -((expr522.*expr523.*expr566.*expr567.*((expr2279 + expr2280).*expr523.*expr538.*expr566.*expr874 - expr2281.*expr523.*expr538.*expr567.*expr876))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^2);
expr2298 = -(((expr2282 + expr2283).*expr542.*expr543.*expr568.*expr880)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr2299 = (expr2284.*expr542.*expr543.*expr569.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr2300 = -((expr542.*expr543.*expr568.*expr569.*((expr2282 + expr2283).*expr543.*expr558.*expr568.*expr880 - expr2284.*expr543.*expr558.*expr569.*expr882))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^2);
expr2301 = -(expr2275.*expr483.*expr563.*expr864) + (expr2273 + expr2274).*expr483.*expr562.*expr866;
expr2302 = expr2276 + expr2277;
expr2303 = (expr2276 + expr2277).*expr503.*expr564.*expr868 - expr2278.*expr503.*expr565.*expr870;
expr2304 = expr2279 + expr2280;
expr2305 = (expr2279 + expr2280).*expr523.*expr566.*expr874 - expr2281.*expr523.*expr567.*expr876;
expr2306 = expr2282 + expr2283;
expr2307 = (expr2282 + expr2283).*expr543.*expr568.*expr880 - expr2284.*expr543.*expr569.*expr882;
expr2308 = (expr2289 + expr2290 + expr2291).*expr501.*expr898 + (expr2292 + expr2293 + expr2294).*expr521.*expr904 + (expr2295 + expr2296 + expr2297).*expr541.*expr908 + (expr2298 + expr2299 + expr2300).*expr561.*expr912;
expr2309 = -(expr2301.*expr501.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2310 = -(expr2303.*expr521.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2311 = -(expr2305.*expr541.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2312 = -(expr2307.*expr561.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2313 = expr2288.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*(1 + expr923);
expr2314 = -2.*expr2207.*expr501.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(1 + expr923);
expr2315 = expr2272.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr835.*expr837.*expr854.*(1 + expr923);
expr2316 = expr2302.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*(1 + expr924);
expr2317 = expr1271.*expr2285.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr838.*expr840.*(1 + expr924);
expr2318 = -2.*expr2207.*expr483.*expr521.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(1 + expr924);
expr2319 = expr2304.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*(1 + expr925);
expr2320 = expr1625.*expr2286.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr841.*expr843.*(1 + expr925);
expr2321 = -2.*expr2207.*expr483.*expr503.*expr541.*expr543.*expr586.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(1 + expr925);
expr2322 = expr2306.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*(1 + expr926);
expr2323 = expr1968.*expr2287.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr615.*expr844.*expr846.*(1 + expr926);
expr2324 = -2.*expr2207.*expr483.*expr503.*expr523.*expr561.*expr586.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(1 + expr926);
expr2325 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(expr2308.*expr498.*expr830.*expr927.*expr930.*tpc - expr927.*(expr2309 + expr2308.*expr830.*expr891.*expr931.*tpc + expr2308.*expr482.*expr830.*expr933.*tpc));
expr2326 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(expr2308.*expr518.*expr830.*expr934.*expr935.*tpc - expr934.*(expr2310 + expr2308.*expr830.*expr892.*expr936.*tpc + expr2308.*expr502.*expr830.*expr938.*tpc));
expr2327 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(expr2308.*expr538.*expr830.*expr939.*expr940.*tpc - expr939.*(expr2311 + expr2308.*expr830.*expr893.*expr941.*tpc + expr2308.*expr522.*expr830.*expr943.*tpc));
expr2328 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(expr2308.*expr558.*expr830.*expr944.*expr945.*tpc - expr944.*(expr2312 + expr2308.*expr830.*expr894.*expr946.*tpc + expr2308.*expr542.*expr830.*expr948.*tpc));
expr2329 = integrate37 + integrate38 + integrate39 + integrate40 + 200.*(expr2313 + expr2314 + expr2315 + expr2316 + expr2317 + expr2318 + expr2319 + expr2320 + expr2321 + expr2322 + expr2323 + expr2324 + expr2325 + expr2326 + expr2327 + expr2328).*(-1 + expr949 + expr950 + expr951 + expr952).*WO;
gf(9) = expr2329;

%% Derivative for d(1)
w41 = [ws:(99.*ws)./100:100.*ws];
expr2330 = ((a(1).^2 + b(1).^2).^2 + w41.^2.*(w41.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr2331 = ((a(2).^2 + b(2).^2).^2 + w41.^2.*(w41.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr2332 = ((a(3).^2 + b(3).^2).^2 + w41.^2.*(w41.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr2333 = ((a(4).^2 + b(4).^2).^2 + w41.^2.*(w41.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr2334 = -4.*w41.^2.*d(1) + 4.*d(1).*(c(1).^2 + d(1).^2);
expr2335 = (c(2).^2 + d(2).^2).^2 + w41.^2.*(w41.^2 + 2.*(c(2).^2 - d(2).^2));
expr2336 = (c(3).^2 + d(3).^2).^2 + w41.^2.*(w41.^2 + 2.*(c(3).^2 - d(3).^2));
expr2337 = (c(4).^2 + d(4).^2).^2 + w41.^2.*(w41.^2 + 2.*(c(4).^2 - d(4).^2));
expr2338 = d(1);
expr2339 = (c(1).^2 + d(1).^2).^2 + w41.^2.*(w41.^2 + 2.*(c(1).^2 - d(1).^2));
expr2340 = expr2206.*expr2208.*expr2330.*expr2331.*expr2332.*expr2333.*expr2335.*expr2336.*expr2337.*expr2338.*expr2339.*expr576.*expr577.*expr580.*expr582.*expr584.*expr588.*expr590.*expr592.*Wms;
expr2341 = expr2197.*expr2330.*expr2331.*expr2332.*expr2333.*expr2334.*expr2335.*expr2336.*expr2337.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*Wms;
expr2342 = expr2340 + expr2341;
integrate41 = trapz(w41, expr2342);
w42 = [0:wp./100:wp];
expr2343 = (a(1).^2 + b(1).^2).^2 + w42.^2.*(w42.^2 + 2.*(a(1).^2 - b(1).^2));
expr2344 = (a(2).^2 + b(2).^2).^2 + w42.^2.*(w42.^2 + 2.*(a(2).^2 - b(2).^2));
expr2345 = (a(3).^2 + b(3).^2).^2 + w42.^2.*(w42.^2 + 2.*(a(3).^2 - b(3).^2));
expr2346 = (a(4).^2 + b(4).^2).^2 + w42.^2.*(w42.^2 + 2.*(a(4).^2 - b(4).^2));
expr2347 = -4.*w42.^2.*d(1) + 4.*d(1).*(c(1).^2 + d(1).^2);
expr2348 = (c(2).^2 + d(2).^2).^2 + w42.^2.*(w42.^2 + 2.*(c(2).^2 - d(2).^2));
expr2349 = (c(3).^2 + d(3).^2).^2 + w42.^2.*(w42.^2 + 2.*(c(3).^2 - d(3).^2));
expr2350 = (c(4).^2 + d(4).^2).^2 + w42.^2.*(w42.^2 + 2.*(c(4).^2 - d(4).^2));
expr2351 = (c(1).^2 + d(1).^2).^2 + w42.^2.*(w42.^2 + 2.*(c(1).^2 - d(1).^2));
expr2352 = -1 + (expr2343.*expr2344.*expr2345.*expr2346).^expr600.*(expr2348.*expr2349.*expr2350.*expr2351).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr2353 = -2.*expr2338.*(expr2343.*expr2344.*expr2345.*expr2346).^expr600.*(expr2348.*expr2349.*expr2350.*expr2351).^expr615.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610;
expr2354 = (expr2343.*expr2344.*expr2345.*expr2346).^expr600.*expr2347.*expr2348.*expr2349.*expr2350.*(expr2348.*expr2349.*expr2350.*expr2351).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr2355 = 2.*expr2352.*(expr2353 + expr2354).*expr599.*Wmp;
integrate42 = trapz(w42, expr2355);
w43 = [wp:(-wp + ws)./100:ws];
expr2356 = (a(1).^2 + b(1).^2).^2 + w43.^2.*(w43.^2 + 2.*(a(1).^2 - b(1).^2));
expr2357 = (a(2).^2 + b(2).^2).^2 + w43.^2.*(w43.^2 + 2.*(a(2).^2 - b(2).^2));
expr2358 = (a(3).^2 + b(3).^2).^2 + w43.^2.*(w43.^2 + 2.*(a(3).^2 - b(3).^2));
expr2359 = (a(4).^2 + b(4).^2).^2 + w43.^2.*(w43.^2 + 2.*(a(4).^2 - b(4).^2));
expr2360 = -4.*w43.^2.*d(1) + 4.*d(1).*(c(1).^2 + d(1).^2);
expr2361 = (c(2).^2 + d(2).^2).^2 + w43.^2.*(w43.^2 + 2.*(c(2).^2 - d(2).^2));
expr2362 = (c(3).^2 + d(3).^2).^2 + w43.^2.*(w43.^2 + 2.*(c(3).^2 - d(3).^2));
expr2363 = (c(4).^2 + d(4).^2).^2 + w43.^2.*(w43.^2 + 2.*(c(4).^2 - d(4).^2));
expr2364 = (c(1).^2 + d(1).^2).^2 + w43.^2.*(w43.^2 + 2.*(c(1).^2 - d(1).^2));
expr2365 = -(w43./(wp - ws));
expr2366 = -2.*expr2338.*(expr2356.*expr2357.*expr2358.*expr2359).^expr600.*(expr2361.*expr2362.*expr2363.*expr2364).^expr615.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610;
expr2367 = (expr2356.*expr2357.*expr2358.*expr2359).^expr600.*expr2360.*expr2361.*expr2362.*expr2363.*(expr2361.*expr2362.*expr2363.*expr2364).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr2368 = expr2365 + (expr2356.*expr2357.*expr2358.*expr2359).^expr600.*(expr2361.*expr2362.*expr2363.*expr2364).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr631;
expr2369 = 2.*(expr2366 + expr2367).*expr2368.*expr620.*Wmt;
integrate43 = trapz(w43, expr2369);
w44 = [0:wmax./100:wmax];
expr2370 = 1./(c(1).*(1 + (w44 - d(1)).^2./c(1).^2));
expr2371 = -(1./(c(1).*(1 + (w44 + d(1)).^2./c(1).^2)));
expr2372 = 2.*(angle(1 + (i.*(wmax - d(1)))./c(1)) + angle(1 + (i.*(wmax + d(1)))./c(1))).*d(1);
expr2373 = (-2.*(wmax - d(1)).*d(1))./(c(1).*(1 + (wmax - d(1)).^2./c(1).^2));
expr2374 = (-2.*d(1).*(wmax + d(1)))./(c(1).*(1 + (wmax + d(1)).^2./c(1).^2));
expr2375 = -(1./(c(1).*(1 + (wmax - d(1)).^2./c(1).^2)));
expr2376 = 1./(c(1).*(1 + (wmax + d(1)).^2./c(1).^2));
expr2377 = c(1).*log(1 + (wmax - d(1)).^2./c(1).^2);
expr2378 = -(c(1).*log(1 + (wmax + d(1)).^2./c(1).^2));
expr2379 = angle(1 + (i.*(w44 - b(1)))./a(1));
expr2380 = angle(1 + (i.*(w44 + b(1)))./a(1));
expr2381 = angle(1 + (i.*(w44 - b(2)))./a(2));
expr2382 = angle(1 + (i.*(w44 + b(2)))./a(2));
expr2383 = angle(1 + (i.*(w44 - b(3)))./a(3));
expr2384 = angle(1 + (i.*(w44 + b(3)))./a(3));
expr2385 = angle(1 + (i.*(w44 - b(4)))./a(4));
expr2386 = angle(1 + (i.*(w44 + b(4)))./a(4));
expr2387 = -angle(1 + (i.*(w44 - d(1)))./c(1));
expr2388 = -angle(1 + (i.*(w44 + d(1)))./c(1));
expr2389 = -angle(1 + (i.*(w44 - d(2)))./c(2));
expr2390 = -angle(1 + (i.*(w44 + d(2)))./c(2));
expr2391 = -angle(1 + (i.*(w44 - d(3)))./c(3));
expr2392 = -angle(1 + (i.*(w44 + d(3)))./c(3));
expr2393 = -angle(1 + (i.*(w44 - d(4)))./c(4));
expr2394 = -angle(1 + (i.*(w44 + d(4)))./c(4));
expr2395 = expr2370 + expr2371 + expr606.*expr639.*(expr2372 + expr2373 + expr2374 + expr2377 + expr2378 + (expr2375 + expr2376).*expr686).*w44;
expr2396 = 2.*expr2395.*expr636.*(expr2379 + expr2380 + expr2381 + expr2382 + expr2383 + expr2384 + expr2385 + expr2386 + expr2387 + expr2388 + expr2389 + expr2390 + expr2391 + expr2392 + expr2393 + expr2394 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w44).*Wph;
integrate44 = trapz(w44, expr2396);
expr2397 = 1./((a(1) - c(1)).*(1 + (b(1) - d(1)).^2./(a(1) - c(1)).^2));
expr2398 = 1./((a(2) - c(1)).*(1 + (b(2) - d(1)).^2./(a(2) - c(1)).^2));
expr2399 = 1./((a(3) - c(1)).*(1 + (b(3) - d(1)).^2./(a(3) - c(1)).^2));
expr2400 = 1./((a(4) - c(1)).*(1 + (b(4) - d(1)).^2./(a(4) - c(1)).^2));
expr2401 = (expr1053 + expr2397).*expr498.*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr2402 = -((expr1053 + expr2397).*expr482.*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497));
expr2403 = 2.*expr1045.*expr732.*expr734.*expr735.*expr736.*expr737.*expr738.*expr739 - 2.*expr733.*expr734.*expr735.*expr736.*expr737.*expr738.*expr739.*expr803;
expr2404 = expr1053 + expr2397;
expr2405 = (expr1410 + expr2398).*expr518.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr2406 = -((expr1410 + expr2398).*expr502.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517));
expr2407 = expr1410 + expr2398;
expr2408 = (expr1763 + expr2399).*expr538.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr2409 = -((expr1763 + expr2399).*expr522.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537));
expr2410 = expr1763 + expr2399;
expr2411 = (expr2105 + expr2400).*expr558.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr2412 = -((expr2105 + expr2400).*expr542.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557));
expr2413 = expr2105 + expr2400;
expr2414 = 2.*expr1427.*expr746.*expr748.*expr749.*expr750.*expr751.*expr752.*expr753 - 2.*expr1228.*expr747.*expr748.*expr749.*expr750.*expr751.*expr752.*expr753;
expr2415 = 2.*expr1777.*expr760.*expr762.*expr763.*expr764.*expr765.*expr766.*expr767 - 2.*expr1587.*expr761.*expr762.*expr763.*expr764.*expr765.*expr766.*expr767;
expr2416 = 2.*expr2116.*expr774.*expr776.*expr777.*expr778.*expr779.*expr780.*expr781 - 2.*expr1935.*expr775.*expr776.*expr777.*expr778.*expr779.*expr780.*expr781;
expr2417 = expr2401 + expr2402;
expr2418 = (expr2404.*expr482.*expr483.*expr563.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr2419 = -(((expr2401 + expr2402).*expr482.*expr483.*expr562.*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr2420 = -((expr482.*expr483.*expr562.*expr563.*(-(expr2404.*expr483.*expr498.*expr563.*expr864) + (expr2401 + expr2402).*expr483.*expr498.*expr562.*expr866))./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^2);
expr2421 = -(((expr2405 + expr2406).*expr502.*expr503.*expr564.*expr868)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr2422 = (expr2407.*expr502.*expr503.*expr565.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr2423 = -((expr502.*expr503.*expr564.*expr565.*((expr2405 + expr2406).*expr503.*expr518.*expr564.*expr868 - expr2407.*expr503.*expr518.*expr565.*expr870))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^2);
expr2424 = -(((expr2408 + expr2409).*expr522.*expr523.*expr566.*expr874)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr2425 = (expr2410.*expr522.*expr523.*expr567.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr2426 = -((expr522.*expr523.*expr566.*expr567.*((expr2408 + expr2409).*expr523.*expr538.*expr566.*expr874 - expr2410.*expr523.*expr538.*expr567.*expr876))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^2);
expr2427 = -(((expr2411 + expr2412).*expr542.*expr543.*expr568.*expr880)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr2428 = (expr2413.*expr542.*expr543.*expr569.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr2429 = -((expr542.*expr543.*expr568.*expr569.*((expr2411 + expr2412).*expr543.*expr558.*expr568.*expr880 - expr2413.*expr543.*expr558.*expr569.*expr882))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^2);
expr2430 = -(expr2404.*expr483.*expr563.*expr864) + (expr2401 + expr2402).*expr483.*expr562.*expr866;
expr2431 = expr2405 + expr2406;
expr2432 = (expr2405 + expr2406).*expr503.*expr564.*expr868 - expr2407.*expr503.*expr565.*expr870;
expr2433 = expr2408 + expr2409;
expr2434 = (expr2408 + expr2409).*expr523.*expr566.*expr874 - expr2410.*expr523.*expr567.*expr876;
expr2435 = expr2411 + expr2412;
expr2436 = (expr2411 + expr2412).*expr543.*expr568.*expr880 - expr2413.*expr543.*expr569.*expr882;
expr2437 = (expr2418 + expr2419 + expr2420).*expr501.*expr898 + (expr2421 + expr2422 + expr2423).*expr521.*expr904 + (expr2424 + expr2425 + expr2426).*expr541.*expr908 + (expr2427 + expr2428 + expr2429).*expr561.*expr912;
expr2438 = -(expr2430.*expr501.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2439 = -(expr2432.*expr521.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2440 = -(expr2434.*expr541.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2441 = -(expr2436.*expr561.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2442 = expr2417.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*(1 + expr923);
expr2443 = -2.*expr2338.*expr501.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(1 + expr923);
expr2444 = expr2403.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr835.*expr837.*expr854.*(1 + expr923);
expr2445 = expr2431.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*(1 + expr924);
expr2446 = expr1271.*expr2414.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr838.*expr840.*(1 + expr924);
expr2447 = -2.*expr2338.*expr483.*expr521.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(1 + expr924);
expr2448 = expr2433.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*(1 + expr925);
expr2449 = expr1625.*expr2415.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr841.*expr843.*(1 + expr925);
expr2450 = -2.*expr2338.*expr483.*expr503.*expr541.*expr543.*expr586.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(1 + expr925);
expr2451 = expr2435.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*(1 + expr926);
expr2452 = expr1968.*expr2416.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr615.*expr844.*expr846.*(1 + expr926);
expr2453 = -2.*expr2338.*expr483.*expr503.*expr523.*expr561.*expr586.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(1 + expr926);
expr2454 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(expr2437.*expr498.*expr830.*expr927.*expr930.*tpc - expr927.*(expr2438 + expr2437.*expr830.*expr891.*expr931.*tpc + expr2437.*expr482.*expr830.*expr933.*tpc));
expr2455 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(expr2437.*expr518.*expr830.*expr934.*expr935.*tpc - expr934.*(expr2439 + expr2437.*expr830.*expr892.*expr936.*tpc + expr2437.*expr502.*expr830.*expr938.*tpc));
expr2456 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(expr2437.*expr538.*expr830.*expr939.*expr940.*tpc - expr939.*(expr2440 + expr2437.*expr830.*expr893.*expr941.*tpc + expr2437.*expr522.*expr830.*expr943.*tpc));
expr2457 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(expr2437.*expr558.*expr830.*expr944.*expr945.*tpc - expr944.*(expr2441 + expr2437.*expr830.*expr894.*expr946.*tpc + expr2437.*expr542.*expr830.*expr948.*tpc));
expr2458 = integrate41 + integrate42 + integrate43 + integrate44 + 200.*(expr2442 + expr2443 + expr2444 + expr2445 + expr2446 + expr2447 + expr2448 + expr2449 + expr2450 + expr2451 + expr2452 + expr2453 + expr2454 + expr2455 + expr2456 + expr2457).*(-1 + expr949 + expr950 + expr951 + expr952).*WO;
gf(13) = expr2458;

%% Derivative for c(2)
w45 = [ws:(99.*ws)./100:100.*ws];
expr2459 = ((a(1).^2 + b(1).^2).^2 + w45.^2.*(w45.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr2460 = ((a(2).^2 + b(2).^2).^2 + w45.^2.*(w45.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr2461 = ((a(3).^2 + b(3).^2).^2 + w45.^2.*(w45.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr2462 = ((a(4).^2 + b(4).^2).^2 + w45.^2.*(w45.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr2463 = (c(1).^2 + d(1).^2).^2 + w45.^2.*(w45.^2 + 2.*(c(1).^2 - d(1).^2));
expr2464 = 4.*w45.^2.*c(2) + 4.*c(2).*(c(2).^2 + d(2).^2);
expr2465 = (c(3).^2 + d(3).^2).^2 + w45.^2.*(w45.^2 + 2.*(c(3).^2 - d(3).^2));
expr2466 = (c(4).^2 + d(4).^2).^2 + w45.^2.*(w45.^2 + 2.*(c(4).^2 - d(4).^2));
expr2467 = c(2);
expr2468 = (c(2).^2 + d(2).^2).^(-3);
expr2469 = (c(2).^2 + d(2).^2).^2 + w45.^2.*(w45.^2 + 2.*(c(2).^2 - d(2).^2));
expr2470 = expr2206.*expr2459.*expr2460.*expr2461.*expr2462.*expr2463.*expr2465.*expr2466.*expr2467.*expr2468.*expr2469.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr590.*expr592.*Wms;
expr2471 = expr2197.*expr2459.*expr2460.*expr2461.*expr2462.*expr2463.*expr2464.*expr2465.*expr2466.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*Wms;
expr2472 = expr2470 + expr2471;
integrate45 = trapz(w45, expr2472);
w46 = [0:wp./100:wp];
expr2473 = (a(1).^2 + b(1).^2).^2 + w46.^2.*(w46.^2 + 2.*(a(1).^2 - b(1).^2));
expr2474 = (a(2).^2 + b(2).^2).^2 + w46.^2.*(w46.^2 + 2.*(a(2).^2 - b(2).^2));
expr2475 = (a(3).^2 + b(3).^2).^2 + w46.^2.*(w46.^2 + 2.*(a(3).^2 - b(3).^2));
expr2476 = (a(4).^2 + b(4).^2).^2 + w46.^2.*(w46.^2 + 2.*(a(4).^2 - b(4).^2));
expr2477 = (c(1).^2 + d(1).^2).^2 + w46.^2.*(w46.^2 + 2.*(c(1).^2 - d(1).^2));
expr2478 = 4.*w46.^2.*c(2) + 4.*c(2).*(c(2).^2 + d(2).^2);
expr2479 = (c(3).^2 + d(3).^2).^2 + w46.^2.*(w46.^2 + 2.*(c(3).^2 - d(3).^2));
expr2480 = (c(4).^2 + d(4).^2).^2 + w46.^2.*(w46.^2 + 2.*(c(4).^2 - d(4).^2));
expr2481 = (c(2).^2 + d(2).^2).^2 + w46.^2.*(w46.^2 + 2.*(c(2).^2 - d(2).^2));
expr2482 = -1 + (expr2473.*expr2474.*expr2475.*expr2476).^expr600.*(expr2477.*expr2479.*expr2480.*expr2481).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr2483 = -2.*expr2467.*(expr2473.*expr2474.*expr2475.*expr2476).^expr600.*(expr2477.*expr2479.*expr2480.*expr2481).^expr615.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610;
expr2484 = (expr2473.*expr2474.*expr2475.*expr2476).^expr600.*expr2477.*expr2478.*expr2479.*expr2480.*(expr2477.*expr2479.*expr2480.*expr2481).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr2485 = 2.*expr2482.*(expr2483 + expr2484).*expr599.*Wmp;
integrate46 = trapz(w46, expr2485);
w47 = [wp:(-wp + ws)./100:ws];
expr2486 = (a(1).^2 + b(1).^2).^2 + w47.^2.*(w47.^2 + 2.*(a(1).^2 - b(1).^2));
expr2487 = (a(2).^2 + b(2).^2).^2 + w47.^2.*(w47.^2 + 2.*(a(2).^2 - b(2).^2));
expr2488 = (a(3).^2 + b(3).^2).^2 + w47.^2.*(w47.^2 + 2.*(a(3).^2 - b(3).^2));
expr2489 = (a(4).^2 + b(4).^2).^2 + w47.^2.*(w47.^2 + 2.*(a(4).^2 - b(4).^2));
expr2490 = (c(1).^2 + d(1).^2).^2 + w47.^2.*(w47.^2 + 2.*(c(1).^2 - d(1).^2));
expr2491 = 4.*w47.^2.*c(2) + 4.*c(2).*(c(2).^2 + d(2).^2);
expr2492 = (c(3).^2 + d(3).^2).^2 + w47.^2.*(w47.^2 + 2.*(c(3).^2 - d(3).^2));
expr2493 = (c(4).^2 + d(4).^2).^2 + w47.^2.*(w47.^2 + 2.*(c(4).^2 - d(4).^2));
expr2494 = (c(2).^2 + d(2).^2).^2 + w47.^2.*(w47.^2 + 2.*(c(2).^2 - d(2).^2));
expr2495 = -(w47./(wp - ws));
expr2496 = -2.*expr2467.*(expr2486.*expr2487.*expr2488.*expr2489).^expr600.*(expr2490.*expr2492.*expr2493.*expr2494).^expr615.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610;
expr2497 = (expr2486.*expr2487.*expr2488.*expr2489).^expr600.*expr2490.*expr2491.*expr2492.*expr2493.*(expr2490.*expr2492.*expr2493.*expr2494).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr2498 = expr2495 + (expr2486.*expr2487.*expr2488.*expr2489).^expr600.*(expr2490.*expr2492.*expr2493.*expr2494).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr631;
expr2499 = 2.*(expr2496 + expr2497).*expr2498.*expr620.*Wmt;
integrate47 = trapz(w47, expr2499);
w48 = [0:wmax./100:wmax];
expr2500 = (w48 - d(2))./(c(2).^2.*(1 + (w48 - d(2)).^2./c(2).^2));
expr2501 = (w48 + d(2))./(c(2).^2.*(1 + (w48 + d(2)).^2./c(2).^2));
expr2502 = -2.*(angle(1 + (i.*(wmax - d(2)))./c(2)) + angle(1 + (i.*(wmax + d(2)))./c(2))).*c(2);
expr2503 = (-2.*(wmax - d(2)).^2.*d(2))./(c(2).^2.*(1 + (wmax - d(2)).^2./c(2).^2));
expr2504 = (2.*d(2).*(wmax + d(2)).^2)./(c(2).^2.*(1 + (wmax + d(2)).^2./c(2).^2));
expr2505 = -((wmax - d(2))./(c(2).^2.*(1 + (wmax - d(2)).^2./c(2).^2)));
expr2506 = -((wmax + d(2))./(c(2).^2.*(1 + (wmax + d(2)).^2./c(2).^2)));
expr2507 = d(2).*log(1 + (wmax - d(2)).^2./c(2).^2);
expr2508 = -(d(2).*log(1 + (wmax + d(2)).^2./c(2).^2));
expr2509 = angle(1 + (i.*(w48 - b(1)))./a(1));
expr2510 = angle(1 + (i.*(w48 + b(1)))./a(1));
expr2511 = angle(1 + (i.*(w48 - b(2)))./a(2));
expr2512 = angle(1 + (i.*(w48 + b(2)))./a(2));
expr2513 = angle(1 + (i.*(w48 - b(3)))./a(3));
expr2514 = angle(1 + (i.*(w48 + b(3)))./a(3));
expr2515 = angle(1 + (i.*(w48 - b(4)))./a(4));
expr2516 = angle(1 + (i.*(w48 + b(4)))./a(4));
expr2517 = -angle(1 + (i.*(w48 - d(1)))./c(1));
expr2518 = -angle(1 + (i.*(w48 + d(1)))./c(1));
expr2519 = -angle(1 + (i.*(w48 - d(2)))./c(2));
expr2520 = -angle(1 + (i.*(w48 + d(2)))./c(2));
expr2521 = -angle(1 + (i.*(w48 - d(3)))./c(3));
expr2522 = -angle(1 + (i.*(w48 + d(3)))./c(3));
expr2523 = -angle(1 + (i.*(w48 - d(4)))./c(4));
expr2524 = -angle(1 + (i.*(w48 + d(4)))./c(4));
expr2525 = expr2500 + expr2501 + expr606.*expr639.*(expr2242 + expr2502 + expr2503 + expr2504 + expr2507 + expr2508 + (expr2505 + expr2506).*expr691).*w48;
expr2526 = 2.*expr2525.*expr636.*(expr2509 + expr2510 + expr2511 + expr2512 + expr2513 + expr2514 + expr2515 + expr2516 + expr2517 + expr2518 + expr2519 + expr2520 + expr2521 + expr2522 + expr2523 + expr2524 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w48).*Wph;
integrate48 = trapz(w48, expr2526);
expr2527 = -((b(1) + d(2))./((a(1) - c(2)).^2.*(1 + (b(1) + d(2)).^2./(a(1) - c(2)).^2)));
expr2528 = -((b(2) + d(2))./((a(2) - c(2)).^2.*(1 + (b(2) + d(2)).^2./(a(2) - c(2)).^2)));
expr2529 = -((b(3) + d(2))./((a(3) - c(2)).^2.*(1 + (b(3) + d(2)).^2./(a(3) - c(2)).^2)));
expr2530 = -((b(4) + d(2))./((a(4) - c(2)).^2.*(1 + (b(4) + d(2)).^2./(a(4) - c(2)).^2)));
expr2531 = -2.*expr732.*expr733.*expr734.*expr736.*expr737.*expr738.*expr739.*expr787 - 2.*expr732.*expr733.*expr735.*expr736.*expr737.*expr738.*expr739.*expr787;
expr2532 = expr498.*(expr2527 - expr805.*expr806.*expr807).*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr2533 = -(expr482.*(expr2527 - expr805.*expr806.*expr807).*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497));
expr2534 = expr2527 - expr805.*expr806.*expr807;
expr2535 = (-(expr1230.*expr1231.*expr1232) + expr2528).*expr518.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr2536 = -((-(expr1230.*expr1231.*expr1232) + expr2528).*expr502.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517));
expr2537 = -(expr1230.*expr1231.*expr1232) + expr2528;
expr2538 = (-(expr1589.*expr1590.*expr1591) + expr2529).*expr538.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr2539 = -((-(expr1589.*expr1590.*expr1591) + expr2529).*expr522.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537));
expr2540 = -(expr1589.*expr1590.*expr1591) + expr2529;
expr2541 = (-(expr1937.*expr1938.*expr1939) + expr2530).*expr558.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr2542 = -((-(expr1937.*expr1938.*expr1939) + expr2530).*expr542.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557));
expr2543 = -(expr1937.*expr1938.*expr1939) + expr2530;
expr2544 = -2.*expr1255.*expr746.*expr747.*expr748.*expr750.*expr751.*expr752.*expr753 - 2.*expr1255.*expr746.*expr747.*expr749.*expr750.*expr751.*expr752.*expr753;
expr2545 = -2.*expr1609.*expr760.*expr761.*expr762.*expr764.*expr765.*expr766.*expr767 - 2.*expr1609.*expr760.*expr761.*expr763.*expr764.*expr765.*expr766.*expr767;
expr2546 = -2.*expr1952.*expr774.*expr775.*expr776.*expr778.*expr779.*expr780.*expr781 - 2.*expr1952.*expr774.*expr775.*expr777.*expr778.*expr779.*expr780.*expr781;
expr2547 = expr2532 + expr2533;
expr2548 = (expr2534.*expr482.*expr483.*expr563.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr2549 = -(((expr2532 + expr2533).*expr482.*expr483.*expr562.*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr2550 = -((expr482.*expr483.*expr562.*expr563.*(-(expr2534.*expr483.*expr498.*expr563.*expr864) + (expr2532 + expr2533).*expr483.*expr498.*expr562.*expr866))./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^2);
expr2551 = -(((expr2535 + expr2536).*expr502.*expr503.*expr564.*expr868)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr2552 = (expr2537.*expr502.*expr503.*expr565.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr2553 = -((expr502.*expr503.*expr564.*expr565.*((expr2535 + expr2536).*expr503.*expr518.*expr564.*expr868 - expr2537.*expr503.*expr518.*expr565.*expr870))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^2);
expr2554 = -(((expr2538 + expr2539).*expr522.*expr523.*expr566.*expr874)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr2555 = (expr2540.*expr522.*expr523.*expr567.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr2556 = -((expr522.*expr523.*expr566.*expr567.*((expr2538 + expr2539).*expr523.*expr538.*expr566.*expr874 - expr2540.*expr523.*expr538.*expr567.*expr876))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^2);
expr2557 = -(((expr2541 + expr2542).*expr542.*expr543.*expr568.*expr880)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr2558 = (expr2543.*expr542.*expr543.*expr569.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr2559 = -((expr542.*expr543.*expr568.*expr569.*((expr2541 + expr2542).*expr543.*expr558.*expr568.*expr880 - expr2543.*expr543.*expr558.*expr569.*expr882))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^2);
expr2560 = -(expr2534.*expr483.*expr563.*expr864) + (expr2532 + expr2533).*expr483.*expr562.*expr866;
expr2561 = expr2535 + expr2536;
expr2562 = (expr2535 + expr2536).*expr503.*expr564.*expr868 - expr2537.*expr503.*expr565.*expr870;
expr2563 = expr2538 + expr2539;
expr2564 = (expr2538 + expr2539).*expr523.*expr566.*expr874 - expr2540.*expr523.*expr567.*expr876;
expr2565 = expr2541 + expr2542;
expr2566 = (expr2541 + expr2542).*expr543.*expr568.*expr880 - expr2543.*expr543.*expr569.*expr882;
expr2567 = (expr2548 + expr2549 + expr2550).*expr501.*expr898 + (expr2551 + expr2552 + expr2553).*expr521.*expr904 + (expr2554 + expr2555 + expr2556).*expr541.*expr908 + (expr2557 + expr2558 + expr2559).*expr561.*expr912;
expr2568 = -(expr2560.*expr501.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2569 = -(expr2562.*expr521.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2570 = -(expr2564.*expr541.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2571 = -(expr2566.*expr561.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2572 = expr2547.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*(1 + expr923);
expr2573 = -2.*expr2467.*expr501.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610.*expr835.*expr836.*expr837.*(1 + expr923);
expr2574 = expr2531.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr835.*expr837.*expr854.*(1 + expr923);
expr2575 = expr2561.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*(1 + expr924);
expr2576 = expr1271.*expr2544.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr838.*expr840.*(1 + expr924);
expr2577 = -2.*expr2467.*expr483.*expr521.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610.*expr838.*expr839.*expr840.*(1 + expr924);
expr2578 = expr2563.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*(1 + expr925);
expr2579 = expr1625.*expr2545.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr841.*expr843.*(1 + expr925);
expr2580 = -2.*expr2467.*expr483.*expr503.*expr541.*expr543.*expr588.*expr607.*expr609.*expr610.*expr841.*expr842.*expr843.*(1 + expr925);
expr2581 = expr2565.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*(1 + expr926);
expr2582 = expr1968.*expr2546.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr615.*expr844.*expr846.*(1 + expr926);
expr2583 = -2.*expr2467.*expr483.*expr503.*expr523.*expr561.*expr588.*expr607.*expr609.*expr610.*expr844.*expr845.*expr846.*(1 + expr926);
expr2584 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(expr2567.*expr498.*expr830.*expr927.*expr930.*tpc - expr927.*(expr2568 + expr2567.*expr830.*expr891.*expr931.*tpc + expr2567.*expr482.*expr830.*expr933.*tpc));
expr2585 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(expr2567.*expr518.*expr830.*expr934.*expr935.*tpc - expr934.*(expr2569 + expr2567.*expr830.*expr892.*expr936.*tpc + expr2567.*expr502.*expr830.*expr938.*tpc));
expr2586 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(expr2567.*expr538.*expr830.*expr939.*expr940.*tpc - expr939.*(expr2570 + expr2567.*expr830.*expr893.*expr941.*tpc + expr2567.*expr522.*expr830.*expr943.*tpc));
expr2587 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(expr2567.*expr558.*expr830.*expr944.*expr945.*tpc - expr944.*(expr2571 + expr2567.*expr830.*expr894.*expr946.*tpc + expr2567.*expr542.*expr830.*expr948.*tpc));
expr2588 = integrate45 + integrate46 + integrate47 + integrate48 + 200.*(expr2572 + expr2573 + expr2574 + expr2575 + expr2576 + expr2577 + expr2578 + expr2579 + expr2580 + expr2581 + expr2582 + expr2583 + expr2584 + expr2585 + expr2586 + expr2587).*(-1 + expr949 + expr950 + expr951 + expr952).*WO;
gf(10) = expr2588;

%% Derivative for d(2)
w49 = [ws:(99.*ws)./100:100.*ws];
expr2589 = ((a(1).^2 + b(1).^2).^2 + w49.^2.*(w49.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr2590 = ((a(2).^2 + b(2).^2).^2 + w49.^2.*(w49.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr2591 = ((a(3).^2 + b(3).^2).^2 + w49.^2.*(w49.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr2592 = ((a(4).^2 + b(4).^2).^2 + w49.^2.*(w49.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr2593 = (c(1).^2 + d(1).^2).^2 + w49.^2.*(w49.^2 + 2.*(c(1).^2 - d(1).^2));
expr2594 = -4.*w49.^2.*d(2) + 4.*d(2).*(c(2).^2 + d(2).^2);
expr2595 = (c(3).^2 + d(3).^2).^2 + w49.^2.*(w49.^2 + 2.*(c(3).^2 - d(3).^2));
expr2596 = (c(4).^2 + d(4).^2).^2 + w49.^2.*(w49.^2 + 2.*(c(4).^2 - d(4).^2));
expr2597 = d(2);
expr2598 = (c(2).^2 + d(2).^2).^2 + w49.^2.*(w49.^2 + 2.*(c(2).^2 - d(2).^2));
expr2599 = expr2206.*expr2468.*expr2589.*expr2590.*expr2591.*expr2592.*expr2593.*expr2595.*expr2596.*expr2597.*expr2598.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr590.*expr592.*Wms;
expr2600 = expr2197.*expr2589.*expr2590.*expr2591.*expr2592.*expr2593.*expr2594.*expr2595.*expr2596.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*Wms;
expr2601 = expr2599 + expr2600;
integrate49 = trapz(w49, expr2601);
w50 = [0:wp./100:wp];
expr2602 = (a(1).^2 + b(1).^2).^2 + w50.^2.*(w50.^2 + 2.*(a(1).^2 - b(1).^2));
expr2603 = (a(2).^2 + b(2).^2).^2 + w50.^2.*(w50.^2 + 2.*(a(2).^2 - b(2).^2));
expr2604 = (a(3).^2 + b(3).^2).^2 + w50.^2.*(w50.^2 + 2.*(a(3).^2 - b(3).^2));
expr2605 = (a(4).^2 + b(4).^2).^2 + w50.^2.*(w50.^2 + 2.*(a(4).^2 - b(4).^2));
expr2606 = (c(1).^2 + d(1).^2).^2 + w50.^2.*(w50.^2 + 2.*(c(1).^2 - d(1).^2));
expr2607 = -4.*w50.^2.*d(2) + 4.*d(2).*(c(2).^2 + d(2).^2);
expr2608 = (c(3).^2 + d(3).^2).^2 + w50.^2.*(w50.^2 + 2.*(c(3).^2 - d(3).^2));
expr2609 = (c(4).^2 + d(4).^2).^2 + w50.^2.*(w50.^2 + 2.*(c(4).^2 - d(4).^2));
expr2610 = (c(2).^2 + d(2).^2).^2 + w50.^2.*(w50.^2 + 2.*(c(2).^2 - d(2).^2));
expr2611 = -1 + (expr2602.*expr2603.*expr2604.*expr2605).^expr600.*(expr2606.*expr2608.*expr2609.*expr2610).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr2612 = -2.*expr2597.*(expr2602.*expr2603.*expr2604.*expr2605).^expr600.*(expr2606.*expr2608.*expr2609.*expr2610).^expr615.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610;
expr2613 = (expr2602.*expr2603.*expr2604.*expr2605).^expr600.*expr2606.*expr2607.*expr2608.*expr2609.*(expr2606.*expr2608.*expr2609.*expr2610).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr2614 = 2.*expr2611.*(expr2612 + expr2613).*expr599.*Wmp;
integrate50 = trapz(w50, expr2614);
w51 = [wp:(-wp + ws)./100:ws];
expr2615 = (a(1).^2 + b(1).^2).^2 + w51.^2.*(w51.^2 + 2.*(a(1).^2 - b(1).^2));
expr2616 = (a(2).^2 + b(2).^2).^2 + w51.^2.*(w51.^2 + 2.*(a(2).^2 - b(2).^2));
expr2617 = (a(3).^2 + b(3).^2).^2 + w51.^2.*(w51.^2 + 2.*(a(3).^2 - b(3).^2));
expr2618 = (a(4).^2 + b(4).^2).^2 + w51.^2.*(w51.^2 + 2.*(a(4).^2 - b(4).^2));
expr2619 = (c(1).^2 + d(1).^2).^2 + w51.^2.*(w51.^2 + 2.*(c(1).^2 - d(1).^2));
expr2620 = -4.*w51.^2.*d(2) + 4.*d(2).*(c(2).^2 + d(2).^2);
expr2621 = (c(3).^2 + d(3).^2).^2 + w51.^2.*(w51.^2 + 2.*(c(3).^2 - d(3).^2));
expr2622 = (c(4).^2 + d(4).^2).^2 + w51.^2.*(w51.^2 + 2.*(c(4).^2 - d(4).^2));
expr2623 = (c(2).^2 + d(2).^2).^2 + w51.^2.*(w51.^2 + 2.*(c(2).^2 - d(2).^2));
expr2624 = -(w51./(wp - ws));
expr2625 = -2.*expr2597.*(expr2615.*expr2616.*expr2617.*expr2618).^expr600.*(expr2619.*expr2621.*expr2622.*expr2623).^expr615.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610;
expr2626 = (expr2615.*expr2616.*expr2617.*expr2618).^expr600.*expr2619.*expr2620.*expr2621.*expr2622.*(expr2619.*expr2621.*expr2622.*expr2623).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr2627 = expr2624 + (expr2615.*expr2616.*expr2617.*expr2618).^expr600.*(expr2619.*expr2621.*expr2622.*expr2623).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr631;
expr2628 = 2.*(expr2625 + expr2626).*expr2627.*expr620.*Wmt;
integrate51 = trapz(w51, expr2628);
w52 = [0:wmax./100:wmax];
expr2629 = 1./(c(2).*(1 + (w52 - d(2)).^2./c(2).^2));
expr2630 = -(1./(c(2).*(1 + (w52 + d(2)).^2./c(2).^2)));
expr2631 = 2.*(angle(1 + (i.*(wmax - d(2)))./c(2)) + angle(1 + (i.*(wmax + d(2)))./c(2))).*d(2);
expr2632 = (-2.*(wmax - d(2)).*d(2))./(c(2).*(1 + (wmax - d(2)).^2./c(2).^2));
expr2633 = (-2.*d(2).*(wmax + d(2)))./(c(2).*(1 + (wmax + d(2)).^2./c(2).^2));
expr2634 = -(1./(c(2).*(1 + (wmax - d(2)).^2./c(2).^2)));
expr2635 = 1./(c(2).*(1 + (wmax + d(2)).^2./c(2).^2));
expr2636 = c(2).*log(1 + (wmax - d(2)).^2./c(2).^2);
expr2637 = -(c(2).*log(1 + (wmax + d(2)).^2./c(2).^2));
expr2638 = angle(1 + (i.*(w52 - b(1)))./a(1));
expr2639 = angle(1 + (i.*(w52 + b(1)))./a(1));
expr2640 = angle(1 + (i.*(w52 - b(2)))./a(2));
expr2641 = angle(1 + (i.*(w52 + b(2)))./a(2));
expr2642 = angle(1 + (i.*(w52 - b(3)))./a(3));
expr2643 = angle(1 + (i.*(w52 + b(3)))./a(3));
expr2644 = angle(1 + (i.*(w52 - b(4)))./a(4));
expr2645 = angle(1 + (i.*(w52 + b(4)))./a(4));
expr2646 = -angle(1 + (i.*(w52 - d(1)))./c(1));
expr2647 = -angle(1 + (i.*(w52 + d(1)))./c(1));
expr2648 = -angle(1 + (i.*(w52 - d(2)))./c(2));
expr2649 = -angle(1 + (i.*(w52 + d(2)))./c(2));
expr2650 = -angle(1 + (i.*(w52 - d(3)))./c(3));
expr2651 = -angle(1 + (i.*(w52 + d(3)))./c(3));
expr2652 = -angle(1 + (i.*(w52 - d(4)))./c(4));
expr2653 = -angle(1 + (i.*(w52 + d(4)))./c(4));
expr2654 = expr2629 + expr2630 + expr606.*expr639.*(expr2631 + expr2632 + expr2633 + expr2636 + expr2637 + (expr2634 + expr2635).*expr691).*w52;
expr2655 = 2.*expr2654.*expr636.*(expr2638 + expr2639 + expr2640 + expr2641 + expr2642 + expr2643 + expr2644 + expr2645 + expr2646 + expr2647 + expr2648 + expr2649 + expr2650 + expr2651 + expr2652 + expr2653 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w52).*Wph;
integrate52 = trapz(w52, expr2655);
expr2656 = 1./((a(1) - c(2)).*(1 + (b(1) - d(2)).^2./(a(1) - c(2)).^2));
expr2657 = 1./((a(2) - c(2)).*(1 + (b(2) - d(2)).^2./(a(2) - c(2)).^2));
expr2658 = 1./((a(3) - c(2)).*(1 + (b(3) - d(2)).^2./(a(3) - c(2)).^2));
expr2659 = 1./((a(4) - c(2)).*(1 + (b(4) - d(2)).^2./(a(4) - c(2)).^2));
expr2660 = (expr1055 + expr2656).*expr498.*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr2661 = -((expr1055 + expr2656).*expr482.*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497));
expr2662 = 2.*expr1044.*expr732.*expr733.*expr734.*expr736.*expr737.*expr738.*expr739 - 2.*expr732.*expr733.*expr735.*expr736.*expr737.*expr738.*expr739.*expr807;
expr2663 = expr1055 + expr2656;
expr2664 = (expr1412 + expr2657).*expr518.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr2665 = -((expr1412 + expr2657).*expr502.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517));
expr2666 = expr1412 + expr2657;
expr2667 = (expr1765 + expr2658).*expr538.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr2668 = -((expr1765 + expr2658).*expr522.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537));
expr2669 = expr1765 + expr2658;
expr2670 = (expr2107 + expr2659).*expr558.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr2671 = -((expr2107 + expr2659).*expr542.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557));
expr2672 = expr2107 + expr2659;
expr2673 = 2.*expr1426.*expr746.*expr747.*expr748.*expr750.*expr751.*expr752.*expr753 - 2.*expr1232.*expr746.*expr747.*expr749.*expr750.*expr751.*expr752.*expr753;
expr2674 = 2.*expr1776.*expr760.*expr761.*expr762.*expr764.*expr765.*expr766.*expr767 - 2.*expr1591.*expr760.*expr761.*expr763.*expr764.*expr765.*expr766.*expr767;
expr2675 = 2.*expr2115.*expr774.*expr775.*expr776.*expr778.*expr779.*expr780.*expr781 - 2.*expr1939.*expr774.*expr775.*expr777.*expr778.*expr779.*expr780.*expr781;
expr2676 = expr2660 + expr2661;
expr2677 = (expr2663.*expr482.*expr483.*expr563.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr2678 = -(((expr2660 + expr2661).*expr482.*expr483.*expr562.*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr2679 = -((expr482.*expr483.*expr562.*expr563.*(-(expr2663.*expr483.*expr498.*expr563.*expr864) + (expr2660 + expr2661).*expr483.*expr498.*expr562.*expr866))./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^2);
expr2680 = -(((expr2664 + expr2665).*expr502.*expr503.*expr564.*expr868)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr2681 = (expr2666.*expr502.*expr503.*expr565.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr2682 = -((expr502.*expr503.*expr564.*expr565.*((expr2664 + expr2665).*expr503.*expr518.*expr564.*expr868 - expr2666.*expr503.*expr518.*expr565.*expr870))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^2);
expr2683 = -(((expr2667 + expr2668).*expr522.*expr523.*expr566.*expr874)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr2684 = (expr2669.*expr522.*expr523.*expr567.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr2685 = -((expr522.*expr523.*expr566.*expr567.*((expr2667 + expr2668).*expr523.*expr538.*expr566.*expr874 - expr2669.*expr523.*expr538.*expr567.*expr876))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^2);
expr2686 = -(((expr2670 + expr2671).*expr542.*expr543.*expr568.*expr880)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr2687 = (expr2672.*expr542.*expr543.*expr569.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr2688 = -((expr542.*expr543.*expr568.*expr569.*((expr2670 + expr2671).*expr543.*expr558.*expr568.*expr880 - expr2672.*expr543.*expr558.*expr569.*expr882))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^2);
expr2689 = -(expr2663.*expr483.*expr563.*expr864) + (expr2660 + expr2661).*expr483.*expr562.*expr866;
expr2690 = expr2664 + expr2665;
expr2691 = (expr2664 + expr2665).*expr503.*expr564.*expr868 - expr2666.*expr503.*expr565.*expr870;
expr2692 = expr2667 + expr2668;
expr2693 = (expr2667 + expr2668).*expr523.*expr566.*expr874 - expr2669.*expr523.*expr567.*expr876;
expr2694 = expr2670 + expr2671;
expr2695 = (expr2670 + expr2671).*expr543.*expr568.*expr880 - expr2672.*expr543.*expr569.*expr882;
expr2696 = (expr2677 + expr2678 + expr2679).*expr501.*expr898 + (expr2680 + expr2681 + expr2682).*expr521.*expr904 + (expr2683 + expr2684 + expr2685).*expr541.*expr908 + (expr2686 + expr2687 + expr2688).*expr561.*expr912;
expr2697 = -(expr2689.*expr501.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2698 = -(expr2691.*expr521.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2699 = -(expr2693.*expr541.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2700 = -(expr2695.*expr561.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2701 = expr2676.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*(1 + expr923);
expr2702 = -2.*expr2597.*expr501.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610.*expr835.*expr836.*expr837.*(1 + expr923);
expr2703 = expr2662.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr835.*expr837.*expr854.*(1 + expr923);
expr2704 = expr2690.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*(1 + expr924);
expr2705 = expr1271.*expr2673.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr838.*expr840.*(1 + expr924);
expr2706 = -2.*expr2597.*expr483.*expr521.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610.*expr838.*expr839.*expr840.*(1 + expr924);
expr2707 = expr2692.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*(1 + expr925);
expr2708 = expr1625.*expr2674.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr841.*expr843.*(1 + expr925);
expr2709 = -2.*expr2597.*expr483.*expr503.*expr541.*expr543.*expr588.*expr607.*expr609.*expr610.*expr841.*expr842.*expr843.*(1 + expr925);
expr2710 = expr2694.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*(1 + expr926);
expr2711 = expr1968.*expr2675.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr615.*expr844.*expr846.*(1 + expr926);
expr2712 = -2.*expr2597.*expr483.*expr503.*expr523.*expr561.*expr588.*expr607.*expr609.*expr610.*expr844.*expr845.*expr846.*(1 + expr926);
expr2713 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(expr2696.*expr498.*expr830.*expr927.*expr930.*tpc - expr927.*(expr2697 + expr2696.*expr830.*expr891.*expr931.*tpc + expr2696.*expr482.*expr830.*expr933.*tpc));
expr2714 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(expr2696.*expr518.*expr830.*expr934.*expr935.*tpc - expr934.*(expr2698 + expr2696.*expr830.*expr892.*expr936.*tpc + expr2696.*expr502.*expr830.*expr938.*tpc));
expr2715 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(expr2696.*expr538.*expr830.*expr939.*expr940.*tpc - expr939.*(expr2699 + expr2696.*expr830.*expr893.*expr941.*tpc + expr2696.*expr522.*expr830.*expr943.*tpc));
expr2716 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(expr2696.*expr558.*expr830.*expr944.*expr945.*tpc - expr944.*(expr2700 + expr2696.*expr830.*expr894.*expr946.*tpc + expr2696.*expr542.*expr830.*expr948.*tpc));
expr2717 = integrate49 + integrate50 + integrate51 + integrate52 + 200.*(expr2701 + expr2702 + expr2703 + expr2704 + expr2705 + expr2706 + expr2707 + expr2708 + expr2709 + expr2710 + expr2711 + expr2712 + expr2713 + expr2714 + expr2715 + expr2716).*(-1 + expr949 + expr950 + expr951 + expr952).*WO;
gf(14) = expr2717;

%% Derivative for c(3)
w53 = [ws:(99.*ws)./100:100.*ws];
expr2718 = ((a(1).^2 + b(1).^2).^2 + w53.^2.*(w53.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr2719 = ((a(2).^2 + b(2).^2).^2 + w53.^2.*(w53.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr2720 = ((a(3).^2 + b(3).^2).^2 + w53.^2.*(w53.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr2721 = ((a(4).^2 + b(4).^2).^2 + w53.^2.*(w53.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr2722 = (c(1).^2 + d(1).^2).^2 + w53.^2.*(w53.^2 + 2.*(c(1).^2 - d(1).^2));
expr2723 = (c(2).^2 + d(2).^2).^2 + w53.^2.*(w53.^2 + 2.*(c(2).^2 - d(2).^2));
expr2724 = 4.*w53.^2.*c(3) + 4.*c(3).*(c(3).^2 + d(3).^2);
expr2725 = (c(4).^2 + d(4).^2).^2 + w53.^2.*(w53.^2 + 2.*(c(4).^2 - d(4).^2));
expr2726 = c(3);
expr2727 = (c(3).^2 + d(3).^2).^(-3);
expr2728 = (c(3).^2 + d(3).^2).^2 + w53.^2.*(w53.^2 + 2.*(c(3).^2 - d(3).^2));
expr2729 = expr2206.*expr2718.*expr2719.*expr2720.*expr2721.*expr2722.*expr2723.*expr2725.*expr2726.*expr2727.*expr2728.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr592.*Wms;
expr2730 = expr2197.*expr2718.*expr2719.*expr2720.*expr2721.*expr2722.*expr2723.*expr2724.*expr2725.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*Wms;
expr2731 = expr2729 + expr2730;
integrate53 = trapz(w53, expr2731);
w54 = [0:wp./100:wp];
expr2732 = (a(1).^2 + b(1).^2).^2 + w54.^2.*(w54.^2 + 2.*(a(1).^2 - b(1).^2));
expr2733 = (a(2).^2 + b(2).^2).^2 + w54.^2.*(w54.^2 + 2.*(a(2).^2 - b(2).^2));
expr2734 = (a(3).^2 + b(3).^2).^2 + w54.^2.*(w54.^2 + 2.*(a(3).^2 - b(3).^2));
expr2735 = (a(4).^2 + b(4).^2).^2 + w54.^2.*(w54.^2 + 2.*(a(4).^2 - b(4).^2));
expr2736 = (c(1).^2 + d(1).^2).^2 + w54.^2.*(w54.^2 + 2.*(c(1).^2 - d(1).^2));
expr2737 = (c(2).^2 + d(2).^2).^2 + w54.^2.*(w54.^2 + 2.*(c(2).^2 - d(2).^2));
expr2738 = 4.*w54.^2.*c(3) + 4.*c(3).*(c(3).^2 + d(3).^2);
expr2739 = (c(4).^2 + d(4).^2).^2 + w54.^2.*(w54.^2 + 2.*(c(4).^2 - d(4).^2));
expr2740 = (c(3).^2 + d(3).^2).^2 + w54.^2.*(w54.^2 + 2.*(c(3).^2 - d(3).^2));
expr2741 = -1 + (expr2732.*expr2733.*expr2734.*expr2735).^expr600.*(expr2736.*expr2737.*expr2739.*expr2740).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr2742 = -2.*expr2726.*(expr2732.*expr2733.*expr2734.*expr2735).^expr600.*(expr2736.*expr2737.*expr2739.*expr2740).^expr615.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610;
expr2743 = (expr2732.*expr2733.*expr2734.*expr2735).^expr600.*expr2736.*expr2737.*expr2738.*expr2739.*(expr2736.*expr2737.*expr2739.*expr2740).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr2744 = 2.*expr2741.*(expr2742 + expr2743).*expr599.*Wmp;
integrate54 = trapz(w54, expr2744);
w55 = [wp:(-wp + ws)./100:ws];
expr2745 = (a(1).^2 + b(1).^2).^2 + w55.^2.*(w55.^2 + 2.*(a(1).^2 - b(1).^2));
expr2746 = (a(2).^2 + b(2).^2).^2 + w55.^2.*(w55.^2 + 2.*(a(2).^2 - b(2).^2));
expr2747 = (a(3).^2 + b(3).^2).^2 + w55.^2.*(w55.^2 + 2.*(a(3).^2 - b(3).^2));
expr2748 = (a(4).^2 + b(4).^2).^2 + w55.^2.*(w55.^2 + 2.*(a(4).^2 - b(4).^2));
expr2749 = (c(1).^2 + d(1).^2).^2 + w55.^2.*(w55.^2 + 2.*(c(1).^2 - d(1).^2));
expr2750 = (c(2).^2 + d(2).^2).^2 + w55.^2.*(w55.^2 + 2.*(c(2).^2 - d(2).^2));
expr2751 = 4.*w55.^2.*c(3) + 4.*c(3).*(c(3).^2 + d(3).^2);
expr2752 = (c(4).^2 + d(4).^2).^2 + w55.^2.*(w55.^2 + 2.*(c(4).^2 - d(4).^2));
expr2753 = (c(3).^2 + d(3).^2).^2 + w55.^2.*(w55.^2 + 2.*(c(3).^2 - d(3).^2));
expr2754 = -(w55./(wp - ws));
expr2755 = -2.*expr2726.*(expr2745.*expr2746.*expr2747.*expr2748).^expr600.*(expr2749.*expr2750.*expr2752.*expr2753).^expr615.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610;
expr2756 = (expr2745.*expr2746.*expr2747.*expr2748).^expr600.*expr2749.*expr2750.*expr2751.*expr2752.*(expr2749.*expr2750.*expr2752.*expr2753).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr2757 = expr2754 + (expr2745.*expr2746.*expr2747.*expr2748).^expr600.*(expr2749.*expr2750.*expr2752.*expr2753).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr631;
expr2758 = 2.*(expr2755 + expr2756).*expr2757.*expr620.*Wmt;
integrate55 = trapz(w55, expr2758);
w56 = [0:wmax./100:wmax];
expr2759 = (w56 - d(3))./(c(3).^2.*(1 + (w56 - d(3)).^2./c(3).^2));
expr2760 = (w56 + d(3))./(c(3).^2.*(1 + (w56 + d(3)).^2./c(3).^2));
expr2761 = -2.*(angle(1 + (i.*(wmax - d(3)))./c(3)) + angle(1 + (i.*(wmax + d(3)))./c(3))).*c(3);
expr2762 = (-2.*(wmax - d(3)).^2.*d(3))./(c(3).^2.*(1 + (wmax - d(3)).^2./c(3).^2));
expr2763 = (2.*d(3).*(wmax + d(3)).^2)./(c(3).^2.*(1 + (wmax + d(3)).^2./c(3).^2));
expr2764 = -((wmax - d(3))./(c(3).^2.*(1 + (wmax - d(3)).^2./c(3).^2)));
expr2765 = -((wmax + d(3))./(c(3).^2.*(1 + (wmax + d(3)).^2./c(3).^2)));
expr2766 = d(3).*log(1 + (wmax - d(3)).^2./c(3).^2);
expr2767 = -(d(3).*log(1 + (wmax + d(3)).^2./c(3).^2));
expr2768 = angle(1 + (i.*(w56 - b(1)))./a(1));
expr2769 = angle(1 + (i.*(w56 + b(1)))./a(1));
expr2770 = angle(1 + (i.*(w56 - b(2)))./a(2));
expr2771 = angle(1 + (i.*(w56 + b(2)))./a(2));
expr2772 = angle(1 + (i.*(w56 - b(3)))./a(3));
expr2773 = angle(1 + (i.*(w56 + b(3)))./a(3));
expr2774 = angle(1 + (i.*(w56 - b(4)))./a(4));
expr2775 = angle(1 + (i.*(w56 + b(4)))./a(4));
expr2776 = -angle(1 + (i.*(w56 - d(1)))./c(1));
expr2777 = -angle(1 + (i.*(w56 + d(1)))./c(1));
expr2778 = -angle(1 + (i.*(w56 - d(2)))./c(2));
expr2779 = -angle(1 + (i.*(w56 + d(2)))./c(2));
expr2780 = -angle(1 + (i.*(w56 - d(3)))./c(3));
expr2781 = -angle(1 + (i.*(w56 + d(3)))./c(3));
expr2782 = -angle(1 + (i.*(w56 - d(4)))./c(4));
expr2783 = -angle(1 + (i.*(w56 + d(4)))./c(4));
expr2784 = expr2759 + expr2760 + expr606.*expr639.*(expr2242 + expr2761 + expr2762 + expr2763 + expr2766 + expr2767 + (expr2764 + expr2765).*expr696).*w56;
expr2785 = 2.*expr2784.*expr636.*(expr2768 + expr2769 + expr2770 + expr2771 + expr2772 + expr2773 + expr2774 + expr2775 + expr2776 + expr2777 + expr2778 + expr2779 + expr2780 + expr2781 + expr2782 + expr2783 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w56).*Wph;
integrate56 = trapz(w56, expr2785);
expr2786 = -((b(1) + d(3))./((a(1) - c(3)).^2.*(1 + (b(1) + d(3)).^2./(a(1) - c(3)).^2)));
expr2787 = -((b(2) + d(3))./((a(2) - c(3)).^2.*(1 + (b(2) + d(3)).^2./(a(2) - c(3)).^2)));
expr2788 = -((b(3) + d(3))./((a(3) - c(3)).^2.*(1 + (b(3) + d(3)).^2./(a(3) - c(3)).^2)));
expr2789 = -((b(4) + d(3))./((a(4) - c(3)).^2.*(1 + (b(4) + d(3)).^2./(a(4) - c(3)).^2)));
expr2790 = -2.*expr732.*expr733.*expr734.*expr735.*expr736.*expr738.*expr739.*expr786 - 2.*expr732.*expr733.*expr734.*expr735.*expr737.*expr738.*expr739.*expr786;
expr2791 = expr498.*(expr2786 - expr809.*expr810.*expr811).*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr2792 = -(expr482.*(expr2786 - expr809.*expr810.*expr811).*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497));
expr2793 = expr2786 - expr809.*expr810.*expr811;
expr2794 = (-(expr1234.*expr1235.*expr1236) + expr2787).*expr518.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr2795 = -((-(expr1234.*expr1235.*expr1236) + expr2787).*expr502.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517));
expr2796 = -(expr1234.*expr1235.*expr1236) + expr2787;
expr2797 = (-(expr1593.*expr1594.*expr1595) + expr2788).*expr538.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr2798 = -((-(expr1593.*expr1594.*expr1595) + expr2788).*expr522.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537));
expr2799 = -(expr1593.*expr1594.*expr1595) + expr2788;
expr2800 = (-(expr1941.*expr1942.*expr1943) + expr2789).*expr558.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr2801 = -((-(expr1941.*expr1942.*expr1943) + expr2789).*expr542.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557));
expr2802 = -(expr1941.*expr1942.*expr1943) + expr2789;
expr2803 = -2.*expr1254.*expr746.*expr747.*expr748.*expr749.*expr750.*expr752.*expr753 - 2.*expr1254.*expr746.*expr747.*expr748.*expr749.*expr751.*expr752.*expr753;
expr2804 = -2.*expr1608.*expr760.*expr761.*expr762.*expr763.*expr764.*expr766.*expr767 - 2.*expr1608.*expr760.*expr761.*expr762.*expr763.*expr765.*expr766.*expr767;
expr2805 = -2.*expr1951.*expr774.*expr775.*expr776.*expr777.*expr778.*expr780.*expr781 - 2.*expr1951.*expr774.*expr775.*expr776.*expr777.*expr779.*expr780.*expr781;
expr2806 = expr2791 + expr2792;
expr2807 = (expr2793.*expr482.*expr483.*expr563.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr2808 = -(((expr2791 + expr2792).*expr482.*expr483.*expr562.*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr2809 = -((expr482.*expr483.*expr562.*expr563.*(-(expr2793.*expr483.*expr498.*expr563.*expr864) + (expr2791 + expr2792).*expr483.*expr498.*expr562.*expr866))./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^2);
expr2810 = -(((expr2794 + expr2795).*expr502.*expr503.*expr564.*expr868)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr2811 = (expr2796.*expr502.*expr503.*expr565.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr2812 = -((expr502.*expr503.*expr564.*expr565.*((expr2794 + expr2795).*expr503.*expr518.*expr564.*expr868 - expr2796.*expr503.*expr518.*expr565.*expr870))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^2);
expr2813 = -(((expr2797 + expr2798).*expr522.*expr523.*expr566.*expr874)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr2814 = (expr2799.*expr522.*expr523.*expr567.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr2815 = -((expr522.*expr523.*expr566.*expr567.*((expr2797 + expr2798).*expr523.*expr538.*expr566.*expr874 - expr2799.*expr523.*expr538.*expr567.*expr876))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^2);
expr2816 = -(((expr2800 + expr2801).*expr542.*expr543.*expr568.*expr880)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr2817 = (expr2802.*expr542.*expr543.*expr569.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr2818 = -((expr542.*expr543.*expr568.*expr569.*((expr2800 + expr2801).*expr543.*expr558.*expr568.*expr880 - expr2802.*expr543.*expr558.*expr569.*expr882))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^2);
expr2819 = -(expr2793.*expr483.*expr563.*expr864) + (expr2791 + expr2792).*expr483.*expr562.*expr866;
expr2820 = expr2794 + expr2795;
expr2821 = (expr2794 + expr2795).*expr503.*expr564.*expr868 - expr2796.*expr503.*expr565.*expr870;
expr2822 = expr2797 + expr2798;
expr2823 = (expr2797 + expr2798).*expr523.*expr566.*expr874 - expr2799.*expr523.*expr567.*expr876;
expr2824 = expr2800 + expr2801;
expr2825 = (expr2800 + expr2801).*expr543.*expr568.*expr880 - expr2802.*expr543.*expr569.*expr882;
expr2826 = (expr2807 + expr2808 + expr2809).*expr501.*expr898 + (expr2810 + expr2811 + expr2812).*expr521.*expr904 + (expr2813 + expr2814 + expr2815).*expr541.*expr908 + (expr2816 + expr2817 + expr2818).*expr561.*expr912;
expr2827 = -(expr2819.*expr501.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2828 = -(expr2821.*expr521.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2829 = -(expr2823.*expr541.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2830 = -(expr2825.*expr561.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2831 = expr2806.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*(1 + expr923);
expr2832 = -2.*expr2726.*expr501.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610.*expr835.*expr836.*expr837.*(1 + expr923);
expr2833 = expr2790.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr835.*expr837.*expr854.*(1 + expr923);
expr2834 = expr2820.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*(1 + expr924);
expr2835 = expr1271.*expr2803.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr838.*expr840.*(1 + expr924);
expr2836 = -2.*expr2726.*expr483.*expr521.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610.*expr838.*expr839.*expr840.*(1 + expr924);
expr2837 = expr2822.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*(1 + expr925);
expr2838 = expr1625.*expr2804.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr841.*expr843.*(1 + expr925);
expr2839 = -2.*expr2726.*expr483.*expr503.*expr541.*expr543.*expr590.*expr607.*expr608.*expr610.*expr841.*expr842.*expr843.*(1 + expr925);
expr2840 = expr2824.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*(1 + expr926);
expr2841 = expr1968.*expr2805.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr615.*expr844.*expr846.*(1 + expr926);
expr2842 = -2.*expr2726.*expr483.*expr503.*expr523.*expr561.*expr590.*expr607.*expr608.*expr610.*expr844.*expr845.*expr846.*(1 + expr926);
expr2843 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(expr2826.*expr498.*expr830.*expr927.*expr930.*tpc - expr927.*(expr2827 + expr2826.*expr830.*expr891.*expr931.*tpc + expr2826.*expr482.*expr830.*expr933.*tpc));
expr2844 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(expr2826.*expr518.*expr830.*expr934.*expr935.*tpc - expr934.*(expr2828 + expr2826.*expr830.*expr892.*expr936.*tpc + expr2826.*expr502.*expr830.*expr938.*tpc));
expr2845 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(expr2826.*expr538.*expr830.*expr939.*expr940.*tpc - expr939.*(expr2829 + expr2826.*expr830.*expr893.*expr941.*tpc + expr2826.*expr522.*expr830.*expr943.*tpc));
expr2846 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(expr2826.*expr558.*expr830.*expr944.*expr945.*tpc - expr944.*(expr2830 + expr2826.*expr830.*expr894.*expr946.*tpc + expr2826.*expr542.*expr830.*expr948.*tpc));
expr2847 = integrate53 + integrate54 + integrate55 + integrate56 + 200.*(expr2831 + expr2832 + expr2833 + expr2834 + expr2835 + expr2836 + expr2837 + expr2838 + expr2839 + expr2840 + expr2841 + expr2842 + expr2843 + expr2844 + expr2845 + expr2846).*(-1 + expr949 + expr950 + expr951 + expr952).*WO;
gf(11) = expr2847;

%% Derivative for d(3)
w57 = [ws:(99.*ws)./100:100.*ws];
expr2848 = ((a(1).^2 + b(1).^2).^2 + w57.^2.*(w57.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr2849 = ((a(2).^2 + b(2).^2).^2 + w57.^2.*(w57.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr2850 = ((a(3).^2 + b(3).^2).^2 + w57.^2.*(w57.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr2851 = ((a(4).^2 + b(4).^2).^2 + w57.^2.*(w57.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr2852 = (c(1).^2 + d(1).^2).^2 + w57.^2.*(w57.^2 + 2.*(c(1).^2 - d(1).^2));
expr2853 = (c(2).^2 + d(2).^2).^2 + w57.^2.*(w57.^2 + 2.*(c(2).^2 - d(2).^2));
expr2854 = -4.*w57.^2.*d(3) + 4.*d(3).*(c(3).^2 + d(3).^2);
expr2855 = (c(4).^2 + d(4).^2).^2 + w57.^2.*(w57.^2 + 2.*(c(4).^2 - d(4).^2));
expr2856 = d(3);
expr2857 = (c(3).^2 + d(3).^2).^2 + w57.^2.*(w57.^2 + 2.*(c(3).^2 - d(3).^2));
expr2858 = expr2206.*expr2727.*expr2848.*expr2849.*expr2850.*expr2851.*expr2852.*expr2853.*expr2855.*expr2856.*expr2857.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr592.*Wms;
expr2859 = expr2197.*expr2848.*expr2849.*expr2850.*expr2851.*expr2852.*expr2853.*expr2854.*expr2855.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*Wms;
expr2860 = expr2858 + expr2859;
integrate57 = trapz(w57, expr2860);
w58 = [0:wp./100:wp];
expr2861 = (a(1).^2 + b(1).^2).^2 + w58.^2.*(w58.^2 + 2.*(a(1).^2 - b(1).^2));
expr2862 = (a(2).^2 + b(2).^2).^2 + w58.^2.*(w58.^2 + 2.*(a(2).^2 - b(2).^2));
expr2863 = (a(3).^2 + b(3).^2).^2 + w58.^2.*(w58.^2 + 2.*(a(3).^2 - b(3).^2));
expr2864 = (a(4).^2 + b(4).^2).^2 + w58.^2.*(w58.^2 + 2.*(a(4).^2 - b(4).^2));
expr2865 = (c(1).^2 + d(1).^2).^2 + w58.^2.*(w58.^2 + 2.*(c(1).^2 - d(1).^2));
expr2866 = (c(2).^2 + d(2).^2).^2 + w58.^2.*(w58.^2 + 2.*(c(2).^2 - d(2).^2));
expr2867 = -4.*w58.^2.*d(3) + 4.*d(3).*(c(3).^2 + d(3).^2);
expr2868 = (c(4).^2 + d(4).^2).^2 + w58.^2.*(w58.^2 + 2.*(c(4).^2 - d(4).^2));
expr2869 = (c(3).^2 + d(3).^2).^2 + w58.^2.*(w58.^2 + 2.*(c(3).^2 - d(3).^2));
expr2870 = -1 + (expr2861.*expr2862.*expr2863.*expr2864).^expr600.*(expr2865.*expr2866.*expr2868.*expr2869).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr2871 = -2.*expr2856.*(expr2861.*expr2862.*expr2863.*expr2864).^expr600.*(expr2865.*expr2866.*expr2868.*expr2869).^expr615.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610;
expr2872 = (expr2861.*expr2862.*expr2863.*expr2864).^expr600.*expr2865.*expr2866.*expr2867.*expr2868.*(expr2865.*expr2866.*expr2868.*expr2869).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr2873 = 2.*expr2870.*(expr2871 + expr2872).*expr599.*Wmp;
integrate58 = trapz(w58, expr2873);
w59 = [wp:(-wp + ws)./100:ws];
expr2874 = (a(1).^2 + b(1).^2).^2 + w59.^2.*(w59.^2 + 2.*(a(1).^2 - b(1).^2));
expr2875 = (a(2).^2 + b(2).^2).^2 + w59.^2.*(w59.^2 + 2.*(a(2).^2 - b(2).^2));
expr2876 = (a(3).^2 + b(3).^2).^2 + w59.^2.*(w59.^2 + 2.*(a(3).^2 - b(3).^2));
expr2877 = (a(4).^2 + b(4).^2).^2 + w59.^2.*(w59.^2 + 2.*(a(4).^2 - b(4).^2));
expr2878 = (c(1).^2 + d(1).^2).^2 + w59.^2.*(w59.^2 + 2.*(c(1).^2 - d(1).^2));
expr2879 = (c(2).^2 + d(2).^2).^2 + w59.^2.*(w59.^2 + 2.*(c(2).^2 - d(2).^2));
expr2880 = -4.*w59.^2.*d(3) + 4.*d(3).*(c(3).^2 + d(3).^2);
expr2881 = (c(4).^2 + d(4).^2).^2 + w59.^2.*(w59.^2 + 2.*(c(4).^2 - d(4).^2));
expr2882 = (c(3).^2 + d(3).^2).^2 + w59.^2.*(w59.^2 + 2.*(c(3).^2 - d(3).^2));
expr2883 = -(w59./(wp - ws));
expr2884 = -2.*expr2856.*(expr2874.*expr2875.*expr2876.*expr2877).^expr600.*(expr2878.*expr2879.*expr2881.*expr2882).^expr615.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610;
expr2885 = (expr2874.*expr2875.*expr2876.*expr2877).^expr600.*expr2878.*expr2879.*expr2880.*expr2881.*(expr2878.*expr2879.*expr2881.*expr2882).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr2886 = expr2883 + (expr2874.*expr2875.*expr2876.*expr2877).^expr600.*(expr2878.*expr2879.*expr2881.*expr2882).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr631;
expr2887 = 2.*(expr2884 + expr2885).*expr2886.*expr620.*Wmt;
integrate59 = trapz(w59, expr2887);
w60 = [0:wmax./100:wmax];
expr2888 = 1./(c(3).*(1 + (w60 - d(3)).^2./c(3).^2));
expr2889 = -(1./(c(3).*(1 + (w60 + d(3)).^2./c(3).^2)));
expr2890 = 2.*(angle(1 + (i.*(wmax - d(3)))./c(3)) + angle(1 + (i.*(wmax + d(3)))./c(3))).*d(3);
expr2891 = (-2.*(wmax - d(3)).*d(3))./(c(3).*(1 + (wmax - d(3)).^2./c(3).^2));
expr2892 = (-2.*d(3).*(wmax + d(3)))./(c(3).*(1 + (wmax + d(3)).^2./c(3).^2));
expr2893 = -(1./(c(3).*(1 + (wmax - d(3)).^2./c(3).^2)));
expr2894 = 1./(c(3).*(1 + (wmax + d(3)).^2./c(3).^2));
expr2895 = c(3).*log(1 + (wmax - d(3)).^2./c(3).^2);
expr2896 = -(c(3).*log(1 + (wmax + d(3)).^2./c(3).^2));
expr2897 = angle(1 + (i.*(w60 - b(1)))./a(1));
expr2898 = angle(1 + (i.*(w60 + b(1)))./a(1));
expr2899 = angle(1 + (i.*(w60 - b(2)))./a(2));
expr2900 = angle(1 + (i.*(w60 + b(2)))./a(2));
expr2901 = angle(1 + (i.*(w60 - b(3)))./a(3));
expr2902 = angle(1 + (i.*(w60 + b(3)))./a(3));
expr2903 = angle(1 + (i.*(w60 - b(4)))./a(4));
expr2904 = angle(1 + (i.*(w60 + b(4)))./a(4));
expr2905 = -angle(1 + (i.*(w60 - d(1)))./c(1));
expr2906 = -angle(1 + (i.*(w60 + d(1)))./c(1));
expr2907 = -angle(1 + (i.*(w60 - d(2)))./c(2));
expr2908 = -angle(1 + (i.*(w60 + d(2)))./c(2));
expr2909 = -angle(1 + (i.*(w60 - d(3)))./c(3));
expr2910 = -angle(1 + (i.*(w60 + d(3)))./c(3));
expr2911 = -angle(1 + (i.*(w60 - d(4)))./c(4));
expr2912 = -angle(1 + (i.*(w60 + d(4)))./c(4));
expr2913 = expr2888 + expr2889 + expr606.*expr639.*(expr2890 + expr2891 + expr2892 + expr2895 + expr2896 + (expr2893 + expr2894).*expr696).*w60;
expr2914 = 2.*expr2913.*expr636.*(expr2897 + expr2898 + expr2899 + expr2900 + expr2901 + expr2902 + expr2903 + expr2904 + expr2905 + expr2906 + expr2907 + expr2908 + expr2909 + expr2910 + expr2911 + expr2912 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w60).*Wph;
integrate60 = trapz(w60, expr2914);
expr2915 = 1./((a(1) - c(3)).*(1 + (b(1) - d(3)).^2./(a(1) - c(3)).^2));
expr2916 = 1./((a(2) - c(3)).*(1 + (b(2) - d(3)).^2./(a(2) - c(3)).^2));
expr2917 = 1./((a(3) - c(3)).*(1 + (b(3) - d(3)).^2./(a(3) - c(3)).^2));
expr2918 = 1./((a(4) - c(3)).*(1 + (b(4) - d(3)).^2./(a(4) - c(3)).^2));
expr2919 = (expr1057 + expr2915).*expr498.*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr2920 = -((expr1057 + expr2915).*expr482.*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497));
expr2921 = 2.*expr1043.*expr732.*expr733.*expr734.*expr735.*expr736.*expr738.*expr739 - 2.*expr732.*expr733.*expr734.*expr735.*expr737.*expr738.*expr739.*expr811;
expr2922 = expr1057 + expr2915;
expr2923 = (expr1414 + expr2916).*expr518.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr2924 = -((expr1414 + expr2916).*expr502.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517));
expr2925 = expr1414 + expr2916;
expr2926 = (expr1767 + expr2917).*expr538.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr2927 = -((expr1767 + expr2917).*expr522.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537));
expr2928 = expr1767 + expr2917;
expr2929 = (expr2109 + expr2918).*expr558.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr2930 = -((expr2109 + expr2918).*expr542.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557));
expr2931 = expr2109 + expr2918;
expr2932 = 2.*expr1425.*expr746.*expr747.*expr748.*expr749.*expr750.*expr752.*expr753 - 2.*expr1236.*expr746.*expr747.*expr748.*expr749.*expr751.*expr752.*expr753;
expr2933 = 2.*expr1775.*expr760.*expr761.*expr762.*expr763.*expr764.*expr766.*expr767 - 2.*expr1595.*expr760.*expr761.*expr762.*expr763.*expr765.*expr766.*expr767;
expr2934 = 2.*expr2114.*expr774.*expr775.*expr776.*expr777.*expr778.*expr780.*expr781 - 2.*expr1943.*expr774.*expr775.*expr776.*expr777.*expr779.*expr780.*expr781;
expr2935 = expr2919 + expr2920;
expr2936 = (expr2922.*expr482.*expr483.*expr563.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr2937 = -(((expr2919 + expr2920).*expr482.*expr483.*expr562.*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr2938 = -((expr482.*expr483.*expr562.*expr563.*(-(expr2922.*expr483.*expr498.*expr563.*expr864) + (expr2919 + expr2920).*expr483.*expr498.*expr562.*expr866))./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^2);
expr2939 = -(((expr2923 + expr2924).*expr502.*expr503.*expr564.*expr868)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr2940 = (expr2925.*expr502.*expr503.*expr565.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr2941 = -((expr502.*expr503.*expr564.*expr565.*((expr2923 + expr2924).*expr503.*expr518.*expr564.*expr868 - expr2925.*expr503.*expr518.*expr565.*expr870))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^2);
expr2942 = -(((expr2926 + expr2927).*expr522.*expr523.*expr566.*expr874)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr2943 = (expr2928.*expr522.*expr523.*expr567.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr2944 = -((expr522.*expr523.*expr566.*expr567.*((expr2926 + expr2927).*expr523.*expr538.*expr566.*expr874 - expr2928.*expr523.*expr538.*expr567.*expr876))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^2);
expr2945 = -(((expr2929 + expr2930).*expr542.*expr543.*expr568.*expr880)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr2946 = (expr2931.*expr542.*expr543.*expr569.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr2947 = -((expr542.*expr543.*expr568.*expr569.*((expr2929 + expr2930).*expr543.*expr558.*expr568.*expr880 - expr2931.*expr543.*expr558.*expr569.*expr882))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^2);
expr2948 = -(expr2922.*expr483.*expr563.*expr864) + (expr2919 + expr2920).*expr483.*expr562.*expr866;
expr2949 = expr2923 + expr2924;
expr2950 = (expr2923 + expr2924).*expr503.*expr564.*expr868 - expr2925.*expr503.*expr565.*expr870;
expr2951 = expr2926 + expr2927;
expr2952 = (expr2926 + expr2927).*expr523.*expr566.*expr874 - expr2928.*expr523.*expr567.*expr876;
expr2953 = expr2929 + expr2930;
expr2954 = (expr2929 + expr2930).*expr543.*expr568.*expr880 - expr2931.*expr543.*expr569.*expr882;
expr2955 = (expr2936 + expr2937 + expr2938).*expr501.*expr898 + (expr2939 + expr2940 + expr2941).*expr521.*expr904 + (expr2942 + expr2943 + expr2944).*expr541.*expr908 + (expr2945 + expr2946 + expr2947).*expr561.*expr912;
expr2956 = -(expr2948.*expr501.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2957 = -(expr2950.*expr521.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2958 = -(expr2952.*expr541.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2959 = -(expr2954.*expr561.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr2960 = expr2935.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*(1 + expr923);
expr2961 = -2.*expr2856.*expr501.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610.*expr835.*expr836.*expr837.*(1 + expr923);
expr2962 = expr2921.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr835.*expr837.*expr854.*(1 + expr923);
expr2963 = expr2949.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*(1 + expr924);
expr2964 = expr1271.*expr2932.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr838.*expr840.*(1 + expr924);
expr2965 = -2.*expr2856.*expr483.*expr521.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610.*expr838.*expr839.*expr840.*(1 + expr924);
expr2966 = expr2951.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*(1 + expr925);
expr2967 = expr1625.*expr2933.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr841.*expr843.*(1 + expr925);
expr2968 = -2.*expr2856.*expr483.*expr503.*expr541.*expr543.*expr590.*expr607.*expr608.*expr610.*expr841.*expr842.*expr843.*(1 + expr925);
expr2969 = expr2953.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*(1 + expr926);
expr2970 = expr1968.*expr2934.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr615.*expr844.*expr846.*(1 + expr926);
expr2971 = -2.*expr2856.*expr483.*expr503.*expr523.*expr561.*expr590.*expr607.*expr608.*expr610.*expr844.*expr845.*expr846.*(1 + expr926);
expr2972 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(expr2955.*expr498.*expr830.*expr927.*expr930.*tpc - expr927.*(expr2956 + expr2955.*expr830.*expr891.*expr931.*tpc + expr2955.*expr482.*expr830.*expr933.*tpc));
expr2973 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(expr2955.*expr518.*expr830.*expr934.*expr935.*tpc - expr934.*(expr2957 + expr2955.*expr830.*expr892.*expr936.*tpc + expr2955.*expr502.*expr830.*expr938.*tpc));
expr2974 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(expr2955.*expr538.*expr830.*expr939.*expr940.*tpc - expr939.*(expr2958 + expr2955.*expr830.*expr893.*expr941.*tpc + expr2955.*expr522.*expr830.*expr943.*tpc));
expr2975 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(expr2955.*expr558.*expr830.*expr944.*expr945.*tpc - expr944.*(expr2959 + expr2955.*expr830.*expr894.*expr946.*tpc + expr2955.*expr542.*expr830.*expr948.*tpc));
expr2976 = integrate57 + integrate58 + integrate59 + integrate60 + 200.*(expr2960 + expr2961 + expr2962 + expr2963 + expr2964 + expr2965 + expr2966 + expr2967 + expr2968 + expr2969 + expr2970 + expr2971 + expr2972 + expr2973 + expr2974 + expr2975).*(-1 + expr949 + expr950 + expr951 + expr952).*WO;
gf(15) = expr2976;

%% Derivative for c(4)
w61 = [ws:(99.*ws)./100:100.*ws];
expr2977 = ((a(1).^2 + b(1).^2).^2 + w61.^2.*(w61.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr2978 = ((a(2).^2 + b(2).^2).^2 + w61.^2.*(w61.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr2979 = ((a(3).^2 + b(3).^2).^2 + w61.^2.*(w61.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr2980 = ((a(4).^2 + b(4).^2).^2 + w61.^2.*(w61.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr2981 = (c(1).^2 + d(1).^2).^2 + w61.^2.*(w61.^2 + 2.*(c(1).^2 - d(1).^2));
expr2982 = (c(2).^2 + d(2).^2).^2 + w61.^2.*(w61.^2 + 2.*(c(2).^2 - d(2).^2));
expr2983 = (c(3).^2 + d(3).^2).^2 + w61.^2.*(w61.^2 + 2.*(c(3).^2 - d(3).^2));
expr2984 = 4.*w61.^2.*c(4) + 4.*c(4).*(c(4).^2 + d(4).^2);
expr2985 = c(4);
expr2986 = (c(4).^2 + d(4).^2).^(-3);
expr2987 = (c(4).^2 + d(4).^2).^2 + w61.^2.*(w61.^2 + 2.*(c(4).^2 - d(4).^2));
expr2988 = expr2206.*expr2977.*expr2978.*expr2979.*expr2980.*expr2981.*expr2982.*expr2983.*expr2985.*expr2986.*expr2987.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*Wms;
expr2989 = expr2197.*expr2977.*expr2978.*expr2979.*expr2980.*expr2981.*expr2982.*expr2983.*expr2984.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*Wms;
expr2990 = expr2988 + expr2989;
integrate61 = trapz(w61, expr2990);
w62 = [0:wp./100:wp];
expr2991 = (a(1).^2 + b(1).^2).^2 + w62.^2.*(w62.^2 + 2.*(a(1).^2 - b(1).^2));
expr2992 = (a(2).^2 + b(2).^2).^2 + w62.^2.*(w62.^2 + 2.*(a(2).^2 - b(2).^2));
expr2993 = (a(3).^2 + b(3).^2).^2 + w62.^2.*(w62.^2 + 2.*(a(3).^2 - b(3).^2));
expr2994 = (a(4).^2 + b(4).^2).^2 + w62.^2.*(w62.^2 + 2.*(a(4).^2 - b(4).^2));
expr2995 = (c(1).^2 + d(1).^2).^2 + w62.^2.*(w62.^2 + 2.*(c(1).^2 - d(1).^2));
expr2996 = (c(2).^2 + d(2).^2).^2 + w62.^2.*(w62.^2 + 2.*(c(2).^2 - d(2).^2));
expr2997 = (c(3).^2 + d(3).^2).^2 + w62.^2.*(w62.^2 + 2.*(c(3).^2 - d(3).^2));
expr2998 = 4.*w62.^2.*c(4) + 4.*c(4).*(c(4).^2 + d(4).^2);
expr2999 = (c(4).^2 + d(4).^2).^2 + w62.^2.*(w62.^2 + 2.*(c(4).^2 - d(4).^2));
expr3000 = -1 + (expr2991.*expr2992.*expr2993.*expr2994).^expr600.*(expr2995.*expr2996.*expr2997.*expr2999).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3001 = -2.*expr2985.*(expr2991.*expr2992.*expr2993.*expr2994).^expr600.*(expr2995.*expr2996.*expr2997.*expr2999).^expr615.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609;
expr3002 = (expr2991.*expr2992.*expr2993.*expr2994).^expr600.*expr2995.*expr2996.*expr2997.*expr2998.*(expr2995.*expr2996.*expr2997.*expr2999).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3003 = 2.*expr3000.*(expr3001 + expr3002).*expr599.*Wmp;
integrate62 = trapz(w62, expr3003);
w63 = [wp:(-wp + ws)./100:ws];
expr3004 = (a(1).^2 + b(1).^2).^2 + w63.^2.*(w63.^2 + 2.*(a(1).^2 - b(1).^2));
expr3005 = (a(2).^2 + b(2).^2).^2 + w63.^2.*(w63.^2 + 2.*(a(2).^2 - b(2).^2));
expr3006 = (a(3).^2 + b(3).^2).^2 + w63.^2.*(w63.^2 + 2.*(a(3).^2 - b(3).^2));
expr3007 = (a(4).^2 + b(4).^2).^2 + w63.^2.*(w63.^2 + 2.*(a(4).^2 - b(4).^2));
expr3008 = (c(1).^2 + d(1).^2).^2 + w63.^2.*(w63.^2 + 2.*(c(1).^2 - d(1).^2));
expr3009 = (c(2).^2 + d(2).^2).^2 + w63.^2.*(w63.^2 + 2.*(c(2).^2 - d(2).^2));
expr3010 = (c(3).^2 + d(3).^2).^2 + w63.^2.*(w63.^2 + 2.*(c(3).^2 - d(3).^2));
expr3011 = 4.*w63.^2.*c(4) + 4.*c(4).*(c(4).^2 + d(4).^2);
expr3012 = (c(4).^2 + d(4).^2).^2 + w63.^2.*(w63.^2 + 2.*(c(4).^2 - d(4).^2));
expr3013 = -(w63./(wp - ws));
expr3014 = -2.*expr2985.*(expr3004.*expr3005.*expr3006.*expr3007).^expr600.*(expr3008.*expr3009.*expr3010.*expr3012).^expr615.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609;
expr3015 = (expr3004.*expr3005.*expr3006.*expr3007).^expr600.*expr3008.*expr3009.*expr3010.*expr3011.*(expr3008.*expr3009.*expr3010.*expr3012).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3016 = expr3013 + (expr3004.*expr3005.*expr3006.*expr3007).^expr600.*(expr3008.*expr3009.*expr3010.*expr3012).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr631;
expr3017 = 2.*(expr3014 + expr3015).*expr3016.*expr620.*Wmt;
integrate63 = trapz(w63, expr3017);
w64 = [0:wmax./100:wmax];
expr3018 = (w64 - d(4))./(c(4).^2.*(1 + (w64 - d(4)).^2./c(4).^2));
expr3019 = (w64 + d(4))./(c(4).^2.*(1 + (w64 + d(4)).^2./c(4).^2));
expr3020 = -2.*(angle(1 + (i.*(wmax - d(4)))./c(4)) + angle(1 + (i.*(wmax + d(4)))./c(4))).*c(4);
expr3021 = (-2.*(wmax - d(4)).^2.*d(4))./(c(4).^2.*(1 + (wmax - d(4)).^2./c(4).^2));
expr3022 = (2.*d(4).*(wmax + d(4)).^2)./(c(4).^2.*(1 + (wmax + d(4)).^2./c(4).^2));
expr3023 = -((wmax - d(4))./(c(4).^2.*(1 + (wmax - d(4)).^2./c(4).^2)));
expr3024 = -((wmax + d(4))./(c(4).^2.*(1 + (wmax + d(4)).^2./c(4).^2)));
expr3025 = d(4).*log(1 + (wmax - d(4)).^2./c(4).^2);
expr3026 = -(d(4).*log(1 + (wmax + d(4)).^2./c(4).^2));
expr3027 = angle(1 + (i.*(w64 - b(1)))./a(1));
expr3028 = angle(1 + (i.*(w64 + b(1)))./a(1));
expr3029 = angle(1 + (i.*(w64 - b(2)))./a(2));
expr3030 = angle(1 + (i.*(w64 + b(2)))./a(2));
expr3031 = angle(1 + (i.*(w64 - b(3)))./a(3));
expr3032 = angle(1 + (i.*(w64 + b(3)))./a(3));
expr3033 = angle(1 + (i.*(w64 - b(4)))./a(4));
expr3034 = angle(1 + (i.*(w64 + b(4)))./a(4));
expr3035 = -angle(1 + (i.*(w64 - d(1)))./c(1));
expr3036 = -angle(1 + (i.*(w64 + d(1)))./c(1));
expr3037 = -angle(1 + (i.*(w64 - d(2)))./c(2));
expr3038 = -angle(1 + (i.*(w64 + d(2)))./c(2));
expr3039 = -angle(1 + (i.*(w64 - d(3)))./c(3));
expr3040 = -angle(1 + (i.*(w64 + d(3)))./c(3));
expr3041 = -angle(1 + (i.*(w64 - d(4)))./c(4));
expr3042 = -angle(1 + (i.*(w64 + d(4)))./c(4));
expr3043 = expr3018 + expr3019 + expr606.*expr639.*(expr2242 + expr3020 + expr3021 + expr3022 + expr3025 + expr3026 + (expr3023 + expr3024).*expr701).*w64;
expr3044 = 2.*expr3043.*expr636.*(expr3027 + expr3028 + expr3029 + expr3030 + expr3031 + expr3032 + expr3033 + expr3034 + expr3035 + expr3036 + expr3037 + expr3038 + expr3039 + expr3040 + expr3041 + expr3042 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w64).*Wph;
integrate64 = trapz(w64, expr3044);
expr3045 = -((b(1) + d(4))./((a(1) - c(4)).^2.*(1 + (b(1) + d(4)).^2./(a(1) - c(4)).^2)));
expr3046 = -((b(2) + d(4))./((a(2) - c(4)).^2.*(1 + (b(2) + d(4)).^2./(a(2) - c(4)).^2)));
expr3047 = -((b(3) + d(4))./((a(3) - c(4)).^2.*(1 + (b(3) + d(4)).^2./(a(3) - c(4)).^2)));
expr3048 = -((b(4) + d(4))./((a(4) - c(4)).^2.*(1 + (b(4) + d(4)).^2./(a(4) - c(4)).^2)));
expr3049 = -2.*expr732.*expr733.*expr734.*expr735.*expr736.*expr737.*expr738.*expr785 - 2.*expr732.*expr733.*expr734.*expr735.*expr736.*expr737.*expr739.*expr785;
expr3050 = expr498.*(expr3045 - expr813.*expr814.*expr815).*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr3051 = -(expr482.*(expr3045 - expr813.*expr814.*expr815).*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497));
expr3052 = expr3045 - expr813.*expr814.*expr815;
expr3053 = (-(expr1238.*expr1239.*expr1240) + expr3046).*expr518.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr3054 = -((-(expr1238.*expr1239.*expr1240) + expr3046).*expr502.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517));
expr3055 = -(expr1238.*expr1239.*expr1240) + expr3046;
expr3056 = (-(expr1597.*expr1598.*expr1599) + expr3047).*expr538.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr3057 = -((-(expr1597.*expr1598.*expr1599) + expr3047).*expr522.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537));
expr3058 = -(expr1597.*expr1598.*expr1599) + expr3047;
expr3059 = (-(expr1945.*expr1946.*expr1947) + expr3048).*expr558.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr3060 = -((-(expr1945.*expr1946.*expr1947) + expr3048).*expr542.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557));
expr3061 = -(expr1945.*expr1946.*expr1947) + expr3048;
expr3062 = -2.*expr1253.*expr746.*expr747.*expr748.*expr749.*expr750.*expr751.*expr752 - 2.*expr1253.*expr746.*expr747.*expr748.*expr749.*expr750.*expr751.*expr753;
expr3063 = -2.*expr1607.*expr760.*expr761.*expr762.*expr763.*expr764.*expr765.*expr766 - 2.*expr1607.*expr760.*expr761.*expr762.*expr763.*expr764.*expr765.*expr767;
expr3064 = -2.*expr1950.*expr774.*expr775.*expr776.*expr777.*expr778.*expr779.*expr780 - 2.*expr1950.*expr774.*expr775.*expr776.*expr777.*expr778.*expr779.*expr781;
expr3065 = expr3050 + expr3051;
expr3066 = (expr3052.*expr482.*expr483.*expr563.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr3067 = -(((expr3050 + expr3051).*expr482.*expr483.*expr562.*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr3068 = -((expr482.*expr483.*expr562.*expr563.*(-(expr3052.*expr483.*expr498.*expr563.*expr864) + (expr3050 + expr3051).*expr483.*expr498.*expr562.*expr866))./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^2);
expr3069 = -(((expr3053 + expr3054).*expr502.*expr503.*expr564.*expr868)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr3070 = (expr3055.*expr502.*expr503.*expr565.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr3071 = -((expr502.*expr503.*expr564.*expr565.*((expr3053 + expr3054).*expr503.*expr518.*expr564.*expr868 - expr3055.*expr503.*expr518.*expr565.*expr870))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^2);
expr3072 = -(((expr3056 + expr3057).*expr522.*expr523.*expr566.*expr874)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr3073 = (expr3058.*expr522.*expr523.*expr567.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr3074 = -((expr522.*expr523.*expr566.*expr567.*((expr3056 + expr3057).*expr523.*expr538.*expr566.*expr874 - expr3058.*expr523.*expr538.*expr567.*expr876))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^2);
expr3075 = -(((expr3059 + expr3060).*expr542.*expr543.*expr568.*expr880)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr3076 = (expr3061.*expr542.*expr543.*expr569.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr3077 = -((expr542.*expr543.*expr568.*expr569.*((expr3059 + expr3060).*expr543.*expr558.*expr568.*expr880 - expr3061.*expr543.*expr558.*expr569.*expr882))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^2);
expr3078 = -(expr3052.*expr483.*expr563.*expr864) + (expr3050 + expr3051).*expr483.*expr562.*expr866;
expr3079 = expr3053 + expr3054;
expr3080 = (expr3053 + expr3054).*expr503.*expr564.*expr868 - expr3055.*expr503.*expr565.*expr870;
expr3081 = expr3056 + expr3057;
expr3082 = (expr3056 + expr3057).*expr523.*expr566.*expr874 - expr3058.*expr523.*expr567.*expr876;
expr3083 = expr3059 + expr3060;
expr3084 = (expr3059 + expr3060).*expr543.*expr568.*expr880 - expr3061.*expr543.*expr569.*expr882;
expr3085 = (expr3066 + expr3067 + expr3068).*expr501.*expr898 + (expr3069 + expr3070 + expr3071).*expr521.*expr904 + (expr3072 + expr3073 + expr3074).*expr541.*expr908 + (expr3075 + expr3076 + expr3077).*expr561.*expr912;
expr3086 = -(expr3078.*expr501.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr3087 = -(expr3080.*expr521.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr3088 = -(expr3082.*expr541.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr3089 = -(expr3084.*expr561.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr3090 = expr3065.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*(1 + expr923);
expr3091 = -2.*expr2985.*expr501.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609.*expr835.*expr836.*expr837.*(1 + expr923);
expr3092 = expr3049.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr835.*expr837.*expr854.*(1 + expr923);
expr3093 = expr3079.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*(1 + expr924);
expr3094 = expr1271.*expr3062.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr838.*expr840.*(1 + expr924);
expr3095 = -2.*expr2985.*expr483.*expr521.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609.*expr838.*expr839.*expr840.*(1 + expr924);
expr3096 = expr3081.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*(1 + expr925);
expr3097 = expr1625.*expr3063.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr841.*expr843.*(1 + expr925);
expr3098 = -2.*expr2985.*expr483.*expr503.*expr541.*expr543.*expr592.*expr607.*expr608.*expr609.*expr841.*expr842.*expr843.*(1 + expr925);
expr3099 = expr3083.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*(1 + expr926);
expr3100 = expr1968.*expr3064.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr615.*expr844.*expr846.*(1 + expr926);
expr3101 = -2.*expr2985.*expr483.*expr503.*expr523.*expr561.*expr592.*expr607.*expr608.*expr609.*expr844.*expr845.*expr846.*(1 + expr926);
expr3102 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(expr3085.*expr498.*expr830.*expr927.*expr930.*tpc - expr927.*(expr3086 + expr3085.*expr830.*expr891.*expr931.*tpc + expr3085.*expr482.*expr830.*expr933.*tpc));
expr3103 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(expr3085.*expr518.*expr830.*expr934.*expr935.*tpc - expr934.*(expr3087 + expr3085.*expr830.*expr892.*expr936.*tpc + expr3085.*expr502.*expr830.*expr938.*tpc));
expr3104 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(expr3085.*expr538.*expr830.*expr939.*expr940.*tpc - expr939.*(expr3088 + expr3085.*expr830.*expr893.*expr941.*tpc + expr3085.*expr522.*expr830.*expr943.*tpc));
expr3105 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(expr3085.*expr558.*expr830.*expr944.*expr945.*tpc - expr944.*(expr3089 + expr3085.*expr830.*expr894.*expr946.*tpc + expr3085.*expr542.*expr830.*expr948.*tpc));
expr3106 = integrate61 + integrate62 + integrate63 + integrate64 + 200.*(expr3090 + expr3091 + expr3092 + expr3093 + expr3094 + expr3095 + expr3096 + expr3097 + expr3098 + expr3099 + expr3100 + expr3101 + expr3102 + expr3103 + expr3104 + expr3105).*(-1 + expr949 + expr950 + expr951 + expr952).*WO;
gf(12) = expr3106;

%% Derivative for d(4)
w65 = [ws:(99.*ws)./100:100.*ws];
expr3107 = ((a(1).^2 + b(1).^2).^2 + w65.^2.*(w65.^2 + 2.*(a(1).^2 - b(1).^2))).^(-1);
expr3108 = ((a(2).^2 + b(2).^2).^2 + w65.^2.*(w65.^2 + 2.*(a(2).^2 - b(2).^2))).^(-1);
expr3109 = ((a(3).^2 + b(3).^2).^2 + w65.^2.*(w65.^2 + 2.*(a(3).^2 - b(3).^2))).^(-1);
expr3110 = ((a(4).^2 + b(4).^2).^2 + w65.^2.*(w65.^2 + 2.*(a(4).^2 - b(4).^2))).^(-1);
expr3111 = (c(1).^2 + d(1).^2).^2 + w65.^2.*(w65.^2 + 2.*(c(1).^2 - d(1).^2));
expr3112 = (c(2).^2 + d(2).^2).^2 + w65.^2.*(w65.^2 + 2.*(c(2).^2 - d(2).^2));
expr3113 = (c(3).^2 + d(3).^2).^2 + w65.^2.*(w65.^2 + 2.*(c(3).^2 - d(3).^2));
expr3114 = -4.*w65.^2.*d(4) + 4.*d(4).*(c(4).^2 + d(4).^2);
expr3115 = d(4);
expr3116 = (c(4).^2 + d(4).^2).^2 + w65.^2.*(w65.^2 + 2.*(c(4).^2 - d(4).^2));
expr3117 = expr2206.*expr2986.*expr3107.*expr3108.*expr3109.*expr3110.*expr3111.*expr3112.*expr3113.*expr3115.*expr3116.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*Wms;
expr3118 = expr2197.*expr3107.*expr3108.*expr3109.*expr3110.*expr3111.*expr3112.*expr3113.*expr3114.*expr576.*expr577.*expr580.*expr582.*expr584.*expr586.*expr588.*expr590.*expr592.*Wms;
expr3119 = expr3117 + expr3118;
integrate65 = trapz(w65, expr3119);
w66 = [0:wp./100:wp];
expr3120 = (a(1).^2 + b(1).^2).^2 + w66.^2.*(w66.^2 + 2.*(a(1).^2 - b(1).^2));
expr3121 = (a(2).^2 + b(2).^2).^2 + w66.^2.*(w66.^2 + 2.*(a(2).^2 - b(2).^2));
expr3122 = (a(3).^2 + b(3).^2).^2 + w66.^2.*(w66.^2 + 2.*(a(3).^2 - b(3).^2));
expr3123 = (a(4).^2 + b(4).^2).^2 + w66.^2.*(w66.^2 + 2.*(a(4).^2 - b(4).^2));
expr3124 = (c(1).^2 + d(1).^2).^2 + w66.^2.*(w66.^2 + 2.*(c(1).^2 - d(1).^2));
expr3125 = (c(2).^2 + d(2).^2).^2 + w66.^2.*(w66.^2 + 2.*(c(2).^2 - d(2).^2));
expr3126 = (c(3).^2 + d(3).^2).^2 + w66.^2.*(w66.^2 + 2.*(c(3).^2 - d(3).^2));
expr3127 = -4.*w66.^2.*d(4) + 4.*d(4).*(c(4).^2 + d(4).^2);
expr3128 = (c(4).^2 + d(4).^2).^2 + w66.^2.*(w66.^2 + 2.*(c(4).^2 - d(4).^2));
expr3129 = -1 + (expr3120.*expr3121.*expr3122.*expr3123).^expr600.*(expr3124.*expr3125.*expr3126.*expr3128).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3130 = -2.*expr3115.*(expr3120.*expr3121.*expr3122.*expr3123).^expr600.*(expr3124.*expr3125.*expr3126.*expr3128).^expr615.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609;
expr3131 = (expr3120.*expr3121.*expr3122.*expr3123).^expr600.*expr3124.*expr3125.*expr3126.*expr3127.*(expr3124.*expr3125.*expr3126.*expr3128).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3132 = 2.*expr3129.*(expr3130 + expr3131).*expr599.*Wmp;
integrate66 = trapz(w66, expr3132);
w67 = [wp:(-wp + ws)./100:ws];
expr3133 = (a(1).^2 + b(1).^2).^2 + w67.^2.*(w67.^2 + 2.*(a(1).^2 - b(1).^2));
expr3134 = (a(2).^2 + b(2).^2).^2 + w67.^2.*(w67.^2 + 2.*(a(2).^2 - b(2).^2));
expr3135 = (a(3).^2 + b(3).^2).^2 + w67.^2.*(w67.^2 + 2.*(a(3).^2 - b(3).^2));
expr3136 = (a(4).^2 + b(4).^2).^2 + w67.^2.*(w67.^2 + 2.*(a(4).^2 - b(4).^2));
expr3137 = (c(1).^2 + d(1).^2).^2 + w67.^2.*(w67.^2 + 2.*(c(1).^2 - d(1).^2));
expr3138 = (c(2).^2 + d(2).^2).^2 + w67.^2.*(w67.^2 + 2.*(c(2).^2 - d(2).^2));
expr3139 = (c(3).^2 + d(3).^2).^2 + w67.^2.*(w67.^2 + 2.*(c(3).^2 - d(3).^2));
expr3140 = -4.*w67.^2.*d(4) + 4.*d(4).*(c(4).^2 + d(4).^2);
expr3141 = (c(4).^2 + d(4).^2).^2 + w67.^2.*(w67.^2 + 2.*(c(4).^2 - d(4).^2));
expr3142 = -(w67./(wp - ws));
expr3143 = -2.*expr3115.*(expr3133.*expr3134.*expr3135.*expr3136).^expr600.*(expr3137.*expr3138.*expr3139.*expr3141).^expr615.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609;
expr3144 = (expr3133.*expr3134.*expr3135.*expr3136).^expr600.*expr3137.*expr3138.*expr3139.*expr3140.*(expr3137.*expr3138.*expr3139.*expr3141).^expr600.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3145 = expr3142 + (expr3133.*expr3134.*expr3135.*expr3136).^expr600.*(expr3137.*expr3138.*expr3139.*expr3141).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr631;
expr3146 = 2.*(expr3143 + expr3144).*expr3145.*expr620.*Wmt;
integrate67 = trapz(w67, expr3146);
w68 = [0:wmax./100:wmax];
expr3147 = 1./(c(4).*(1 + (w68 - d(4)).^2./c(4).^2));
expr3148 = -(1./(c(4).*(1 + (w68 + d(4)).^2./c(4).^2)));
expr3149 = 2.*(angle(1 + (i.*(wmax - d(4)))./c(4)) + angle(1 + (i.*(wmax + d(4)))./c(4))).*d(4);
expr3150 = (-2.*(wmax - d(4)).*d(4))./(c(4).*(1 + (wmax - d(4)).^2./c(4).^2));
expr3151 = (-2.*d(4).*(wmax + d(4)))./(c(4).*(1 + (wmax + d(4)).^2./c(4).^2));
expr3152 = -(1./(c(4).*(1 + (wmax - d(4)).^2./c(4).^2)));
expr3153 = 1./(c(4).*(1 + (wmax + d(4)).^2./c(4).^2));
expr3154 = c(4).*log(1 + (wmax - d(4)).^2./c(4).^2);
expr3155 = -(c(4).*log(1 + (wmax + d(4)).^2./c(4).^2));
expr3156 = angle(1 + (i.*(w68 - b(1)))./a(1));
expr3157 = angle(1 + (i.*(w68 + b(1)))./a(1));
expr3158 = angle(1 + (i.*(w68 - b(2)))./a(2));
expr3159 = angle(1 + (i.*(w68 + b(2)))./a(2));
expr3160 = angle(1 + (i.*(w68 - b(3)))./a(3));
expr3161 = angle(1 + (i.*(w68 + b(3)))./a(3));
expr3162 = angle(1 + (i.*(w68 - b(4)))./a(4));
expr3163 = angle(1 + (i.*(w68 + b(4)))./a(4));
expr3164 = -angle(1 + (i.*(w68 - d(1)))./c(1));
expr3165 = -angle(1 + (i.*(w68 + d(1)))./c(1));
expr3166 = -angle(1 + (i.*(w68 - d(2)))./c(2));
expr3167 = -angle(1 + (i.*(w68 + d(2)))./c(2));
expr3168 = -angle(1 + (i.*(w68 - d(3)))./c(3));
expr3169 = -angle(1 + (i.*(w68 + d(3)))./c(3));
expr3170 = -angle(1 + (i.*(w68 - d(4)))./c(4));
expr3171 = -angle(1 + (i.*(w68 + d(4)))./c(4));
expr3172 = expr3147 + expr3148 + expr606.*expr639.*(expr3149 + expr3150 + expr3151 + expr3154 + expr3155 + (expr3152 + expr3153).*expr701).*w68;
expr3173 = 2.*expr3172.*expr636.*(expr3156 + expr3157 + expr3158 + expr3159 + expr3160 + expr3161 + expr3162 + expr3163 + expr3164 + expr3165 + expr3166 + expr3167 + expr3168 + expr3169 + expr3170 + expr3171 - 3.*expr639.*(expr705 + expr706 + expr707 + expr708 + expr709 + expr710 + expr711 + expr712).*w68).*Wph;
integrate68 = trapz(w68, expr3173);
expr3174 = 1./((a(1) - c(4)).*(1 + (b(1) - d(4)).^2./(a(1) - c(4)).^2));
expr3175 = 1./((a(2) - c(4)).*(1 + (b(2) - d(4)).^2./(a(2) - c(4)).^2));
expr3176 = 1./((a(3) - c(4)).*(1 + (b(3) - d(4)).^2./(a(3) - c(4)).^2));
expr3177 = 1./((a(4) - c(4)).*(1 + (b(4) - d(4)).^2./(a(4) - c(4)).^2));
expr3178 = (expr1059 + expr3174).*expr498.*cos(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497);
expr3179 = -((expr1059 + expr3174).*expr482.*sin(expr484 + expr485 + expr486 + expr487 + expr488 + expr489 + expr490 + expr491 + expr492 + expr493 + expr494 + expr495 + expr496 + expr497));
expr3180 = 2.*expr1042.*expr732.*expr733.*expr734.*expr735.*expr736.*expr737.*expr738 - 2.*expr732.*expr733.*expr734.*expr735.*expr736.*expr737.*expr739.*expr815;
expr3181 = expr1059 + expr3174;
expr3182 = (expr1416 + expr3175).*expr518.*cos(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517);
expr3183 = -((expr1416 + expr3175).*expr502.*sin(expr504 + expr505 + expr506 + expr507 + expr508 + expr509 + expr510 + expr511 + expr512 + expr513 + expr514 + expr515 + expr516 + expr517));
expr3184 = expr1416 + expr3175;
expr3185 = (expr1769 + expr3176).*expr538.*cos(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537);
expr3186 = -((expr1769 + expr3176).*expr522.*sin(expr524 + expr525 + expr526 + expr527 + expr528 + expr529 + expr530 + expr531 + expr532 + expr533 + expr534 + expr535 + expr536 + expr537));
expr3187 = expr1769 + expr3176;
expr3188 = (expr2111 + expr3177).*expr558.*cos(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557);
expr3189 = -((expr2111 + expr3177).*expr542.*sin(expr544 + expr545 + expr546 + expr547 + expr548 + expr549 + expr550 + expr551 + expr552 + expr553 + expr554 + expr555 + expr556 + expr557));
expr3190 = expr2111 + expr3177;
expr3191 = 2.*expr1424.*expr746.*expr747.*expr748.*expr749.*expr750.*expr751.*expr752 - 2.*expr1240.*expr746.*expr747.*expr748.*expr749.*expr750.*expr751.*expr753;
expr3192 = 2.*expr1774.*expr760.*expr761.*expr762.*expr763.*expr764.*expr765.*expr766 - 2.*expr1599.*expr760.*expr761.*expr762.*expr763.*expr764.*expr765.*expr767;
expr3193 = 2.*expr2113.*expr774.*expr775.*expr776.*expr777.*expr778.*expr779.*expr780 - 2.*expr1947.*expr774.*expr775.*expr776.*expr777.*expr778.*expr779.*expr781;
expr3194 = expr3178 + expr3179;
expr3195 = (expr3181.*expr482.*expr483.*expr563.*expr864)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563);
expr3196 = -(((expr3178 + expr3179).*expr482.*expr483.*expr562.*expr866)./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563));
expr3197 = -((expr482.*expr483.*expr562.*expr563.*(-(expr3181.*expr483.*expr498.*expr563.*expr864) + (expr3178 + expr3179).*expr483.*expr498.*expr562.*expr866))./(expr499 + expr500 - expr483.*expr498.*expr562.*expr563).^2);
expr3198 = -(((expr3182 + expr3183).*expr502.*expr503.*expr564.*expr868)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565));
expr3199 = (expr3184.*expr502.*expr503.*expr565.*expr870)./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565);
expr3200 = -((expr502.*expr503.*expr564.*expr565.*((expr3182 + expr3183).*expr503.*expr518.*expr564.*expr868 - expr3184.*expr503.*expr518.*expr565.*expr870))./(expr519 + expr520 - expr503.*expr518.*expr564.*expr565).^2);
expr3201 = -(((expr3185 + expr3186).*expr522.*expr523.*expr566.*expr874)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567));
expr3202 = (expr3187.*expr522.*expr523.*expr567.*expr876)./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567);
expr3203 = -((expr522.*expr523.*expr566.*expr567.*((expr3185 + expr3186).*expr523.*expr538.*expr566.*expr874 - expr3187.*expr523.*expr538.*expr567.*expr876))./(expr539 + expr540 - expr523.*expr538.*expr566.*expr567).^2);
expr3204 = -(((expr3188 + expr3189).*expr542.*expr543.*expr568.*expr880)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569));
expr3205 = (expr3190.*expr542.*expr543.*expr569.*expr882)./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569);
expr3206 = -((expr542.*expr543.*expr568.*expr569.*((expr3188 + expr3189).*expr543.*expr558.*expr568.*expr880 - expr3190.*expr543.*expr558.*expr569.*expr882))./(expr559 + expr560 - expr543.*expr558.*expr568.*expr569).^2);
expr3207 = -(expr3181.*expr483.*expr563.*expr864) + (expr3178 + expr3179).*expr483.*expr562.*expr866;
expr3208 = expr3182 + expr3183;
expr3209 = (expr3182 + expr3183).*expr503.*expr564.*expr868 - expr3184.*expr503.*expr565.*expr870;
expr3210 = expr3185 + expr3186;
expr3211 = (expr3185 + expr3186).*expr523.*expr566.*expr874 - expr3187.*expr523.*expr567.*expr876;
expr3212 = expr3188 + expr3189;
expr3213 = (expr3188 + expr3189).*expr543.*expr568.*expr880 - expr3190.*expr543.*expr569.*expr882;
expr3214 = (expr3195 + expr3196 + expr3197).*expr501.*expr898 + (expr3198 + expr3199 + expr3200).*expr521.*expr904 + (expr3201 + expr3202 + expr3203).*expr541.*expr908 + (expr3204 + expr3205 + expr3206).*expr561.*expr912;
expr3215 = -(expr3207.*expr501.*sin(expr481.*expr482.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr3216 = -(expr3209.*expr521.*sin(expr481.*expr502.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr3217 = -(expr3211.*expr541.*sin(expr481.*expr522.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr3218 = -(expr3213.*expr561.*sin(expr481.*expr542.*(expr570 + expr571 + expr572 + expr573).*tpc));
expr3219 = expr3194.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*(1 + expr923);
expr3220 = -2.*expr3115.*expr501.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609.*expr835.*expr836.*expr837.*(1 + expr923);
expr3221 = expr3180.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr835.*expr837.*expr854.*(1 + expr923);
expr3222 = expr3208.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*(1 + expr924);
expr3223 = expr1271.*expr3191.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr838.*expr840.*(1 + expr924);
expr3224 = -2.*expr3115.*expr483.*expr521.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609.*expr838.*expr839.*expr840.*(1 + expr924);
expr3225 = expr3210.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*(1 + expr925);
expr3226 = expr1625.*expr3192.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615.*expr841.*expr843.*(1 + expr925);
expr3227 = -2.*expr3115.*expr483.*expr503.*expr541.*expr543.*expr592.*expr607.*expr608.*expr609.*expr841.*expr842.*expr843.*(1 + expr925);
expr3228 = expr3212.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*(1 + expr926);
expr3229 = expr1968.*expr3193.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr615.*expr844.*expr846.*(1 + expr926);
expr3230 = -2.*expr3115.*expr483.*expr503.*expr523.*expr561.*expr592.*expr607.*expr608.*expr609.*expr844.*expr845.*expr846.*(1 + expr926);
expr3231 = expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*(expr3214.*expr498.*expr830.*expr927.*expr930.*tpc - expr927.*(expr3215 + expr3214.*expr830.*expr891.*expr931.*tpc + expr3214.*expr482.*expr830.*expr933.*tpc));
expr3232 = expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840.*(expr3214.*expr518.*expr830.*expr934.*expr935.*tpc - expr934.*(expr3216 + expr3214.*expr830.*expr892.*expr936.*tpc + expr3214.*expr502.*expr830.*expr938.*tpc));
expr3233 = expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843.*(expr3214.*expr538.*expr830.*expr939.*expr940.*tpc - expr939.*(expr3217 + expr3214.*expr830.*expr893.*expr941.*tpc + expr3214.*expr522.*expr830.*expr943.*tpc));
expr3234 = expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846.*(expr3214.*expr558.*expr830.*expr944.*expr945.*tpc - expr944.*(expr3218 + expr3214.*expr830.*expr894.*expr946.*tpc + expr3214.*expr542.*expr830.*expr948.*tpc));
expr3235 = integrate65 + integrate66 + integrate67 + integrate68 + 200.*(expr3219 + expr3220 + expr3221 + expr3222 + expr3223 + expr3224 + expr3225 + expr3226 + expr3227 + expr3228 + expr3229 + expr3230 + expr3231 + expr3232 + expr3233 + expr3234).*(-1 + expr949 + expr950 + expr951 + expr952).*WO;
gf(16) = expr3235;

%% Derivative of constraints on the cost function

%%   First derivative w/r to a(1) of constraint #1
expr3236 = -1./(2.*sqrt(a(1).^2 + b(1).^2)) + sqrt(a(1).^2 + b(1).^2)./(2.*a(1).^2);
GC(1, 1) = expr3236;

%%   First derivative w/r to a(1) of constraint #2
expr3237 = 0;
GC(1, 2) = expr3237;

%%   First derivative w/r to a(1) of constraint #3
expr3238 = 0;
GC(1, 3) = expr3238;

%%   First derivative w/r to a(1) of constraint #4
expr3239 = 0;
GC(1, 4) = expr3239;

%%   First derivative w/r to a(1) of constraint #5
expr3240 = (wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr3241 = (wp.^2.*(wp.^2./100 + 2.*(a(2).^2 - b(2).^2)))./100;
expr3242 = (wp.^2.*(wp.^2./100 + 2.*(a(3).^2 - b(3).^2)))./100;
expr3243 = (wp.^2.*(wp.^2./100 + 2.*(a(4).^2 - b(4).^2)))./100;
expr3244 = (wp.^2.*(wp.^2./100 + 2.*(a(1).^2 - b(1).^2)))./100;
expr3245 = (c(1).^2 + d(1).^2).^2;
expr3246 = (wp.^2.*(wp.^2./100 + 2.*(c(1).^2 - d(1).^2)))./100;
expr3247 = (c(2).^2 + d(2).^2).^2;
expr3248 = (wp.^2.*(wp.^2./100 + 2.*(c(2).^2 - d(2).^2)))./100;
expr3249 = (c(3).^2 + d(3).^2).^2;
expr3250 = (wp.^2.*(wp.^2./100 + 2.*(c(3).^2 - d(3).^2)))./100;
expr3251 = (c(4).^2 + d(4).^2).^2;
expr3252 = (wp.^2.*(wp.^2./100 + 2.*(c(4).^2 - d(4).^2)))./100;
expr3253 = ((expr3245 + expr3246).*(expr3247 + expr3248).*(expr3249 + expr3250).*(expr3251 + expr3252)).^expr615;
expr3254 = ((expr3244 + expr577).*(expr3241 + expr580).*(expr3242 + expr582).*(expr3243 + expr584)).^expr600;
expr3255 = expr3241 + expr580;
expr3256 = expr3242 + expr582;
expr3257 = expr3243 + expr584;
expr3258 = ((expr3244 + expr577).*(expr3241 + expr580).*(expr3242 + expr582).*(expr3243 + expr584)).^expr606;
expr3259 = 2.*expr3253.*expr3254.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3240.*expr3253.*expr3255.*expr3256.*expr3257.*expr3258.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(1, 5) = expr3259;

%%   First derivative w/r to a(1) of constraint #6
expr3260 = -2.*expr3253.*expr3254.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3240.*expr3253.*expr3255.*expr3256.*expr3257.*expr3258.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(1, 6) = expr3260;

%%   First derivative w/r to a(1) of constraint #7
expr3261 = (4.*wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr3262 = (wp.^2.*(wp.^2./25 + 2.*(a(2).^2 - b(2).^2)))./25;
expr3263 = (wp.^2.*(wp.^2./25 + 2.*(a(3).^2 - b(3).^2)))./25;
expr3264 = (wp.^2.*(wp.^2./25 + 2.*(a(4).^2 - b(4).^2)))./25;
expr3265 = (wp.^2.*(wp.^2./25 + 2.*(a(1).^2 - b(1).^2)))./25;
expr3266 = (wp.^2.*(wp.^2./25 + 2.*(c(1).^2 - d(1).^2)))./25;
expr3267 = (wp.^2.*(wp.^2./25 + 2.*(c(2).^2 - d(2).^2)))./25;
expr3268 = (wp.^2.*(wp.^2./25 + 2.*(c(3).^2 - d(3).^2)))./25;
expr3269 = (wp.^2.*(wp.^2./25 + 2.*(c(4).^2 - d(4).^2)))./25;
expr3270 = ((expr3245 + expr3266).*(expr3247 + expr3267).*(expr3249 + expr3268).*(expr3251 + expr3269)).^expr615;
expr3271 = ((expr3265 + expr577).*(expr3262 + expr580).*(expr3263 + expr582).*(expr3264 + expr584)).^expr600;
expr3272 = expr3262 + expr580;
expr3273 = expr3263 + expr582;
expr3274 = expr3264 + expr584;
expr3275 = ((expr3265 + expr577).*(expr3262 + expr580).*(expr3263 + expr582).*(expr3264 + expr584)).^expr606;
expr3276 = 2.*expr3270.*expr3271.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3261.*expr3270.*expr3272.*expr3273.*expr3274.*expr3275.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(1, 7) = expr3276;

%%   First derivative w/r to a(1) of constraint #8
expr3277 = -2.*expr3270.*expr3271.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3261.*expr3270.*expr3272.*expr3273.*expr3274.*expr3275.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(1, 8) = expr3277;

%%   First derivative w/r to a(1) of constraint #9
expr3278 = (9.*wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr3279 = (9.*wp.^2.*((9.*wp.^2)./100 + 2.*(a(2).^2 - b(2).^2)))./100;
expr3280 = (9.*wp.^2.*((9.*wp.^2)./100 + 2.*(a(3).^2 - b(3).^2)))./100;
expr3281 = (9.*wp.^2.*((9.*wp.^2)./100 + 2.*(a(4).^2 - b(4).^2)))./100;
expr3282 = (9.*wp.^2.*((9.*wp.^2)./100 + 2.*(a(1).^2 - b(1).^2)))./100;
expr3283 = (9.*wp.^2.*((9.*wp.^2)./100 + 2.*(c(1).^2 - d(1).^2)))./100;
expr3284 = (9.*wp.^2.*((9.*wp.^2)./100 + 2.*(c(2).^2 - d(2).^2)))./100;
expr3285 = (9.*wp.^2.*((9.*wp.^2)./100 + 2.*(c(3).^2 - d(3).^2)))./100;
expr3286 = (9.*wp.^2.*((9.*wp.^2)./100 + 2.*(c(4).^2 - d(4).^2)))./100;
expr3287 = ((expr3245 + expr3283).*(expr3247 + expr3284).*(expr3249 + expr3285).*(expr3251 + expr3286)).^expr615;
expr3288 = ((expr3282 + expr577).*(expr3279 + expr580).*(expr3280 + expr582).*(expr3281 + expr584)).^expr600;
expr3289 = expr3279 + expr580;
expr3290 = expr3280 + expr582;
expr3291 = expr3281 + expr584;
expr3292 = ((expr3282 + expr577).*(expr3279 + expr580).*(expr3280 + expr582).*(expr3281 + expr584)).^expr606;
expr3293 = 2.*expr3287.*expr3288.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3278.*expr3287.*expr3289.*expr3290.*expr3291.*expr3292.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(1, 9) = expr3293;

%%   First derivative w/r to a(1) of constraint #10
expr3294 = -2.*expr3287.*expr3288.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3278.*expr3287.*expr3289.*expr3290.*expr3291.*expr3292.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(1, 10) = expr3294;

%%   First derivative w/r to a(1) of constraint #11
expr3295 = (16.*wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr3296 = (4.*wp.^2.*((4.*wp.^2)./25 + 2.*(a(2).^2 - b(2).^2)))./25;
expr3297 = (4.*wp.^2.*((4.*wp.^2)./25 + 2.*(a(3).^2 - b(3).^2)))./25;
expr3298 = (4.*wp.^2.*((4.*wp.^2)./25 + 2.*(a(4).^2 - b(4).^2)))./25;
expr3299 = (4.*wp.^2.*((4.*wp.^2)./25 + 2.*(a(1).^2 - b(1).^2)))./25;
expr3300 = (4.*wp.^2.*((4.*wp.^2)./25 + 2.*(c(1).^2 - d(1).^2)))./25;
expr3301 = (4.*wp.^2.*((4.*wp.^2)./25 + 2.*(c(2).^2 - d(2).^2)))./25;
expr3302 = (4.*wp.^2.*((4.*wp.^2)./25 + 2.*(c(3).^2 - d(3).^2)))./25;
expr3303 = (4.*wp.^2.*((4.*wp.^2)./25 + 2.*(c(4).^2 - d(4).^2)))./25;
expr3304 = ((expr3245 + expr3300).*(expr3247 + expr3301).*(expr3249 + expr3302).*(expr3251 + expr3303)).^expr615;
expr3305 = ((expr3299 + expr577).*(expr3296 + expr580).*(expr3297 + expr582).*(expr3298 + expr584)).^expr600;
expr3306 = expr3296 + expr580;
expr3307 = expr3297 + expr582;
expr3308 = expr3298 + expr584;
expr3309 = ((expr3299 + expr577).*(expr3296 + expr580).*(expr3297 + expr582).*(expr3298 + expr584)).^expr606;
expr3310 = 2.*expr3304.*expr3305.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3295.*expr3304.*expr3306.*expr3307.*expr3308.*expr3309.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(1, 11) = expr3310;

%%   First derivative w/r to a(1) of constraint #12
expr3311 = -2.*expr3304.*expr3305.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3295.*expr3304.*expr3306.*expr3307.*expr3308.*expr3309.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(1, 12) = expr3311;

%%   First derivative w/r to a(1) of constraint #13
expr3312 = wp.^2.*a(1) + 4.*a(1).*(a(1).^2 + b(1).^2);
expr3313 = (wp.^2.*(wp.^2./4 + 2.*(a(2).^2 - b(2).^2)))./4;
expr3314 = (wp.^2.*(wp.^2./4 + 2.*(a(3).^2 - b(3).^2)))./4;
expr3315 = (wp.^2.*(wp.^2./4 + 2.*(a(4).^2 - b(4).^2)))./4;
expr3316 = (wp.^2.*(wp.^2./4 + 2.*(a(1).^2 - b(1).^2)))./4;
expr3317 = (wp.^2.*(wp.^2./4 + 2.*(c(1).^2 - d(1).^2)))./4;
expr3318 = (wp.^2.*(wp.^2./4 + 2.*(c(2).^2 - d(2).^2)))./4;
expr3319 = (wp.^2.*(wp.^2./4 + 2.*(c(3).^2 - d(3).^2)))./4;
expr3320 = (wp.^2.*(wp.^2./4 + 2.*(c(4).^2 - d(4).^2)))./4;
expr3321 = ((expr3245 + expr3317).*(expr3247 + expr3318).*(expr3249 + expr3319).*(expr3251 + expr3320)).^expr615;
expr3322 = ((expr3316 + expr577).*(expr3313 + expr580).*(expr3314 + expr582).*(expr3315 + expr584)).^expr600;
expr3323 = expr3313 + expr580;
expr3324 = expr3314 + expr582;
expr3325 = expr3315 + expr584;
expr3326 = ((expr3316 + expr577).*(expr3313 + expr580).*(expr3314 + expr582).*(expr3315 + expr584)).^expr606;
expr3327 = 2.*expr3321.*expr3322.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3312.*expr3321.*expr3323.*expr3324.*expr3325.*expr3326.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(1, 13) = expr3327;

%%   First derivative w/r to a(1) of constraint #14
expr3328 = -2.*expr3321.*expr3322.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3312.*expr3321.*expr3323.*expr3324.*expr3325.*expr3326.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(1, 14) = expr3328;

%%   First derivative w/r to a(1) of constraint #15
expr3329 = (36.*wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr3330 = (9.*wp.^2.*((9.*wp.^2)./25 + 2.*(a(2).^2 - b(2).^2)))./25;
expr3331 = (9.*wp.^2.*((9.*wp.^2)./25 + 2.*(a(3).^2 - b(3).^2)))./25;
expr3332 = (9.*wp.^2.*((9.*wp.^2)./25 + 2.*(a(4).^2 - b(4).^2)))./25;
expr3333 = (9.*wp.^2.*((9.*wp.^2)./25 + 2.*(a(1).^2 - b(1).^2)))./25;
expr3334 = (9.*wp.^2.*((9.*wp.^2)./25 + 2.*(c(1).^2 - d(1).^2)))./25;
expr3335 = (9.*wp.^2.*((9.*wp.^2)./25 + 2.*(c(2).^2 - d(2).^2)))./25;
expr3336 = (9.*wp.^2.*((9.*wp.^2)./25 + 2.*(c(3).^2 - d(3).^2)))./25;
expr3337 = (9.*wp.^2.*((9.*wp.^2)./25 + 2.*(c(4).^2 - d(4).^2)))./25;
expr3338 = ((expr3245 + expr3334).*(expr3247 + expr3335).*(expr3249 + expr3336).*(expr3251 + expr3337)).^expr615;
expr3339 = ((expr3333 + expr577).*(expr3330 + expr580).*(expr3331 + expr582).*(expr3332 + expr584)).^expr600;
expr3340 = expr3330 + expr580;
expr3341 = expr3331 + expr582;
expr3342 = expr3332 + expr584;
expr3343 = ((expr3333 + expr577).*(expr3330 + expr580).*(expr3331 + expr582).*(expr3332 + expr584)).^expr606;
expr3344 = 2.*expr3338.*expr3339.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3329.*expr3338.*expr3340.*expr3341.*expr3342.*expr3343.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(1, 15) = expr3344;

%%   First derivative w/r to a(1) of constraint #16
expr3345 = -2.*expr3338.*expr3339.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3329.*expr3338.*expr3340.*expr3341.*expr3342.*expr3343.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(1, 16) = expr3345;

%%   First derivative w/r to a(1) of constraint #17
expr3346 = (49.*wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr3347 = (49.*wp.^2.*((49.*wp.^2)./100 + 2.*(a(2).^2 - b(2).^2)))./100;
expr3348 = (49.*wp.^2.*((49.*wp.^2)./100 + 2.*(a(3).^2 - b(3).^2)))./100;
expr3349 = (49.*wp.^2.*((49.*wp.^2)./100 + 2.*(a(4).^2 - b(4).^2)))./100;
expr3350 = (49.*wp.^2.*((49.*wp.^2)./100 + 2.*(a(1).^2 - b(1).^2)))./100;
expr3351 = (49.*wp.^2.*((49.*wp.^2)./100 + 2.*(c(1).^2 - d(1).^2)))./100;
expr3352 = (49.*wp.^2.*((49.*wp.^2)./100 + 2.*(c(2).^2 - d(2).^2)))./100;
expr3353 = (49.*wp.^2.*((49.*wp.^2)./100 + 2.*(c(3).^2 - d(3).^2)))./100;
expr3354 = (49.*wp.^2.*((49.*wp.^2)./100 + 2.*(c(4).^2 - d(4).^2)))./100;
expr3355 = ((expr3245 + expr3351).*(expr3247 + expr3352).*(expr3249 + expr3353).*(expr3251 + expr3354)).^expr615;
expr3356 = ((expr3350 + expr577).*(expr3347 + expr580).*(expr3348 + expr582).*(expr3349 + expr584)).^expr600;
expr3357 = expr3347 + expr580;
expr3358 = expr3348 + expr582;
expr3359 = expr3349 + expr584;
expr3360 = ((expr3350 + expr577).*(expr3347 + expr580).*(expr3348 + expr582).*(expr3349 + expr584)).^expr606;
expr3361 = 2.*expr3355.*expr3356.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3346.*expr3355.*expr3357.*expr3358.*expr3359.*expr3360.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(1, 17) = expr3361;

%%   First derivative w/r to a(1) of constraint #18
expr3362 = -2.*expr3355.*expr3356.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3346.*expr3355.*expr3357.*expr3358.*expr3359.*expr3360.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(1, 18) = expr3362;

%%   First derivative w/r to a(1) of constraint #19
expr3363 = (64.*wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr3364 = (16.*wp.^2.*((16.*wp.^2)./25 + 2.*(a(2).^2 - b(2).^2)))./25;
expr3365 = (16.*wp.^2.*((16.*wp.^2)./25 + 2.*(a(3).^2 - b(3).^2)))./25;
expr3366 = (16.*wp.^2.*((16.*wp.^2)./25 + 2.*(a(4).^2 - b(4).^2)))./25;
expr3367 = (16.*wp.^2.*((16.*wp.^2)./25 + 2.*(a(1).^2 - b(1).^2)))./25;
expr3368 = (16.*wp.^2.*((16.*wp.^2)./25 + 2.*(c(1).^2 - d(1).^2)))./25;
expr3369 = (16.*wp.^2.*((16.*wp.^2)./25 + 2.*(c(2).^2 - d(2).^2)))./25;
expr3370 = (16.*wp.^2.*((16.*wp.^2)./25 + 2.*(c(3).^2 - d(3).^2)))./25;
expr3371 = (16.*wp.^2.*((16.*wp.^2)./25 + 2.*(c(4).^2 - d(4).^2)))./25;
expr3372 = ((expr3245 + expr3368).*(expr3247 + expr3369).*(expr3249 + expr3370).*(expr3251 + expr3371)).^expr615;
expr3373 = ((expr3367 + expr577).*(expr3364 + expr580).*(expr3365 + expr582).*(expr3366 + expr584)).^expr600;
expr3374 = expr3364 + expr580;
expr3375 = expr3365 + expr582;
expr3376 = expr3366 + expr584;
expr3377 = ((expr3367 + expr577).*(expr3364 + expr580).*(expr3365 + expr582).*(expr3366 + expr584)).^expr606;
expr3378 = 2.*expr3372.*expr3373.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3363.*expr3372.*expr3374.*expr3375.*expr3376.*expr3377.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(1, 19) = expr3378;

%%   First derivative w/r to a(1) of constraint #20
expr3379 = -2.*expr3372.*expr3373.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3363.*expr3372.*expr3374.*expr3375.*expr3376.*expr3377.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(1, 20) = expr3379;

%%   First derivative w/r to a(1) of constraint #21
expr3380 = (81.*wp.^2.*a(1))./25 + 4.*a(1).*(a(1).^2 + b(1).^2);
expr3381 = (81.*wp.^2.*((81.*wp.^2)./100 + 2.*(a(2).^2 - b(2).^2)))./100;
expr3382 = (81.*wp.^2.*((81.*wp.^2)./100 + 2.*(a(3).^2 - b(3).^2)))./100;
expr3383 = (81.*wp.^2.*((81.*wp.^2)./100 + 2.*(a(4).^2 - b(4).^2)))./100;
expr3384 = (81.*wp.^2.*((81.*wp.^2)./100 + 2.*(a(1).^2 - b(1).^2)))./100;
expr3385 = (81.*wp.^2.*((81.*wp.^2)./100 + 2.*(c(1).^2 - d(1).^2)))./100;
expr3386 = (81.*wp.^2.*((81.*wp.^2)./100 + 2.*(c(2).^2 - d(2).^2)))./100;
expr3387 = (81.*wp.^2.*((81.*wp.^2)./100 + 2.*(c(3).^2 - d(3).^2)))./100;
expr3388 = (81.*wp.^2.*((81.*wp.^2)./100 + 2.*(c(4).^2 - d(4).^2)))./100;
expr3389 = ((expr3245 + expr3385).*(expr3247 + expr3386).*(expr3249 + expr3387).*(expr3251 + expr3388)).^expr615;
expr3390 = ((expr3384 + expr577).*(expr3381 + expr580).*(expr3382 + expr582).*(expr3383 + expr584)).^expr600;
expr3391 = expr3381 + expr580;
expr3392 = expr3382 + expr582;
expr3393 = expr3383 + expr584;
expr3394 = ((expr3384 + expr577).*(expr3381 + expr580).*(expr3382 + expr582).*(expr3383 + expr584)).^expr606;
expr3395 = 2.*expr3389.*expr3390.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3380.*expr3389.*expr3391.*expr3392.*expr3393.*expr3394.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(1, 21) = expr3395;

%%   First derivative w/r to a(1) of constraint #22
expr3396 = -2.*expr3389.*expr3390.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3380.*expr3389.*expr3391.*expr3392.*expr3393.*expr3394.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(1, 22) = expr3396;

%%   First derivative w/r to a(1) of constraint #23
expr3397 = 4.*wp.^2.*a(1) + 4.*a(1).*(a(1).^2 + b(1).^2);
expr3398 = (a(2).^2 + b(2).^2).^2 + wp.^2.*(wp.^2 + 2.*(a(2).^2 - b(2).^2));
expr3399 = (a(3).^2 + b(3).^2).^2 + wp.^2.*(wp.^2 + 2.*(a(3).^2 - b(3).^2));
expr3400 = (a(4).^2 + b(4).^2).^2 + wp.^2.*(wp.^2 + 2.*(a(4).^2 - b(4).^2));
expr3401 = (a(1).^2 + b(1).^2).^2 + wp.^2.*(wp.^2 + 2.*(a(1).^2 - b(1).^2));
expr3402 = (c(1).^2 + d(1).^2).^2 + wp.^2.*(wp.^2 + 2.*(c(1).^2 - d(1).^2));
expr3403 = (c(2).^2 + d(2).^2).^2 + wp.^2.*(wp.^2 + 2.*(c(2).^2 - d(2).^2));
expr3404 = (c(3).^2 + d(3).^2).^2 + wp.^2.*(wp.^2 + 2.*(c(3).^2 - d(3).^2));
expr3405 = (c(4).^2 + d(4).^2).^2 + wp.^2.*(wp.^2 + 2.*(c(4).^2 - d(4).^2));
expr3406 = 2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3407 = expr3397.*expr3398.*expr3399.*expr3400.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3408 = expr3406 + expr3407;
GC(1, 23) = expr3408;

%%   First derivative w/r to a(1) of constraint #24
expr3409 = -2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3410 = expr3397.*expr3398.*expr3399.*expr3400.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3411 = expr3409 + expr3410;
GC(1, 24) = expr3411;

%%   First derivative w/r to a(1) of constraint #25
expr3412 = 4.*ws.^2.*a(1) + 4.*a(1).*(a(1).^2 + b(1).^2);
expr3413 = (a(2).^2 + b(2).^2).^2 + ws.^2.*(ws.^2 + 2.*(a(2).^2 - b(2).^2));
expr3414 = (a(3).^2 + b(3).^2).^2 + ws.^2.*(ws.^2 + 2.*(a(3).^2 - b(3).^2));
expr3415 = (a(4).^2 + b(4).^2).^2 + ws.^2.*(ws.^2 + 2.*(a(4).^2 - b(4).^2));
expr3416 = (a(1).^2 + b(1).^2).^2 + ws.^2.*(ws.^2 + 2.*(a(1).^2 - b(1).^2));
expr3417 = (c(1).^2 + d(1).^2).^2 + ws.^2.*(ws.^2 + 2.*(c(1).^2 - d(1).^2));
expr3418 = (c(2).^2 + d(2).^2).^2 + ws.^2.*(ws.^2 + 2.*(c(2).^2 - d(2).^2));
expr3419 = (c(3).^2 + d(3).^2).^2 + ws.^2.*(ws.^2 + 2.*(c(3).^2 - d(3).^2));
expr3420 = (c(4).^2 + d(4).^2).^2 + ws.^2.*(ws.^2 + 2.*(c(4).^2 - d(4).^2));
expr3421 = 2.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr498.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3422 = expr3412.*expr3413.*expr3414.*expr3415.*(expr3413.*expr3414.*expr3415.*expr3416).^expr606.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3423 = expr3421 + expr3422;
GC(1, 25) = expr3423;

%%   First derivative w/r to a(1) of constraint #26
expr3424 = expr953 + expr954 + expr955 + expr956 + expr957 + expr958 + expr959 + expr960 + expr961 + expr962 + expr963 + expr964 + expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837.*expr965 + expr966 + expr967 + expr968;
GC(1, 26) = expr3424;

%%   First derivative w/r to a(2) of constraint #1
expr3425 = 0;
GC(2, 1) = expr3425;

%%   First derivative w/r to a(2) of constraint #2
expr3426 = -1./(2.*sqrt(a(2).^2 + b(2).^2)) + sqrt(a(2).^2 + b(2).^2)./(2.*a(2).^2);
GC(2, 2) = expr3426;

%%   First derivative w/r to a(2) of constraint #3
expr3427 = 0;
GC(2, 3) = expr3427;

%%   First derivative w/r to a(2) of constraint #4
expr3428 = 0;
GC(2, 4) = expr3428;

%%   First derivative w/r to a(2) of constraint #5
expr3429 = (wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr3430 = expr3244 + expr577;
expr3431 = 2.*expr3253.*expr3254.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3253.*expr3256.*expr3257.*expr3258.*expr3429.*expr3430.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(2, 5) = expr3431;

%%   First derivative w/r to a(2) of constraint #6
expr3432 = -2.*expr3253.*expr3254.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3253.*expr3256.*expr3257.*expr3258.*expr3429.*expr3430.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(2, 6) = expr3432;

%%   First derivative w/r to a(2) of constraint #7
expr3433 = (4.*wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr3434 = expr3265 + expr577;
expr3435 = 2.*expr3270.*expr3271.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3270.*expr3273.*expr3274.*expr3275.*expr3433.*expr3434.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(2, 7) = expr3435;

%%   First derivative w/r to a(2) of constraint #8
expr3436 = -2.*expr3270.*expr3271.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3270.*expr3273.*expr3274.*expr3275.*expr3433.*expr3434.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(2, 8) = expr3436;

%%   First derivative w/r to a(2) of constraint #9
expr3437 = (9.*wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr3438 = expr3282 + expr577;
expr3439 = 2.*expr3287.*expr3288.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3287.*expr3290.*expr3291.*expr3292.*expr3437.*expr3438.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(2, 9) = expr3439;

%%   First derivative w/r to a(2) of constraint #10
expr3440 = -2.*expr3287.*expr3288.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3287.*expr3290.*expr3291.*expr3292.*expr3437.*expr3438.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(2, 10) = expr3440;

%%   First derivative w/r to a(2) of constraint #11
expr3441 = (16.*wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr3442 = expr3299 + expr577;
expr3443 = 2.*expr3304.*expr3305.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3304.*expr3307.*expr3308.*expr3309.*expr3441.*expr3442.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(2, 11) = expr3443;

%%   First derivative w/r to a(2) of constraint #12
expr3444 = -2.*expr3304.*expr3305.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3304.*expr3307.*expr3308.*expr3309.*expr3441.*expr3442.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(2, 12) = expr3444;

%%   First derivative w/r to a(2) of constraint #13
expr3445 = wp.^2.*a(2) + 4.*a(2).*(a(2).^2 + b(2).^2);
expr3446 = expr3316 + expr577;
expr3447 = 2.*expr3321.*expr3322.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3321.*expr3324.*expr3325.*expr3326.*expr3445.*expr3446.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(2, 13) = expr3447;

%%   First derivative w/r to a(2) of constraint #14
expr3448 = -2.*expr3321.*expr3322.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3321.*expr3324.*expr3325.*expr3326.*expr3445.*expr3446.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(2, 14) = expr3448;

%%   First derivative w/r to a(2) of constraint #15
expr3449 = (36.*wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr3450 = expr3333 + expr577;
expr3451 = 2.*expr3338.*expr3339.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3338.*expr3341.*expr3342.*expr3343.*expr3449.*expr3450.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(2, 15) = expr3451;

%%   First derivative w/r to a(2) of constraint #16
expr3452 = -2.*expr3338.*expr3339.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3338.*expr3341.*expr3342.*expr3343.*expr3449.*expr3450.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(2, 16) = expr3452;

%%   First derivative w/r to a(2) of constraint #17
expr3453 = (49.*wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr3454 = expr3350 + expr577;
expr3455 = 2.*expr3355.*expr3356.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3355.*expr3358.*expr3359.*expr3360.*expr3453.*expr3454.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(2, 17) = expr3455;

%%   First derivative w/r to a(2) of constraint #18
expr3456 = -2.*expr3355.*expr3356.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3355.*expr3358.*expr3359.*expr3360.*expr3453.*expr3454.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(2, 18) = expr3456;

%%   First derivative w/r to a(2) of constraint #19
expr3457 = (64.*wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr3458 = expr3367 + expr577;
expr3459 = 2.*expr3372.*expr3373.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3372.*expr3375.*expr3376.*expr3377.*expr3457.*expr3458.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(2, 19) = expr3459;

%%   First derivative w/r to a(2) of constraint #20
expr3460 = -2.*expr3372.*expr3373.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3372.*expr3375.*expr3376.*expr3377.*expr3457.*expr3458.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(2, 20) = expr3460;

%%   First derivative w/r to a(2) of constraint #21
expr3461 = (81.*wp.^2.*a(2))./25 + 4.*a(2).*(a(2).^2 + b(2).^2);
expr3462 = expr3384 + expr577;
expr3463 = 2.*expr3389.*expr3390.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3389.*expr3392.*expr3393.*expr3394.*expr3461.*expr3462.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(2, 21) = expr3463;

%%   First derivative w/r to a(2) of constraint #22
expr3464 = -2.*expr3389.*expr3390.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3389.*expr3392.*expr3393.*expr3394.*expr3461.*expr3462.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(2, 22) = expr3464;

%%   First derivative w/r to a(2) of constraint #23
expr3465 = 4.*wp.^2.*a(2) + 4.*a(2).*(a(2).^2 + b(2).^2);
expr3466 = 2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3467 = expr3399.*expr3400.*expr3401.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr3465.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3468 = expr3466 + expr3467;
GC(2, 23) = expr3468;

%%   First derivative w/r to a(2) of constraint #24
expr3469 = -2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3470 = expr3399.*expr3400.*expr3401.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr3465.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3471 = expr3469 + expr3470;
GC(2, 24) = expr3471;

%%   First derivative w/r to a(2) of constraint #25
expr3472 = 4.*ws.^2.*a(2) + 4.*a(2).*(a(2).^2 + b(2).^2);
expr3473 = 2.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr483.*expr518.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3474 = expr3414.*expr3415.*expr3416.*(expr3413.*expr3414.*expr3415.*expr3416).^expr606.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr3472.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3475 = expr3473 + expr3474;
GC(2, 25) = expr3475;

%%   First derivative w/r to a(2) of constraint #26
expr3476 = expr1317 + expr1318 + expr1319 + expr1320 + expr1321 + expr1322 + expr1323 + expr1324 + expr1325 + expr1326 + expr1327 + expr1328 + expr1329 + expr1331 + expr1332 + expr1330.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840;
GC(2, 26) = expr3476;

%%   First derivative w/r to a(3) of constraint #1
expr3477 = 0;
GC(3, 1) = expr3477;

%%   First derivative w/r to a(3) of constraint #2
expr3478 = 0;
GC(3, 2) = expr3478;

%%   First derivative w/r to a(3) of constraint #3
expr3479 = -1./(2.*sqrt(a(3).^2 + b(3).^2)) + sqrt(a(3).^2 + b(3).^2)./(2.*a(3).^2);
GC(3, 3) = expr3479;

%%   First derivative w/r to a(3) of constraint #4
expr3480 = 0;
GC(3, 4) = expr3480;

%%   First derivative w/r to a(3) of constraint #5
expr3481 = (wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr3482 = 2.*expr3253.*expr3254.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3253.*expr3255.*expr3257.*expr3258.*expr3430.*expr3481.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(3, 5) = expr3482;

%%   First derivative w/r to a(3) of constraint #6
expr3483 = -2.*expr3253.*expr3254.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3253.*expr3255.*expr3257.*expr3258.*expr3430.*expr3481.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(3, 6) = expr3483;

%%   First derivative w/r to a(3) of constraint #7
expr3484 = (4.*wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr3485 = 2.*expr3270.*expr3271.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3270.*expr3272.*expr3274.*expr3275.*expr3434.*expr3484.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(3, 7) = expr3485;

%%   First derivative w/r to a(3) of constraint #8
expr3486 = -2.*expr3270.*expr3271.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3270.*expr3272.*expr3274.*expr3275.*expr3434.*expr3484.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(3, 8) = expr3486;

%%   First derivative w/r to a(3) of constraint #9
expr3487 = (9.*wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr3488 = 2.*expr3287.*expr3288.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3287.*expr3289.*expr3291.*expr3292.*expr3438.*expr3487.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(3, 9) = expr3488;

%%   First derivative w/r to a(3) of constraint #10
expr3489 = -2.*expr3287.*expr3288.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3287.*expr3289.*expr3291.*expr3292.*expr3438.*expr3487.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(3, 10) = expr3489;

%%   First derivative w/r to a(3) of constraint #11
expr3490 = (16.*wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr3491 = 2.*expr3304.*expr3305.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3304.*expr3306.*expr3308.*expr3309.*expr3442.*expr3490.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(3, 11) = expr3491;

%%   First derivative w/r to a(3) of constraint #12
expr3492 = -2.*expr3304.*expr3305.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3304.*expr3306.*expr3308.*expr3309.*expr3442.*expr3490.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(3, 12) = expr3492;

%%   First derivative w/r to a(3) of constraint #13
expr3493 = wp.^2.*a(3) + 4.*a(3).*(a(3).^2 + b(3).^2);
expr3494 = 2.*expr3321.*expr3322.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3321.*expr3323.*expr3325.*expr3326.*expr3446.*expr3493.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(3, 13) = expr3494;

%%   First derivative w/r to a(3) of constraint #14
expr3495 = -2.*expr3321.*expr3322.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3321.*expr3323.*expr3325.*expr3326.*expr3446.*expr3493.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(3, 14) = expr3495;

%%   First derivative w/r to a(3) of constraint #15
expr3496 = (36.*wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr3497 = 2.*expr3338.*expr3339.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3338.*expr3340.*expr3342.*expr3343.*expr3450.*expr3496.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(3, 15) = expr3497;

%%   First derivative w/r to a(3) of constraint #16
expr3498 = -2.*expr3338.*expr3339.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3338.*expr3340.*expr3342.*expr3343.*expr3450.*expr3496.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(3, 16) = expr3498;

%%   First derivative w/r to a(3) of constraint #17
expr3499 = (49.*wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr3500 = 2.*expr3355.*expr3356.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3355.*expr3357.*expr3359.*expr3360.*expr3454.*expr3499.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(3, 17) = expr3500;

%%   First derivative w/r to a(3) of constraint #18
expr3501 = -2.*expr3355.*expr3356.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3355.*expr3357.*expr3359.*expr3360.*expr3454.*expr3499.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(3, 18) = expr3501;

%%   First derivative w/r to a(3) of constraint #19
expr3502 = (64.*wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr3503 = 2.*expr3372.*expr3373.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3372.*expr3374.*expr3376.*expr3377.*expr3458.*expr3502.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(3, 19) = expr3503;

%%   First derivative w/r to a(3) of constraint #20
expr3504 = -2.*expr3372.*expr3373.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3372.*expr3374.*expr3376.*expr3377.*expr3458.*expr3502.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(3, 20) = expr3504;

%%   First derivative w/r to a(3) of constraint #21
expr3505 = (81.*wp.^2.*a(3))./25 + 4.*a(3).*(a(3).^2 + b(3).^2);
expr3506 = 2.*expr3389.*expr3390.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3389.*expr3391.*expr3393.*expr3394.*expr3462.*expr3505.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(3, 21) = expr3506;

%%   First derivative w/r to a(3) of constraint #22
expr3507 = -2.*expr3389.*expr3390.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3389.*expr3391.*expr3393.*expr3394.*expr3462.*expr3505.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(3, 22) = expr3507;

%%   First derivative w/r to a(3) of constraint #23
expr3508 = 4.*wp.^2.*a(3) + 4.*a(3).*(a(3).^2 + b(3).^2);
expr3509 = 2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3510 = expr3398.*expr3400.*expr3401.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr3508.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3511 = expr3509 + expr3510;
GC(3, 23) = expr3511;

%%   First derivative w/r to a(3) of constraint #24
expr3512 = -2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3513 = expr3398.*expr3400.*expr3401.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr3508.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3514 = expr3512 + expr3513;
GC(3, 24) = expr3514;

%%   First derivative w/r to a(3) of constraint #25
expr3515 = 4.*ws.^2.*a(3) + 4.*a(3).*(a(3).^2 + b(3).^2);
expr3516 = 2.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr483.*expr503.*expr538.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3517 = expr3413.*expr3415.*expr3416.*(expr3413.*expr3414.*expr3415.*expr3416).^expr606.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr3515.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3518 = expr3516 + expr3517;
GC(3, 25) = expr3518;

%%   First derivative w/r to a(3) of constraint #26
expr3519 = expr1670 + expr1671 + expr1672 + expr1673 + expr1674 + expr1675 + expr1676 + expr1677 + expr1678 + expr1679 + expr1680 + expr1681 + expr1682 + expr1683 + expr1685 + expr1684.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843;
GC(3, 26) = expr3519;

%%   First derivative w/r to a(4) of constraint #1
expr3520 = 0;
GC(4, 1) = expr3520;

%%   First derivative w/r to a(4) of constraint #2
expr3521 = 0;
GC(4, 2) = expr3521;

%%   First derivative w/r to a(4) of constraint #3
expr3522 = 0;
GC(4, 3) = expr3522;

%%   First derivative w/r to a(4) of constraint #4
expr3523 = -1./(2.*sqrt(a(4).^2 + b(4).^2)) + sqrt(a(4).^2 + b(4).^2)./(2.*a(4).^2);
GC(4, 4) = expr3523;

%%   First derivative w/r to a(4) of constraint #5
expr3524 = (wp.^2.*a(4))./25 + 4.*a(4).*(a(4).^2 + b(4).^2);
expr3525 = 2.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3253.*expr3255.*expr3256.*expr3258.*expr3430.*expr3524.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(4, 5) = expr3525;

%%   First derivative w/r to a(4) of constraint #6
expr3526 = -2.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3253.*expr3255.*expr3256.*expr3258.*expr3430.*expr3524.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(4, 6) = expr3526;

%%   First derivative w/r to a(4) of constraint #7
expr3527 = (4.*wp.^2.*a(4))./25 + 4.*a(4).*(a(4).^2 + b(4).^2);
expr3528 = 2.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3270.*expr3272.*expr3273.*expr3275.*expr3434.*expr3527.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(4, 7) = expr3528;

%%   First derivative w/r to a(4) of constraint #8
expr3529 = -2.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3270.*expr3272.*expr3273.*expr3275.*expr3434.*expr3527.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(4, 8) = expr3529;

%%   First derivative w/r to a(4) of constraint #9
expr3530 = (9.*wp.^2.*a(4))./25 + 4.*a(4).*(a(4).^2 + b(4).^2);
expr3531 = 2.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3287.*expr3289.*expr3290.*expr3292.*expr3438.*expr3530.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(4, 9) = expr3531;

%%   First derivative w/r to a(4) of constraint #10
expr3532 = -2.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3287.*expr3289.*expr3290.*expr3292.*expr3438.*expr3530.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(4, 10) = expr3532;

%%   First derivative w/r to a(4) of constraint #11
expr3533 = (16.*wp.^2.*a(4))./25 + 4.*a(4).*(a(4).^2 + b(4).^2);
expr3534 = 2.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3304.*expr3306.*expr3307.*expr3309.*expr3442.*expr3533.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(4, 11) = expr3534;

%%   First derivative w/r to a(4) of constraint #12
expr3535 = -2.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3304.*expr3306.*expr3307.*expr3309.*expr3442.*expr3533.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(4, 12) = expr3535;

%%   First derivative w/r to a(4) of constraint #13
expr3536 = wp.^2.*a(4) + 4.*a(4).*(a(4).^2 + b(4).^2);
expr3537 = 2.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3321.*expr3323.*expr3324.*expr3326.*expr3446.*expr3536.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(4, 13) = expr3537;

%%   First derivative w/r to a(4) of constraint #14
expr3538 = -2.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3321.*expr3323.*expr3324.*expr3326.*expr3446.*expr3536.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(4, 14) = expr3538;

%%   First derivative w/r to a(4) of constraint #15
expr3539 = (36.*wp.^2.*a(4))./25 + 4.*a(4).*(a(4).^2 + b(4).^2);
expr3540 = 2.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3338.*expr3340.*expr3341.*expr3343.*expr3450.*expr3539.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(4, 15) = expr3540;

%%   First derivative w/r to a(4) of constraint #16
expr3541 = -2.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3338.*expr3340.*expr3341.*expr3343.*expr3450.*expr3539.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(4, 16) = expr3541;

%%   First derivative w/r to a(4) of constraint #17
expr3542 = (49.*wp.^2.*a(4))./25 + 4.*a(4).*(a(4).^2 + b(4).^2);
expr3543 = 2.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3355.*expr3357.*expr3358.*expr3360.*expr3454.*expr3542.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(4, 17) = expr3543;

%%   First derivative w/r to a(4) of constraint #18
expr3544 = -2.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3355.*expr3357.*expr3358.*expr3360.*expr3454.*expr3542.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(4, 18) = expr3544;

%%   First derivative w/r to a(4) of constraint #19
expr3545 = (64.*wp.^2.*a(4))./25 + 4.*a(4).*(a(4).^2 + b(4).^2);
expr3546 = 2.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3372.*expr3374.*expr3375.*expr3377.*expr3458.*expr3545.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(4, 19) = expr3546;

%%   First derivative w/r to a(4) of constraint #20
expr3547 = -2.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3372.*expr3374.*expr3375.*expr3377.*expr3458.*expr3545.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(4, 20) = expr3547;

%%   First derivative w/r to a(4) of constraint #21
expr3548 = (81.*wp.^2.*a(4))./25 + 4.*a(4).*(a(4).^2 + b(4).^2);
expr3549 = 2.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3389.*expr3391.*expr3392.*expr3394.*expr3462.*expr3548.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(4, 21) = expr3549;

%%   First derivative w/r to a(4) of constraint #22
expr3550 = -2.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610 + expr3389.*expr3391.*expr3392.*expr3394.*expr3462.*expr3548.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(4, 22) = expr3550;

%%   First derivative w/r to a(4) of constraint #23
expr3551 = 4.*wp.^2.*a(4) + 4.*a(4).*(a(4).^2 + b(4).^2);
expr3552 = 2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610;
expr3553 = expr3398.*expr3399.*expr3401.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr3551.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3554 = expr3552 + expr3553;
GC(4, 23) = expr3554;

%%   First derivative w/r to a(4) of constraint #24
expr3555 = -2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610;
expr3556 = expr3398.*expr3399.*expr3401.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr3551.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3557 = expr3555 + expr3556;
GC(4, 24) = expr3557;

%%   First derivative w/r to a(4) of constraint #25
expr3558 = 4.*ws.^2.*a(4) + 4.*a(4).*(a(4).^2 + b(4).^2);
expr3559 = 2.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr483.*expr503.*expr523.*expr558.*expr607.*expr608.*expr609.*expr610;
expr3560 = expr3413.*expr3414.*expr3416.*(expr3413.*expr3414.*expr3415.*expr3416).^expr606.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr3558.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3561 = expr3559 + expr3560;
GC(4, 25) = expr3561;

%%   First derivative w/r to a(4) of constraint #26
expr3562 = expr2012 + expr2013 + expr2014 + expr2015 + expr2016 + expr2017 + expr2018 + expr2019 + expr2020 + expr2021 + expr2022 + expr2023 + expr2024 + expr2025 + expr2026 + expr2027.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846;
GC(4, 26) = expr3562;

%%   First derivative w/r to b(1) of constraint #1
expr3563 = -b(1)./(2.*a(1).*sqrt(a(1).^2 + b(1).^2));
GC(5, 1) = expr3563;

%%   First derivative w/r to b(1) of constraint #2
expr3564 = 0;
GC(5, 2) = expr3564;

%%   First derivative w/r to b(1) of constraint #3
expr3565 = 0;
GC(5, 3) = expr3565;

%%   First derivative w/r to b(1) of constraint #4
expr3566 = 0;
GC(5, 4) = expr3566;

%%   First derivative w/r to b(1) of constraint #5
expr3567 = -(wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr3568 = 2.*expr3253.*expr3254.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3253.*expr3255.*expr3256.*expr3257.*expr3258.*expr3567.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(5, 5) = expr3568;

%%   First derivative w/r to b(1) of constraint #6
expr3569 = -2.*expr3253.*expr3254.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3253.*expr3255.*expr3256.*expr3257.*expr3258.*expr3567.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(5, 6) = expr3569;

%%   First derivative w/r to b(1) of constraint #7
expr3570 = (-4.*wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr3571 = 2.*expr3270.*expr3271.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3270.*expr3272.*expr3273.*expr3274.*expr3275.*expr3570.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(5, 7) = expr3571;

%%   First derivative w/r to b(1) of constraint #8
expr3572 = -2.*expr3270.*expr3271.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3270.*expr3272.*expr3273.*expr3274.*expr3275.*expr3570.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(5, 8) = expr3572;

%%   First derivative w/r to b(1) of constraint #9
expr3573 = (-9.*wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr3574 = 2.*expr3287.*expr3288.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3287.*expr3289.*expr3290.*expr3291.*expr3292.*expr3573.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(5, 9) = expr3574;

%%   First derivative w/r to b(1) of constraint #10
expr3575 = -2.*expr3287.*expr3288.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3287.*expr3289.*expr3290.*expr3291.*expr3292.*expr3573.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(5, 10) = expr3575;

%%   First derivative w/r to b(1) of constraint #11
expr3576 = (-16.*wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr3577 = 2.*expr3304.*expr3305.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3304.*expr3306.*expr3307.*expr3308.*expr3309.*expr3576.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(5, 11) = expr3577;

%%   First derivative w/r to b(1) of constraint #12
expr3578 = -2.*expr3304.*expr3305.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3304.*expr3306.*expr3307.*expr3308.*expr3309.*expr3576.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(5, 12) = expr3578;

%%   First derivative w/r to b(1) of constraint #13
expr3579 = -(wp.^2.*b(1)) + 4.*b(1).*(a(1).^2 + b(1).^2);
expr3580 = 2.*expr3321.*expr3322.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3321.*expr3323.*expr3324.*expr3325.*expr3326.*expr3579.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(5, 13) = expr3580;

%%   First derivative w/r to b(1) of constraint #14
expr3581 = -2.*expr3321.*expr3322.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3321.*expr3323.*expr3324.*expr3325.*expr3326.*expr3579.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(5, 14) = expr3581;

%%   First derivative w/r to b(1) of constraint #15
expr3582 = (-36.*wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr3583 = 2.*expr3338.*expr3339.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3338.*expr3340.*expr3341.*expr3342.*expr3343.*expr3582.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(5, 15) = expr3583;

%%   First derivative w/r to b(1) of constraint #16
expr3584 = -2.*expr3338.*expr3339.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3338.*expr3340.*expr3341.*expr3342.*expr3343.*expr3582.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(5, 16) = expr3584;

%%   First derivative w/r to b(1) of constraint #17
expr3585 = (-49.*wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr3586 = 2.*expr3355.*expr3356.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3355.*expr3357.*expr3358.*expr3359.*expr3360.*expr3585.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(5, 17) = expr3586;

%%   First derivative w/r to b(1) of constraint #18
expr3587 = -2.*expr3355.*expr3356.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3355.*expr3357.*expr3358.*expr3359.*expr3360.*expr3585.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(5, 18) = expr3587;

%%   First derivative w/r to b(1) of constraint #19
expr3588 = (-64.*wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr3589 = 2.*expr3372.*expr3373.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3372.*expr3374.*expr3375.*expr3376.*expr3377.*expr3588.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(5, 19) = expr3589;

%%   First derivative w/r to b(1) of constraint #20
expr3590 = -2.*expr3372.*expr3373.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3372.*expr3374.*expr3375.*expr3376.*expr3377.*expr3588.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(5, 20) = expr3590;

%%   First derivative w/r to b(1) of constraint #21
expr3591 = (-81.*wp.^2.*b(1))./25 + 4.*b(1).*(a(1).^2 + b(1).^2);
expr3592 = 2.*expr3389.*expr3390.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3389.*expr3391.*expr3392.*expr3393.*expr3394.*expr3591.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(5, 21) = expr3592;

%%   First derivative w/r to b(1) of constraint #22
expr3593 = -2.*expr3389.*expr3390.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3389.*expr3391.*expr3392.*expr3393.*expr3394.*expr3591.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(5, 22) = expr3593;

%%   First derivative w/r to b(1) of constraint #23
expr3594 = -4.*wp.^2.*b(1) + 4.*b(1).*(a(1).^2 + b(1).^2);
expr3595 = 2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3596 = expr3398.*expr3399.*expr3400.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr3594.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3597 = expr3595 + expr3596;
GC(5, 23) = expr3597;

%%   First derivative w/r to b(1) of constraint #24
expr3598 = -2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3599 = expr3398.*expr3399.*expr3400.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr3594.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3600 = expr3598 + expr3599;
GC(5, 24) = expr3600;

%%   First derivative w/r to b(1) of constraint #25
expr3601 = -4.*ws.^2.*b(1) + 4.*b(1).*(a(1).^2 + b(1).^2);
expr3602 = 2.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr482.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3603 = expr3413.*expr3414.*expr3415.*(expr3413.*expr3414.*expr3415.*expr3416).^expr606.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr3601.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3604 = expr3602 + expr3603;
GC(5, 25) = expr3604;

%%   First derivative w/r to b(1) of constraint #26
expr3605 = expr1128 + expr1129 + expr1130 + expr1131 + expr1132 + expr1133 + expr1134 + expr1135 + expr1136 + expr1137 + expr1138 + expr1139 + expr1140 + expr1141 + expr1142 + expr1143 + expr1144.*expr501.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr835.*expr836.*expr837;
GC(5, 26) = expr3605;

%%   First derivative w/r to b(2) of constraint #1
expr3606 = 0;
GC(6, 1) = expr3606;

%%   First derivative w/r to b(2) of constraint #2
expr3607 = -b(2)./(2.*a(2).*sqrt(a(2).^2 + b(2).^2));
GC(6, 2) = expr3607;

%%   First derivative w/r to b(2) of constraint #3
expr3608 = 0;
GC(6, 3) = expr3608;

%%   First derivative w/r to b(2) of constraint #4
expr3609 = 0;
GC(6, 4) = expr3609;

%%   First derivative w/r to b(2) of constraint #5
expr3610 = -(wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr3611 = 2.*expr3253.*expr3254.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3253.*expr3256.*expr3257.*expr3258.*expr3430.*expr3610.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(6, 5) = expr3611;

%%   First derivative w/r to b(2) of constraint #6
expr3612 = -2.*expr3253.*expr3254.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3253.*expr3256.*expr3257.*expr3258.*expr3430.*expr3610.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(6, 6) = expr3612;

%%   First derivative w/r to b(2) of constraint #7
expr3613 = (-4.*wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr3614 = 2.*expr3270.*expr3271.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3270.*expr3273.*expr3274.*expr3275.*expr3434.*expr3613.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(6, 7) = expr3614;

%%   First derivative w/r to b(2) of constraint #8
expr3615 = -2.*expr3270.*expr3271.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3270.*expr3273.*expr3274.*expr3275.*expr3434.*expr3613.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(6, 8) = expr3615;

%%   First derivative w/r to b(2) of constraint #9
expr3616 = (-9.*wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr3617 = 2.*expr3287.*expr3288.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3287.*expr3290.*expr3291.*expr3292.*expr3438.*expr3616.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(6, 9) = expr3617;

%%   First derivative w/r to b(2) of constraint #10
expr3618 = -2.*expr3287.*expr3288.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3287.*expr3290.*expr3291.*expr3292.*expr3438.*expr3616.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(6, 10) = expr3618;

%%   First derivative w/r to b(2) of constraint #11
expr3619 = (-16.*wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr3620 = 2.*expr3304.*expr3305.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3304.*expr3307.*expr3308.*expr3309.*expr3442.*expr3619.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(6, 11) = expr3620;

%%   First derivative w/r to b(2) of constraint #12
expr3621 = -2.*expr3304.*expr3305.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3304.*expr3307.*expr3308.*expr3309.*expr3442.*expr3619.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(6, 12) = expr3621;

%%   First derivative w/r to b(2) of constraint #13
expr3622 = -(wp.^2.*b(2)) + 4.*b(2).*(a(2).^2 + b(2).^2);
expr3623 = 2.*expr3321.*expr3322.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3321.*expr3324.*expr3325.*expr3326.*expr3446.*expr3622.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(6, 13) = expr3623;

%%   First derivative w/r to b(2) of constraint #14
expr3624 = -2.*expr3321.*expr3322.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3321.*expr3324.*expr3325.*expr3326.*expr3446.*expr3622.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(6, 14) = expr3624;

%%   First derivative w/r to b(2) of constraint #15
expr3625 = (-36.*wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr3626 = 2.*expr3338.*expr3339.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3338.*expr3341.*expr3342.*expr3343.*expr3450.*expr3625.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(6, 15) = expr3626;

%%   First derivative w/r to b(2) of constraint #16
expr3627 = -2.*expr3338.*expr3339.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3338.*expr3341.*expr3342.*expr3343.*expr3450.*expr3625.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(6, 16) = expr3627;

%%   First derivative w/r to b(2) of constraint #17
expr3628 = (-49.*wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr3629 = 2.*expr3355.*expr3356.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3355.*expr3358.*expr3359.*expr3360.*expr3454.*expr3628.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(6, 17) = expr3629;

%%   First derivative w/r to b(2) of constraint #18
expr3630 = -2.*expr3355.*expr3356.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3355.*expr3358.*expr3359.*expr3360.*expr3454.*expr3628.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(6, 18) = expr3630;

%%   First derivative w/r to b(2) of constraint #19
expr3631 = (-64.*wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr3632 = 2.*expr3372.*expr3373.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3372.*expr3375.*expr3376.*expr3377.*expr3458.*expr3631.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(6, 19) = expr3632;

%%   First derivative w/r to b(2) of constraint #20
expr3633 = -2.*expr3372.*expr3373.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3372.*expr3375.*expr3376.*expr3377.*expr3458.*expr3631.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(6, 20) = expr3633;

%%   First derivative w/r to b(2) of constraint #21
expr3634 = (-81.*wp.^2.*b(2))./25 + 4.*b(2).*(a(2).^2 + b(2).^2);
expr3635 = 2.*expr3389.*expr3390.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3389.*expr3392.*expr3393.*expr3394.*expr3462.*expr3634.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(6, 21) = expr3635;

%%   First derivative w/r to b(2) of constraint #22
expr3636 = -2.*expr3389.*expr3390.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3389.*expr3392.*expr3393.*expr3394.*expr3462.*expr3634.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(6, 22) = expr3636;

%%   First derivative w/r to b(2) of constraint #23
expr3637 = -4.*wp.^2.*b(2) + 4.*b(2).*(a(2).^2 + b(2).^2);
expr3638 = 2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3639 = expr3399.*expr3400.*expr3401.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr3637.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3640 = expr3638 + expr3639;
GC(6, 23) = expr3640;

%%   First derivative w/r to b(2) of constraint #24
expr3641 = -2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3642 = expr3399.*expr3400.*expr3401.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr3637.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3643 = expr3641 + expr3642;
GC(6, 24) = expr3643;

%%   First derivative w/r to b(2) of constraint #25
expr3644 = -4.*ws.^2.*b(2) + 4.*b(2).*(a(2).^2 + b(2).^2);
expr3645 = 2.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr483.*expr502.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3646 = expr3414.*expr3415.*expr3416.*(expr3413.*expr3414.*expr3415.*expr3416).^expr606.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr3644.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3647 = expr3645 + expr3646;
GC(6, 25) = expr3647;

%%   First derivative w/r to b(2) of constraint #26
expr3648 = expr1489 + expr1490 + expr1491 + expr1492 + expr1493 + expr1494 + expr1495 + expr1496 + expr1497 + expr1498 + expr1499 + expr1500 + expr1501 + expr1502 + expr1503 + expr1504 + expr1505.*expr483.*expr521.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr838.*expr839.*expr840;
GC(6, 26) = expr3648;

%%   First derivative w/r to b(3) of constraint #1
expr3649 = 0;
GC(7, 1) = expr3649;

%%   First derivative w/r to b(3) of constraint #2
expr3650 = 0;
GC(7, 2) = expr3650;

%%   First derivative w/r to b(3) of constraint #3
expr3651 = -b(3)./(2.*a(3).*sqrt(a(3).^2 + b(3).^2));
GC(7, 3) = expr3651;

%%   First derivative w/r to b(3) of constraint #4
expr3652 = 0;
GC(7, 4) = expr3652;

%%   First derivative w/r to b(3) of constraint #5
expr3653 = -(wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr3654 = 2.*expr3253.*expr3254.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3253.*expr3255.*expr3257.*expr3258.*expr3430.*expr3653.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(7, 5) = expr3654;

%%   First derivative w/r to b(3) of constraint #6
expr3655 = -2.*expr3253.*expr3254.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3253.*expr3255.*expr3257.*expr3258.*expr3430.*expr3653.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(7, 6) = expr3655;

%%   First derivative w/r to b(3) of constraint #7
expr3656 = (-4.*wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr3657 = 2.*expr3270.*expr3271.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3270.*expr3272.*expr3274.*expr3275.*expr3434.*expr3656.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(7, 7) = expr3657;

%%   First derivative w/r to b(3) of constraint #8
expr3658 = -2.*expr3270.*expr3271.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3270.*expr3272.*expr3274.*expr3275.*expr3434.*expr3656.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(7, 8) = expr3658;

%%   First derivative w/r to b(3) of constraint #9
expr3659 = (-9.*wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr3660 = 2.*expr3287.*expr3288.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3287.*expr3289.*expr3291.*expr3292.*expr3438.*expr3659.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(7, 9) = expr3660;

%%   First derivative w/r to b(3) of constraint #10
expr3661 = -2.*expr3287.*expr3288.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3287.*expr3289.*expr3291.*expr3292.*expr3438.*expr3659.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(7, 10) = expr3661;

%%   First derivative w/r to b(3) of constraint #11
expr3662 = (-16.*wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr3663 = 2.*expr3304.*expr3305.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3304.*expr3306.*expr3308.*expr3309.*expr3442.*expr3662.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(7, 11) = expr3663;

%%   First derivative w/r to b(3) of constraint #12
expr3664 = -2.*expr3304.*expr3305.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3304.*expr3306.*expr3308.*expr3309.*expr3442.*expr3662.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(7, 12) = expr3664;

%%   First derivative w/r to b(3) of constraint #13
expr3665 = -(wp.^2.*b(3)) + 4.*b(3).*(a(3).^2 + b(3).^2);
expr3666 = 2.*expr3321.*expr3322.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3321.*expr3323.*expr3325.*expr3326.*expr3446.*expr3665.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(7, 13) = expr3666;

%%   First derivative w/r to b(3) of constraint #14
expr3667 = -2.*expr3321.*expr3322.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3321.*expr3323.*expr3325.*expr3326.*expr3446.*expr3665.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(7, 14) = expr3667;

%%   First derivative w/r to b(3) of constraint #15
expr3668 = (-36.*wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr3669 = 2.*expr3338.*expr3339.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3338.*expr3340.*expr3342.*expr3343.*expr3450.*expr3668.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(7, 15) = expr3669;

%%   First derivative w/r to b(3) of constraint #16
expr3670 = -2.*expr3338.*expr3339.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3338.*expr3340.*expr3342.*expr3343.*expr3450.*expr3668.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(7, 16) = expr3670;

%%   First derivative w/r to b(3) of constraint #17
expr3671 = (-49.*wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr3672 = 2.*expr3355.*expr3356.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3355.*expr3357.*expr3359.*expr3360.*expr3454.*expr3671.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(7, 17) = expr3672;

%%   First derivative w/r to b(3) of constraint #18
expr3673 = -2.*expr3355.*expr3356.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3355.*expr3357.*expr3359.*expr3360.*expr3454.*expr3671.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(7, 18) = expr3673;

%%   First derivative w/r to b(3) of constraint #19
expr3674 = (-64.*wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr3675 = 2.*expr3372.*expr3373.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3372.*expr3374.*expr3376.*expr3377.*expr3458.*expr3674.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(7, 19) = expr3675;

%%   First derivative w/r to b(3) of constraint #20
expr3676 = -2.*expr3372.*expr3373.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3372.*expr3374.*expr3376.*expr3377.*expr3458.*expr3674.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(7, 20) = expr3676;

%%   First derivative w/r to b(3) of constraint #21
expr3677 = (-81.*wp.^2.*b(3))./25 + 4.*b(3).*(a(3).^2 + b(3).^2);
expr3678 = 2.*expr3389.*expr3390.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3389.*expr3391.*expr3393.*expr3394.*expr3462.*expr3677.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(7, 21) = expr3678;

%%   First derivative w/r to b(3) of constraint #22
expr3679 = -2.*expr3389.*expr3390.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610 + expr3389.*expr3391.*expr3393.*expr3394.*expr3462.*expr3677.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(7, 22) = expr3679;

%%   First derivative w/r to b(3) of constraint #23
expr3680 = -4.*wp.^2.*b(3) + 4.*b(3).*(a(3).^2 + b(3).^2);
expr3681 = 2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3682 = expr3398.*expr3400.*expr3401.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr3680.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3683 = expr3681 + expr3682;
GC(7, 23) = expr3683;

%%   First derivative w/r to b(3) of constraint #24
expr3684 = -2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3685 = expr3398.*expr3400.*expr3401.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr3680.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3686 = expr3684 + expr3685;
GC(7, 24) = expr3686;

%%   First derivative w/r to b(3) of constraint #25
expr3687 = -4.*ws.^2.*b(3) + 4.*b(3).*(a(3).^2 + b(3).^2);
expr3688 = 2.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr483.*expr503.*expr522.*expr543.*expr607.*expr608.*expr609.*expr610;
expr3689 = expr3413.*expr3415.*expr3416.*(expr3413.*expr3414.*expr3415.*expr3416).^expr606.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr3687.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3690 = expr3688 + expr3689;
GC(7, 25) = expr3690;

%%   First derivative w/r to b(3) of constraint #26
expr3691 = expr1839 + expr1840 + expr1841 + expr1842 + expr1843 + expr1844 + expr1845 + expr1846 + expr1847 + expr1848 + expr1849 + expr1850 + expr1851 + expr1852 + expr1853 + expr1854 + expr1855.*expr483.*expr503.*expr541.*expr543.*expr607.*expr608.*expr609.*expr610.*expr841.*expr842.*expr843;
GC(7, 26) = expr3691;

%%   First derivative w/r to b(4) of constraint #1
expr3692 = 0;
GC(8, 1) = expr3692;

%%   First derivative w/r to b(4) of constraint #2
expr3693 = 0;
GC(8, 2) = expr3693;

%%   First derivative w/r to b(4) of constraint #3
expr3694 = 0;
GC(8, 3) = expr3694;

%%   First derivative w/r to b(4) of constraint #4
expr3695 = -b(4)./(2.*a(4).*sqrt(a(4).^2 + b(4).^2));
GC(8, 4) = expr3695;

%%   First derivative w/r to b(4) of constraint #5
expr3696 = -(wp.^2.*b(4))./25 + 4.*b(4).*(a(4).^2 + b(4).^2);
expr3697 = 2.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3253.*expr3255.*expr3256.*expr3258.*expr3430.*expr3696.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(8, 5) = expr3697;

%%   First derivative w/r to b(4) of constraint #6
expr3698 = -2.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3253.*expr3255.*expr3256.*expr3258.*expr3430.*expr3696.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(8, 6) = expr3698;

%%   First derivative w/r to b(4) of constraint #7
expr3699 = (-4.*wp.^2.*b(4))./25 + 4.*b(4).*(a(4).^2 + b(4).^2);
expr3700 = 2.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3270.*expr3272.*expr3273.*expr3275.*expr3434.*expr3699.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(8, 7) = expr3700;

%%   First derivative w/r to b(4) of constraint #8
expr3701 = -2.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3270.*expr3272.*expr3273.*expr3275.*expr3434.*expr3699.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(8, 8) = expr3701;

%%   First derivative w/r to b(4) of constraint #9
expr3702 = (-9.*wp.^2.*b(4))./25 + 4.*b(4).*(a(4).^2 + b(4).^2);
expr3703 = 2.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3287.*expr3289.*expr3290.*expr3292.*expr3438.*expr3702.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(8, 9) = expr3703;

%%   First derivative w/r to b(4) of constraint #10
expr3704 = -2.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3287.*expr3289.*expr3290.*expr3292.*expr3438.*expr3702.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(8, 10) = expr3704;

%%   First derivative w/r to b(4) of constraint #11
expr3705 = (-16.*wp.^2.*b(4))./25 + 4.*b(4).*(a(4).^2 + b(4).^2);
expr3706 = 2.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3304.*expr3306.*expr3307.*expr3309.*expr3442.*expr3705.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(8, 11) = expr3706;

%%   First derivative w/r to b(4) of constraint #12
expr3707 = -2.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3304.*expr3306.*expr3307.*expr3309.*expr3442.*expr3705.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(8, 12) = expr3707;

%%   First derivative w/r to b(4) of constraint #13
expr3708 = -(wp.^2.*b(4)) + 4.*b(4).*(a(4).^2 + b(4).^2);
expr3709 = 2.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3321.*expr3323.*expr3324.*expr3326.*expr3446.*expr3708.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(8, 13) = expr3709;

%%   First derivative w/r to b(4) of constraint #14
expr3710 = -2.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3321.*expr3323.*expr3324.*expr3326.*expr3446.*expr3708.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(8, 14) = expr3710;

%%   First derivative w/r to b(4) of constraint #15
expr3711 = (-36.*wp.^2.*b(4))./25 + 4.*b(4).*(a(4).^2 + b(4).^2);
expr3712 = 2.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3338.*expr3340.*expr3341.*expr3343.*expr3450.*expr3711.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(8, 15) = expr3712;

%%   First derivative w/r to b(4) of constraint #16
expr3713 = -2.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3338.*expr3340.*expr3341.*expr3343.*expr3450.*expr3711.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(8, 16) = expr3713;

%%   First derivative w/r to b(4) of constraint #17
expr3714 = (-49.*wp.^2.*b(4))./25 + 4.*b(4).*(a(4).^2 + b(4).^2);
expr3715 = 2.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3355.*expr3357.*expr3358.*expr3360.*expr3454.*expr3714.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(8, 17) = expr3715;

%%   First derivative w/r to b(4) of constraint #18
expr3716 = -2.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3355.*expr3357.*expr3358.*expr3360.*expr3454.*expr3714.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(8, 18) = expr3716;

%%   First derivative w/r to b(4) of constraint #19
expr3717 = (-64.*wp.^2.*b(4))./25 + 4.*b(4).*(a(4).^2 + b(4).^2);
expr3718 = 2.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3372.*expr3374.*expr3375.*expr3377.*expr3458.*expr3717.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(8, 19) = expr3718;

%%   First derivative w/r to b(4) of constraint #20
expr3719 = -2.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3372.*expr3374.*expr3375.*expr3377.*expr3458.*expr3717.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(8, 20) = expr3719;

%%   First derivative w/r to b(4) of constraint #21
expr3720 = (-81.*wp.^2.*b(4))./25 + 4.*b(4).*(a(4).^2 + b(4).^2);
expr3721 = 2.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3389.*expr3391.*expr3392.*expr3394.*expr3462.*expr3720.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(8, 21) = expr3721;

%%   First derivative w/r to b(4) of constraint #22
expr3722 = -2.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610 + expr3389.*expr3391.*expr3392.*expr3394.*expr3462.*expr3720.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(8, 22) = expr3722;

%%   First derivative w/r to b(4) of constraint #23
expr3723 = -4.*wp.^2.*b(4) + 4.*b(4).*(a(4).^2 + b(4).^2);
expr3724 = 2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610;
expr3725 = expr3398.*expr3399.*expr3401.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr3723.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3726 = expr3724 + expr3725;
GC(8, 23) = expr3726;

%%   First derivative w/r to b(4) of constraint #24
expr3727 = -2.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610;
expr3728 = expr3398.*expr3399.*expr3401.*(expr3398.*expr3399.*expr3400.*expr3401).^expr606.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr3723.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3729 = expr3727 + expr3728;
GC(8, 24) = expr3729;

%%   First derivative w/r to b(4) of constraint #25
expr3730 = -4.*ws.^2.*b(4) + 4.*b(4).*(a(4).^2 + b(4).^2);
expr3731 = 2.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr483.*expr503.*expr523.*expr542.*expr607.*expr608.*expr609.*expr610;
expr3732 = expr3413.*expr3414.*expr3416.*(expr3413.*expr3414.*expr3415.*expr3416).^expr606.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr3730.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3733 = expr3731 + expr3732;
GC(8, 25) = expr3733;

%%   First derivative w/r to b(4) of constraint #26
expr3734 = expr2178 + expr2179 + expr2180 + expr2181 + expr2182 + expr2183 + expr2184 + expr2185 + expr2186 + expr2187 + expr2188 + expr2189 + expr2190 + expr2191 + expr2192 + expr2193 + expr2194.*expr483.*expr503.*expr523.*expr561.*expr607.*expr608.*expr609.*expr610.*expr844.*expr845.*expr846;
GC(8, 26) = expr3734;

%%   First derivative w/r to c(1) of constraint #1
expr3735 = 0;
GC(9, 1) = expr3735;

%%   First derivative w/r to c(1) of constraint #2
expr3736 = 0;
GC(9, 2) = expr3736;

%%   First derivative w/r to c(1) of constraint #3
expr3737 = 0;
GC(9, 3) = expr3737;

%%   First derivative w/r to c(1) of constraint #4
expr3738 = 0;
GC(9, 4) = expr3738;

%%   First derivative w/r to c(1) of constraint #5
expr3739 = (wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr3740 = expr3247 + expr3248;
expr3741 = expr3249 + expr3250;
expr3742 = expr3251 + expr3252;
expr3743 = ((expr3245 + expr3246).*(expr3247 + expr3248).*(expr3249 + expr3250).*(expr3251 + expr3252)).^expr600;
expr3744 = -2.*expr2207.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3254.*expr3739.*expr3740.*expr3741.*expr3742.*expr3743.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(9, 5) = expr3744;

%%   First derivative w/r to c(1) of constraint #6
expr3745 = 2.*expr2207.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3254.*expr3739.*expr3740.*expr3741.*expr3742.*expr3743.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(9, 6) = expr3745;

%%   First derivative w/r to c(1) of constraint #7
expr3746 = (4.*wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr3747 = expr3247 + expr3267;
expr3748 = expr3249 + expr3268;
expr3749 = expr3251 + expr3269;
expr3750 = ((expr3245 + expr3266).*(expr3247 + expr3267).*(expr3249 + expr3268).*(expr3251 + expr3269)).^expr600;
expr3751 = -2.*expr2207.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3271.*expr3746.*expr3747.*expr3748.*expr3749.*expr3750.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(9, 7) = expr3751;

%%   First derivative w/r to c(1) of constraint #8
expr3752 = 2.*expr2207.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3271.*expr3746.*expr3747.*expr3748.*expr3749.*expr3750.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(9, 8) = expr3752;

%%   First derivative w/r to c(1) of constraint #9
expr3753 = (9.*wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr3754 = expr3247 + expr3284;
expr3755 = expr3249 + expr3285;
expr3756 = expr3251 + expr3286;
expr3757 = ((expr3245 + expr3283).*(expr3247 + expr3284).*(expr3249 + expr3285).*(expr3251 + expr3286)).^expr600;
expr3758 = -2.*expr2207.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3288.*expr3753.*expr3754.*expr3755.*expr3756.*expr3757.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(9, 9) = expr3758;

%%   First derivative w/r to c(1) of constraint #10
expr3759 = 2.*expr2207.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3288.*expr3753.*expr3754.*expr3755.*expr3756.*expr3757.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(9, 10) = expr3759;

%%   First derivative w/r to c(1) of constraint #11
expr3760 = (16.*wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr3761 = expr3247 + expr3301;
expr3762 = expr3249 + expr3302;
expr3763 = expr3251 + expr3303;
expr3764 = ((expr3245 + expr3300).*(expr3247 + expr3301).*(expr3249 + expr3302).*(expr3251 + expr3303)).^expr600;
expr3765 = -2.*expr2207.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3305.*expr3760.*expr3761.*expr3762.*expr3763.*expr3764.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(9, 11) = expr3765;

%%   First derivative w/r to c(1) of constraint #12
expr3766 = 2.*expr2207.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3305.*expr3760.*expr3761.*expr3762.*expr3763.*expr3764.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(9, 12) = expr3766;

%%   First derivative w/r to c(1) of constraint #13
expr3767 = wp.^2.*c(1) + 4.*c(1).*(c(1).^2 + d(1).^2);
expr3768 = expr3247 + expr3318;
expr3769 = expr3249 + expr3319;
expr3770 = expr3251 + expr3320;
expr3771 = ((expr3245 + expr3317).*(expr3247 + expr3318).*(expr3249 + expr3319).*(expr3251 + expr3320)).^expr600;
expr3772 = -2.*expr2207.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3322.*expr3767.*expr3768.*expr3769.*expr3770.*expr3771.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(9, 13) = expr3772;

%%   First derivative w/r to c(1) of constraint #14
expr3773 = 2.*expr2207.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3322.*expr3767.*expr3768.*expr3769.*expr3770.*expr3771.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(9, 14) = expr3773;

%%   First derivative w/r to c(1) of constraint #15
expr3774 = (36.*wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr3775 = expr3247 + expr3335;
expr3776 = expr3249 + expr3336;
expr3777 = expr3251 + expr3337;
expr3778 = ((expr3245 + expr3334).*(expr3247 + expr3335).*(expr3249 + expr3336).*(expr3251 + expr3337)).^expr600;
expr3779 = -2.*expr2207.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3339.*expr3774.*expr3775.*expr3776.*expr3777.*expr3778.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(9, 15) = expr3779;

%%   First derivative w/r to c(1) of constraint #16
expr3780 = 2.*expr2207.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3339.*expr3774.*expr3775.*expr3776.*expr3777.*expr3778.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(9, 16) = expr3780;

%%   First derivative w/r to c(1) of constraint #17
expr3781 = (49.*wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr3782 = expr3247 + expr3352;
expr3783 = expr3249 + expr3353;
expr3784 = expr3251 + expr3354;
expr3785 = ((expr3245 + expr3351).*(expr3247 + expr3352).*(expr3249 + expr3353).*(expr3251 + expr3354)).^expr600;
expr3786 = -2.*expr2207.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3356.*expr3781.*expr3782.*expr3783.*expr3784.*expr3785.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(9, 17) = expr3786;

%%   First derivative w/r to c(1) of constraint #18
expr3787 = 2.*expr2207.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3356.*expr3781.*expr3782.*expr3783.*expr3784.*expr3785.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(9, 18) = expr3787;

%%   First derivative w/r to c(1) of constraint #19
expr3788 = (64.*wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr3789 = expr3247 + expr3369;
expr3790 = expr3249 + expr3370;
expr3791 = expr3251 + expr3371;
expr3792 = ((expr3245 + expr3368).*(expr3247 + expr3369).*(expr3249 + expr3370).*(expr3251 + expr3371)).^expr600;
expr3793 = -2.*expr2207.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3373.*expr3788.*expr3789.*expr3790.*expr3791.*expr3792.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(9, 19) = expr3793;

%%   First derivative w/r to c(1) of constraint #20
expr3794 = 2.*expr2207.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3373.*expr3788.*expr3789.*expr3790.*expr3791.*expr3792.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(9, 20) = expr3794;

%%   First derivative w/r to c(1) of constraint #21
expr3795 = (81.*wp.^2.*c(1))./25 + 4.*c(1).*(c(1).^2 + d(1).^2);
expr3796 = expr3247 + expr3386;
expr3797 = expr3249 + expr3387;
expr3798 = expr3251 + expr3388;
expr3799 = ((expr3245 + expr3385).*(expr3247 + expr3386).*(expr3249 + expr3387).*(expr3251 + expr3388)).^expr600;
expr3800 = -2.*expr2207.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3390.*expr3795.*expr3796.*expr3797.*expr3798.*expr3799.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(9, 21) = expr3800;

%%   First derivative w/r to c(1) of constraint #22
expr3801 = 2.*expr2207.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3390.*expr3795.*expr3796.*expr3797.*expr3798.*expr3799.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(9, 22) = expr3801;

%%   First derivative w/r to c(1) of constraint #23
expr3802 = 4.*wp.^2.*c(1) + 4.*c(1).*(c(1).^2 + d(1).^2);
expr3803 = -2.*expr2207.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610;
expr3804 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3403.*expr3404.*expr3405.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr3802.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3805 = expr3803 + expr3804;
GC(9, 23) = expr3805;

%%   First derivative w/r to c(1) of constraint #24
expr3806 = 2.*expr2207.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610;
expr3807 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3403.*expr3404.*expr3405.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr3802.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3808 = expr3806 + expr3807;
GC(9, 24) = expr3808;

%%   First derivative w/r to c(1) of constraint #25
expr3809 = 4.*ws.^2.*c(1) + 4.*c(1).*(c(1).^2 + d(1).^2);
expr3810 = -2.*expr2207.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610;
expr3811 = (expr3413.*expr3414.*expr3415.*expr3416).^expr600.*expr3418.*expr3419.*expr3420.*(expr3417.*expr3418.*expr3419.*expr3420).^expr600.*expr3809.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3812 = expr3810 + expr3811;
GC(9, 25) = expr3812;

%%   First derivative w/r to c(1) of constraint #26
expr3813 = expr2313 + expr2314 + expr2315 + expr2316 + expr2317 + expr2318 + expr2319 + expr2320 + expr2321 + expr2322 + expr2323 + expr2324 + expr2325 + expr2326 + expr2327 + expr2328;
GC(9, 26) = expr3813;

%%   First derivative w/r to c(2) of constraint #1
expr3814 = 0;
GC(10, 1) = expr3814;

%%   First derivative w/r to c(2) of constraint #2
expr3815 = 0;
GC(10, 2) = expr3815;

%%   First derivative w/r to c(2) of constraint #3
expr3816 = 0;
GC(10, 3) = expr3816;

%%   First derivative w/r to c(2) of constraint #4
expr3817 = 0;
GC(10, 4) = expr3817;

%%   First derivative w/r to c(2) of constraint #5
expr3818 = (wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr3819 = expr3245 + expr3246;
expr3820 = -2.*expr2467.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3254.*expr3741.*expr3742.*expr3743.*expr3818.*expr3819.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(10, 5) = expr3820;

%%   First derivative w/r to c(2) of constraint #6
expr3821 = 2.*expr2467.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3254.*expr3741.*expr3742.*expr3743.*expr3818.*expr3819.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(10, 6) = expr3821;

%%   First derivative w/r to c(2) of constraint #7
expr3822 = (4.*wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr3823 = expr3245 + expr3266;
expr3824 = -2.*expr2467.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3271.*expr3748.*expr3749.*expr3750.*expr3822.*expr3823.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(10, 7) = expr3824;

%%   First derivative w/r to c(2) of constraint #8
expr3825 = 2.*expr2467.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3271.*expr3748.*expr3749.*expr3750.*expr3822.*expr3823.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(10, 8) = expr3825;

%%   First derivative w/r to c(2) of constraint #9
expr3826 = (9.*wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr3827 = expr3245 + expr3283;
expr3828 = -2.*expr2467.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3288.*expr3755.*expr3756.*expr3757.*expr3826.*expr3827.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(10, 9) = expr3828;

%%   First derivative w/r to c(2) of constraint #10
expr3829 = 2.*expr2467.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3288.*expr3755.*expr3756.*expr3757.*expr3826.*expr3827.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(10, 10) = expr3829;

%%   First derivative w/r to c(2) of constraint #11
expr3830 = (16.*wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr3831 = expr3245 + expr3300;
expr3832 = -2.*expr2467.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3305.*expr3762.*expr3763.*expr3764.*expr3830.*expr3831.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(10, 11) = expr3832;

%%   First derivative w/r to c(2) of constraint #12
expr3833 = 2.*expr2467.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3305.*expr3762.*expr3763.*expr3764.*expr3830.*expr3831.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(10, 12) = expr3833;

%%   First derivative w/r to c(2) of constraint #13
expr3834 = wp.^2.*c(2) + 4.*c(2).*(c(2).^2 + d(2).^2);
expr3835 = expr3245 + expr3317;
expr3836 = -2.*expr2467.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3322.*expr3769.*expr3770.*expr3771.*expr3834.*expr3835.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(10, 13) = expr3836;

%%   First derivative w/r to c(2) of constraint #14
expr3837 = 2.*expr2467.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3322.*expr3769.*expr3770.*expr3771.*expr3834.*expr3835.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(10, 14) = expr3837;

%%   First derivative w/r to c(2) of constraint #15
expr3838 = (36.*wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr3839 = expr3245 + expr3334;
expr3840 = -2.*expr2467.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3339.*expr3776.*expr3777.*expr3778.*expr3838.*expr3839.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(10, 15) = expr3840;

%%   First derivative w/r to c(2) of constraint #16
expr3841 = 2.*expr2467.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3339.*expr3776.*expr3777.*expr3778.*expr3838.*expr3839.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(10, 16) = expr3841;

%%   First derivative w/r to c(2) of constraint #17
expr3842 = (49.*wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr3843 = expr3245 + expr3351;
expr3844 = -2.*expr2467.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3356.*expr3783.*expr3784.*expr3785.*expr3842.*expr3843.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(10, 17) = expr3844;

%%   First derivative w/r to c(2) of constraint #18
expr3845 = 2.*expr2467.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3356.*expr3783.*expr3784.*expr3785.*expr3842.*expr3843.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(10, 18) = expr3845;

%%   First derivative w/r to c(2) of constraint #19
expr3846 = (64.*wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr3847 = expr3245 + expr3368;
expr3848 = -2.*expr2467.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3373.*expr3790.*expr3791.*expr3792.*expr3846.*expr3847.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(10, 19) = expr3848;

%%   First derivative w/r to c(2) of constraint #20
expr3849 = 2.*expr2467.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3373.*expr3790.*expr3791.*expr3792.*expr3846.*expr3847.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(10, 20) = expr3849;

%%   First derivative w/r to c(2) of constraint #21
expr3850 = (81.*wp.^2.*c(2))./25 + 4.*c(2).*(c(2).^2 + d(2).^2);
expr3851 = expr3245 + expr3385;
expr3852 = -2.*expr2467.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3390.*expr3797.*expr3798.*expr3799.*expr3850.*expr3851.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(10, 21) = expr3852;

%%   First derivative w/r to c(2) of constraint #22
expr3853 = 2.*expr2467.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3390.*expr3797.*expr3798.*expr3799.*expr3850.*expr3851.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(10, 22) = expr3853;

%%   First derivative w/r to c(2) of constraint #23
expr3854 = 4.*wp.^2.*c(2) + 4.*c(2).*(c(2).^2 + d(2).^2);
expr3855 = -2.*expr2467.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610;
expr3856 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3402.*expr3404.*expr3405.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr3854.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3857 = expr3855 + expr3856;
GC(10, 23) = expr3857;

%%   First derivative w/r to c(2) of constraint #24
expr3858 = 2.*expr2467.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610;
expr3859 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3402.*expr3404.*expr3405.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr3854.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3860 = expr3858 + expr3859;
GC(10, 24) = expr3860;

%%   First derivative w/r to c(2) of constraint #25
expr3861 = 4.*ws.^2.*c(2) + 4.*c(2).*(c(2).^2 + d(2).^2);
expr3862 = -2.*expr2467.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610;
expr3863 = (expr3413.*expr3414.*expr3415.*expr3416).^expr600.*expr3417.*expr3419.*expr3420.*(expr3417.*expr3418.*expr3419.*expr3420).^expr600.*expr3861.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3864 = expr3862 + expr3863;
GC(10, 25) = expr3864;

%%   First derivative w/r to c(2) of constraint #26
expr3865 = expr2572 + expr2573 + expr2574 + expr2575 + expr2576 + expr2577 + expr2578 + expr2579 + expr2580 + expr2581 + expr2582 + expr2583 + expr2584 + expr2585 + expr2586 + expr2587;
GC(10, 26) = expr3865;

%%   First derivative w/r to c(3) of constraint #1
expr3866 = 0;
GC(11, 1) = expr3866;

%%   First derivative w/r to c(3) of constraint #2
expr3867 = 0;
GC(11, 2) = expr3867;

%%   First derivative w/r to c(3) of constraint #3
expr3868 = 0;
GC(11, 3) = expr3868;

%%   First derivative w/r to c(3) of constraint #4
expr3869 = 0;
GC(11, 4) = expr3869;

%%   First derivative w/r to c(3) of constraint #5
expr3870 = (wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr3871 = -2.*expr2726.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3254.*expr3740.*expr3742.*expr3743.*expr3819.*expr3870.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(11, 5) = expr3871;

%%   First derivative w/r to c(3) of constraint #6
expr3872 = 2.*expr2726.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3254.*expr3740.*expr3742.*expr3743.*expr3819.*expr3870.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(11, 6) = expr3872;

%%   First derivative w/r to c(3) of constraint #7
expr3873 = (4.*wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr3874 = -2.*expr2726.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3271.*expr3747.*expr3749.*expr3750.*expr3823.*expr3873.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(11, 7) = expr3874;

%%   First derivative w/r to c(3) of constraint #8
expr3875 = 2.*expr2726.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3271.*expr3747.*expr3749.*expr3750.*expr3823.*expr3873.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(11, 8) = expr3875;

%%   First derivative w/r to c(3) of constraint #9
expr3876 = (9.*wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr3877 = -2.*expr2726.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3288.*expr3754.*expr3756.*expr3757.*expr3827.*expr3876.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(11, 9) = expr3877;

%%   First derivative w/r to c(3) of constraint #10
expr3878 = 2.*expr2726.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3288.*expr3754.*expr3756.*expr3757.*expr3827.*expr3876.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(11, 10) = expr3878;

%%   First derivative w/r to c(3) of constraint #11
expr3879 = (16.*wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr3880 = -2.*expr2726.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3305.*expr3761.*expr3763.*expr3764.*expr3831.*expr3879.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(11, 11) = expr3880;

%%   First derivative w/r to c(3) of constraint #12
expr3881 = 2.*expr2726.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3305.*expr3761.*expr3763.*expr3764.*expr3831.*expr3879.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(11, 12) = expr3881;

%%   First derivative w/r to c(3) of constraint #13
expr3882 = wp.^2.*c(3) + 4.*c(3).*(c(3).^2 + d(3).^2);
expr3883 = -2.*expr2726.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3322.*expr3768.*expr3770.*expr3771.*expr3835.*expr3882.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(11, 13) = expr3883;

%%   First derivative w/r to c(3) of constraint #14
expr3884 = 2.*expr2726.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3322.*expr3768.*expr3770.*expr3771.*expr3835.*expr3882.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(11, 14) = expr3884;

%%   First derivative w/r to c(3) of constraint #15
expr3885 = (36.*wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr3886 = -2.*expr2726.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3339.*expr3775.*expr3777.*expr3778.*expr3839.*expr3885.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(11, 15) = expr3886;

%%   First derivative w/r to c(3) of constraint #16
expr3887 = 2.*expr2726.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3339.*expr3775.*expr3777.*expr3778.*expr3839.*expr3885.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(11, 16) = expr3887;

%%   First derivative w/r to c(3) of constraint #17
expr3888 = (49.*wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr3889 = -2.*expr2726.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3356.*expr3782.*expr3784.*expr3785.*expr3843.*expr3888.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(11, 17) = expr3889;

%%   First derivative w/r to c(3) of constraint #18
expr3890 = 2.*expr2726.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3356.*expr3782.*expr3784.*expr3785.*expr3843.*expr3888.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(11, 18) = expr3890;

%%   First derivative w/r to c(3) of constraint #19
expr3891 = (64.*wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr3892 = -2.*expr2726.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3373.*expr3789.*expr3791.*expr3792.*expr3847.*expr3891.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(11, 19) = expr3892;

%%   First derivative w/r to c(3) of constraint #20
expr3893 = 2.*expr2726.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3373.*expr3789.*expr3791.*expr3792.*expr3847.*expr3891.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(11, 20) = expr3893;

%%   First derivative w/r to c(3) of constraint #21
expr3894 = (81.*wp.^2.*c(3))./25 + 4.*c(3).*(c(3).^2 + d(3).^2);
expr3895 = -2.*expr2726.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3390.*expr3796.*expr3798.*expr3799.*expr3851.*expr3894.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(11, 21) = expr3895;

%%   First derivative w/r to c(3) of constraint #22
expr3896 = 2.*expr2726.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3390.*expr3796.*expr3798.*expr3799.*expr3851.*expr3894.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(11, 22) = expr3896;

%%   First derivative w/r to c(3) of constraint #23
expr3897 = 4.*wp.^2.*c(3) + 4.*c(3).*(c(3).^2 + d(3).^2);
expr3898 = -2.*expr2726.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610;
expr3899 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3402.*expr3403.*expr3405.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr3897.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3900 = expr3898 + expr3899;
GC(11, 23) = expr3900;

%%   First derivative w/r to c(3) of constraint #24
expr3901 = 2.*expr2726.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610;
expr3902 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3402.*expr3403.*expr3405.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr3897.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3903 = expr3901 + expr3902;
GC(11, 24) = expr3903;

%%   First derivative w/r to c(3) of constraint #25
expr3904 = 4.*ws.^2.*c(3) + 4.*c(3).*(c(3).^2 + d(3).^2);
expr3905 = -2.*expr2726.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610;
expr3906 = (expr3413.*expr3414.*expr3415.*expr3416).^expr600.*expr3417.*expr3418.*expr3420.*(expr3417.*expr3418.*expr3419.*expr3420).^expr600.*expr3904.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3907 = expr3905 + expr3906;
GC(11, 25) = expr3907;

%%   First derivative w/r to c(3) of constraint #26
expr3908 = expr2831 + expr2832 + expr2833 + expr2834 + expr2835 + expr2836 + expr2837 + expr2838 + expr2839 + expr2840 + expr2841 + expr2842 + expr2843 + expr2844 + expr2845 + expr2846;
GC(11, 26) = expr3908;

%%   First derivative w/r to c(4) of constraint #1
expr3909 = 0;
GC(12, 1) = expr3909;

%%   First derivative w/r to c(4) of constraint #2
expr3910 = 0;
GC(12, 2) = expr3910;

%%   First derivative w/r to c(4) of constraint #3
expr3911 = 0;
GC(12, 3) = expr3911;

%%   First derivative w/r to c(4) of constraint #4
expr3912 = 0;
GC(12, 4) = expr3912;

%%   First derivative w/r to c(4) of constraint #5
expr3913 = (wp.^2.*c(4))./25 + 4.*c(4).*(c(4).^2 + d(4).^2);
expr3914 = -2.*expr2985.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3254.*expr3740.*expr3741.*expr3743.*expr3819.*expr3913.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(12, 5) = expr3914;

%%   First derivative w/r to c(4) of constraint #6
expr3915 = 2.*expr2985.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3254.*expr3740.*expr3741.*expr3743.*expr3819.*expr3913.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(12, 6) = expr3915;

%%   First derivative w/r to c(4) of constraint #7
expr3916 = (4.*wp.^2.*c(4))./25 + 4.*c(4).*(c(4).^2 + d(4).^2);
expr3917 = -2.*expr2985.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3271.*expr3747.*expr3748.*expr3750.*expr3823.*expr3916.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(12, 7) = expr3917;

%%   First derivative w/r to c(4) of constraint #8
expr3918 = 2.*expr2985.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3271.*expr3747.*expr3748.*expr3750.*expr3823.*expr3916.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(12, 8) = expr3918;

%%   First derivative w/r to c(4) of constraint #9
expr3919 = (9.*wp.^2.*c(4))./25 + 4.*c(4).*(c(4).^2 + d(4).^2);
expr3920 = -2.*expr2985.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3288.*expr3754.*expr3755.*expr3757.*expr3827.*expr3919.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(12, 9) = expr3920;

%%   First derivative w/r to c(4) of constraint #10
expr3921 = 2.*expr2985.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3288.*expr3754.*expr3755.*expr3757.*expr3827.*expr3919.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(12, 10) = expr3921;

%%   First derivative w/r to c(4) of constraint #11
expr3922 = (16.*wp.^2.*c(4))./25 + 4.*c(4).*(c(4).^2 + d(4).^2);
expr3923 = -2.*expr2985.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3305.*expr3761.*expr3762.*expr3764.*expr3831.*expr3922.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(12, 11) = expr3923;

%%   First derivative w/r to c(4) of constraint #12
expr3924 = 2.*expr2985.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3305.*expr3761.*expr3762.*expr3764.*expr3831.*expr3922.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(12, 12) = expr3924;

%%   First derivative w/r to c(4) of constraint #13
expr3925 = wp.^2.*c(4) + 4.*c(4).*(c(4).^2 + d(4).^2);
expr3926 = -2.*expr2985.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3322.*expr3768.*expr3769.*expr3771.*expr3835.*expr3925.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(12, 13) = expr3926;

%%   First derivative w/r to c(4) of constraint #14
expr3927 = 2.*expr2985.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3322.*expr3768.*expr3769.*expr3771.*expr3835.*expr3925.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(12, 14) = expr3927;

%%   First derivative w/r to c(4) of constraint #15
expr3928 = (36.*wp.^2.*c(4))./25 + 4.*c(4).*(c(4).^2 + d(4).^2);
expr3929 = -2.*expr2985.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3339.*expr3775.*expr3776.*expr3778.*expr3839.*expr3928.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(12, 15) = expr3929;

%%   First derivative w/r to c(4) of constraint #16
expr3930 = 2.*expr2985.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3339.*expr3775.*expr3776.*expr3778.*expr3839.*expr3928.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(12, 16) = expr3930;

%%   First derivative w/r to c(4) of constraint #17
expr3931 = (49.*wp.^2.*c(4))./25 + 4.*c(4).*(c(4).^2 + d(4).^2);
expr3932 = -2.*expr2985.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3356.*expr3782.*expr3783.*expr3785.*expr3843.*expr3931.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(12, 17) = expr3932;

%%   First derivative w/r to c(4) of constraint #18
expr3933 = 2.*expr2985.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3356.*expr3782.*expr3783.*expr3785.*expr3843.*expr3931.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(12, 18) = expr3933;

%%   First derivative w/r to c(4) of constraint #19
expr3934 = (64.*wp.^2.*c(4))./25 + 4.*c(4).*(c(4).^2 + d(4).^2);
expr3935 = -2.*expr2985.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3373.*expr3789.*expr3790.*expr3792.*expr3847.*expr3934.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(12, 19) = expr3935;

%%   First derivative w/r to c(4) of constraint #20
expr3936 = 2.*expr2985.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3373.*expr3789.*expr3790.*expr3792.*expr3847.*expr3934.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(12, 20) = expr3936;

%%   First derivative w/r to c(4) of constraint #21
expr3937 = (81.*wp.^2.*c(4))./25 + 4.*c(4).*(c(4).^2 + d(4).^2);
expr3938 = -2.*expr2985.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3390.*expr3796.*expr3797.*expr3799.*expr3851.*expr3937.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(12, 21) = expr3938;

%%   First derivative w/r to c(4) of constraint #22
expr3939 = 2.*expr2985.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3390.*expr3796.*expr3797.*expr3799.*expr3851.*expr3937.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(12, 22) = expr3939;

%%   First derivative w/r to c(4) of constraint #23
expr3940 = 4.*wp.^2.*c(4) + 4.*c(4).*(c(4).^2 + d(4).^2);
expr3941 = -2.*expr2985.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609;
expr3942 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3402.*expr3403.*expr3404.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr3940.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3943 = expr3941 + expr3942;
GC(12, 23) = expr3943;

%%   First derivative w/r to c(4) of constraint #24
expr3944 = 2.*expr2985.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609;
expr3945 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3402.*expr3403.*expr3404.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr3940.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3946 = expr3944 + expr3945;
GC(12, 24) = expr3946;

%%   First derivative w/r to c(4) of constraint #25
expr3947 = 4.*ws.^2.*c(4) + 4.*c(4).*(c(4).^2 + d(4).^2);
expr3948 = -2.*expr2985.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609;
expr3949 = (expr3413.*expr3414.*expr3415.*expr3416).^expr600.*expr3417.*expr3418.*expr3419.*(expr3417.*expr3418.*expr3419.*expr3420).^expr600.*expr3947.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3950 = expr3948 + expr3949;
GC(12, 25) = expr3950;

%%   First derivative w/r to c(4) of constraint #26
expr3951 = expr3090 + expr3091 + expr3092 + expr3093 + expr3094 + expr3095 + expr3096 + expr3097 + expr3098 + expr3099 + expr3100 + expr3101 + expr3102 + expr3103 + expr3104 + expr3105;
GC(12, 26) = expr3951;

%%   First derivative w/r to d(1) of constraint #1
expr3952 = 0;
GC(13, 1) = expr3952;

%%   First derivative w/r to d(1) of constraint #2
expr3953 = 0;
GC(13, 2) = expr3953;

%%   First derivative w/r to d(1) of constraint #3
expr3954 = 0;
GC(13, 3) = expr3954;

%%   First derivative w/r to d(1) of constraint #4
expr3955 = 0;
GC(13, 4) = expr3955;

%%   First derivative w/r to d(1) of constraint #5
expr3956 = -(wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr3957 = -2.*expr2338.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3254.*expr3740.*expr3741.*expr3742.*expr3743.*expr3956.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(13, 5) = expr3957;

%%   First derivative w/r to d(1) of constraint #6
expr3958 = 2.*expr2338.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3254.*expr3740.*expr3741.*expr3742.*expr3743.*expr3956.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(13, 6) = expr3958;

%%   First derivative w/r to d(1) of constraint #7
expr3959 = (-4.*wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr3960 = -2.*expr2338.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3271.*expr3747.*expr3748.*expr3749.*expr3750.*expr3959.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(13, 7) = expr3960;

%%   First derivative w/r to d(1) of constraint #8
expr3961 = 2.*expr2338.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3271.*expr3747.*expr3748.*expr3749.*expr3750.*expr3959.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(13, 8) = expr3961;

%%   First derivative w/r to d(1) of constraint #9
expr3962 = (-9.*wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr3963 = -2.*expr2338.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3288.*expr3754.*expr3755.*expr3756.*expr3757.*expr3962.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(13, 9) = expr3963;

%%   First derivative w/r to d(1) of constraint #10
expr3964 = 2.*expr2338.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3288.*expr3754.*expr3755.*expr3756.*expr3757.*expr3962.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(13, 10) = expr3964;

%%   First derivative w/r to d(1) of constraint #11
expr3965 = (-16.*wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr3966 = -2.*expr2338.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3305.*expr3761.*expr3762.*expr3763.*expr3764.*expr3965.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(13, 11) = expr3966;

%%   First derivative w/r to d(1) of constraint #12
expr3967 = 2.*expr2338.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3305.*expr3761.*expr3762.*expr3763.*expr3764.*expr3965.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(13, 12) = expr3967;

%%   First derivative w/r to d(1) of constraint #13
expr3968 = -(wp.^2.*d(1)) + 4.*d(1).*(c(1).^2 + d(1).^2);
expr3969 = -2.*expr2338.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3322.*expr3768.*expr3769.*expr3770.*expr3771.*expr3968.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(13, 13) = expr3969;

%%   First derivative w/r to d(1) of constraint #14
expr3970 = 2.*expr2338.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3322.*expr3768.*expr3769.*expr3770.*expr3771.*expr3968.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(13, 14) = expr3970;

%%   First derivative w/r to d(1) of constraint #15
expr3971 = (-36.*wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr3972 = -2.*expr2338.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3339.*expr3775.*expr3776.*expr3777.*expr3778.*expr3971.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(13, 15) = expr3972;

%%   First derivative w/r to d(1) of constraint #16
expr3973 = 2.*expr2338.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3339.*expr3775.*expr3776.*expr3777.*expr3778.*expr3971.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(13, 16) = expr3973;

%%   First derivative w/r to d(1) of constraint #17
expr3974 = (-49.*wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr3975 = -2.*expr2338.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3356.*expr3782.*expr3783.*expr3784.*expr3785.*expr3974.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(13, 17) = expr3975;

%%   First derivative w/r to d(1) of constraint #18
expr3976 = 2.*expr2338.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3356.*expr3782.*expr3783.*expr3784.*expr3785.*expr3974.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(13, 18) = expr3976;

%%   First derivative w/r to d(1) of constraint #19
expr3977 = (-64.*wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr3978 = -2.*expr2338.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3373.*expr3789.*expr3790.*expr3791.*expr3792.*expr3977.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(13, 19) = expr3978;

%%   First derivative w/r to d(1) of constraint #20
expr3979 = 2.*expr2338.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3373.*expr3789.*expr3790.*expr3791.*expr3792.*expr3977.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(13, 20) = expr3979;

%%   First derivative w/r to d(1) of constraint #21
expr3980 = (-81.*wp.^2.*d(1))./25 + 4.*d(1).*(c(1).^2 + d(1).^2);
expr3981 = -2.*expr2338.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3390.*expr3796.*expr3797.*expr3798.*expr3799.*expr3980.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(13, 21) = expr3981;

%%   First derivative w/r to d(1) of constraint #22
expr3982 = 2.*expr2338.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610 + expr3390.*expr3796.*expr3797.*expr3798.*expr3799.*expr3980.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(13, 22) = expr3982;

%%   First derivative w/r to d(1) of constraint #23
expr3983 = -4.*wp.^2.*d(1) + 4.*d(1).*(c(1).^2 + d(1).^2);
expr3984 = -2.*expr2338.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610;
expr3985 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3403.*expr3404.*expr3405.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr3983.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3986 = expr3984 + expr3985;
GC(13, 23) = expr3986;

%%   First derivative w/r to d(1) of constraint #24
expr3987 = 2.*expr2338.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610;
expr3988 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3403.*expr3404.*expr3405.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr3983.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr3989 = expr3987 + expr3988;
GC(13, 24) = expr3989;

%%   First derivative w/r to d(1) of constraint #25
expr3990 = -4.*ws.^2.*d(1) + 4.*d(1).*(c(1).^2 + d(1).^2);
expr3991 = -2.*expr2338.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr483.*expr503.*expr523.*expr543.*expr586.*expr608.*expr609.*expr610;
expr3992 = (expr3413.*expr3414.*expr3415.*expr3416).^expr600.*expr3418.*expr3419.*expr3420.*(expr3417.*expr3418.*expr3419.*expr3420).^expr600.*expr3990.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr3993 = expr3991 + expr3992;
GC(13, 25) = expr3993;

%%   First derivative w/r to d(1) of constraint #26
expr3994 = expr2442 + expr2443 + expr2444 + expr2445 + expr2446 + expr2447 + expr2448 + expr2449 + expr2450 + expr2451 + expr2452 + expr2453 + expr2454 + expr2455 + expr2456 + expr2457;
GC(13, 26) = expr3994;

%%   First derivative w/r to d(2) of constraint #1
expr3995 = 0;
GC(14, 1) = expr3995;

%%   First derivative w/r to d(2) of constraint #2
expr3996 = 0;
GC(14, 2) = expr3996;

%%   First derivative w/r to d(2) of constraint #3
expr3997 = 0;
GC(14, 3) = expr3997;

%%   First derivative w/r to d(2) of constraint #4
expr3998 = 0;
GC(14, 4) = expr3998;

%%   First derivative w/r to d(2) of constraint #5
expr3999 = -(wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr4000 = -2.*expr2597.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3254.*expr3741.*expr3742.*expr3743.*expr3819.*expr3999.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(14, 5) = expr4000;

%%   First derivative w/r to d(2) of constraint #6
expr4001 = 2.*expr2597.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3254.*expr3741.*expr3742.*expr3743.*expr3819.*expr3999.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(14, 6) = expr4001;

%%   First derivative w/r to d(2) of constraint #7
expr4002 = (-4.*wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr4003 = -2.*expr2597.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3271.*expr3748.*expr3749.*expr3750.*expr3823.*expr4002.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(14, 7) = expr4003;

%%   First derivative w/r to d(2) of constraint #8
expr4004 = 2.*expr2597.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3271.*expr3748.*expr3749.*expr3750.*expr3823.*expr4002.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(14, 8) = expr4004;

%%   First derivative w/r to d(2) of constraint #9
expr4005 = (-9.*wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr4006 = -2.*expr2597.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3288.*expr3755.*expr3756.*expr3757.*expr3827.*expr4005.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(14, 9) = expr4006;

%%   First derivative w/r to d(2) of constraint #10
expr4007 = 2.*expr2597.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3288.*expr3755.*expr3756.*expr3757.*expr3827.*expr4005.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(14, 10) = expr4007;

%%   First derivative w/r to d(2) of constraint #11
expr4008 = (-16.*wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr4009 = -2.*expr2597.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3305.*expr3762.*expr3763.*expr3764.*expr3831.*expr4008.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(14, 11) = expr4009;

%%   First derivative w/r to d(2) of constraint #12
expr4010 = 2.*expr2597.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3305.*expr3762.*expr3763.*expr3764.*expr3831.*expr4008.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(14, 12) = expr4010;

%%   First derivative w/r to d(2) of constraint #13
expr4011 = -(wp.^2.*d(2)) + 4.*d(2).*(c(2).^2 + d(2).^2);
expr4012 = -2.*expr2597.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3322.*expr3769.*expr3770.*expr3771.*expr3835.*expr4011.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(14, 13) = expr4012;

%%   First derivative w/r to d(2) of constraint #14
expr4013 = 2.*expr2597.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3322.*expr3769.*expr3770.*expr3771.*expr3835.*expr4011.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(14, 14) = expr4013;

%%   First derivative w/r to d(2) of constraint #15
expr4014 = (-36.*wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr4015 = -2.*expr2597.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3339.*expr3776.*expr3777.*expr3778.*expr3839.*expr4014.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(14, 15) = expr4015;

%%   First derivative w/r to d(2) of constraint #16
expr4016 = 2.*expr2597.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3339.*expr3776.*expr3777.*expr3778.*expr3839.*expr4014.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(14, 16) = expr4016;

%%   First derivative w/r to d(2) of constraint #17
expr4017 = (-49.*wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr4018 = -2.*expr2597.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3356.*expr3783.*expr3784.*expr3785.*expr3843.*expr4017.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(14, 17) = expr4018;

%%   First derivative w/r to d(2) of constraint #18
expr4019 = 2.*expr2597.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3356.*expr3783.*expr3784.*expr3785.*expr3843.*expr4017.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(14, 18) = expr4019;

%%   First derivative w/r to d(2) of constraint #19
expr4020 = (-64.*wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr4021 = -2.*expr2597.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3373.*expr3790.*expr3791.*expr3792.*expr3847.*expr4020.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(14, 19) = expr4021;

%%   First derivative w/r to d(2) of constraint #20
expr4022 = 2.*expr2597.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3373.*expr3790.*expr3791.*expr3792.*expr3847.*expr4020.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(14, 20) = expr4022;

%%   First derivative w/r to d(2) of constraint #21
expr4023 = (-81.*wp.^2.*d(2))./25 + 4.*d(2).*(c(2).^2 + d(2).^2);
expr4024 = -2.*expr2597.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3390.*expr3797.*expr3798.*expr3799.*expr3851.*expr4023.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(14, 21) = expr4024;

%%   First derivative w/r to d(2) of constraint #22
expr4025 = 2.*expr2597.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610 + expr3390.*expr3797.*expr3798.*expr3799.*expr3851.*expr4023.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(14, 22) = expr4025;

%%   First derivative w/r to d(2) of constraint #23
expr4026 = -4.*wp.^2.*d(2) + 4.*d(2).*(c(2).^2 + d(2).^2);
expr4027 = -2.*expr2597.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610;
expr4028 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3402.*expr3404.*expr3405.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr4026.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr4029 = expr4027 + expr4028;
GC(14, 23) = expr4029;

%%   First derivative w/r to d(2) of constraint #24
expr4030 = 2.*expr2597.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610;
expr4031 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3402.*expr3404.*expr3405.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr4026.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr4032 = expr4030 + expr4031;
GC(14, 24) = expr4032;

%%   First derivative w/r to d(2) of constraint #25
expr4033 = -4.*ws.^2.*d(2) + 4.*d(2).*(c(2).^2 + d(2).^2);
expr4034 = -2.*expr2597.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr483.*expr503.*expr523.*expr543.*expr588.*expr607.*expr609.*expr610;
expr4035 = (expr3413.*expr3414.*expr3415.*expr3416).^expr600.*expr3417.*expr3419.*expr3420.*(expr3417.*expr3418.*expr3419.*expr3420).^expr600.*expr4033.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr4036 = expr4034 + expr4035;
GC(14, 25) = expr4036;

%%   First derivative w/r to d(2) of constraint #26
expr4037 = expr2701 + expr2702 + expr2703 + expr2704 + expr2705 + expr2706 + expr2707 + expr2708 + expr2709 + expr2710 + expr2711 + expr2712 + expr2713 + expr2714 + expr2715 + expr2716;
GC(14, 26) = expr4037;

%%   First derivative w/r to d(3) of constraint #1
expr4038 = 0;
GC(15, 1) = expr4038;

%%   First derivative w/r to d(3) of constraint #2
expr4039 = 0;
GC(15, 2) = expr4039;

%%   First derivative w/r to d(3) of constraint #3
expr4040 = 0;
GC(15, 3) = expr4040;

%%   First derivative w/r to d(3) of constraint #4
expr4041 = 0;
GC(15, 4) = expr4041;

%%   First derivative w/r to d(3) of constraint #5
expr4042 = -(wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr4043 = -2.*expr2856.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3254.*expr3740.*expr3742.*expr3743.*expr3819.*expr4042.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(15, 5) = expr4043;

%%   First derivative w/r to d(3) of constraint #6
expr4044 = 2.*expr2856.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3254.*expr3740.*expr3742.*expr3743.*expr3819.*expr4042.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(15, 6) = expr4044;

%%   First derivative w/r to d(3) of constraint #7
expr4045 = (-4.*wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr4046 = -2.*expr2856.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3271.*expr3747.*expr3749.*expr3750.*expr3823.*expr4045.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(15, 7) = expr4046;

%%   First derivative w/r to d(3) of constraint #8
expr4047 = 2.*expr2856.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3271.*expr3747.*expr3749.*expr3750.*expr3823.*expr4045.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(15, 8) = expr4047;

%%   First derivative w/r to d(3) of constraint #9
expr4048 = (-9.*wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr4049 = -2.*expr2856.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3288.*expr3754.*expr3756.*expr3757.*expr3827.*expr4048.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(15, 9) = expr4049;

%%   First derivative w/r to d(3) of constraint #10
expr4050 = 2.*expr2856.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3288.*expr3754.*expr3756.*expr3757.*expr3827.*expr4048.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(15, 10) = expr4050;

%%   First derivative w/r to d(3) of constraint #11
expr4051 = (-16.*wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr4052 = -2.*expr2856.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3305.*expr3761.*expr3763.*expr3764.*expr3831.*expr4051.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(15, 11) = expr4052;

%%   First derivative w/r to d(3) of constraint #12
expr4053 = 2.*expr2856.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3305.*expr3761.*expr3763.*expr3764.*expr3831.*expr4051.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(15, 12) = expr4053;

%%   First derivative w/r to d(3) of constraint #13
expr4054 = -(wp.^2.*d(3)) + 4.*d(3).*(c(3).^2 + d(3).^2);
expr4055 = -2.*expr2856.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3322.*expr3768.*expr3770.*expr3771.*expr3835.*expr4054.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(15, 13) = expr4055;

%%   First derivative w/r to d(3) of constraint #14
expr4056 = 2.*expr2856.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3322.*expr3768.*expr3770.*expr3771.*expr3835.*expr4054.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(15, 14) = expr4056;

%%   First derivative w/r to d(3) of constraint #15
expr4057 = (-36.*wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr4058 = -2.*expr2856.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3339.*expr3775.*expr3777.*expr3778.*expr3839.*expr4057.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(15, 15) = expr4058;

%%   First derivative w/r to d(3) of constraint #16
expr4059 = 2.*expr2856.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3339.*expr3775.*expr3777.*expr3778.*expr3839.*expr4057.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(15, 16) = expr4059;

%%   First derivative w/r to d(3) of constraint #17
expr4060 = (-49.*wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr4061 = -2.*expr2856.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3356.*expr3782.*expr3784.*expr3785.*expr3843.*expr4060.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(15, 17) = expr4061;

%%   First derivative w/r to d(3) of constraint #18
expr4062 = 2.*expr2856.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3356.*expr3782.*expr3784.*expr3785.*expr3843.*expr4060.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(15, 18) = expr4062;

%%   First derivative w/r to d(3) of constraint #19
expr4063 = (-64.*wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr4064 = -2.*expr2856.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3373.*expr3789.*expr3791.*expr3792.*expr3847.*expr4063.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(15, 19) = expr4064;

%%   First derivative w/r to d(3) of constraint #20
expr4065 = 2.*expr2856.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3373.*expr3789.*expr3791.*expr3792.*expr3847.*expr4063.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(15, 20) = expr4065;

%%   First derivative w/r to d(3) of constraint #21
expr4066 = (-81.*wp.^2.*d(3))./25 + 4.*d(3).*(c(3).^2 + d(3).^2);
expr4067 = -2.*expr2856.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3390.*expr3796.*expr3798.*expr3799.*expr3851.*expr4066.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(15, 21) = expr4067;

%%   First derivative w/r to d(3) of constraint #22
expr4068 = 2.*expr2856.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610 + expr3390.*expr3796.*expr3798.*expr3799.*expr3851.*expr4066.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(15, 22) = expr4068;

%%   First derivative w/r to d(3) of constraint #23
expr4069 = -4.*wp.^2.*d(3) + 4.*d(3).*(c(3).^2 + d(3).^2);
expr4070 = -2.*expr2856.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610;
expr4071 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3402.*expr3403.*expr3405.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr4069.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr4072 = expr4070 + expr4071;
GC(15, 23) = expr4072;

%%   First derivative w/r to d(3) of constraint #24
expr4073 = 2.*expr2856.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610;
expr4074 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3402.*expr3403.*expr3405.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr4069.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr4075 = expr4073 + expr4074;
GC(15, 24) = expr4075;

%%   First derivative w/r to d(3) of constraint #25
expr4076 = -4.*ws.^2.*d(3) + 4.*d(3).*(c(3).^2 + d(3).^2);
expr4077 = -2.*expr2856.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr483.*expr503.*expr523.*expr543.*expr590.*expr607.*expr608.*expr610;
expr4078 = (expr3413.*expr3414.*expr3415.*expr3416).^expr600.*expr3417.*expr3418.*expr3420.*(expr3417.*expr3418.*expr3419.*expr3420).^expr600.*expr4076.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr4079 = expr4077 + expr4078;
GC(15, 25) = expr4079;

%%   First derivative w/r to d(3) of constraint #26
expr4080 = expr2960 + expr2961 + expr2962 + expr2963 + expr2964 + expr2965 + expr2966 + expr2967 + expr2968 + expr2969 + expr2970 + expr2971 + expr2972 + expr2973 + expr2974 + expr2975;
GC(15, 26) = expr4080;

%%   First derivative w/r to d(4) of constraint #1
expr4081 = 0;
GC(16, 1) = expr4081;

%%   First derivative w/r to d(4) of constraint #2
expr4082 = 0;
GC(16, 2) = expr4082;

%%   First derivative w/r to d(4) of constraint #3
expr4083 = 0;
GC(16, 3) = expr4083;

%%   First derivative w/r to d(4) of constraint #4
expr4084 = 0;
GC(16, 4) = expr4084;

%%   First derivative w/r to d(4) of constraint #5
expr4085 = -(wp.^2.*d(4))./25 + 4.*d(4).*(c(4).^2 + d(4).^2);
expr4086 = -2.*expr3115.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3254.*expr3740.*expr3741.*expr3743.*expr3819.*expr4085.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(16, 5) = expr4086;

%%   First derivative w/r to d(4) of constraint #6
expr4087 = 2.*expr3115.*expr3253.*expr3254.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3254.*expr3740.*expr3741.*expr3743.*expr3819.*expr4085.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(16, 6) = expr4087;

%%   First derivative w/r to d(4) of constraint #7
expr4088 = (-4.*wp.^2.*d(4))./25 + 4.*d(4).*(c(4).^2 + d(4).^2);
expr4089 = -2.*expr3115.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3271.*expr3747.*expr3748.*expr3750.*expr3823.*expr4088.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(16, 7) = expr4089;

%%   First derivative w/r to d(4) of constraint #8
expr4090 = 2.*expr3115.*expr3270.*expr3271.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3271.*expr3747.*expr3748.*expr3750.*expr3823.*expr4088.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(16, 8) = expr4090;

%%   First derivative w/r to d(4) of constraint #9
expr4091 = (-9.*wp.^2.*d(4))./25 + 4.*d(4).*(c(4).^2 + d(4).^2);
expr4092 = -2.*expr3115.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3288.*expr3754.*expr3755.*expr3757.*expr3827.*expr4091.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(16, 9) = expr4092;

%%   First derivative w/r to d(4) of constraint #10
expr4093 = 2.*expr3115.*expr3287.*expr3288.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3288.*expr3754.*expr3755.*expr3757.*expr3827.*expr4091.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(16, 10) = expr4093;

%%   First derivative w/r to d(4) of constraint #11
expr4094 = (-16.*wp.^2.*d(4))./25 + 4.*d(4).*(c(4).^2 + d(4).^2);
expr4095 = -2.*expr3115.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3305.*expr3761.*expr3762.*expr3764.*expr3831.*expr4094.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(16, 11) = expr4095;

%%   First derivative w/r to d(4) of constraint #12
expr4096 = 2.*expr3115.*expr3304.*expr3305.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3305.*expr3761.*expr3762.*expr3764.*expr3831.*expr4094.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(16, 12) = expr4096;

%%   First derivative w/r to d(4) of constraint #13
expr4097 = -(wp.^2.*d(4)) + 4.*d(4).*(c(4).^2 + d(4).^2);
expr4098 = -2.*expr3115.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3322.*expr3768.*expr3769.*expr3771.*expr3835.*expr4097.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(16, 13) = expr4098;

%%   First derivative w/r to d(4) of constraint #14
expr4099 = 2.*expr3115.*expr3321.*expr3322.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3322.*expr3768.*expr3769.*expr3771.*expr3835.*expr4097.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(16, 14) = expr4099;

%%   First derivative w/r to d(4) of constraint #15
expr4100 = (-36.*wp.^2.*d(4))./25 + 4.*d(4).*(c(4).^2 + d(4).^2);
expr4101 = -2.*expr3115.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3339.*expr3775.*expr3776.*expr3778.*expr3839.*expr4100.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(16, 15) = expr4101;

%%   First derivative w/r to d(4) of constraint #16
expr4102 = 2.*expr3115.*expr3338.*expr3339.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3339.*expr3775.*expr3776.*expr3778.*expr3839.*expr4100.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(16, 16) = expr4102;

%%   First derivative w/r to d(4) of constraint #17
expr4103 = (-49.*wp.^2.*d(4))./25 + 4.*d(4).*(c(4).^2 + d(4).^2);
expr4104 = -2.*expr3115.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3356.*expr3782.*expr3783.*expr3785.*expr3843.*expr4103.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(16, 17) = expr4104;

%%   First derivative w/r to d(4) of constraint #18
expr4105 = 2.*expr3115.*expr3355.*expr3356.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3356.*expr3782.*expr3783.*expr3785.*expr3843.*expr4103.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(16, 18) = expr4105;

%%   First derivative w/r to d(4) of constraint #19
expr4106 = (-64.*wp.^2.*d(4))./25 + 4.*d(4).*(c(4).^2 + d(4).^2);
expr4107 = -2.*expr3115.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3373.*expr3789.*expr3790.*expr3792.*expr3847.*expr4106.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(16, 19) = expr4107;

%%   First derivative w/r to d(4) of constraint #20
expr4108 = 2.*expr3115.*expr3372.*expr3373.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3373.*expr3789.*expr3790.*expr3792.*expr3847.*expr4106.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(16, 20) = expr4108;

%%   First derivative w/r to d(4) of constraint #21
expr4109 = (-81.*wp.^2.*d(4))./25 + 4.*d(4).*(c(4).^2 + d(4).^2);
expr4110 = -2.*expr3115.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3390.*expr3796.*expr3797.*expr3799.*expr3851.*expr4109.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
GC(16, 21) = expr4110;

%%   First derivative w/r to d(4) of constraint #22
expr4111 = 2.*expr3115.*expr3389.*expr3390.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609 + expr3390.*expr3796.*expr3797.*expr3799.*expr3851.*expr4109.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
GC(16, 22) = expr4111;

%%   First derivative w/r to d(4) of constraint #23
expr4112 = -4.*wp.^2.*d(4) + 4.*d(4).*(c(4).^2 + d(4).^2);
expr4113 = -2.*expr3115.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609;
expr4114 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3402.*expr3403.*expr3404.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr4112.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr4115 = expr4113 + expr4114;
GC(16, 23) = expr4115;

%%   First derivative w/r to d(4) of constraint #24
expr4116 = 2.*expr3115.*(expr3398.*expr3399.*expr3400.*expr3401).^expr600.*(expr3402.*expr3403.*expr3404.*expr3405).^expr615.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609;
expr4117 = (expr3398.*expr3399.*expr3400.*expr3401).^expr600.*expr3402.*expr3403.*expr3404.*(expr3402.*expr3403.*expr3404.*expr3405).^expr600.*expr4112.*expr483.*expr503.*expr523.*expr543.*expr600.*expr607.*expr608.*expr609.*expr610;
expr4118 = expr4116 + expr4117;
GC(16, 24) = expr4118;

%%   First derivative w/r to d(4) of constraint #25
expr4119 = -4.*ws.^2.*d(4) + 4.*d(4).*(c(4).^2 + d(4).^2);
expr4120 = -2.*expr3115.*(expr3413.*expr3414.*expr3415.*expr3416).^expr600.*(expr3417.*expr3418.*expr3419.*expr3420).^expr615.*expr483.*expr503.*expr523.*expr543.*expr592.*expr607.*expr608.*expr609;
expr4121 = (expr3413.*expr3414.*expr3415.*expr3416).^expr600.*expr3417.*expr3418.*expr3419.*(expr3417.*expr3418.*expr3419.*expr3420).^expr600.*expr4119.*expr483.*expr503.*expr523.*expr543.*expr607.*expr608.*expr609.*expr610.*expr615;
expr4122 = expr4120 + expr4121;
GC(16, 25) = expr4122;

%%   First derivative w/r to d(4) of constraint #26
expr4123 = expr3219 + expr3220 + expr3221 + expr3222 + expr3223 + expr3224 + expr3225 + expr3226 + expr3227 + expr3228 + expr3229 + expr3230 + expr3231 + expr3232 + expr3233 + expr3234;
GC(16, 26) = expr4123;

end
